      program m3d2uwv
c
c Pour comprendre le fonctionnement de visualisation du programme
c $\fortran$, lisez le chapitre pr\'eliminaire du fichier
c COMMENTAIRES/preliminaire.tex.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/COMMENTAIRES/preliminaire.tex
c|_____________________________________________________________________S
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/COMMENTAIRES/MAIN.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/COMMENTAIRES/formulation.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/COMMENTAIRES/debuggage.tex
c|_____________________________________________________________________S
c \chapter{D\'eclaration}
      IMPLICIT NONE
c \section{D\'eclaration des param\`etres des tableaux et fichiers.}
c \subsection{D\'eclaration des param\`etres de dimensionnement des tableaux.}
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbelt.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbsom.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbare.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbnode.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbfacobj.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbfactot.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbelmat.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbmat.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbfreq.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbftrac.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbfb.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbelmaJnomat.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/VARIABLES/nbelnomaJmat.tex
      integer nbeltx,nbsomx,nbarex,nbnodex
      integer nbfacobjx,nbfactotx,nbelmatx,nbmatx
      integer nbfreqx,nbftracx,nbfbx
      integer nbroutx
      integer nbelmaJnomatx,nbelnomaJmatx
      integer lnbentx
c \subsection{Affectation des param\`etres de dimensionnement des tableaux.}
c \begin{remark}
c Pour le placement automatique des param\`etres \`a la valeur
c exacte du tableau du cas, il faut respecter le format
c suivant par rapport au format du fichier fortran de
c pretraitement dimfor (dimforf). Voyez l'\'ex\'ecutable
c \$HOME/m3d/bin/dim
c Un seul espace
c avant le nom du parametre et le signe \'egal, idem apr\`es.
c De plus, le programme dimforf place les ``,'' comme cela est donn\'e ici.
c Si vous modifiez l'ordre d'apparition des param\`etres, pensez \`a aller
c modifier les formats d'\'ecriture dans dimforf.
c \end{remark}
c \begin{enumerate}
c \item Param\`etres g\'en\'eraux et fondamentaux.
      parameter(
     &                 nbeltx = 65,
     &                 nbsomx = 4,
     &                 nbarex = 4,
     &                nbnodex = 30
     &                                   )
c \item Param\`etres compliqu\`es pour le rep\'erage des \'el\'ements
c avec mat\'eriau ou les interfaces ou les faces fronti\`eres.
      parameter(
     &               nbelmatx = 4,
     &                 nbmatx = 1,
     &          nbelmaJnomatx = 4,
     &          nbelnomaJmatx = 8,
     &              nbfacobjx = 4,
     &              nbfactotx = 62
     &                                   ) 
c \item Param\`etres connus seulement pour ce programme, non donn\'es pas
c $\unv$.
      parameter(
     &                  nbfbx = 3,
     &                nbfreqx = 1
     &                                   ) 
c \item Param\`etres propres au contr\^ole de l'\'ex\'ecution du MAIN.
      parameter(
     &                nbroutx = 200
     &                                   ) 
c \item Param\`etres qu'il n'est pas int\'eressant de toucher.
      parameter(
     &               nbftracx = 1000
     &                                   )
c \item Param\`etres fixes.
      parameter(
     &            lnbentx   =       5 
     &                                   ) 
c \end{enumerate}
c \subsection{D\'eclaration des param\`etres de tailles effectives des tableaux.}
      integer nbeltv,nbsomv,nbarev,nbnodev
      integer nbfacobjv,nbfactotv,nbelmatv,nbmatv
      integer nbfreqv,nbftracv,nbfbv
      integer nbroutv
      integer nbelmaJnomatv,nbelnomaJmatv
      integer lnbentv
c \subsection{D\'eclaration des unit\'es logiques et variables de contr\^ole.}
c \begin{enumerate}
c \item Unit\'es logiques des fichiers Entr\'ee/Sortie.
c \begin{enumerate}
c \item inmail Unit\'e logique du fichier de g\'eom\'etrie pour le programme
c $\uwv$.
c \item inideas Unit\'e logique du fichier de g\'eom\'etrie pour le programme
c $\unv$. Le format est le format $\Ideas$.
c \item iout1 Unit\'e logique de commentaires lisibles.
c \item iout2 Unit\'e logique de commentaires tableaux.
c \item indon Unit\'e logique du fichier de donn\'ees.
c \item inmat Unit\'e logique du fichier mat\'eriau.
c \item ifavs Unit\'e logique du fichier d'\'ecriture AVS des courants de fronti\`eres.
c \end{enumerate}
      integer inmail,inideas,iout1,iout2,indon,inmat
      integer ifavs,inres2
c \item Type de structure de donn\'ees
      integer itypdata
c \item Variables de contr\^oles du programme.
      integer debug,g100,w100,t100
      real    precmail
      real    deltah
c \end{enumerate}
c \section{Param\`etres d'entr\'ee caract\'eristiques du cas trait\'e.}
c \begin{enumerate}
c \item Param\`etres descriptifs du cas trait\'e dans muwCas.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/nbal.tex
      integer nbal
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/npol.tex
      integer npol
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/ncond.tex
      integer ncond
      real    freqdeb,freqpas
      integer nbtheta
      real    thetadeb,thetapas
      integer nbphi
      real    phideb,phipas
      integer nbobstheta
      real    obsthetadeb,obsthetapas
      integer nbobsphi
      real    obsphideb,obsphipas
c \item Tableaux auxiliaires permettant de calculer les tableaux
c du cas trait\'e.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/nommat.tex
      character*8 nommat(nbmatx)
      real    fretab(nbftracx)
      real    epreel(nbftracx),epcomp(nbftracx)
      real    xmuree(nbftracx),xmucom(nbftracx)
c \item Param\`etres descriptifs du cas trait\'e dans muwCasM3d.
c \begin{description}
c \item[frestep] Entier permettant de trouver la fr\'euence de travail par
c  $$ \mbox{Fr\'equence} = freqdeb + (frestep-1) \times freqpas $$
c \item[thetastep,phistep] Idem que frestep mais pour les angles $\theta$
c et $\phi$.
c \item[nbfreroutv] Nombre de subroutines travaill\'ees dans le Main. Ceci
c permet d'affecter un tableau donnant les noms des routines et le temps
c de passage du programme.
c \item[eps0,mu0] Les caract\'eristiques $\ep_0$ et $\mu_0$ du vide.
c Ces caract\'eristiques valent $1$.
c \end{description}
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/freqdeb.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/nbiterv.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/bountyp.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/tir3alea.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/intcrit.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/reacrit.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/inodcal.tex
      integer      frestep
      integer      thetastep,phistep
      integer      obsthetastep,obsphistep
      complex      eps0,mu0
      integer      nbiterv
      integer      bountyp
      integer      tir3alea
      integer      intcrit
      real         reacrit
      integer      inodcal
c \item Num\'ero de l'it\'eration (fr\'equence ou angle) trait\'ee.
      integer      loopstep
c \item Nombre de l'it\'eration (fr\'equence ou angle) \`a traiter.
      integer      nbloopv
c \item Fronti\`ere d'\'ecriture du post-traitement.
      integer      myitypfr
c \item Fr\'equence ou pulsation r\'eelle de travail.
      real         omega
c \end{enumerate}
c \section{Param\`etres d'entr\'ee caract\'eristiques de la g\'eom\'etrie.}
c \begin{enumerate}
c \item Tableaux fondamentaux donn\'es par le programme pr\'ec\'edent $\unv$.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/nrnode.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/nrelt.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/eltmat.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/x.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/y.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/z.tex
      integer nrnode(nbeltx,nbsomx)
      integer nrelt(nbeltx,nbarex)
      integer eltmat(0:nbelmatx)
      real    x(nbnodex)
      real    y(nbnodex)
      real    z(nbnodex)
c \item Rep\'erage de l'interface Vide/Mat\'eriau et fronti\`eres objet et CLA.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/eltvmatfro.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/facvmatfro.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/nbnodefr.tex
      integer eltvmatfro(nbfactotx)
      integer facvmatfro(0:5*nbarex)
      integer nbnodefr(7)
c \item D\'etermination des normales.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/normale.tex
      real    normale(3,nbeltx,nbarex)
c \end{enumerate}
c \section{Tableaux des fonctions de base, mat\'eriaux et condition de bord.}
c \begin{enumerate}
c \item Caract\'eristiques des mat\'eriaux
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/ceps.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/cmu.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/cepst.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/cmut.tex
      complex ceps(nbmatx,nbfreqx)
      complex cmu(nbmatx,nbfreqx)
      complex cepst(0:nbmatx)
      complex cmut(0:nbmatx)
c \item Fonctions de base
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/Vfb.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/Epol.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/Vfbg0.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/Epolg0.tex
      real    Vfb(3,nbeltx,nbfbx)
      real    Epol(3,nbeltx,nbfbx)
      real    Vfbg0(3)
      real    Epolg0(3)
      real    Hpolg0(3)
      real    err(3)
      real    ertheta(3)
      real    erphi(3)
c \item Condition de bord
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/opert.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/PARAMETRE/ifrcas.tex
      complex opert(nbfacobjx)
      integer ifrcas
c \end{enumerate}
c \section{Tableaux caract\'eristiques du probl\`eme.}
c \begin{enumerate}
c \item Matrice $D$ de sortie. Mise sous forme DFF,DGG et DFG. 
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/DFF.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/DGG.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/DFG.tex
      complex DFF((nbfbx*(nbfbx+1))/2*nbeltx)
      complex DGG((nbfbx*(nbfbx+1))/2*nbeltx)
      complex DFG((nbelmatx+nbelnomaJmatx)*nbfbx*nbfbx)
c \item Matrice $C$ de sortie. Mise sous forme CFF,CGG et CFG,CGF. 
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/CFF.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/CGG.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/CFG.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/CGF.tex
      complex CFF(nbfbx*nbfbx*nbeltx,nbarex)
      complex CGG(nbfbx*nbfbx*nbeltx,nbarex)
      complex CFG(nbfbx*nbfbx*(nbelmatx+nbelnomaJmatx),nbarex)
      complex CGF(nbfbx*nbfbx*(nbelmatx+nbelnomaJmatx),nbarex)
c \item Second membre et vecteur solution. Mise sous forme bF et bG. 
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/bF.tex
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/bG.tex
      complex bF1(nbeltx*nbfbx)
      complex bG1(nbeltx*nbfbx)
      complex bF2(nbeltx*nbfbx)
      complex bG2(nbeltx*nbfbx)
c \item variables locales au MAIN de $\uwv$.
      integer      lecunit
      integer irout
      include 'namerout.h'
      integer iloc
      integer   mem
      real      tstart,tend
c \end{enumerate}
c \section{Tableaux auxiliaires de calcul ou de v\'erifications.}
c \begin{enumerate}
c \item Rep\'erage des noeuds localement sur face.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/TABLEAUX/nodefac.tex
      integer nodefac(nbarex,nbarex/2+1)
c
c \item Tableaux auxiliaires de stockage.
c \begin{description}
c \item[bF3] Pour muwCoebb et muwCoemm, CalDC, CalDb et InvSys.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/AUXILIAIRE/bF3.tex
      complex bF3(nbeltx*nbfbx)
c \item[bG3] Pour muwCoemm et muwIntmm,muwIntbb, CalDC, CalDb et InvSys.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/AUXILIAIRE/bG3.tex
      complex bG3(nbeltx*nbfbx)
c \item[bF4] Pour muwCoebm, CalDC et InvSys.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/AUXILIAIRE/bF4.tex
      complex bF4(nbeltx*nbfbx)
c \item[bG4] Pour muwCoebm et muwIntbm, CalDC et InvSys.
c \input /jupiter/home/m8/cessenat/m3d/m3d2uwv/AUXILIAIRE/bG4.tex
      complex bG4(nbeltx*nbfbx)
c \end{description}
c \item Directions des fonctions de base dans le cas o\`u elles sont fixes.
      real    Vfb0(3,nbfbx)
      real    Epol0(3,nbfbx)
c \end{enumerate}
c \section{Normalement utilis\'es dans $\unv$.}
c \begin{enumerate}
c \item Codes $\Ideas$ pour les tableaux de connectivit\'e.
      integer codeentite(lnbentx)
c \item Num\'ero de la version $\Ideas$.
      integer ideas
c \item Code de l'unit\'e de longueur de la version $\Ideas$.
c \begin{enumerate}
c \item iunit = 1 : m\`etre.
c \item iunit = 2 : centim\`etre.
c \item iunit = 3 : millim\`etre.
c \end{enumerate}
      integer iunit
c \end{enumerate}
c \section{Sp\'ecifique au d\'ebuggage}
      integer sundeb
      complex VfbCg0(3)
      complex EpolCg0(3)
      complex HpolCg0(3)
c|_____________________________________________________________________S
c \chapter{Phase de construction du probl\`eme}
c \section{NAJ}
c NAJ
      if ((precmail.lt.1.E-15).or.(precmail.gt.1.E-13)) then
        sundeb=1
      else
        sundeb=0
      end if
c
c \section{Initialisation}
      tstart = second()
      lecunit = 10
      nbfreroutv(1) = 0
      iout1=41
      call DebugSet(debug,iout1,0)
c
c \subsection{Affectation des unit\'es logiques}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='unvInit'
      nbcall(irout)=nbcall(irout)+1
      mess3='Initialisation des parametres du programme m3d2uwv'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call Initiale(
     &           lecunit,g100,w100,t100,debug,precmail,
     &           inmail,inideas,iout1,iout2,indon,
     &           ifavs,inres2,inmat,
     &           eps0,mu0
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c
c \subsection{Calcul de la m\'emoire requise par le programme.}
c Cette routine sera \`a terme \`a impl\'ementer dans $\unv$ ou 
c le programme de pr\'etraitement-lancement du cas dim ou go.
      if (1.eq.0) then
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='muwMem'
      nbcall(irout)=nbcall(irout)+1
      mess3='Calcul de la place memoire occupee'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call muwMem(
     &           g100,w100,t100,iout1,debug,
     &           nbeltx,nbsomx,nbarex,nbnodex,
     &           nbfacobjx,nbfactotx,nbelmatx,nbmatx,
     &           nbfreqx,nbfbx,nbroutx,
     &           mem
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c|_____________________________________________________________________S
c \section{Lecture des caract\'eristiques du probl\`eme}
c \subsection{Param\`etres de la g\'eom\'etrie donn\'es par $\unv$.}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='uwvParam'
      nbcall(irout)=nbcall(irout)+1
      mess3='Parametres geometrique du maillage'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call uwvParam(
     & g100,w100,t100,debug,iout1,iout2,precmail,
     & inmail,deltah,
     & nbeltx,nbnodex,nbsomx,nbarex,
     & nbelmatx,nbelmaJnomatx,nbelnomaJmatx,nbmatx,
     & nbfactotx,nbfacobjx,
     & nbeltv,nbnodev,nbsomv,nbarev,
     & nbelmatv,nbelmaJnomatv,nbelnomaJmatv,nbmatv,
     & nbfactotv,nbfacobjv,
     & facvmatfro,eltvmatfro,itypdata,nbnodefr
     & )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c
c \subsection{G\'eom\'etrie r\'eordonn\'ee par le programme $\unv$.}
c \begin{enumerate}
      if (itypdata.eq.10) then
c \item Format $10$.
c \begin{remark}
c Ce format permet de faire tourner une seule fois le programme de
c pr\'e-traitement $\unv$ \`a partir du fichier num\'ero logique $10$ de
c ce progrmme. Le num\'ero de fichier de uwvGeoN est inmail ($=11$).
c \end{remark}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='uwvGeoN'
      nbcall(irout)=nbcall(irout)+1
      mess3='Lecture du fichier de donne geometrique du maillage'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call uwvGeoN(
     & g100,w100,t100,debug,iout1,iout2,precmail,
     & inmail,deltah,
     & nbeltx,nbnodex,nbsomx,nbarex,
     & nbelmatx,nbelmaJnomatx,nbelnomaJmatx,nbmatx,
     & nbfactotx,nbfacobjx,
     & nbeltv,nbnodev,nbsomv,nbarev,
     & nbelmatv,nbelmaJnomatv,nbelnomaJmatv,nbmatv,
     & nbfactotv,nbfacobjv,
     & nrnode,nrelt,eltmat,
     & x,y,z
     & )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      else if (itypdata.eq.11) then
c \item Format $11$.
c \begin{remark}
c Ce format n\'ecessite de faire tourner deux fois le programme de
c pr\'e-traitement $\unv$ qui \`a partir du fichier de maillage $\Ideas$
c num\'ero $20$ pour $\unv$ donne une premi\`ere fois
c| m3d1unv ;
c le fichier num\'ero $18$.
c| NewIdeas fort.20 fort.18 IdeasFile
c| mv IdeasFile fort.20
c| m3d1unv ;
c donne le fichier de num\'ero logique $11$.
c Le num\'ero de fichier de uwvGeoN est inmail ($=11$).
c \end{remark}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='uwvGeoF'
      nbcall(irout)=nbcall(irout)+1
      mess3='Lecture du fichier de donne geometrique du maillage'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call uwvGeoF(
     & g100,w100,t100,debug,iout1,iout2,precmail,
     & inmail,deltah,
     & nbeltx,nbnodex,nbsomx,nbarex,
     & nbelmatx,nbelmaJnomatx,nbelnomaJmatx,nbmatx,
     & nbfactotx,nbfacobjx,
     & nbeltv,nbnodev,nbsomv,nbarev,
     & nbelmatv,nbelmaJnomatv,nbelnomaJmatv,nbmatv,
     & nbfactotv,nbfacobjv,
     & nrnode,nrelt,eltmat,
     & x,y,z
     & )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      else if (itypdata.eq.20) then
c \item Format $20$.
c \begin{enumerate}
c \item Lecture du fichier $\Ideas$ d'unit\'e lgique inideas ($=20$).
c \begin{remark}
c Ce format permet de faire tourner une seule fois le programme de
c pr\'e-traitement $\unv$ \`a partir du fichier num\'ero logique $18$ de
c ce sortie de ce programme et du fichier de maillage d'entr\'ee ($20$).
c Le num\'ero de fichier de uwvGeoN est inmail ($=11$).
c| NewIdeas fort.20 fort.18 IdeasFile
c| mv IdeasFile fort.20
c permet de r\'ecup\'erer le fichier inideas ($=20$) et on utilisera le 
c fichier $10$ de $\unv$ pour le code $\uwv$ avec le num\'ero logique
c inmail ($11$).
c \end{remark}
c \begin{remark}
c Ce proc\'ed\'e n'est pour le moment pas utilis\'e puisqu'il ne permet pas
c d'\'eviter le programme $\unv$ de pr\'e-traitement. Une version future
c coupl\'ee avec le programme de d\'etermination de $\nrelt$ serait avantageuse
c dans le cas d'un maillage effectu\'e directement d'apr\`es les crit\`eres
c sp\'ecifiques \`a $\uwv$.
c \end{remark}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='uwvIdeas'
      nbcall(irout)=nbcall(irout)+1
      mess3='Lecture ideas version semi-rapide: elts, noeuds, unites'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call uwvIdeas(g100,debug,inideas,iout1,
     & nbnodex,nbeltx,nbarex,nbsomx,lnbentx,nbmatx,nbelmatx,
     & nbnodev,nbeltv,nbarev,nbsomv,lnbentv,nbmatv,nbelmatv,
     & ideas,codeentite,iunit,
     & eltmat,x,y,z,nrnode)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c
c \item Dimensionnant du probl\`eme en m\`etres (SI).
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='stmetre'
      nbcall(irout)=nbcall(irout)+1
      mess3='Calcul des nouvelles positions des noeuds'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call stmetre(nbnodev,x,y,z,iunit)
      temps(irout) = temps(irout) + second() - taux
      if (debug.ge.1) write(iout1,1101) subname(irout)
c
c \item Lecture de la connectivit\'e \'el\'ement \'el\'ement voisin
c du tableau $\nrelt$.
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='uwvGeoM'
      nbcall(irout)=nbcall(irout)+1
      mess3='Lecture du fichier de donne geometrique du maillage'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call uwvGeoM(
     & g100,w100,t100,debug,iout1,iout2,precmail,inmail,
     & nbeltx,nbarex,
     & nbeltv,nbarev,
     & nrelt)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c \end{enumerate}
      end if
c \end{enumerate}
c
c \subsection{Etude de la g\'eom\'etrie fronti\`ere.}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='uwvFront'
      nbcall(irout)=nbcall(irout)+1
      mess3='Etude des frontieres caracteristiques du maillage'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call uwvFront(
     & g100,w100,t100,debug,iout1,iout2,
     & nbeltx,nbarex,nbelmatx,nbelmaJnomatx,nbelnomaJmatx,nbfactotx,
     & nbeltv,nbarev,nbelmatv,nbelmaJnomatv,nbelnomaJmatv,nbfactotv,
     & facvmatfro,eltvmatfro,nbfacobjv,
     & nrelt)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c
c \subsection{Fichier de donn\'ees du cas \`a traiter.}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='muwCas'
      nbcall(irout)=nbcall(irout)+1
      mess3='Lecture du fichier de donne du cas'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call muwCas(
     &           g100,w100,t100,iout1,iout2,debug,precmail,
     &           indon,
     &           nbmatx,nbmatv,
     &           freqdeb,nbfreqv,freqpas,
     &           thetadeb,nbtheta,thetapas,
     &           phideb,nbphi,phipas,
     &           obsthetadeb,nbobstheta,obsthetapas,
     &           obsphideb,nbobsphi,obsphipas,
     &           nommat,nbal,npol,ncond
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c
c \subsection{Donn\'ees sp\'ecifiques \`a la m\'ethode UWVF: $\uwv$.}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='muwCasM3d'
      nbcall(irout)=nbcall(irout)+1
      mess3='Lecture du fichier de donne du cas pour m3d'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call muwCasM3d(
     &           g100,w100,t100,iout1,iout2,debug,precmail,
     &           indon,nbarex,nbarev,facvmatfro,
     &           nbfbv,tir3alea,bountyp,nbiterv,intcrit,reacrit,inodcal
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c
c \subsection{Caract\'eristiques des mat\'eriaux utilis\'es}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='muwMat'
      nbcall(irout)=nbcall(irout)+1
      mess3='Lecture des caracteristiques des materiaux par freq'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call muwMat(
     &           g100,w100,t100,iout1,iout2,debug,precmail,
     &           nbftracx,nbmatx,nbfreqx,
     &           nbftracv,nbmatv,nbfreqv,
     &           freqdeb,freqpas,
     &           inmat,nommat,fretab,epreel,epcomp,xmuree,xmucom,
     &           ceps,cmu
     &           )
      eltmat(0) = 0
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c
c \subsection{Baisse de la valeur du param\`etre de d\'ebuggage selon la taille du probl\`eme.}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='DebugSet'
      nbcall(irout)=nbcall(irout)+1
      mess3='Controle du parametre de debuggage selon la taille du pb.'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call DebugSet(debug,iout1,nbeltv*nbfbv)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c \section{D\'etermination des quantit\'es utilis\'es par la formulation}
c \subsection{Normales aux faces de tous les \'el\'ements.}
c \begin{enumerate}
c \item Version rapide programm\'ee de fa\c con moins esth\'etique.
      if (1.eq.1) then
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='muwNor'
      nbcall(irout)=nbcall(irout)+1
      mess3='Determination Rapide des normales sortantes'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call muwNor(
     &           g100,debug,iout1,
     &           nrnode,x,y,z,
     &           nbeltx,nbnodex,nbarex,nbsomx,
     &           nbeltv,nbnodev,nbarev,nbsomv,
     &           normale
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c
c \item Version plus lente mais programm\'ee de fa\c con plus esth\'etique.
      if (1.eq.0) then
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='muwNor'
      nbcall(irout)=nbcall(irout)+1
      mess3='Determination Lente des normales sortantes'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call uwvNor(g100,debug,iout1,iout2,precmail,
     & nrnode,x,y,z,nodefac,
     & nbeltx,nbnodex,nbarex,nbsomx,
     & nbeltv,nbnodev,nbarev,nbsomv,
     & normale)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c \end{enumerate}
c
c \subsection{Sortie de la g\'eom\'etrie du post-traitement.}
c \begin{remark}
c La fronti\`ere choisie pour le post-traitement est la fronti\`ere de
c l'objet d\'esign\'ee par le num\'ero logique myitypfr=1. Si l'on met
c myitypfr=2 on \'ecrira les caract\'eristiques de la fronti\`ere
c artificielle.
c \end{remark}
      if (inodcal.eq.1) then
      myitypfr=1
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='GeoWri'
      nbcall(irout)=nbcall(irout)+1
        mess3='Ecriture de la geometrie'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      loopstep=1
        call GeoWri(
     & g100,w100,t100,debug,iout1,iout2,
     & precmail,loopstep,
     & nbeltx,nbsomx,nbarex,nbelmatx,nbnodex,
     & nbfacobjx,nbfactotx,nbmatx,nbfbx,
     & nbeltv,nbsomv,nbarev,nbelmatv,nbnodev,
     & nbfacobjv,nbfactotv,nbmatv,nbfbv,
     & nrnode,eltmat,x,y,z,normale,
     & nodefac,nbnodefr,eltvmatfro,facvmatfro,
     & myitypfr,ifavs)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c
c \subsection{Directions de propagation et polarisations.}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='AssFbk'
      nbcall(irout)=nbcall(irout)+1
      mess3='Determination des fonctions de base sur chaque elt'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call AssFbk(
     &           g100,w100,t100,debug,iout1,iout2,tir3alea,
     &           precmail,
     &           nbeltx,nbfbx,
     &           nbeltv,nbfbv,
     &           Vfb0,Epol0,
     &           Vfb,Epol
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c
c \subsection{Sortie des fonctions de base pour le post-traitement.}
      if (inodcal.eq.1) then
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='NodFbk'
      nbcall(irout)=nbcall(irout)+1
        mess3='Fonctions de base pour le post traitement'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      loopstep=1
      nbloopv=1
        call NodFbk(
     & g100,w100,t100,debug,iout1,iout2,
     & precmail,myitypfr,loopstep,nbloopv,
     & nbeltx,nbarex,nbfactotx,nbfbx,
     & nbeltv,nbarev,nbfactotv,nbfbv,
     & eltvmatfro,facvmatfro,
     & Vfb,Epol,tir3alea,ifavs)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c
c \subsection{Op\'erateur de bord.}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='muwGop'
      nbcall(irout)=nbcall(irout)+1
      mess3='Determination de l''operateur de bord'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call muwGop(
     & g100,w100,t100,debug,iout1,
     & nbfacobjx,nbfacobjv,bountyp,
     & nbarex,nbarev,facvmatfro,
     & ncond,opert,ifrcas)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c \chapter{It\'erations en fr\'equence}
      if (nbal.eq.3) then
        nbfreqv=1
        nbtheta=1
        nbphi=1
        nbloopv = 1
      endif
      if (nbal.eq.1) then
        nbtheta=1
        nbphi=1
        nbloopv = nbfreqv
      endif
      if (nbal.eq.2) then
        nbfreqv=1
        nbloopv = nbtheta * nbphi
      endif
      loopstep = 0
c|_____________________________________________________________________S
c \section{Initialisation \`a z\'ero du vecteur solution $(\bF_2,\bG_2)$.}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='InitVect'
      nbcall(irout)=nbcall(irout)+1
      mess3='Initialisation de la solution'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call InitVect(bF2,bG2,1,nbeltv*nbfbv)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c \section{Lancement des it\'erations.}
      do 111 frestep = 1 , nbfreqv
      omega = (acos(-1.)*(freqdeb + freqpas * real (frestep-1)))/150.
      if (debug.ge.1) then
        write(iout1,2101) frestep,nbfreqv,
     &  (freqdeb + freqpas * real (frestep-1)),
     &  30000./(freqdeb + freqpas * real (frestep-1)),
     &  (300./(freqdeb + freqpas * real (frestep-1)))/(deltah),
     &  (freqdeb + freqpas * real (frestep-1))/300.,
     &  omega
      if (debug.ge.5) then
      if (iout1.ne.6) then
        write(6,2101) frestep,nbfreqv,
     &  (freqdeb + freqpas * real (frestep-1)),
     &  30000./(freqdeb + freqpas * real (frestep-1)),
     &  (300./(freqdeb + freqpas * real (frestep-1)))/(deltah),
     &  (freqdeb + freqpas * real (frestep-1))/300.,
     &  omega
      end if
      end if
      end if
      nbfreroutv(2)=nbfreroutv(1)
c|_____________________________________________________________________S
c \section{Affectation des caract\'eristiques des mat\'eriaux}
      nbfreroutv(2)=nbfreroutv(2)+1
      irout=nbfreroutv(2)
      subname(irout)='muwMatFre'
      nbcall(irout)=nbcall(irout)+1
      mess3='Determine les caracteristiques des materiaux par elt'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call muwMatFre(
     &           g100,debug,iout1,
     &           frestep,
     &           nbelmatx,nbmatx,nbfreqx,
     &           nbelmatv,nbmatv,nbfreqv,
     &           eltmat,ceps,cmu,
     &           cepst,cmut
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c \section{Construction de la matrice $C$ du syst\`eme lin\'eaire}
c \begin{enumerate}
c NAJ
c|      if (tir3alea.eq.1) then
      if (tir3alea.eq.0) then
c \item Cas g\'en\'eral.
      nbfreroutv(2)=nbfreroutv(2)+1
      irout=nbfreroutv(2)
      subname(irout)='AssMatC'
      nbcall(irout)=nbcall(irout)+1
      mess3='Assemblage cas general de la matrice C'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call AssMatC(
     &           g100,w100,t100,debug,iout1,iout2,
     & subname,temps,nbcall,nbfreroutv,nbroutx,
     &           precmail,omega,
     &           nbeltx,nbsomx,nbarex,nbelmatx,nbnodex,
     &           nbfactotx,nbfacobjx,nbmatx,nbfbx,
     &           nbeltv,nbsomv,nbarev,nbelmatv,nbnodev,
     &           nbfactotv,nbfacobjv,nbmatv,nbfbv,
     &           nrnode,nrelt,eltmat,x,y,z,
     &           eltvmatfro,facvmatfro,cepst,cmut,
     &           Vfb,Epol,opert,normale,
     &           nbelnomaJmatx,nbelnomaJmatv,
     &           nodefac,
     &           bF3,bG3,bF4,bG4,
     &           CFF,CGG,CFG,CGF
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      else
c \item Cas particulier de fonctions de base identiques sur tous
c les \'el\'ements.
      nbfreroutv(2)=nbfreroutv(2)+1
      irout=nbfreroutv(2)
      subname(irout)='AssCMat'
      nbcall(irout)=nbcall(irout)+1
      mess3='Assemblage rapide de la matrice C du systeme'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call AssCMat(
     &           g100,w100,t100,debug,iout1,iout2,
     & subname,temps,nbcall,nbfreroutv,nbroutx,
     &           precmail,omega,
     &           nbeltx,nbsomx,nbarex,nbelmatx,nbnodex,
     &           nbfactotx,nbfacobjx,nbmatx,nbfbx,
     &           nbeltv,nbsomv,nbarev,nbelmatv,nbnodev,
     &           nbfactotv,nbfacobjv,nbmatv,nbfbv,
     &           nrnode,nrelt,eltmat,x,y,z,
     &           eltvmatfro,facvmatfro,cepst,cmut,
     &           Vfb,Epol,opert,normale,
     &           nbelnomaJmatx,nbelnomaJmatv,
     &           nodefac,tir3alea,
     &           bF3,bG3,bF4,bG4,
     &           CFF,CGG,CFG,CGF
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c \end{enumerate}
c|_____________________________________________________________________S
c \section{Construction de la matrice $D$ du syst\`eme lin\'eaire}
c \begin{enumerate}
c NAJ
c|      if (tir3alea.eq.1) then
      if (tir3alea.eq.0) then
c \item Cas g\'en\'eral.
      nbfreroutv(2)=nbfreroutv(2)+1
      irout=nbfreroutv(2)
      subname(irout)='AssMatD'
      nbcall(irout)=nbcall(irout)+1
        mess3='Assemblage cas general de la matrice D'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call AssMatD(
     &           g100,w100,t100,debug,iout1,iout2,
     & subname,temps,nbcall,nbfreroutv,nbroutx,
     &           precmail,omega,
     &           nbeltx,nbsomx,nbarex,nbelmatx,nbnodex,
     &           nbfactotx,nbfacobjx,nbmatx,nbfbx,
     &           nbeltv,nbsomv,nbarev,nbelmatv,nbnodev,
     &           nbfactotv,nbfacobjv,nbmatv,nbfbv,
     &           nrnode,nrelt,eltmat,x,y,z,
     &           eltvmatfro,facvmatfro,cepst,cmut,
     &           Vfb,Epol,normale,
     &           nbelnomaJmatx,nbelnomaJmatv,
     &           nodefac,
     &           bF3,bG3,bF4,bG4,
     &           DFF,DGG,DFG
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c \item Cas particulier de fonctions de base identiques sur tous
c les \'el\'ements.
c \begin{remark}
c Dans ce cas l'assemblage de la matrice $D$ doit se faire apr\`es celui de
c la matrice $C$.
c \end{remark}
      else
      nbfreroutv(2)=nbfreroutv(2)+1
      irout=nbfreroutv(2)
      subname(irout)='AssDMat'
      nbcall(irout)=nbcall(irout)+1
        mess3='Assemblage (rapide sur le vide) de la matrice D'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call AssDMat(
     &           g100,w100,t100,debug,iout1,iout2,
     & subname,temps,nbcall,nbfreroutv,nbroutx,
     &           precmail,omega,tir3alea,
     &           nbeltx,nbsomx,nbarex,nbelmatx,nbnodex,
     &           nbfactotx,nbfacobjx,nbmatx,nbfbx,
     &           nbeltv,nbsomv,nbarev,nbelmatv,nbnodev,
     &           nbfactotv,nbfacobjv,nbmatv,nbfbv,
     &           nrnode,nrelt,eltmat,x,y,z,
     &           eltvmatfro,facvmatfro,cepst,cmut,
     &           Vfb,Epol,normale,
     &           nbelnomaJmatx,nbelnomaJmatv,
     &           nodefac,
     &           bF3,bG3,bF4,bG4,
     &           CFF,CGG,CFG,CGF,
     &           DFF,DGG,DFG
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c \end{enumerate}
c
      if (sundeb.eq.1) then
      if (debug.ge.13) then
      print*,'La somme suivante doit souvent faire 0'
      print*,'	visudc= D+C en ligne sur lvois.'
      call visudc(debug,iout1,precmail,
     &           nbfbx,nbeltx,nbelmatx,nbelnomaJmatx,nbarex,
     &           nbfbv,nbeltv,nbelmatv,nbelnomaJmatv,nbarev,
     &           DFF,DGG,DFG,CFF,CGG,CFG,CGF,nrelt)
      end if
      else
        write(iout1,*) 'Pas de somme de matrices a ce niveau'
      end if

c|_____________________________________________________________________S
c \section{Inversion de la matrice $D$ du syst\`eme lin\'eaire}
      nbfreroutv(2)=nbfreroutv(2)+1
      irout=nbfreroutv(2)
      subname(irout)='InvD'
      nbcall(irout)=nbcall(irout)+1
        mess3='Inversion de D et stockage dans D'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call InvD(
     & g100,w100,t100,debug,iout1,iout2,precmail,
     & nbeltx,nbarex,nbelmatx,nbfbx,nbelnomaJmatx,
     & nbeltv,nbarev,nbelmatv,nbfbv,nbelnomaJmatv,
     & bF3,bG3,bF4,bG4,
     & DFF,DGG,DFG)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c \section{Multiplication \`a gauche de $C$ par $D^{-1}$ et stockage dans $C$}
      nbfreroutv(2)=nbfreroutv(2)+1
      irout=nbfreroutv(2)
      subname(irout)='CalDC'
      nbcall(irout)=nbcall(irout)+1
        mess3='calcul de l''inverse de D fois C'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call CalDC(
     & g100,w100,t100,debug,iout1,iout2,precmail,
     & subname,temps,nbcall,nbfreroutv,nbroutx,
     & nbeltx,nbarex,nbelmatx,nbfbx,nbelnomaJmatx,
     & nbeltv,nbarev,nbelmatv,nbfbv,nbelnomaJmatv,
     & bF3,bG3,bF4,bG4,
     & DFF,DGG,DFG,CFF,CGG,CFG,CGF)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c \chapter{It\'erations en incidence}
      do 110 thetastep = 1 , nbtheta
      do 110 phistep = 1 , nbphi
      loopstep = loopstep + 1
      if (debug.ge.1) then
        write(iout1,2102) frestep,nbfreqv,omega,
     &  thetastep,nbtheta,(thetadeb + thetapas * real (thetastep-1)),
     &  phistep,nbphi,(thetadeb + phipas * real (phistep-1))
      if (debug.ge.5) then
      if (iout1.ne.6) then
        write(6,2102) frestep,nbfreqv,omega,
     &  thetastep,nbtheta,(thetadeb + thetapas * real (thetastep-1)),
     &  phistep,nbphi,(thetadeb + phipas * real (phistep-1))
      end if
      end if
      end if
      nbfreroutv(3)=nbfreroutv(2)
c|_____________________________________________________________________S
c \section{Pour le calcul du second membre, onde plane $g$}
      nbfreroutv(3)=nbfreroutv(3)+1
      irout=nbfreroutv(3)
      subname(irout)='AngInc'
      nbcall(irout)=nbcall(irout)+1
        mess3='Determine les directions de la fonction de bord g'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call AngInc(
     &           g100,w100,t100,iout1,iout2,debug,precmail,
     &           thetadeb,nbtheta,thetapas,
     &           phideb,nbphi,phipas,
     &           nbal,npol,thetastep,phistep,
     &           Vfbg0,Epolg0,Hpolg0
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c \section{Construction du second membre b dans le cas du ``scattering''}
      nbfreroutv(3)=nbfreroutv(3)+1
      irout=nbfreroutv(3)
      subname(irout)='AssSem'
      nbcall(irout)=nbcall(irout)+1
        mess3='Assemblage du Second Membre du systeme lineaire'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call AssSem(
     & g100,w100,t100,debug,iout1,iout2,
     & subname,temps,nbcall,nbfreroutv,nbroutx,
     & precmail,omega,
     & nbeltx,nbsomx,nbarex,nbelmatx,nbnodex,
     & nbmatx,nbfbx,nbfacobjx,nbfactotx,
     & nbeltv,nbsomv,nbarev,nbelmatv,nbnodev,
     & nbmatv,nbfbv,nbfacobjv,nbfactotv,
     & nrnode,eltmat,x,y,z,
     & eltvmatfro,facvmatfro,cepst,cmut,
     & Vfbg0,Epolg0,Hpolg0,Vfb,Epol,opert,ifrcas,normale,
     & nodefac,
     & bF4,bG4,bF3,bG3,
     & bF1,bG1)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c \section{Calcul de $D^{-1}b$ et stockage dans $b$}
      nbfreroutv(3)=nbfreroutv(3)+1
      irout=nbfreroutv(3)
      subname(irout)='CalDb '
      nbcall(irout)=nbcall(irout)+1
        mess3='calcul de l''inverse de D fois b le second membre'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call CalDb(
     & g100,w100,t100,debug,iout1,iout2,precmail,
     & nbeltx,nbarex,nbelmatx,nbfbx,nbelnomaJmatx,
     & nbeltv,nbarev,nbelmatv,nbfbv,nbelnomaJmatv,
     & bF3,bG3,
     & bF1,bG1,
     & DFF,DGG,DFG)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c \chapter{R\'esolution du probl\`eme}
c|_____________________________________________________________________S
c \section{R\'eflexion monostatique}
      if (intcrit.gt.0) then
      nbfreroutv(3)=nbfreroutv(3)+1
      irout=nbfreroutv(3)
      subname(irout)='AngRef '
      nbcall(irout)=nbcall(irout)+1
        mess3='Calcul du vecteur reflechi pour la SER'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call AngRef(
     &           g100,w100,t100,iout1,iout2,debug,precmail,
     &           thetadeb,nbtheta,thetapas,
     &           phideb,nbphi,phipas,
     &           thetastep,phistep,
     &           err,ertheta,erphi
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c|_____________________________________________________________________S
c \section{Inversion it\'erative du syst\`eme lin\'eaire}
      nbfreroutv(3)=nbfreroutv(3)+1
      irout=nbfreroutv(3)
      subname(irout)='InvSys '
      nbcall(irout)=nbcall(irout)+1
        mess3='Algorithme iteratif - Inversion du systeme lineaire'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call InvSys(
     & g100,w100,t100,debug,iout1,iout2,
     & subname,temps,nbcall,nbfreroutv,nbroutx,
     & precmail,intcrit,reacrit,nbiterv,
     & nbeltx,nbarex,nbelmatx,nbfactotx,nbfacobjx,nbfbx,
     & nbeltv,nbarev,nbelmatv,nbfactotv,nbfacobjv,nbfbv,
     & nbelnomaJmatx,nbelnomaJmatv,
     & nrelt,eltvmatfro,facvmatfro,
     & DFF,DGG,DFG,bF3,bG3,bF4,bG4,
     & CFF,CGG,CFG,CGF,
     & Vfbg0,Epolg0,Hpolg0,
     & nbsomx,nbnodex,nbmatx,nbsomv,nbnodev,nbmatv,
     & normale,nrnode,eltmat,x,y,z,nodefac,omega,
     & err,ertheta,erphi,Vfb,Epol,opert,ifrcas,cepst,cmut,
     & bF2,bG2,bF1,bG1
     & )
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c
c|_____________________________________________________________________S
c \chapter{Post-traitements et sortie des fichiers de r\'esultats}
c|_____________________________________________________________________S
c \section{Pour le calcul de la SER cas bistatique.}
c NAJ      if (nbal.ne.3) then
      if (debug.ge.1) then
        write(iout1,2103) obsthetadeb,obsthetapas,nbobstheta,
     &  obsphideb,obsphipas,nbobsphi
      if (debug.ge.5) then
      if (iout1.ne.6) then
        write(6,2103)
     &  obsthetadeb,obsthetapas,nbobstheta,
     &  obsphideb,obsphipas,nbobsphi
      end if
      end if
      end if
c|_____________________________________________________________________S
      if (facvmatfro(2*nbarev).ge.1) then
      nbfreroutv(3)=nbfreroutv(3)+1
      irout=nbfreroutv(3)
      subname(irout)='SerCal'
      nbcall(irout)=nbcall(irout)+1
        mess3='Calcul de la SER a la frequence donnee'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call SerCal(
     &           g100,w100,t100,iout1,iout2,debug,precmail,
     & subname,temps,nbcall,nbfreroutv,nbroutx,
     &           nbeltx,nbsomx,nbarex,nbelmatx,nbnodex,
     &           nbfactotx,nbfacobjx,nbmatx,nbfbx,nbelnomaJmatx,
     &           nbeltv,nbsomv,nbarev,nbelmatv,nbnodev,
     &           nbfactotv,nbfacobjv,nbmatv,nbfbv,nbelnomaJmatv,
     &           obsthetadeb,nbobstheta,obsthetapas,
     &           obsphideb,nbobsphi,obsphipas,
     &           obsthetastep,obsphistep,
     &           err,ertheta,erphi,
     &           nrnode,eltmat,x,y,z,
     &           eltvmatfro,facvmatfro,cepst,cmut,
     &           Vfbg0,Epolg0,Hpolg0,Vfb,Epol,opert,ifrcas,normale,
     &           nodefac,omega,nrelt,
     &           bF2,bG2,bF3,bG3,bF4,bG4,loopstep,nbloopv,inres2)
      temps(irout) = temps(irout) + second() - taux 
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c|_____________________________________________________________________S
c NAJ      else
c|_____________________________________________________________________S
c \subsection{Calcul des champs aux barycentres des faces d'une fronti\`ere.}
c \begin{enumerate}
c \item Cas quelconque.
      nbfreroutv(3)=nbfreroutv(3)+1
      irout=nbfreroutv(3)
      subname(irout)='CalBary'
      nbcall(irout)=nbcall(irout)+1
        mess3='Valeurs des courants sur une fronti\`ere'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call CalBary(
     &           g100,w100,t100,debug,iout1,iout2,
     &           precmail,loopstep,nbloopv,omega,0,
     &           nbeltx,nbsomx,nbarex,nbelmatx,nbnodex,
     &           nbfacobjx,nbfactotx,nbmatx,nbfbx,
     &           nbeltv,nbsomv,nbarev,nbelmatv,nbnodev,
     &           nbfacobjv,nbfactotv,nbmatv,nbfbv,
     &           nrnode,eltmat,x,y,z,
     &           eltvmatfro,facvmatfro,cepst,cmut,
     &           Vfbg0,Epolg0,Hpolg0,Vfb,Epol,opert,ifrcas,normale,
     &           nodefac,nbnodefr,ifavs,bF2,bG2,
     &           bF3,bG3,bF4,bG4)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
c \item Cas o\`u l'on demande une sortie pour le postraitement.
c On donne la solution dans $\C^{2pK}$.
      if (inodcal.eq.1) then
      nbfreroutv(3)=nbfreroutv(3)+1
      irout=nbfreroutv(3)
      subname(irout)='NodSol'
      nbcall(irout)=nbcall(irout)+1
        mess3='Ecriture de la solution'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call NodSol(
     & g100,w100,t100,debug,iout1,iout2,
     & precmail,myitypfr,loopstep,nbloopv,
     & nbeltx,nbarex,nbfactotx,nbfbx,
     & nbeltv,nbarev,nbfactotv,nbfbv,
     & eltvmatfro,facvmatfro,
     & bF2,bG2,ifavs)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c \item Cas sans second membre dans l'\'equation sur $\Omega$.
      if (1.eq.1) then
      nbfreroutv(3)=nbfreroutv(3)+1
      irout=nbfreroutv(3)
      subname(irout)='CalHmgG'
      nbcall(irout)=nbcall(irout)+1
        mess3='Autre calcul des courants sur une fronti\`ere'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
        call CalHmgG(
     &           g100,w100,t100,debug,iout1,iout2,
     &           precmail,loopstep,nbloopv,omega,0,
     &           nbeltx,nbsomx,nbarex,nbelmatx,nbnodex,
     &           nbfacobjx,nbfactotx,nbmatx,nbfbx,
     &           nbeltv,nbsomv,nbarev,nbelmatv,nbnodev,
     &           nbfacobjv,nbfactotv,nbmatv,nbfbv,
     &           nrnode,eltmat,x,y,z,
     &           eltvmatfro,facvmatfro,cepst,cmut,
     &           Vfbg0,Epolg0,Hpolg0,Vfb,Epol,opert,ifrcas,normale,
     &           nodefac,nbnodefr,inres2,bF2,bG2,
     &           bF3,bG3,bF4,bG4)
      temps(irout) = temps(irout) + second() - taux
      if (g100.ne.0) goto 1501
      if (debug.ge.1) write(iout1,1101) subname(irout)
      end if
c \end{enumerate}
c|_____________________________________________________________________S
c NAJ      end if
c|_____________________________________________________________________S
110   continue
111   continue
      nbfreroutv(1)=nbfreroutv(3)
c|_____________________________________________________________________S
c \chapter{Fin de programme.}
c|_____________________________________________________________________S
c \section{Contr\^ole de la bonne ex\'ecution.}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='m3d2uwv '
1501  continue
      do irout=1,3
        nbfreroutv(1)=max(nbfreroutv(1),nbfreroutv(irout+1))
      end do
c|_____________________________________________________________________S
c \section{Formats d'\'ecriture.}
1102  format('+ m3d2uwv ',65('+'),/, 
     &       '+ Appel de la routine :	',A25,'	',17X,' +',/,
     &       '+ 	',A65,' +')
1101  format('+ Sortie de la routine :	',A25,'	',17X,' +',/, 
     &       75('+'))
c
2101  format(8X,'---------- m3d2uwv ----------',/,
     & 8X,'Numero logique de frequence ',I3,/,
     & 8X,'sur ',I3,' frequence(s) demandee(s).',/,
     & 8X,'Frequence traitee en MHz ',F15.8,/,
     & 8X,'Longueur d''onde (en cm) ',F15.8,/,
     & 8X,'Rapport lambda/n = deltah, n=',F15.8,/,
     & 8X,'Nombre d''ondes par metre ',F15.8,/,
     & 8X,'Pulsation normalisee pour c=1 omega ',E15.8,/,
     & 8X,'---------- m3d2uwv ----------')
c
2102  format(8X,'---------- m3d2uwv ----------',/,
     & 8X,'Numero logique de frequence ',I3,/,
     & 8X,'sur ',I3,' frequence(s) demandee(s).',/,
     & 8X,'Pulsation normalisee pour c=1 omega ',E15.8,/,
     & 8X,'Incidence en theta ',/,
     & 16X,'Numero logique d''incidence ',I5,/,
     & 16X,'sur ',I5,' incidence(s) demandee(s).',/,
     & 16X,'soit une incidence de (degres) ',F15.8,/,
     & 8X,'Incidence en phi ',/,
     & 16X,'Numero logique d''incidence ',I5,/,
     & 16X,'sur ',I5,' incidence(s) demandee(s).',/,
     & 16X,'soit une incidence de (degres) ',F15.8,/,
     & 8X,'---------- m3d2uwv ----------')
c
2103  format(8X,'---------- m3d2uwv ----------',/,
     & 8X,'Observation en theta ',/,
     & 16X,'Debut ',F15.8,/,
     & 16X,'Pas ',F15.8,/,
     & 16X,'Nombre d''observation(s) demandee(s) ',I10,/,
     & 8X,'Observation en phi ',/,
     & 16X,'Debut ',F15.8,/,
     & 16X,'Pas ',F15.8,/,
     & 16X,'Nombre d''observation(s) demandee(s) ',I10,/,
     & 8X,'---------- m3d2uwv ----------')
c|_____________________________________________________________________S
c  \section{Message de fin}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='muwEnd'
      nbcall(irout)=nbcall(irout)+1
      mess3='Messages de fin'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call muwEnd(
     & g100,debug,iout1,
     & mem,irout,frestep,nbfreqv,tend,
     & subname,temps,nbcall,nbfreroutv,nbroutx)
      temps(irout) = temps(irout) + second() - taux
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c  \section{Estimation ``a posteriori'' du temps de calcul.}
      nbfreroutv(1)=nbfreroutv(1)+1
      irout=nbfreroutv(1)
      subname(irout)='muwTim'
      nbcall(irout)=nbcall(irout)+1
      mess3='Prevision du temps de calcul'
      if (debug.ge.1) write(iout1,1102) subname(irout),mess3
      taux = second()
      call muwTim(
     &           g100,debug,iout2,
     &           mem,nbiterv,nbroutv,
     &           nbeltv,nbsomv,nbarev,nbnodev,
     &           nbfacobjv,nbfactotv,nbelmatv,nbmatv,
     &           nbfreqv,nbfbv,
     &           nbroutx,subname,temps,nbcall
     &           )
      temps(irout) = temps(irout) + second() - taux
      if (debug.ge.1) write(iout1,1101) subname(irout)
c|_____________________________________________________________________S
c \section{Ecriture des temps d'ex\'ecution.}
      tend = second()-tstart
      write(iout1,*) 
      write(iout1,*) '-----------------------'
      write(iout1,*) '- BILAN DES TEMPS CPU -'
      write(iout1,*) '-----------------------'
      write(iout1,*) '  TEMPS TOTAL               : ',tend,' s '
      do irout=1,nbfreroutv(1)
        if (nbcall(irout).ge.1) then
        write(iout1,*) '-----------------------------------------------'
        write(iout1,*) 'Routine Number	: ',irout
        write(iout1,*) 'Routine Name		: ',subname(irout)
        write(iout1,*) '	Time		: ',temps(irout)
        write(iout1,*) '	Nb of Call	: ',nbcall(irout)
        end if
      end do
      write(iout1,*) '-----------------------------------------------'
      call stop(iout1,'m3d2uwv ',subname(nbfreroutv(1)-2))
c|_____________________________________________________________________S
501   end

      subroutine visuc(debug,dgpinv,iout1,precmail,lvois,
     &           nbfbx,nbeltx,nbelmatx,nbelnomaJmatx,nbarex,
     &           nbfbv,nbeltv,nbelmatv,nbelnomaJmatv,nbarev,
     &           CFF,CGG,CFG,CGF)
      IMPLICIT NONE
      integer nvisubfbx,nvisubeltx
      integer ndimxx,ndimyx
      parameter(nvisubfbx = 3,
     &          nvisubeltx = 65)
      parameter(ndimxx=2*nvisubfbx,
     &          ndimyx=2*nvisubfbx*nvisubeltx)
c
      integer debug,dgpinv,iout1
      real    precmail
      integer lvois
      integer nbfbx,nbeltx,nbelmatx,nbelnomaJmatx,nbarex
      integer nbfbv,nbeltv,nbelmatv,nbelnomaJmatv,nbarev
c
      complex CFF(nbfbx*nbfbx*nbeltx,nbarex)
      complex CGG(nbfbx*nbfbx*nbeltx,nbarex)
      complex CFG(nbfbx*nbfbx*(nbelmatx+nbelnomaJmatx),nbarex)
      complex CGF(nbfbx*nbfbx*(nbelmatx+nbelnomaJmatx),nbarex)
c
      real DDDD(ndimxx,ndimyx)
      real FFFF(ndimxx,ndimyx)
      real maxDDDD
      real minDDDD
      integer izeroDDD
      complex cmpaux
      complex prev
      real diff
c
      integer i,j,kel
      integer iCv,iCm,iCm2
      integer ArrStoiCv,ArrStoiCm
      integer ndimv
c
      if (debug.ge.dgpinv) then
      do i=1,2*nbfbv
      do j=1,2*nbfbv
      do kel=1,nbeltv
      DDDD(i,kel+(j-1)*nbeltv)=0.
      FFFF(i,kel+(j-1)*nbeltv)=0.
      end do
      end do
      end do
      ndimv=2*nbfbv
c
      do i=1,nbfbv
      do j=1,nbfbv
      do kel=1,nbeltv
      iCv=ArrStoiCv(i,j,kel,nbfbv,nbeltv)
      cmpaux = CFF(iCv,lvois)
      DDDD(i,kel+(j-1)*nbeltv)=real(cmpaux)
      FFFF(i,kel+(j-1)*nbeltv)=aimag(cmpaux)
      cmpaux = CGG(iCv,lvois)
      DDDD(i+nbfbv,kel+(j+nbfbv-1)*nbeltv)=real(cmpaux)
      FFFF(i+nbfbv,kel+(j+nbfbv-1)*nbeltv)=aimag(cmpaux)
      end do
      end do
      end do
c
      do i=1,nbfbv
      do j=1,nbfbv
      do kel=1,nbelmatv+nbelnomaJmatv
      iCm=ArrStoiCm(i,j,kel,nbfbv,nbelmatv,nbelnomaJmatv)
      cmpaux = CFG(iCm,lvois)
      DDDD(i,kel+(j+nbfbv-1)*nbeltv)=real(cmpaux)
      FFFF(i,kel+(j+nbfbv-1)*nbeltv)=aimag(cmpaux)
      iCm2=ArrStoiCm(j,i,kel,nbfbv,nbelmatv,nbelnomaJmatv)
      cmpaux = CGF(iCm2,lvois)
      DDDD(j+nbfbv,kel+(i-1)*nbeltv)=real(cmpaux)
      FFFF(j+nbfbv,kel+(i-1)*nbeltv)=aimag(cmpaux)
      end do
      end do
      end do
c
c
      minDDDD=999999.
      maxDDDD=-999999.
      izeroDDD=0
      do i=1,2*nbfbv
      do j=1,2*nbfbv
      do kel=1,nbeltv
      maxDDDD = max(DDDD(i,kel+(j-1)*nbeltv),maxDDDD)
      minDDDD = min(DDDD(i,kel+(j-1)*nbeltv),minDDDD)
      izeroDDD = izeroDDD + max(0,
     & nint(sign(1.,100.*precmail-abs(DDDD(i,kel+(j-1)*nbeltv)) )))
      end do
      end do
      end do
      write(6,*) '	maxDDDD=',maxDDDD
      write(6,*) '	minDDDD=',minDDDD
      write(6,*) '	izeroDDD=',izeroDDD
      write(6,*) '	nomat zero=',2*nbeltv*nbfbv**2

c
      print*,'Partie reelle'
      print*,'	Matrice C(*,',lvois,') '
      call psychematd(DDDD,ndimxx,ndimyx,ndimv)
      print*,'DDDD=',DDDD
      read (*,*)
      print*,'Partie imaginaire'
      print*,'	Matrice C(*,',lvois,') '
      call psychematd(FFFF,ndimxx,ndimyx,ndimv)
      print*,'FFFF=',FFFF
      read (*,*)
      else
        write(iout1,*) '	No psychematd'
      end if
c
      end

      program test

      subroutine psychematd(DDDD,ndimxx,ndimyx,dimz)
c|_____________________________________________________________________S
c \chapter{Organisation de la subroutine}
c \label{psychematd}
c \section{Objet de la subroutine psychematd}
c \begin{description} 
c \item[Auteur:] Emmanuelle Bonneaux CEA CEL-V DMA MCN NN SER.
c \item[Cr\'eation:] Programme cr\'e\'e le Fri Jan 26 15:55:53 MET 1996.
c \item[Modification:] Programme modifi\'e le Fri Jan 26 15:55:53 MET 1996.
c \item[Mise \`a jour:] Programme mis \`a jour le ?.
c \item[Status:] Loin d\^etre finie.
c \item[Intitul\'e:] psychematd
c \item[Objet:] Visualisation interactive de tableaux par psyche V1.
c \item[Synopsis:] Appeler l'aide sur mosaic.
c \item[Entr\'ee:] \hfill\noindent
c \begin{description}
c \item[DDDD:] Matrice \`a \'ecrire sur psyche.
c \item[nbfbx,nbeltx:]
c Tailles maximales des tableaux.
c \item[nbfbv,nbeltv:]
c Tailles effectives des tableaux.
c \end{description}
c \item[Sortie:] \hfill\noindent
c \begin{description}
c \item[Image] Psyche.
c \end{description}
c \end{description}
c|_____________________________________________________________________S
c \chapter{Explicatif.}
c \section{Pr\'eliminaires.}
c Pour utiliser cette routine, il faut pr\'evoir, avant de lancer
c psyche par la commande ``Psyche'', de
c \begin{enumerate}
c \item cr\'eer le directory images par
c| mkdir -p $HOME/images
c \item affecter les variables d'environnement
c| setenv PORT_SERVEUR 3333
c| setenv DESTIN_SP3 x11
c \item Relier le makefile \`a la librairie psyche. Ceci vous est expliqu\'e
c en vous logant sur une station.
c \item Pour un calcul sur CRAY, il faut mettre
c| . /usr/local/lm/bin/lm.profile
c dans le fichier ``.profile''
c \end{enumerate}
c \begin{remark}
c Le directory image n'est pas le directory de sauvegarde des images, mais
c c'est le directory de la variable \$IMAGES\_SP3. Par d\'efaut c'est
c /images/.temp.pr pour une sauvegarde ASCII
c \end{remark}
c \section{Fonctions Psyche utilis\'ees.}
c \begin{description}
c \item[spxia] Ouverture d'une configuration.
c \item[spxsai] Configuration \`a une valeur enti\`ere.
c \item[spxsar] Configuration \`a une valeur r\'eelle.
c \item[spxsac] Configuration \`a une valeur cha{\^{\i}}ne de caract\`eres.
c \item[spxopen] Ouverture d'une connexion : renvoie le num\'ero de la 
c connexion.
c \item[spxsv] Envoie de la configuration.
c \item[spx3prc] Fonction Psyche utilis\'ee.
c Trace la matrice DDDD(ndimxx,ndimyx).
c \item[spxpa] Nettoie la configuration.
c \item[spxsync] ``Synchronisation''.
c \item[spxclose] Fermeture de la connexion.
c \end{description}
c|_____________________________________________________________________S
c \chapter{Listing}
c \section{D\'eclaration}
c|_____________________________________________________________________S
c \subsection{Variables principales d'entr\'ee et de sortie}
c \begin{enumerate}
c \item Entr\'ee.
      IMPLICIT NONE
      integer ndimxx,ndimyx,dimz
      real    DDDD(ndimxx,ndimyx)
c \item Variables lcales, sp\'ecifiques \`a Psyche.
      integer taille
      integer spxia,spxopen
      parameter (taille=200)
      integer spxarg(taille)
      integer tailreelle,spxfile
      integer n
      character*1 titre
c \end{enumerate}
c|_____________________________________________________________________S
c \section{Cr\'eation du fichier de configuration}
c \subsection{Initialisation du fichier de configuration}
c \begin{enumerate}
c \item Initialisation du tableau de configuration spxarg \`a $0$.
      n=0
      tailreelle=spxia(spxarg,taille)
c \item Demande l'option $3$-D.
      if (n.lt.tailreelle) then
         call spxsai(spxarg,n,'option_3d_masque',0)
         n=n+1
      endif
c \item Point de vue (premi\`ere bissectrice).
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'ptvue_site',45.)
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'ptvue_azimuth',45.)
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'ptvue_roulis',0.)
         n=n+1
      endif
c \item Axes minimaux et maximaux en $x$, $y$ et $z$ \`a calculer d'apr\`es
c le graphe de la fonction DDDD. Mode automatique.
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'axe_x_min',0.)
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'axe_x_max',0.)
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'axe_y_min',0.)
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'axe_y_max',0.)
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'axe_z_min',0.)
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'axe_z_max',0.)
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'hauteur_zh_min',0.)
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsar(spxarg,n,'hauteur_zh_max',0.)
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsatr(spxarg,n,'hauteur_z',0,10)
         n=n+1
      endif
c \end{enumerate}
c|_____________________________________________________________________S
c \section{D\'efinition de l'interactivit\'e}
c On pr\'ecise si on travaille avec des fichiers (quand le programme a
c fini de tourner ou des sockets (interactivit\'e). On travaille ici
c avec des sockets.
c \begin{enumerate}
c \item ``Socket''.
      if (n.lt.tailreelle) then
         call spxsai(spxarg,n,'calcul_socket',0)
         n=n+1
      endif
c \item Diff\'erents titres.
c M\^eme s'il n'y a pas de titre il faut faire ceci pour le CRAY.
      titre=' '
      if (n.lt.tailreelle) then
         call spxsac(spxarg,n,'titre_valeur_gauche','Colonnes ')
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsac(spxarg,n,'titre_valeur_droit','Lignes ')
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsac(spxarg,n,'titre_valeur_haut','Blocs de couplages')
         n=n+1
      endif
      if (n.lt.tailreelle) then
         call spxsac(spxarg,n,'titre_valeur_bas','Matrice ')
         n=n+1
      endif
c \item Sauvegarde des fichiers de pts sous forme ``ASCII''.
      if (n.lt.tailreelle) then
         call spxsac(spxarg,n,'fichier_sauvegarde','ascii')
         n=n+1
      endif
c \item Sauvegarde automatique de la configuration
      if (n.lt.tailreelle) then
         call spxsai(spxarg,n,'config_sauvegarde',1)
         n=n+1
      endif
c \end{enumerate}
c|_____________________________________________________________________S
c \section{Ouverture de la connexion et envoi de la configuration}
c La quantit\'e $3333$ initialise la variable ``port\_serveur''.
      spxfile=spxopen('berry+3333++cessenat@ie32')
c Envoie de la configuration que l'on a d\'efinie au-dessus \`a psyche
c par l'interm\'ediaire du socket
      call spxsv(spxfile,spxarg,n)
      write(*,*)'configuration psyche envoyee'
c|_____________________________________________________________________S
c \section{Envois de la courbe}
c on envoie la courbe dans le socket
c nx = nombre de points en x absc tableau de taille ndimx.
      call spx3prc(ndimxx,ndimyx,DDDD,dimz,spxfile)
c|    call spx3rec(dimz,dimz,absc,ord,TabVal2D,ndimx,spxfile)
c|_____________________________________________________________________S
c \section{Fin}
c on nettoie le tableau de configuration
      call spxpa(spxarg,taille)
      n=0
c on remplit a nouveau le tableau de configuration pour declencher 
c le trace
      if (n.lt.tailreelle) then
         call spxsai(spxarg,n,'calcul_socket',1)
         n=n+1
      endif
      call spxsv(spxfile,spxarg,n)
c synchronisation
      call spxsync(spxfile)
c fermeture de la connexion
      call spxclose(spxfile)        
c|_____________________________________________________________________S
      end
