/***************************************************************/
/* binding FORTRAN anciens points d'entres en double precision */
/***************************************************************/

/* identification du source */

#ifndef lint
    static const char* const sccs_id = "%W% %G% Pierre Brochard";
#endif

/* includes */

#include "SpxP.h"
#include "narcisse.h"
#include "SpxFtnP.h"

/**********************************************/
/*  implementation                            */
/**********************************************/

/*************************************************************/
/* spx2mo4 appelable en FORTRAN = simple precision au sens C */
/* ou REAL*4 FORTRAN                                         */
/* sur cray float = double = 64 bits => identique a spx2mo   */
/*************************************************************/

void
#ifdef CRAY_PROTO
SPX2MO4(REEL4 xtab[],REEL4 ytab[],int* nx,_fcd tit1,_fcd tit2,
		_fcd ctith,_fcd ctitg,_fcd ctitb,_fcd ctitd,
		_fcd tex1,_fcd tex2,_fcd tex3,_fcd tex4,_fcd nomsp3)
#else
FUNCDECL(spx2mo4)(REEL4 xtab[],REEL4 ytab[],int* nx,char* tit1,char* tit2,
		char* ctith,char* ctitg,char* ctitb,char* ctitd,
		char* tex1,char* tex2,char* tex3,char* tex4,char* nomsp3,
		int l1,int l2,int l3,int l4,int l5,int l6,
		int l7,int l8,int l9,int l10,int l11)
#endif
{
#ifdef CRAY_PROTO
	char* temp_tit1 = SpxStrCopy(_fcdtocp(tit1),_fcdlen(tit1));
	char* temp_tit2 = SpxStrCopy(_fcdtocp(tit2),_fcdlen(tit2));
	char* temp_ctith = SpxStrCopy(_fcdtocp(ctith),_fcdlen(ctith));
	char* temp_ctitg = SpxStrCopy(_fcdtocp(ctitg),_fcdlen(ctitg));
	char* temp_ctitb = SpxStrCopy(_fcdtocp(ctitb),_fcdlen(ctitb));
	char* temp_ctitd = SpxStrCopy(_fcdtocp(ctitd),_fcdlen(ctitd));
	char* temp_tex1 = SpxStrCopy(_fcdtocp(tex1),_fcdlen(tex1));
	char* temp_tex2 = SpxStrCopy(_fcdtocp(tex2),_fcdlen(tex2));
	char* temp_tex3 = SpxStrCopy(_fcdtocp(tex3),_fcdlen(tex3));
	char* temp_tex4 = SpxStrCopy(_fcdtocp(tex4),_fcdlen(tex4));

	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_tit1 = SpxStrCopy(tit1,l1);
	char* temp_tit2 = SpxStrCopy(tit2,l2);
	char* temp_ctith = SpxStrCopy(ctith,l3);
	char* temp_ctitg = SpxStrCopy(ctitg,l4);
	char* temp_ctitb = SpxStrCopy(ctitb,l5);
	char* temp_ctitd = SpxStrCopy(ctitd,l6);
	char* temp_tex1 = SpxStrCopy(tex1,l7);
	char* temp_tex2 = SpxStrCopy(tex2,l8);
	char* temp_tex3 = SpxStrCopy(tex3,l9);
	char* temp_tex4 = SpxStrCopy(tex4,l10);

	char* temp_nomsp3 = SpxStrCopy(nomsp3,l11);
#endif
	SPXFILE* spx_file = NULL;
	SpxArg spx_arg[10];
	unsigned n = 0;

	SpxInitArg(spx_arg,10);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",-1);n++;

	SpxSetArgChar(&spx_arg[n],"axe_valeur_x",temp_tit1);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_y",temp_tit2);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_haut",temp_ctith);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_gauche",temp_ctitg);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_bas",temp_ctitb);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_droit",temp_ctitd);n++;
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex1,0);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex2,1);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex3,2);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex4,3);n++;

	spx_file = SpxOpen(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);

	free(temp_tit1);
	free(temp_tit2);
	free(temp_ctith);
	free(temp_ctitg);
	free(temp_ctitb);
	free(temp_ctitd);
	free(temp_tex1);
	free(temp_tex2);
	free(temp_tex3);
	free(temp_tex4);

	free(temp_nomsp3);

	Spx4MonoCourbe(xtab,ytab,*nx,spx_file);

	SpxClose(spx_file);
	SpxPurgeArg(spx_arg,10);
}

/*************************************************************/
/* spx2mu4 appelable en FORTRAN = simple precision au sens C */
/* sur cray float = double = 64 bits => identique a spx2mu   */
/*************************************************************/

void
#ifdef CRAY_PROTO
SPX2MU4(REEL4 xtab[],int* n1,REEL4 ytab[],int* n2,
       int nxsto[],int* ny,_fcd tit1,_fcd tit2,
       _fcd ctith,_fcd ctitg,_fcd ctitb,_fcd ctitd,
       _fcd tex1,_fcd tex2,_fcd tex3,_fcd tex4,_fcd nomsp3)
#else
FUNCDECL(spx2mu4)(REEL4 xtab[],int* n1,REEL4 ytab[],int* n2,
       int nxsto[],int* ny,char* tit1,char* tit2,
       char* ctith,char* ctitg,char* ctitb,char* ctitd,
       char* tex1,char* tex2,char* tex3,char* tex4,char* nomsp3,
       int l1,int l2,int l3,int l4,int l5,int l6,
       int l7,int l8,int l9,int l10,int l11)
#endif
{
#ifdef CRAY_PROTO
	char* temp_tit1 = SpxStrCopy(_fcdtocp(tit1),_fcdlen(tit1));
	char* temp_tit2 = SpxStrCopy(_fcdtocp(tit2),_fcdlen(tit2));
	char* temp_ctith = SpxStrCopy(_fcdtocp(ctith),_fcdlen(ctith));
	char* temp_ctitg = SpxStrCopy(_fcdtocp(ctitg),_fcdlen(ctitg));
	char* temp_ctitb = SpxStrCopy(_fcdtocp(ctitb),_fcdlen(ctitb));
	char* temp_ctitd = SpxStrCopy(_fcdtocp(ctitd),_fcdlen(ctitd));
	char* temp_tex1 = SpxStrCopy(_fcdtocp(tex1),_fcdlen(tex1));
	char* temp_tex2 = SpxStrCopy(_fcdtocp(tex2),_fcdlen(tex2));
	char* temp_tex3 = SpxStrCopy(_fcdtocp(tex3),_fcdlen(tex3));
	char* temp_tex4 = SpxStrCopy(_fcdtocp(tex4),_fcdlen(tex4));

	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_tit1 = SpxStrCopy(tit1,l1);
	char* temp_tit2 = SpxStrCopy(tit2,l2);
	char* temp_ctith = SpxStrCopy(ctith,l3);
	char* temp_ctitg = SpxStrCopy(ctitg,l4);
	char* temp_ctitb = SpxStrCopy(ctitb,l5);
	char* temp_ctitd = SpxStrCopy(ctitd,l6);
	char* temp_tex1 = SpxStrCopy(tex1,l7);
	char* temp_tex2 = SpxStrCopy(tex2,l8);
	char* temp_tex3 = SpxStrCopy(tex3,l9);
	char* temp_tex4 = SpxStrCopy(tex4,l10);

	char* temp_nomsp3 = SpxStrCopy(nomsp3,l11);
#endif
	SPXFILE* spx_file = NULL;
	SpxArg spx_arg[10];
	unsigned n = 0,compt = 0;
	int i = 0;
	REEL4* temp_x = NULL;
	REEL4* temp_y = NULL;

	SpxInitArg(spx_arg,10);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",-1);n++;

	SpxSetArgChar(&spx_arg[n],"axe_valeur_x",temp_tit1);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_y",temp_tit2);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_haut",temp_ctith);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_gauche",temp_ctitg);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_bas",temp_ctitb);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_droit",temp_ctitd);n++;
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex1,0);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex2,1);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex3,2);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex4,3);n++;

	spx_file = SpxOpen(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);

	free(temp_tit1);
	free(temp_tit2);
	free(temp_ctith);
	free(temp_ctitg);
	free(temp_ctitb);
	free(temp_ctitd);
	free(temp_tex1);
	free(temp_tex2);
	free(temp_tex3);
	free(temp_tex4);

	free(temp_nomsp3);

	for(i=0;i<*ny;i++)
        {
	    compt += nxsto[i];
	}
	
	temp_x = (REEL4*) malloc(compt*sizeof(REEL4));
	temp_y = (REEL4*) malloc(compt*sizeof(REEL4));

	for(i=0,compt=0;i<*ny;compt+=nxsto[i],i++)
        {
	    memcpy((char*) &temp_x[compt],(char*) &xtab[i*(*n1)],
			    sizeof(REEL4)*nxsto[i]);
	    memcpy((char*) &temp_y[compt],(char*) &ytab[i*(*n2)],
			    sizeof(REEL4)*nxsto[i]);
	}

	Spx4MulCourbe(temp_x,temp_y,nxsto,*ny,spx_file);

	free(temp_x);
	free(temp_y);

	SpxClose(spx_file);
	SpxPurgeArg(spx_arg,10);
}

/*************************************************************/
/* spx3prd appelable en FORTRAN = double precision au sens C */
/* sur cray float = double = 64 bits => identique a spx3pr   */
/*************************************************************/

void
#ifdef CRAY_PROTO
SPX3PR4(int* nx,int* ny,REEL4 z[],int* dimz,_fcd nomsp3)
#else
FUNCDECL(spx3pr4)(int* nx,int* ny,REEL4 z[],int* dimz,char* nomsp3,int l1)
#endif
{
#ifdef CRAY_PROTO
	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_nomsp3 = SpxStrCopy(nomsp3,l1);
#endif
	SPXFILE* spx_file = SpxOpen(temp_nomsp3);

	free(temp_nomsp3);

	Spx4PrintSurf(*nx,*ny,z,*dimz,spx_file);
	SpxClose(spx_file);
}

/*************************************************************/
/* spx3red appelable en FORTRAN = double precision au sens C */
/* sur cray float = double = 64 bits => identique a spx3re   */
/*************************************************************/

void
#ifdef CRAY_PROTO
SPX3RE4(int* nx,int* ny,REEL4 x[],REEL4 y[],REEL4 z[],int* dimz,
		_fcd tit1,_fcd tit2,_fcd tit3,
		_fcd ctith,_fcd ctitg,_fcd ctitb,_fcd ctitd,
		_fcd tex1,_fcd tex2,_fcd tex3,_fcd tex4,_fcd nomsp3)
#else
FUNCDECL(spx3re4)(int* nx,int* ny,REEL4 x[],REEL4 y[],REEL4 z[],int* dimz,
		char* tit1,char* tit2,char* tit3,
		char* ctith,char* ctitg,char* ctitb,char* ctitd,
		char* tex1,char* tex2,char* tex3,char* tex4,char* nomsp3,
		int l1,int l2,int l3,int l4,int l5,int l6,
		int l7,int l8,int l9,int l10,int l11,int l12)
#endif
{
#ifdef CRAY_PROTO
	char* temp_tit1 = SpxStrCopy(_fcdtocp(tit1),_fcdlen(tit1));
	char* temp_tit2 = SpxStrCopy(_fcdtocp(tit2),_fcdlen(tit2));
	char* temp_tit3 = SpxStrCopy(_fcdtocp(tit3),_fcdlen(tit3));
	char* temp_ctith = SpxStrCopy(_fcdtocp(ctith),_fcdlen(ctith));
	char* temp_ctitg = SpxStrCopy(_fcdtocp(ctitg),_fcdlen(ctitg));
	char* temp_ctitb = SpxStrCopy(_fcdtocp(ctitb),_fcdlen(ctitb));
	char* temp_ctitd = SpxStrCopy(_fcdtocp(ctitd),_fcdlen(ctitd));
	char* temp_tex1 = SpxStrCopy(_fcdtocp(tex1),_fcdlen(tex1));
	char* temp_tex2 = SpxStrCopy(_fcdtocp(tex2),_fcdlen(tex2));
	char* temp_tex3 = SpxStrCopy(_fcdtocp(tex3),_fcdlen(tex3));
	char* temp_tex4 = SpxStrCopy(_fcdtocp(tex4),_fcdlen(tex4));

	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_tit1 = SpxStrCopy(tit1,l1);
	char* temp_tit2 = SpxStrCopy(tit2,l2);
	char* temp_tit3 = SpxStrCopy(tit3,l3);
	char* temp_ctith = SpxStrCopy(ctith,l4);
	char* temp_ctitg = SpxStrCopy(ctitg,l5);
	char* temp_ctitb = SpxStrCopy(ctitb,l6);
	char* temp_ctitd = SpxStrCopy(ctitd,l7);
	char* temp_tex1 = SpxStrCopy(tex1,l8);
	char* temp_tex2 = SpxStrCopy(tex2,l9);
	char* temp_tex3 = SpxStrCopy(tex3,l10);
	char* temp_tex4 = SpxStrCopy(tex4,l11);

	char* temp_nomsp3 = SpxStrCopy(nomsp3,l12);
#endif
	SPXFILE* spx_file = NULL;
	SpxArg spx_arg[10];
	unsigned n = 0;

	SpxInitArg(spx_arg,10);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",-1);n++;

	SpxSetArgChar(&spx_arg[n],"axe_valeur_x",temp_tit1);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_y",temp_tit2);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_z",temp_tit3);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_haut",temp_ctith);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_gauche",temp_ctitg);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_bas",temp_ctitb);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_droit",temp_ctitd);n++;
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex1,0);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex2,1);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex3,2);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex4,3);n++;

	spx_file = SpxOpen(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);

	free(temp_tit1);
	free(temp_tit2);
	free(temp_tit3);
	free(temp_ctith);
	free(temp_ctitg);
	free(temp_ctitb);
	free(temp_ctitd);
	free(temp_tex1);
	free(temp_tex2);
	free(temp_tex3);
	free(temp_tex4);

	free(temp_nomsp3);

	Spx4Rect3d(*nx,*ny,x,y,z,*dimz,spx_file);

	SpxClose(spx_file);
	SpxPurgeArg(spx_arg,10);
}

/*************************************************************/
/* spx3ted appelable en FORTRAN = double precision au sens C */
/* sur cray float = double = 64 bits => identique a spx3te   */
/*************************************************************/

void
#ifdef CRAY_PROTO
SPX3TE4(int* nx,int* ny,REEL4 x[],int* dimx,REEL4 y[],int* dimy,
		REEL4 z[],int* dimz,_fcd tit1,_fcd tit2,_fcd tit3,
		_fcd ctith,_fcd ctitg,_fcd ctitb,_fcd ctitd,
		_fcd tex1,_fcd tex2,_fcd tex3,_fcd tex4,_fcd nomsp3)
#else
FUNCDECL(spx3te4)(int* nx,int* ny,REEL4 x[],int* dimx,REEL4 y[],int* dimy,
		REEL4 z[],int* dimz,char* tit1,char* tit2,char* tit3,
		char* ctith,char* ctitg,char* ctitb,char* ctitd,
		char* tex1,char* tex2,char* tex3,char* tex4,char* nomsp3,
		int l1,int l2,int l3,int l4,int l5,int l6,
		int l7,int l8,int l9,int l10,int l11,int l12)
#endif
{
#ifdef CRAY_PROTO
	char* temp_tit1 = SpxStrCopy(_fcdtocp(tit1),_fcdlen(tit1));
	char* temp_tit2 = SpxStrCopy(_fcdtocp(tit2),_fcdlen(tit2));
	char* temp_tit3 = SpxStrCopy(_fcdtocp(tit3),_fcdlen(tit3));
	char* temp_ctith = SpxStrCopy(_fcdtocp(ctith),_fcdlen(ctith));
	char* temp_ctitg = SpxStrCopy(_fcdtocp(ctitg),_fcdlen(ctitg));
	char* temp_ctitb = SpxStrCopy(_fcdtocp(ctitb),_fcdlen(ctitb));
	char* temp_ctitd = SpxStrCopy(_fcdtocp(ctitd),_fcdlen(ctitd));
	char* temp_tex1 = SpxStrCopy(_fcdtocp(tex1),_fcdlen(tex1));
	char* temp_tex2 = SpxStrCopy(_fcdtocp(tex2),_fcdlen(tex2));
	char* temp_tex3 = SpxStrCopy(_fcdtocp(tex3),_fcdlen(tex3));
	char* temp_tex4 = SpxStrCopy(_fcdtocp(tex4),_fcdlen(tex4));

	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_tit1 = SpxStrCopy(tit1,l1);
	char* temp_tit2 = SpxStrCopy(tit2,l2);
	char* temp_tit3 = SpxStrCopy(tit3,l3);
	char* temp_ctith = SpxStrCopy(ctith,l4);
	char* temp_ctitg = SpxStrCopy(ctitg,l5);
	char* temp_ctitb = SpxStrCopy(ctitb,l6);
	char* temp_ctitd = SpxStrCopy(ctitd,l7);
	char* temp_tex1 = SpxStrCopy(tex1,l8);
	char* temp_tex2 = SpxStrCopy(tex2,l9);
	char* temp_tex3 = SpxStrCopy(tex3,l10);
	char* temp_tex4 = SpxStrCopy(tex4,l11);

	char* temp_nomsp3 = SpxStrCopy(nomsp3,l12);
#endif
	SPXFILE* spx_file = NULL;
	SpxArg spx_arg[10];
	unsigned n = 0;

	SpxInitArg(spx_arg,10);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",-1);n++;

	SpxSetArgChar(&spx_arg[n],"axe_valeur_x",temp_tit1);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_y",temp_tit2);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_z",temp_tit3);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_haut",temp_ctith);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_gauche",temp_ctitg);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_bas",temp_ctitb);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_droit",temp_ctitd);n++;
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex1,0);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex2,1);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex3,2);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex4,3);n++;

	spx_file = SpxOpen(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);

	free(temp_tit1);
	free(temp_tit2);
	free(temp_tit3);
	free(temp_ctith);
	free(temp_ctitg);
	free(temp_ctitb);
	free(temp_ctitd);
	free(temp_tex1);
	free(temp_tex2);
	free(temp_tex3);
	free(temp_tex4);

	free(temp_nomsp3);

	Spx4Tetra3d(*nx,*ny,x,*dimx,y,*dimy,z,*dimz,spx_file);

	SpxClose(spx_file);
	SpxPurgeArg(spx_arg,10);
}

/*************************************************************/
/* spx4red appelable en FORTRAN = double precision au sens C */
/* sur cray float = double = 64 bits => identique a spx4re   */
/*************************************************************/

void
#ifdef CRAY_PROTO
SPX4RE4(int* nx,int* ny,REEL4 x[],REEL4 y[],REEL4 z[],int* dimz,
		REEL4 c[],int* dimc,_fcd tit1,_fcd tit2,_fcd tit3,
		_fcd ctith,_fcd ctitg,_fcd ctitb,_fcd ctitd,
		_fcd tex1,_fcd tex2,_fcd tex3,_fcd tex4,_fcd nomsp3)
#else
FUNCDECL(spx4re4)(int* nx,int* ny,REEL4 x[],REEL4 y[],REEL4 z[],int* dimz,
		REEL4 c[],int* dimc,char* tit1,char* tit2,char* tit3,
		char* ctith,char* ctitg,char* ctitb,char* ctitd,
		char* tex1,char* tex2,char* tex3,char* tex4,char* nomsp3,
		int l1,int l2,int l3,int l4,int l5,int l6,
		int l7,int l8,int l9,int l10,int l11,int l12)
#endif
{
#ifdef CRAY_PROTO
	char* temp_tit1 = SpxStrCopy(_fcdtocp(tit1),_fcdlen(tit1));
	char* temp_tit2 = SpxStrCopy(_fcdtocp(tit2),_fcdlen(tit2));
	char* temp_tit3 = SpxStrCopy(_fcdtocp(tit3),_fcdlen(tit3));
	char* temp_ctith = SpxStrCopy(_fcdtocp(ctith),_fcdlen(ctith));
	char* temp_ctitg = SpxStrCopy(_fcdtocp(ctitg),_fcdlen(ctitg));
	char* temp_ctitb = SpxStrCopy(_fcdtocp(ctitb),_fcdlen(ctitb));
	char* temp_ctitd = SpxStrCopy(_fcdtocp(ctitd),_fcdlen(ctitd));
	char* temp_tex1 = SpxStrCopy(_fcdtocp(tex1),_fcdlen(tex1));
	char* temp_tex2 = SpxStrCopy(_fcdtocp(tex2),_fcdlen(tex2));
	char* temp_tex3 = SpxStrCopy(_fcdtocp(tex3),_fcdlen(tex3));
	char* temp_tex4 = SpxStrCopy(_fcdtocp(tex4),_fcdlen(tex4));

	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_tit1 = SpxStrCopy(tit1,l1);
	char* temp_tit2 = SpxStrCopy(tit2,l2);
	char* temp_tit3 = SpxStrCopy(tit3,l3);
	char* temp_ctith = SpxStrCopy(ctith,l4);
	char* temp_ctitg = SpxStrCopy(ctitg,l5);
	char* temp_ctitb = SpxStrCopy(ctitb,l6);
	char* temp_ctitd = SpxStrCopy(ctitd,l7);
	char* temp_tex1 = SpxStrCopy(tex1,l8);
	char* temp_tex2 = SpxStrCopy(tex2,l9);
	char* temp_tex3 = SpxStrCopy(tex3,l10);
	char* temp_tex4 = SpxStrCopy(tex4,l11);

	char* temp_nomsp3 = SpxStrCopy(nomsp3,l12);
#endif
	SPXFILE* spx_file = NULL;
	SpxArg spx_arg[10];
	unsigned n = 0;

	SpxInitArg(spx_arg,10);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",-1);n++;

	SpxSetArgChar(&spx_arg[n],"axe_valeur_x",temp_tit1);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_y",temp_tit2);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_z",temp_tit3);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_haut",temp_ctith);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_gauche",temp_ctitg);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_bas",temp_ctitb);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_droit",temp_ctitd);n++;
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex1,0);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex2,1);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex3,2);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex4,3);n++;

	spx_file = SpxOpen(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);

	free(temp_tit1);
	free(temp_tit2);
	free(temp_tit3);
	free(temp_ctith);
	free(temp_ctitg);
	free(temp_ctitb);
	free(temp_ctitd);
	free(temp_tex1);
	free(temp_tex2);
	free(temp_tex3);
	free(temp_tex4);

	free(temp_nomsp3);

	Spx4Rect4d(*nx,*ny,x,y,z,*dimz,c,*dimc,spx_file);

	SpxClose(spx_file);
	SpxPurgeArg(spx_arg,10);
}

/*************************************************************/
/* spx4ted appelable en FORTRAN = double precision au sens C */
/* sur cray float = double = 64 bits => identique a spx4te   */
/*************************************************************/

void
#ifdef CRAY_PROTO
SPX4TE4(int* nx,int* ny,REEL4 x[],int* dimx,REEL4 y[],int* dimy,
		REEL4 z[],int* dimz,REEL4 c[],int* dimc,
		_fcd tit1,_fcd tit2,_fcd tit3,
		_fcd ctith,_fcd ctitg,_fcd ctitb,_fcd ctitd,
		_fcd tex1,_fcd tex2,_fcd tex3,_fcd tex4,_fcd nomsp3)
#else
FUNCDECL(spx4te4)(int* nx,int* ny,REEL4 x[],int* dimx,REEL4 y[],int* dimy,
		REEL4 z[],int* dimz,REEL4 c[],int* dimc,
		char* tit1,char* tit2,char* tit3,
		char* ctith,char* ctitg,char* ctitb,char* ctitd,
		char* tex1,char* tex2,char* tex3,char* tex4,char* nomsp3,
		int l1,int l2,int l3,int l4,int l5,int l6,
		int l7,int l8,int l9,int l10,int l11,int l12)
#endif
{
#ifdef CRAY_PROTO
	char* temp_tit1 = SpxStrCopy(_fcdtocp(tit1),_fcdlen(tit1));
	char* temp_tit2 = SpxStrCopy(_fcdtocp(tit2),_fcdlen(tit2));
	char* temp_tit3 = SpxStrCopy(_fcdtocp(tit3),_fcdlen(tit3));
	char* temp_ctith = SpxStrCopy(_fcdtocp(ctith),_fcdlen(ctith));
	char* temp_ctitg = SpxStrCopy(_fcdtocp(ctitg),_fcdlen(ctitg));
	char* temp_ctitb = SpxStrCopy(_fcdtocp(ctitb),_fcdlen(ctitb));
	char* temp_ctitd = SpxStrCopy(_fcdtocp(ctitd),_fcdlen(ctitd));
	char* temp_tex1 = SpxStrCopy(_fcdtocp(tex1),_fcdlen(tex1));
	char* temp_tex2 = SpxStrCopy(_fcdtocp(tex2),_fcdlen(tex2));
	char* temp_tex3 = SpxStrCopy(_fcdtocp(tex3),_fcdlen(tex3));
	char* temp_tex4 = SpxStrCopy(_fcdtocp(tex4),_fcdlen(tex4));

	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_tit1 = SpxStrCopy(tit1,l1);
	char* temp_tit2 = SpxStrCopy(tit2,l2);
	char* temp_tit3 = SpxStrCopy(tit3,l3);
	char* temp_ctith = SpxStrCopy(ctith,l4);
	char* temp_ctitg = SpxStrCopy(ctitg,l5);
	char* temp_ctitb = SpxStrCopy(ctitb,l6);
	char* temp_ctitd = SpxStrCopy(ctitd,l7);
	char* temp_tex1 = SpxStrCopy(tex1,l8);
	char* temp_tex2 = SpxStrCopy(tex2,l9);
	char* temp_tex3 = SpxStrCopy(tex3,l10);
	char* temp_tex4 = SpxStrCopy(tex4,l11);

	char* temp_nomsp3 = SpxStrCopy(nomsp3,l12);
#endif
	SPXFILE* spx_file = NULL;
	SpxArg spx_arg[10];
	unsigned n = 0;

	SpxInitArg(spx_arg,10);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",-1);n++;

	SpxSetArgChar(&spx_arg[n],"axe_valeur_x",temp_tit1);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_y",temp_tit2);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_z",temp_tit3);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_haut",temp_ctith);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_gauche",temp_ctitg);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_bas",temp_ctitb);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_droit",temp_ctitd);n++;
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex1,0);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex2,1);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex3,2);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex4,3);n++;

	spx_file = SpxOpen(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);

	free(temp_tit1);
	free(temp_tit2);
	free(temp_tit3);
	free(temp_ctith);
	free(temp_ctitg);
	free(temp_ctitb);
	free(temp_ctitd);
	free(temp_tex1);
	free(temp_tex2);
	free(temp_tex3);
	free(temp_tex4);

	free(temp_nomsp3);

	Spx4Tetra4d(*nx,*ny,x,*dimx,y,*dimy,z,*dimz,c,*dimc,spx_file);

	SpxClose(spx_file);
	SpxPurgeArg(spx_arg,10);
}

/*************************************************************/
/* spx4nsd appelable en FORTRAN = double precision au sens C */
/* sur cray float = double = 64 bits => identique a spx4ns   */
/*************************************************************/

void
#ifdef CRAY_PROTO
SPX4NS4(int* npoints,REEL4 x[],REEL4 y[],REEL4 z[],REEL4 c[],
		int* nmailles,int* dimmailles,int mailles[],
		_fcd tit1,_fcd tit2,_fcd tit3,
		_fcd ctith,_fcd ctitg,_fcd ctitb,_fcd ctitd,
		_fcd tex1,_fcd tex2,_fcd tex3,_fcd tex4,_fcd nomsp3)
#else
FUNCDECL(spx4ns4)(int* npoints,REEL4 x[],REEL4 y[],REEL4 z[],REEL4 c[],
		int* nmailles,int* dimmailles,int mailles[],
		char* tit1,char* tit2,char* tit3,
		char* ctith,char* ctitg,char* ctitb,char* ctitd,
		char* tex1,char* tex2,char* tex3,char* tex4,char* nomsp3,
		int l1,int l2,int l3,int l4,int l5,int l6,
		int l7,int l8,int l9,int l10,int l11,int l12)
#endif
{
#ifdef CRAY_PROTO
	char* temp_tit1 = SpxStrCopy(_fcdtocp(tit1),_fcdlen(tit1));
	char* temp_tit2 = SpxStrCopy(_fcdtocp(tit2),_fcdlen(tit2));
	char* temp_tit3 = SpxStrCopy(_fcdtocp(tit3),_fcdlen(tit3));
	char* temp_ctith = SpxStrCopy(_fcdtocp(ctith),_fcdlen(ctith));
	char* temp_ctitg = SpxStrCopy(_fcdtocp(ctitg),_fcdlen(ctitg));
	char* temp_ctitb = SpxStrCopy(_fcdtocp(ctitb),_fcdlen(ctitb));
	char* temp_ctitd = SpxStrCopy(_fcdtocp(ctitd),_fcdlen(ctitd));
	char* temp_tex1 = SpxStrCopy(_fcdtocp(tex1),_fcdlen(tex1));
	char* temp_tex2 = SpxStrCopy(_fcdtocp(tex2),_fcdlen(tex2));
	char* temp_tex3 = SpxStrCopy(_fcdtocp(tex3),_fcdlen(tex3));
	char* temp_tex4 = SpxStrCopy(_fcdtocp(tex4),_fcdlen(tex4));

	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_tit1 = SpxStrCopy(tit1,l1);
	char* temp_tit2 = SpxStrCopy(tit2,l2);
	char* temp_tit3 = SpxStrCopy(tit3,l3);
	char* temp_ctith = SpxStrCopy(ctith,l4);
	char* temp_ctitg = SpxStrCopy(ctitg,l5);
	char* temp_ctitb = SpxStrCopy(ctitb,l6);
	char* temp_ctitd = SpxStrCopy(ctitd,l7);
	char* temp_tex1 = SpxStrCopy(tex1,l8);
	char* temp_tex2 = SpxStrCopy(tex2,l9);
	char* temp_tex3 = SpxStrCopy(tex3,l10);
	char* temp_tex4 = SpxStrCopy(tex4,l11);

	char* temp_nomsp3 = SpxStrCopy(nomsp3,l12);
#endif
	SPXFILE* spx_file = NULL;
	SpxArg spx_arg[10];
	unsigned n = 0;

	SpxInitArg(spx_arg,10);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",-1);n++;

	SpxSetArgChar(&spx_arg[n],"axe_valeur_x",temp_tit1);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_y",temp_tit2);n++;
	SpxSetArgChar(&spx_arg[n],"axe_valeur_z",temp_tit3);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_haut",temp_ctith);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_gauche",temp_ctitg);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_bas",temp_ctitb);n++;
	SpxSetArgChar(&spx_arg[n],"titre_valeur_droit",temp_ctitd);n++;
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex1,0);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex2,1);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex3,2);
	SpxSetArgTabChar(&spx_arg[n],"texte_valeur",temp_tex4,3);n++;

	spx_file = SpxOpen(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);

	free(temp_tit1);
	free(temp_tit2);
	free(temp_tit3);
	free(temp_ctith);
	free(temp_ctitg);
	free(temp_ctitb);
	free(temp_ctitd);
	free(temp_tex1);
	free(temp_tex2);
	free(temp_tex3);
	free(temp_tex4);

	free(temp_nomsp3);

	Spx4NonStruc4d(*npoints,x,y,z,c,*nmailles,*dimmailles,mailles,spx_file);

	SpxClose(spx_file);
	SpxPurgeArg(spx_arg,10);
}

