/* identification du source */

#ifndef lint
    static const char* const sccs_id = "%W% %G% Pierre Brochard";
#endif

#include "SpxFtnP.h"

#ifdef NX_NOSOULIGNE

#include "SpxOpen.h"
#include "SpxFtnBis.h"

/*--------------------------------------------------------------*/
/*    binding fortran avec _ pour AIX et HPUX                   */
/*    Pour ceux qui ne compilent pas avec l'option par defaut.  */
/*--------------------------------------------------------------*/

/* spxgc appelable en FORTRAN */

void
spxgc_(REEL_S* x,REEL_S* y,IntFtn* spx_file)
{
	spxgc(x,y,spx_file);
}

/* spx2gc appelable en FORTRAN */

void
spx2gc_(REEL_S* x,REEL_S* y,IntFtn* spx_file)
{
	spx2gc(x,y,spx_file);
}

/* spx3gc : binding FORTRAN de SpxGetCoord3d */

void
spx3gc_(REEL_S* x,REEL_S* y,REEL_S* z,IntFtn* spx_file)
{
	spx3gc(x,y,z,spx_file);
}

/* spx3gcm : binding FORTRAN de SpxGetCoord3dMaille */

void
spx3gcm_(REEL_S* x,REEL_S* y,REEL_S* z,int* num_maille,
		int* num_bloc,IntFtn* spx_file)
{
	spx3gcm(x,y,z,num_maille,num_bloc,spx_file);
}

/* spxia appelable en FORTRAN */

int
spxia_(int spx_arg[],int* taille)
{
	return spxia(spx_arg,taille);
}

/* spxpa appelable en FORTRAN */

void
spxpa_(int spx_arg[],int* taille)
{
	spxpa(spx_arg,taille);
}

/* spxvpa appelable en FORTRAN */

void
spxvpa_(IntFtn* spx_file)
{
	spxvpa(spx_file);
}

/* spxsai appelable en FORTRAN */

void
spxsai_(int spx_arg[],int* num,char* name,int* val,int lname)
{
	spxsai(spx_arg,num,name,val,lname);
}

/* spxvsai appelable en FORTRAN */

void
spxvsai_(IntFtn* spx_file,char* name,int* val,int lname)
{
	spxvsai(spx_file,name,val,lname);
}

/* spxsar appelable en FORTRAN */

void
spxsar_(int spx_arg[],int* num,char* name,REEL_S* val,int lname)
{
	spxsar(spx_arg,num,name,val,lname);
}

/* spxvsar appelable en FORTRAN */

void
spxvsar_(IntFtn* spx_file,char* name,REEL_S* val,int lname)
{
	spxvsar(spx_file,name,val,lname);
}

/* spxsac appelable en FORTRAN */

void
spxsac_(int spx_arg[],int* num,char* name,char* val,int lname,int lval)
{
	spxsac(spx_arg,num,name,val,lname,lval);
}

/* spxvsac appelable en FORTRAN */

void
spxvsac_(IntFtn* spx_file,char* name,char* val,int lname,int lval)
{
	spxvsac(spx_file,name,val,lname,lval);
}

/* spxsati appelable en FORTRAN */

void
spxsati_(int spx_arg[],int* num,char* name,int* val,
		int* indice,int lname)
{
	spxsati(spx_arg,num,name,val,indice,lname);
}

/* spxvsati appelable en FORTRAN */

void
spxvsati_(IntFtn* spx_file,char* name,int* val,int* indice,int lname)
{
	spxvsati(spx_file,name,val,indice,lname);
}

/* spxsatr appelable en FORTRAN */

void
spxsatr_(int spx_arg[],int* num,char* name,REEL_S* val,
		int* indice,int lname)
{
	spxsatr(spx_arg,num,name,val,indice,lname);
}

/* spxvsatr appelable en FORTRAN */

void
spxvsatr_(IntFtn* spx_file,char* name,REEL_S* val,int* indice,int lname)
{
	spxvsatr(spx_file,name,val,indice,lname);
}

/* spxsatc appelable en FORTRAN */

void
spxsatc_(int spx_arg[],int* num,char* name,char* val,int* indice,
		int lname,int lval)
{
	spxsatc(spx_arg,num,name,val,indice,lname,lval);
}

/* spxvsatc appelable en FORTRAN */

void
spxvsatc_(IntFtn* spx_file,char* name,char* val,int* indice,
		int lname,int lval)
{
	spxvsatc(spx_file,name,val,indice,lname,lval);
}

/* spxsv appelable en FORTRAN */

void
spxsv_(IntFtn* fd,int spx_arg[],int* taille)
{
	spxsv(fd,spx_arg,taille);
}

/* spxvsv appelable en FORTRAN */

void
spxvsv_(IntFtn* fd)
{
	spxvsv(fd);
}

/* spxopenr appelable en FORTRAN (subroutine au lieu de fonction) */

void
spxopenr_(char* name /* in */,IntFtn* fd /* out */,int lname /* in */)
{
	spxopenr(name,fd,lname);
}

/* spxopen appelable en FORTRAN */

IntFtn
spxopen_(char* name,int lname)
{
	return spxopen(name,lname);
}

/* spcopenr appelable en FORTRAN (subroutine au lieu de fonction) */

void
spcopenr_(char* name /* in */,IntFtn* fd /* out */,int lname /* in */)
{
	spcopenr(name,fd,lname);
}

/* spcopen appelable en FORTRAN */

IntFtn
spcopen_(char* name,int lname)
{
	return spcopen(name,lname);
}

/* spxsync appelable en FORTRAN */

void
spxsync_(IntFtn* fd)
{
	spxsync(fd);
}

/* spxclose appelable en FORTRAN */

void
spxclose_(IntFtn* fd)
{
	spxclose(fd);
}

/*****************************************************************/
/*  routines envoyant des donnees numeriques (binaire ou ASCII)  */
/*****************************************************************/

/* spx2moc appelable en FORTRAN */

void
spx2moc_(REEL_S xtab[],REEL_S ytab[],int* nx,IntFtn* spx_file)
{
	spx2moc(xtab,ytab,nx,spx_file);
}

/* spx2muc appelable en FORTRAN */

void
spx2muc_(REEL_S xtab[],REEL_S ytab[],int nxsto[],int* ny,IntFtn* spx_file)
{
	spx2muc(xtab,ytab,nxsto,ny,spx_file);
}

/* spx3prc appelable en FORTRAN */

void
spx3prc_(int* nx,int* ny,REEL_S z[],int* dimz,IntFtn* spx_file)
{
	spx3prc(nx,ny,z,dimz,spx_file);
}

/* spx3rec appelable en FORTRAN */

void
spx3rec_(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		IntFtn* spx_file)
{
	spx3rec(nx,ny,x,y,z,dimz,spx_file);
}

/* spx3recm appelable en FORTRAN (m pour donnees aux mailles) */

void
spx3recm_(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		IntFtn* spx_file)
{
	spx3recm(nx,ny,x,y,z,dimz,spx_file);
}

/* spx3tec appelable en FORTRAN */

void
spx3tec_(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,IntFtn* spx_file)
{
	spx3tec(nx,ny,x,dimx,y,dimy,z,dimz,spx_file);
}

/* spx3tecm appelable en FORTRAN (m pour donnees aux mailles) */

void
spx3tecm_(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,IntFtn* spx_file)
{
	spx3tecm(nx,ny,x,dimx,y,dimy,z,dimz,spx_file);
}

/* spx4rec appelable en FORTRAN */

void
spx4rec_(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		REEL_S c[],int* dimc,IntFtn* spx_file)
{
	spx4rec(nx,ny,x,y,z,dimz,c,dimc,spx_file);
}

/* spx4recm appelable en FORTRAN (m pour donnees aux mailles) */

void
spx4recm_(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		REEL_S c[],int* dimc,IntFtn* spx_file)
{
	spx4recm(nx,ny,x,y,z,dimz,c,dimc,spx_file);
}

/* spx4tec appelable en FORTRAN */

void
spx4tec_(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,REEL_S c[],int* dimc,IntFtn* spx_file)
{
	spx4tec(nx,ny,x,dimx,y,dimy,z,dimz,c,dimc,spx_file);
}

/* spx4tecm appelable en FORTRAN (m pour donnees aux mailles) */

void
spx4tecm_(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,REEL_S c[],int* dimc,IntFtn* spx_file)
{
	spx4tecm(nx,ny,x,dimx,y,dimy,z,dimz,c,dimc,spx_file);
}

/* spx4nsc appelable en FORTRAN */

void
spx4nsc_(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nmailles,int* dimmailles,int mailles[],IntFtn* spx_file)
{
	spx4nsc(npoints,x,y,z,c,nmailles,dimmailles,mailles,spx_file);
}

/* spx4nscm appelable en FORTRAN (m pour donnees aux mailles) */

void
spx4nscm_(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nmailles,int* dimmailles,int mailles[],IntFtn* spx_file)
{
	spx4nscm(npoints,x,y,z,c,nmailles,dimmailles,mailles,spx_file);
}

/* spx4nscb appelable en FORTRAN (b pour donnees aux bras) */

void
spx4nscb_(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nmailles,int* dimmailles,int mailles[],
		int* nbras,int bras[],IntFtn* spx_file)
{
	spx4nscb(npoints,x,y,z,c,nmailles,dimmailles,mailles,nbras,bras,
			spx_file);
}

/* spx4pec appelable en FORTRAN (SpxPointsEpais4d) */

void
spx4pec_(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		IntFtn* spx_file)
{
	spx4pec(npoints,x,y,z,c,spx_file);
}

/* spx4ppc appelable en FORTRAN (SpxPointsPixel4d) */

void
spx4ppc_(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		IntFtn* spx_file)
{
	spx4ppc(npoints,x,y,z,c,spx_file);
}

/* spx4parec appelable en FORTRAN */

void
spx4parec_(int* nx,int* ny,int* nz,REEL_S x[],REEL_S y[],REEL_S z[],
		REEL_S c[],int* dimc1,int* dimc2,IntFtn* spx_file)
{
	spx4parec(nx,ny,nz,x,y,z,c,dimc1,dimc2,spx_file);
}

/*************************************************************************/
/* spxgda appelable en FORTRAN                                           */
/*									 */
/* proto fortran :                                                       */
/* integer spxgda                                                        */
/*                                                                       */
/* integer function spxgda(dimbloc,dimdon,dimc,dimmai,dimvol,            */
/*		x,y,z,c,nbloc,nx,ny,nz,                                  */
/*		type,typec,typemailles,                                  */
/*		nmailles,dimmailles,mailles,                             */
/*		nvolumes,dimvolumes,volumes,spx_file)                    */
/* integer dimbloc 2eme dim des tableaux x,y,z,c,mailles,volumes         */
/*   et 1ere dim des tableaux nx,ny,nz,type,typec,typemailles,           */
/*   nmailles,dimmailles,nvolumes,dimvolumes  (en entree)                */
/* integer dimxy 1ere dim des tableaux x,y    (en entree)                */
/* integer dimz 1ere dim du tableau z         (en entree)                */
/* integer dimc   1ere dim du tableau c       (en entree)                */
/* integer dimmai 1ere dim du tableau mailles  (en entree)               */
/* integer dimvol 1ere dim du tableau volumes   (en entree)              */
/* real x(dimdon,dimbloc),y(dimdon,dimbloc),z(dimdon,dimbloc) (en retour)*/
/* real c(dimc,dimbloc)                       (en retour)                */
/* integer nbloc nombre de blocs lus (en retour)                         */
/* integer nx(dimbloc),ny(dimbloc),nz(dimbloc) (en retour)               */
/* integer type(dimbloc),typec(dimbloc),typemailles(dimbloc) (en retour) */
/* integer nmailles(dimbloc),dimmailles(dimbloc) (en retour)             */
/* integer nvolumes(dimbloc),dimvolumes(dimbloc) (en retour)             */
/* integer mailles(dimmai,dimbloc) (en retour)                           */
/* integer volumes(dimvol,dimbloc) (en retour)                           */
/* integer spx_file (en entree)  donne par appel a spcopen               */
/* spxgda vaut 1 en retour si l'une des dimensions est trop petite pour  */
/*   contenir les donnees lues                                           */
/* spxgda vaut 0 en retour si tout va bien                               */
/* spxgda vaut -1 si spx_file vaut 0 (fichier non ouvert par spcopen     */
/*************************************************************************/

int
spxgda_(int* dimbloc,int* dimxy,int* dimz,int* dimc,int* dimmai,
		int* dimvol,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nbloc,int nx[],int ny[],int nz[],
		int type[],int typec[],int typemailles[],
		int nmailles[],int dimmailles[],int mailles[],
		int nvolumes[],int dimvolumes[],int volumes[],IntFtn* spx_file)
{
	return spxgda(dimbloc,dimxy,dimz,dimc,dimmai,
		dimvol,x,y,z,c,nbloc,nx,ny,nz,type,
		typec,typemailles,nmailles,
		dimmailles,mailles,nvolumes,dimvolumes,volumes,
		spx_file);
}

/**********************************************************************/
/*      Fonction FORTRAN SPXQRY                                       */
/*      le code retour indique la presence du serveur Narcisse :        */
/*          1 => Narcisse existe a coup sur                             */
/*          -1 => Narcisse n'existe pas                                 */
/*      nom_fichier est le nom fourni en entree.                      */
/*          Il est complete par la variable d'environnement DEST_SP3  */
/**********************************************************************/

int
spxqry_(char* nom_fichier,int lnom)
{
	return spxqry(nom_fichier,lnom);
}

/**********************************************************************/
/*      Fonction FORTRAN SPXWHC                                       */
/*      le code retour indique la presence du serveur Narcisse :        */
/*       >= 1 => Narcisse existe a coup sur (il faut "NARCISSE.n"         */
/*               ou rien ou 0 dans le nom du fichier ou comme champ   */
/*               port de DEST_SP3) et on renvoit le numero du Narcisse  */
/*               contacte                                             */
/*          -1 => Narcisse n'existe pas a coup sur                      */
/*          0 => Narcisse existe mais on ne donne pas son numero        */
/*      nom_fichier est le nom fourni en entree.                      */
/*          Il est complete par la variable d'environnement DEST_SP3  */
/**********************************************************************/

int
spxwhc_(char* nom_fichier,int lnom)
{
	return spxwhc(nom_fichier,lnom);
}

#endif /* NX_NOSOULIGNE */
