/* identification du source */

#ifndef lint
    static const char* const sccs_id = "%W% %G% P. Brochard";
#endif

#include "SpxP.h"
#include "SpxObjets.h"
#include "SpxFtnP.h"

/*--------------------------------------------------------------*/
/*    nouveau binding fortran                                   */
/*--------------------------------------------------------------*/

/* spxos = binding FORTRAN de SpxObjetSphere */
/* call spxos(ox (coord x centre sphere),oy,oz,ray (longueur du rayon),
   valc (grandeur physique => representable par Narcisse avec une couleur),
   def (nombre de mailles sur un meridien et 1/2 parallele),
   spx_file (renvoye par SPXOPEN)) */

void
#ifdef CRAY_PROTO
SPXOS(REEL_S* ox,REEL_S* oy,REEL_S* oz,REEL_S* ray,REEL_S* valc,int* def,
		IntFtn* spx_file)
#else
FUNCDECL(spxos)(REEL_S* ox,REEL_S* oy,REEL_S* oz,REEL_S* ray,REEL_S* valc,
		int* def,IntFtn* spx_file)
#endif
{
	SpxObjetSphere(*ox,*oy,*oz,*ray,*valc,
			(unsigned) (*def),(SPXFILE*) (*spx_file));
}

/* spxoc = binding FORTRAN de SpxObjetCylindre */
/* call spxoc(ox1 (coord x 1er point sur l'axe du cylindre),oy1,oz1,
   decal1 (decalage extremite 1 sur l'axe par rapport au 1er point sur
   axe du cylindre en positif ou negatif),

        !==================================!
        !decal1                      decal2!
    ----x------x-------------------x-------x---------
        !    point 1            point 2    !
        !==================================!*/

/* ox2 (coord x 2eme point sur l'axe du cylindre),oy2,oz2,
   decal2 (decalage extremite 2 sur l'axe par rapport au 1er point sur
   axe du cylindre en positif ou negatif),
   ray (longueur du rayon),
   valc (grandeur physique => representable par Narcisse avec une couleur),
   def (nombre de mailles sur une section circulaire du cylindre),
   spx_file (renvoye par SPXOPEN)) */

void
#ifdef CRAY_PROTO
SPXOC(REEL_S* ox1,REEL_S* oy1,REEL_S* oz1,REEL_S* decal1,
		REEL_S* ox2,REEL_S* oy2,REEL_S* oz2,REEL_S* decal2,
		REEL_S* ray,REEL_S* valc,int* def,
		IntFtn* spx_file)
#else
FUNCDECL(spxoc)(REEL_S* ox1,REEL_S* oy1,REEL_S* oz1,REEL_S* decal1,
		REEL_S* ox2,REEL_S* oy2,REEL_S* oz2,REEL_S* decal2,
		REEL_S* ray,REEL_S* valc,int* def,
		IntFtn* spx_file)
#endif
{
	SpxObjetCylindre(*ox1,*oy1,*oz1,*decal1,
			*ox2,*oy2,*oz2,*decal2,*ray,*valc,
			(unsigned) (*def),(SPXFILE*) (*spx_file));
}

/* spxcc = binding FORTRAN de SpxCollectionCercles */
/* call spxcc(ox (tableau des coord x des centres des cercles mailles),oy,oz,
   oc (4d),nval (nbre de cercles), rmin (rayon minimal), rmax (rayone maximal),
   def (nombre de cotes sur le cercle aproxime par un polygone regulier),
   spx_file (renvoye par SPXOPEN)) */

void
#ifdef CRAY_PROTO
SPXCC(REEL_S ox[],REEL_S oy[],REEL_S oz[],REEL_S oc[],
		int* nval,REEL_S* rmin,REEL_S* rmax,int* def,
		IntFtn* spx_file)
#else
FUNCDECL(spxcc)(REEL_S ox[],REEL_S oy[],REEL_S oz[],REEL_S oc[],
		int* nval,REEL_S* rmin,REEL_S* rmax,int* def,
		IntFtn* spx_file)
#endif
{
	SpxCollectionCercles(ox,oy,oz,oc,(unsigned) (*nval),
			*rmin,*rmax,(unsigned) (*def),(SPXFILE*) (*spx_file));
}

/* spxcv = binding FORTRAN de SpxCollectionVecteurs */
/* call spxcv(ox (tableau des coord x des origines des vecteurs),oy,oz,
   oc (4d),vx (tab des coords x du vecteur), vy, vz, nval (nbre de vecteurs),
   rmin (rayon minimal), rmax (rayone maximal),
   spx_file (renvoye par SPXOPEN)) */

void
#ifdef CRAY_PROTO
SPXCV(REEL_S ox[],REEL_S oy[],REEL_S oz[],REEL_S oc[],
		REEL_S vx[],REEL_S vy[],REEL_S vz[],
		int* nval,REEL_S* rmin,REEL_S* rmax,
		IntFtn* spx_file)
#else
FUNCDECL(spxcv)(REEL_S ox[],REEL_S oy[],REEL_S oz[],REEL_S oc[],
		REEL_S vx[],REEL_S vy[],REEL_S vz[],
		int* nval,REEL_S* rmin,REEL_S* rmax,
		IntFtn* spx_file)
#endif
{
	SpxCollectionVecteurs(ox,oy,oz,oc,vx,vy,vz,(unsigned) (*nval),
			*rmin,*rmax,(SPXFILE*) (*spx_file));
}

/* fin fichier */
