/* identification du source */

#ifndef lint
    static const char sccs_id[] = "%W% %G% Pierre Brochard";
#endif

#include "SpxP.h"
#include "SpxVisuDri.h"
#include "nx.h"
#include "SpxParRect4d.h"
#include "SpxOpenP.h"

static void
SpxGenParRect4d(int nx,int ny,int nz,void* x,void* y,void* z,
		void* c,int dimc1,int dimc2,int precision,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;

	if(!spx_file) return;

	if(SpxDebut(spx_file)) return;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp = 0;
            int i = 0,j = 0;
	    char* const cc = (char*) c;

	    SPXDEFICODLMOT(icod,lmot,precision);
            temp = -8;
            fnxwriti(file_fich,1,&temp);
            fnxwriti(file_fich,1,&nx);
            fnxwriti(file_fich,1,&ny);
            fnxwriti(file_fich,1,&nz);
    
	    fnxwritt(file_fich,nx,x,icod,"sp");
	    fnxwritt(file_fich,ny,y,icod,"sp");
	    fnxwritt(file_fich,nz,z,icod,"sp");
    
	    for(i=0;i<nz;i++)
	    {

		for(j=0;j<ny;j++)
		{
		    fnxwritt(file_fich,nx,cc+(j*dimc1+i*dimc1*dimc2)*lmot,
				    icod,"sp");
		}

	    }
        
            temp = 0;
            fnxwriti(file_fich,1,&temp);
    
            fnxwrite(file_fich,"@",1);
	}
	else
	{
	    char temp[80];
	    int i = 0,j = 0,k = 0;

	    for(;i<nx;i++)
	    {

		for(j=0;j<ny;j++)
		{

		    for(k=0;k<nz;k++)
		    {
			SPXASCII(precision,
					sprintf(temp,"%g %g %g %g\n",
							((REEL4*) x)[i],
							((REEL4*) y)[j],
							((REEL4*) z)[k],
							((REEL4*) c)[i+
							j*dimc1+k*dimc1*dimc2]),
					sprintf(temp,"%g %g %g %g\n",
							((REEL_S*) x)[i],
							((REEL_S*) y)[j],
							((REEL_S*) z)[k],
							((REEL_S*) c)[i+
							j*dimc1+k*dimc1*dimc2]),
					sprintf(temp,"%g %g %g %g\n",
							((REEL*) x)[i],
							((REEL*) y)[j],
							((REEL*) z)[k],
							((REEL*) c)[i+
							j*dimc1+k*dimc1*dimc2]));
			fnxwrite(file_fich,temp,strlen(temp));
		    }

		    if(j != ny-1)
		    {
			sprintf(temp,"~d\n");
			fnxwrite(file_fich,temp,strlen(temp));
		    }
		    else if(i != nx-1)
		    {
			sprintf(temp,"~e\n");
			fnxwrite(file_fich,temp,strlen(temp));
		    }
		    else
		    {
			sprintf(temp,"~f\n");
			fnxwrite(file_fich,temp,strlen(temp));
		    }

		}

	    }

	}

	fnxflush(file_fich);
	SpxFin(spx_file);
}

void
SpxParRect4d(int nx,int ny,int nz,REEL_S x[],REEL_S y[],REEL_S z[],
		REEL_S c[],int dimc1,int dimc2,SPXFILE* spx_file)
{
	SpxGenParRect4d(nx,ny,nz,x,y,z,c,dimc1,dimc2,SPXREAL,spx_file);
}

/* double precision (transmis en ieee 32 bits) */

void
SpxDParRect4d(int nx,int ny,int nz,REEL x[],REEL y[],REEL z[],
		REEL c[],int dimc1,int dimc2,SPXFILE* spx_file)
{
	SpxGenParRect4d(nx,ny,nz,x,y,z,c,dimc1,dimc2,SPXDOUBLEPRECISION,
			spx_file);
}

/* REAL*4 (transmis en ieee 32 bits) */

void
Spx4ParRect4d(int nx,int ny,int nz,REEL4 x[],REEL4 y[],REEL4 z[],
		REEL4 c[],int dimc1,int dimc2,SPXFILE* spx_file)
{
	SpxGenParRect4d(nx,ny,nz,x,y,z,c,dimc1,dimc2,SPXREAL4,spx_file);
}

/* REAL*8 (transmis en ieee 32 bits) */

void
Spx8ParRect4d(int nx,int ny,int nz,REEL8 x[],REEL8 y[],REEL8 z[],
		REEL8 c[],int dimc1,int dimc2,SPXFILE* spx_file)
{
#if defined(CRAY)
	SpxGenParRect4d(nx,ny,nz,x,y,z,c,dimc1,dimc2,SPXREAL,spx_file);
#else
	SpxGenParRect4d(nx,ny,nz,x,y,z,c,dimc1,dimc2,SPXDOUBLEPRECISION,
			spx_file);
#endif
}
