/* identification du source */

#ifndef lint
    static const char* const sccs_id = "%W% %G% P. Brochard";
#endif

/* includes */

#include "SpxP.h"
#include "SpxSetColor.h"
#include "SpxVisuDri.h"
#include "nx.h"
#include "SpxOpenP.h"

/*****************************************************************/
/*  envoi d'une carte de couleurs (format COL)                   */
/*****************************************************************/

void
SpxSetColor(const char* type,const char* tabcol,SPXFILE* spx_file)
{
	FILE* file_fich;

	if(!spx_file) return;

	file_fich = spx_file->file;

	if(spx_file->type == SPXSOCKETCOL)
	{
	    char temp[128];
	    unsigned ltemp;

	    strcpy(temp,"\n###COL.");

	    if(!strcmp(type,"pal") || !strcmp(type,"col") ||
			    !strcmp(type,"fond"))
	    {
		strcat(temp,type);
	    }
	    else
	    {
		strcat(temp,"pal");
	    }

	    strcat(temp,"###\n");
	    ltemp = strlen(temp);
	    fnxwrite(file_fich,temp,ltemp);
	    fnxwrite(file_fich,(void*) tabcol,strlen(tabcol));
	    fnxwrite(file_fich,temp,ltemp);
	    fnxflush(file_fich);
	}
	else if(spx_file->type == SPXFICHIERCOL)
	{
	    char file_temp[MAX_FILENAME_LENGTH];
	    char* nomfich = spx_file->nom_fichier;
	    char* marqueur = strstr(nomfich,".col");
	    int delta;

	    if(marqueur)
	    {
		delta = marqueur-nomfich;

		if(!memcmp(nomfich+delta-2,".c",2) ||
			!memcmp(nomfich+delta-2,".f",2) ||
			!memcmp(nomfich+delta-2,".p",2))
		    delta -= 2;

	    }
	    else
	    {
		delta = strlen(nomfich);
	    }

	    memcpy(file_temp,nomfich,delta);
	    file_temp[delta] = '\0';

	    if(!strcmp(type,"col"))
	    {
		sprintf(file_temp+delta,"%5d",spx_file->compteur_fichier_c_col);
		SpxRemplaceBlanc(file_temp+delta);
		memcpy(file_temp+delta+5,".c",3);
		spx_file->compteur_fichier_c_col++;
	    }
	    else if(!strcmp(type,"pal"))
	    {
		sprintf(file_temp+delta,"%5d",spx_file->compteur_fichier_p_col);
		SpxRemplaceBlanc(file_temp+delta);
		memcpy(file_temp+delta+5,".p",3);
		spx_file->compteur_fichier_p_col++;
	    }
	    else if(!strcmp(type,"fond"))
	    {
		sprintf(file_temp+delta,"%5d",spx_file->compteur_fichier_f_col);
		SpxRemplaceBlanc(file_temp+delta);
		memcpy(file_temp+delta+5,".f",3);
		spx_file->compteur_fichier_f_col++;
	    }
	    else /* format pal dans ce cas */
	    {
		sprintf(file_temp+delta,"%5d",spx_file->compteur_fichier_p_col);
		SpxRemplaceBlanc(file_temp+delta);
		memcpy(file_temp+delta+5,".p",3);
		spx_file->compteur_fichier_p_col++;
	    }

	    strcat(file_temp,marqueur);
	    file_fich = fnxopen(file_temp,"w");

	    if(!file_fich)
	    {
		fprintf(stderr,"Pb ouverture fichier : SpxSetColor a echoue\n");

		if(!strcmp(type,"col"))
		{
		    spx_file->compteur_fichier_c_col--;
		}
		else if(!strcmp(type,"pal"))
		{
		    spx_file->compteur_fichier_p_col--;
		}
		else if(!strcmp(type,"fond"))
		{
		    spx_file->compteur_fichier_f_col--;
		}
		else
		{
		    spx_file->compteur_fichier_p_col--;
		}

		return;
	    }

	    fnxwrite(file_fich,(void*) tabcol,strlen(tabcol));
	    fnxclose(file_fich);
	}
	else if(spx_file->type == SPXVISU)
	{
	    char pathrc[MAX_FILENAME_LENGTH];
	    char* suffixecol = ".col";
	    char nomfich[MAX_FILENAME_LENGTH];

	    if(!strcmp(type,"col"))
	    {
		suffixecol = ".c.col";
	    }
	    else if(!strcmp(type,"pal"))
	    {
		suffixecol = ".p.col";
	    }
	    else if(!strcmp(type,"fond"))
	    {
		suffixecol = ".f.col";
	    }
	    else
	    {
		spx_file->compteur_fichier_p_col--;
	    }

	    memset(pathrc,0,sizeof(pathrc));
	    SpxOpenFichier(pathrc,suffixecol);
	    strcpy(nomfich,pathrc);
	    file_fich = fnxopen(nomfich,"w");
	    fnxwrite(file_fich,(void*) tabcol,strlen(tabcol));
	    fnxclose(file_fich);
	    SpxFermeFichier(pathrc);
	}
	else
	{
	    fprintf(stderr,"Pb SpxSetColor\n");
	}

}
