#include "cameleon/C5inout.h"
#include "cameleon/C5tabconfig.h"
#include "C5quicksort.h"
#include "C5constant.h"

struct SccsIdC5Inout
{
	static const char* const sccs_id;
};

const char* const SccsIdC5Inout::sccs_id = "%W% %G% Pierre Brochard";

C5InOut::C5InOut(P4Boolean desalloue) :
		_tabc(desalloue),
		_taiinit(),
		_tai(),
		_val(),
		_depass()
{
}

C5InOut::~C5InOut()
{
}

int C5InOut::C5LectureConfig(int taii,int tair,int taic,
		char* motcle[],int vali[],REEL_S valr[],char* valc[],
		char* nomfich)
{

    // creation objet config

	TabC5ConfigEntSor tabc;
	int i;

	for(i=0;i<taii;i++)
	{
	    C5Config* c = new C5ConfigInt(motcle[i],vali[i]);
	    tabc.Ajoute(c);
	}

	int j;

	for(i=0,j=taii;i<tair;i++,j++)
	{
	    C5Config* c = new C5ConfigReel(motcle[j],valr[i]);
	    tabc.Ajoute(c);
	}

	for(i=0,j=taii+tair;i<taic;i++,j++)
	{
	    C5Config* c = new C5ConfigChar(motcle[j],valc[i]);
	    tabc.Ajoute(c);
	}

    // lecture config

	ifstream leconf(nomfich);
	TabC5ConfigEntSor tabl;

	leconf >> tabl;
	leconf.close();
	tabc = tabl;

    // recopie dans les arguments d'entree

	for(i=0;i<taii;i++)
	{
	    vali[i] = tabc[i].IntA();
	}

	for(i=0,j=taii;i<tair;i++,j++)
	{
	    valr[i] = tabc[j].ReelA();
	}

	for(i=0,j=taii+tair;i<taic;i++,j++)
	{
	    strcpy(valc[i],tabc[j].CharA());
	}

	return 0;
}

int C5InOut::C5EcritureConfig(int taii,int tair,int taic,
		char* motcle[],int vali[],REEL_S valr[],char* valc[],
		char* nomfich)
{

    // creation objet config

	TabC5ConfigEntSor tabc;
	int i;

	for(i=0;i<taii;i++)
	{
	    C5Config* c = new C5ConfigInt(motcle[i],vali[i]);
	    tabc.Ajoute(c);
	}

	int j;

	for(i=0,j=taii;i<tair;i++,j++)
	{
	    C5Config* c = new C5ConfigReel(motcle[j],valr[i]);
	    tabc.Ajoute(c);
	}

	for(i=0,j=taii+tair;i<taic;i++,j++)
	{
	    C5Config* c = new C5ConfigChar(motcle[j],valc[i]);
	    tabc.Ajoute(c);
	}

    // ecriture config

	if(strcmp(nomfich,"cout") != 0)
	{
	    ofstream leconf(nomfich);

	    leconf << tabc;
	    leconf.close();
	}
	else
	{
	    cout << tabc;
	}

	return 0;
}

int C5InOut::C5AjouteConfig(TabC5ConfigEntSor& tabconf)
{
	int taille = tabconf;

	for(int i=0;i<taille;i++)
	{

	// bug ibmrs6000 AIX xlC ci-dessous : mauvais passage d'argument
	// on passe par une variable intermediare 
	// (ce que le compilateur devrait faire tout seul !!!!!!)

	    ptrC5Config ptrcf = &tabconf[i];

	    _tabc.Ajoute(ptrcf);
	    _taiinit.Ajoute(0);
	    _depass.Ajoute(-1);
	}

	_tai.Ajoute(taille);
	_val.Ajoute((char*) NULL);

	return 0;
}

int C5InOut::C5AjouteConfig(int taii,char* motcle[],int vali[])
{

	for(int i=0;i<taii;i++)
	{
	    C5Config* c = new C5ConfigInt(motcle[i],vali[i]);

	    _tabc.Ajoute(c);
	    _taiinit.Ajoute(1);
	    _depass.Ajoute(-1);
	}

	_tai.Ajoute(taii);
	_val.Ajoute((char*) vali);

	return 0;
}

int C5InOut::C5AjouteConfig(int taii,char* identif,char* motcle[],int vali[])
{

	for(int i=0;i<taii;i++)
	{
	    C5Config* c = new C5ConfigInt(identif,motcle[i],vali[i]);
	    _tabc.Ajoute(c);
	    _taiinit.Ajoute(1);
	    _depass.Ajoute(-1);
	}

	_tai.Ajoute(taii);
	_val.Ajoute((char*) vali);

	return 0;
}

int C5InOut::C5AjouteConfig(int tair,char* motcle[],REEL_S valr[])
{

	for(int i=0;i<tair;i++)
	{
	    C5Config* c = new C5ConfigReel(motcle[i],valr[i]);
	    _tabc.Ajoute(c);
	    _taiinit.Ajoute(1);
	    _depass.Ajoute(-1);
	}

	_tai.Ajoute(tair);
	_val.Ajoute((char*) valr);

	return 0;
}

int C5InOut::C5AjouteConfig(int tair,char* identif,char* motcle[],REEL_S valr[])
{

	for(int i=0;i<tair;i++)
	{
	    C5Config* c = new C5ConfigReel(identif,motcle[i],valr[i]);
	    _tabc.Ajoute(c);
	    _taiinit.Ajoute(1);
	    _depass.Ajoute(-1);
	}

	_tai.Ajoute(tair);
	_val.Ajoute((char*) valr);

	return 0;
}

int C5InOut::C5AjouteConfig(int taic,S6constPString motcle[],char* valc[])
{

	for(int i=0;i<taic;i++)
	{
	    C5Config* c = new C5ConfigChar(motcle[i],valc[i]);
	    _tabc.Ajoute(c);
	    _taiinit.Ajoute(int(strlen(valc[i])));
	    _depass.Ajoute(-1);
	}

	_tai.Ajoute(taic);
	_val.Ajoute((char*) valc);

	return 0;
}

int C5InOut::C5AjouteConfig(int taic,char* identif,char* motcle[],char* valc[])
{

	for(int i=0;i<taic;i++)
	{
	    C5Config* c = new C5ConfigChar(identif,motcle[i],valc[i]);
	    _tabc.Ajoute(c);
	    _taiinit.Ajoute(int(strlen(valc[i])));
	    _depass.Ajoute(-1);
	}

	_tai.Ajoute(taic);
	_val.Ajoute((char*) valc);

	return 0;
}

int C5InOut::C5AjouteConfig(char* motcle,const int taille,int vali[])
{
	C5Config* c = new C5ConfigTabInt(motcle,taille,vali);
	_tabc.Ajoute(c);
	_taiinit.Ajoute(taille);
	_depass.Ajoute(-1);

	_tai.Ajoute(1);
	_val.Ajoute((char*) vali);

	return 0;
}

int C5InOut::C5AjouteConfig(char* identif,char* motcle,const int taille,
		int vali[])
{
	C5Config* c = new C5ConfigTabInt(identif,motcle,taille,vali);
	_tabc.Ajoute(c);
	_taiinit.Ajoute(taille);
	_depass.Ajoute(-1);

	_tai.Ajoute(1);
	_val.Ajoute((char*) vali);

	return 0;
}

int C5InOut::C5AjouteConfig(char* motcle,const int taille,REEL_S valr[])
{
	C5Config* c = new C5ConfigTabReel(motcle,taille,valr);
	_tabc.Ajoute(c);
	_taiinit.Ajoute(taille);
	_depass.Ajoute(-1);

	_tai.Ajoute(1);
	_val.Ajoute((char*) valr);

	return 0;
}

int C5InOut::C5AjouteConfig(char* identif,char* motcle,const int taille,
		REEL_S valr[])
{
	C5Config* c = new C5ConfigTabReel(identif,motcle,taille,valr);
	_tabc.Ajoute(c);
	_taiinit.Ajoute(taille);
	_depass.Ajoute(-1);

	_tai.Ajoute(1);
	_val.Ajoute((char*) valr);

	return 0;
}

int C5InOut::C5EnleveConfig()
{
	const unsigned tai = _tabc;

	for(unsigned i=0;i<tai;i++)
	{

	    if(_taiinit(i) != 0)
	    {
		C5Config* c = &_tabc[i];
		delete c;
	    }

	}

	_tabc.Enleve();
	_taiinit.Enleve();
	_tai.Enleve();
	_val.Enleve();
	_depass.Enleve();

	return 0;
}

int C5InOut::C5NettoieConfig()
{
	const unsigned tai = _tai;

	for(unsigned i=0,k=0;i<tai;i++)
	{
	    _tabc[k].Enleve(_val(i));
	    k += max(0,_tai(i));
	}

	return 0;
}

int C5InOut::C5LectureConfig(const char* const nomfich)
{
    // lecture fichier ou chaine de caractere dans tabl puis affectation a _tabc

	if(!nomfich) return -1;

	TabC5ConfigEntSor tabl;
	int ier = 0;

	if(!strcmp(nomfich,"cin"))
	{
	// cas standard input

	    cin >> tabl;
	    _tabc = tabl;
	}
	else if(!strncmp(nomfich,"@@@@",4))
	{
	// cas lecture dans une chaine de caracteres
	// avec cxx sous OSF1_V4 la chaine que istrstream peut lire
	// doit-etre un char* et non un const char*

	    const size_t lnomficht = strlen(nomfich)+1;
	    char* const nomficht = new char[lnomficht];

	    memcpy(nomficht,nomfich,lnomficht);

	    {
		istrstream leconf(nomficht);

		leconf >> tabl;
	    }

	    _tabc = tabl;
	    delete[] nomficht;
	}
	else if(!strcmp(nomfich,"####"))
	{
	// cas lecture de variables d'environnement

	    const unsigned tai = _tabc;

	    for(unsigned j=0;j<tai;j++)
	    {
		const char* const name = _tabc[j].Name();
		const char* const val = getenv(name);

		if(val)
		{
		    const size_t lname = strlen(name);
		    const size_t lval = strlen(val);
		    const size_t lptos = lname + lval + 5;
		    char* const ptos = new char[lptos];

		    memcpy(ptos,name,lname);
		    memcpy(ptos+lname," \"",2);
		    memcpy(ptos+lname+2,val,lval);
		    memcpy(ptos+lptos-3,"\" ",3);

		    {
			istrstream leconf(ptos);
			C5Config& cc = _tabc[j];

			leconf >> cc;
		    }

		    delete[] ptos;
		}
		else
		{
		    cout << "C5InOut> pas de variable definie : " <<
			name << endl;
		}

	    }

	}
	else
	{
	// cas lecture dans un fichier

	    cout << "C5InOut> nom fichier config " << nomfich << endl;

	    ifstream leconf(nomfich);

	    if(leconf && !leconf.eof())
	    {
		leconf.seekg(0);
		leconf >> tabl;
	    }

	    _tabc = tabl;
	}

    // recopie dans les arguments dont les pointeurs sont membres prives

	const unsigned tai = _tai;

	for(unsigned i=0,k=0;i<tai;i++)
	{
	    const int taii = _tai(i);

	    for(int j=0;j<taii;j++,k++)
	    {

		if(_val(i))
		{
		    int taille = _taiinit(k);
		    int ierp = _tabc[k].Val(_val(i),j,taille);

		    ier = max(ier,ierp);

		    if(ierp == 1)
		    {
			_depass.ModVal(taille,k);
		    }
		    else
		    {
			_depass.ModVal(-1,k);
		    }

		}

	    }

	}

	return ier;
}

int C5InOut::C5DepassConfig(const int taille,int depass[])
{

    // depass doit etre alloue par l'utilisateur a la taille
    // donnee par taille (egale ou superieure au nombre de mots cles empiles
    // avec les C5AjouteConfig)

    // n'a de sens que si on a lu une config

	int tai = _depass;
	const void* dep = _depass;

	tai = min(taille,tai);
	memcpy(depass,dep,tai*sizeof(int));

	return 0;
}

int C5InOut::C5LectureConfig(const int num,const int taille)
{

    // on relit _tabc pour le num ieme mot cle avec la taille taille
    // on suppose qu'une config fichier ou chaine de caracteres
    // a deja ete lue
    // utile si des allocations utilisateurs sont insuffisantes
    // il realloue et relit _tabc qui lui etait dynamique

    // recopie dans les arguments dont les pointeurs sont membres prives

	int ier = 0;

	_taiinit[num] = taille;

	unsigned tai = _tai;
	unsigned i;
	int k;

	for(i=0,k=0;i<tai;i++)
	{
	    const int taii = _tai(i);

	    for(int j=0;j<taii;j++,k++)
	    {

		if(k == num)
		{
		    int taill = _taiinit(k);

		    ier = _tabc[k].Val(_val(i),j,taill);

		    if(ier == 1)
		    {
			_depass.ModVal(taill,num);
		    }
		    else
		    {
			_depass.ModVal(-1,num);
		    }

		}

	    }

	}

	return ier;
}


int C5InOut::C5EcritureConfig(const char* const nomfich)
{
    // on ecrit

	if(strcmp(nomfich,"cout") != 0)
	{
	    ofstream leconf(nomfich);

	    leconf << _tabc;
	    leconf.close();
	}
	else
	{
	    cout << _tabc << flush;
	}

	return 0;
}

// ************************************************************************
//     remplacement de la chaine ident_ori par ident_new dans tous les
//     C5Config de _tabc
// ************************************************************************

void
C5InOut::C5ChangeIdent(const char* const ident_ori,
			const char* const ident_new)
{
    // on remplace la chaine ident_ori dans les _tabc[i].Name() par
    // ident_new

	const unsigned taille = _tabc;
	const size_t taille_ori = strlen(ident_ori);
	const size_t taille_new = strlen(ident_new);

	for(register unsigned i=0;i<taille;i++)
	{
	    char* const name = _tabc[i].Name();

	    if(!strncmp(name,ident_ori,taille_ori))
	    {
		const char* const name_suite = name+taille_ori;
		const size_t taille_name_suite = strlen(name_suite)+1;
		char* name_new = new char[taille_new+taille_name_suite];

		memcpy(name_new,ident_new,taille_new);
		memcpy(name_new+taille_new,name_suite,taille_name_suite);

		delete[] name;

		_tabc[i].Name(name_new);
	    }

	}

}
