/* identification du source */

struct SccsIdP4alea
{
	static const char* const sccs_id;
};

const char* const SccsIdP4alea::sccs_id = "%W% %G% Pierre Brochard";

/* includes */

#include <sys/times.h>
#include <limits.h>
#include <stdio.h>

// Ajout PB 24/03/2004
#if defined(OSF1)
extern "C" {
#  include <sys/resource.h>
}
#else
#  include <sys/resource.h>
#endif

#include "dinosaure/P4alea.h"

// *********************************************************
//     generateur de nbre aleatoire (ref RANF de CRAY)
//     sizeof(unsigned) >= 32
// *********************************************************

#ifndef CRAY

static unsigned seedhi = 0x2bc6;
static unsigned seedlo = 0x8cfe166d;

double
alea()
{
	register const unsigned mhi = 0x2875;
	register const unsigned mlohi = 0xa2e7;
	register const unsigned mlolo = 0xb175;

	register const unsigned seedlohi = (0xffff0000 & seedlo) >> 16;
	register const unsigned seedlolo = 0xffff & seedlo;

	seedlo = seedlolo*mlolo + ((seedlolo*mlohi + seedlohi*mlolo) << 16);
	seedlo &= 0xffffffff;
	seedhi = ((seedlolo*mlohi + seedlohi*mlolo) >> 16) +
		seedlohi*mlohi + seedhi*mlolo + mhi*seedlolo;
	seedhi &= 0xffff;

	register const double den = 0x10000;
	register const double se1 = double(seedhi)/den;
	register double se2 = double(seedlo)/den;

	se2 /= den;
	se2 /= den;

	return se1 + se2;
}

void
racinet()
{
	rusage usage;

	getrusage(RUSAGE_SELF,&usage);

	const time_t trac = time(NULL);
	const long rac = trac + usage.ru_nvcsw + usage.ru_nivcsw +
		usage.ru_msgsnd + usage.ru_msgrcv + usage.ru_utime.tv_usec +
		usage.ru_stime.tv_usec;

	seedhi = rac & 0xffff;
	seedlo = rac & 0xffffffff;

	struct tms mytms;

	const clock_t rac2 = times(&mytms);
	unsigned nbturn = rac2 & 0xff;

        while(nbturn--) alea();

}
#endif
