struct SccsIdS6String
{
	static const char* const sccs_id;
};

const char* const SccsIdS6String::sccs_id = "%W% %G% Pierre Brochard";

#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include "P4types.h"
#include "dinosaure/S6string.h"
#include "U8vararg.h"

char*
S6strdup(const char* s1)
{
	char* snew;

	if(!s1)
	{
	    snew = new char[1];

	    if(snew) snew[0] = '\0';

	}
	else
	{
	    register const unsigned taille = strlen(s1) + 1;

	    snew = new char[taille];

	    if(snew) memcpy(snew, s1,taille);

	}

	return snew;
}

char*
S6strcasedup(const char* s1)
{
	char* snew;

	if(!s1)
	{
	    snew = new char[1];

	    if(snew) snew[0] = '\0';

	}
	else
	{
	    register const unsigned taille = strlen(s1) + 1;

	    snew = new char[taille];

	    if(snew)
	    {
		register const unsigned taille1 = taille - 1;

		for(register unsigned i=0;i<taille1;i++)
		{
		    snew[i] = tolower(s1[i]);
		}
	
		snew[taille1] = '\0';
	    }

	}

	return snew;
}

void
S6String::vainit(const char* const str,...)
{
    // on s'arrete au premier NULL

	_str = NULL;

	if(!str) return;

	va_list ap;
	const unsigned lstr = strlen(str);
	unsigned lstrt = lstr;

	va_start(ap,str);

	const char* str1 = va_arg(ap,char*);

	while(str1)
	{
	    lstrt += strlen(str1);
	    str1 = va_arg(ap,char*);
	}

	va_end(ap);

	char* const strt = new char[lstrt+1];

	va_start(ap,str);
	str1 = va_arg(ap,char*);
	lstrt = lstr;
	memcpy(strt,str,lstr);

	while(str1)
	{
	    const unsigned lstr1 = strlen(str1);

	    memcpy(strt+lstrt,str1,lstr1);
	    lstrt += lstr1;
	    str1 = va_arg(ap,char*);
	}

	strt[lstrt] = '\0';
	va_end(ap);

	_str = strt;
}

void
S6String::vainit(unsigned nstr,const char* const str,...)
{
    // on ne s'arrete pas au premier NULL mais on borne a 128 le nombre
    // de strings sans le dire (nstr est le nombre de strings)

	const unsigned nstr_reel = nstr > 128 ? 128 : nstr;
	unsigned lstrsto[128];

	va_list ap;
	unsigned lstrt = lstrsto[0] = str ? strlen(str) : 0;

	va_start(ap,str);

	const char* str1 = va_arg(ap,char*);
	unsigned i;

	for(i = 1;i<nstr_reel;i++)
	{
	    const unsigned lstr1 = str1 ? strlen(str1) : 0;

	    lstrsto[i] = lstr1;
	    lstrt += lstr1;
	    str1 = va_arg(ap,char*);
	}

	va_end(ap);

	char* const strt = new char[lstrt+1];

	va_start(ap,str);
	str1 = str;
	lstrt = 0;

	for(i = 0;i<nstr_reel;i++)
	{
	    const unsigned lstr1 = lstrsto[i];

	    if(lstr1) memcpy(strt+lstrt,str1,lstr1);

	    lstrt += lstr1;
	    str1 = va_arg(ap,char*);
	}

	strt[lstrt] = '\0';
	va_end(ap);

	_str = strt;
}

char*
S6String::init(const double val) const
{
	const unsigned lbuf = 32;
	char buf[lbuf];

	sprintf(buf,"%g",val);

	const size_t lstr = strlen(buf);
	char* str = NULL;

	if(lstr < lbuf)
	{
	    str = new char[lstr+1];

	    if(str)
	    {
		memcpy(str,buf,lstr+1);
	    }

	}

	return str;
}

char*
S6String::init(const int val) const
{
	const unsigned lbuf = 4*sizeof(unsigned);
	char buf[lbuf];

	sprintf(buf,"%d",val);

	const size_t lstr = strlen(buf);
	char* str = NULL;

	if(lstr < lbuf)
	{
	    str = new char[lstr+1];

	    if(str)
	    {
		memcpy(str,buf,lstr+1);
	    }

	}

	return str;
}

char*
S6String::init(const int val,const unsigned tval) const
{
	const unsigned lbuf = 4*sizeof(unsigned);
	const unsigned tval_reel = tval <= lbuf ? tval : lbuf;
	const unsigned lbuf0 = 2*lbuf+3;
	char buf0[lbuf0];
	char buf[lbuf];

	sprintf(buf0,"%%%d.%dd",tval_reel,tval_reel);

	const size_t lstr0 = strlen(buf0);
	char* str = NULL;

	if(lstr0 < lbuf0)
	{
	    sprintf(buf,buf0,val);

	    const size_t lstr = strlen(buf);

	    if(lstr < lbuf)
	    {
		str = new char[lstr+1];

		if(str)
		{
		    memcpy(str,buf,lstr+1);
		}

	    }

	}

	return str;
}

char*
S6String::init(const char* const str) const
{
	char* strt = NULL;

	if(str)
	{
	    const size_t lstr = strlen(str) + 1;

	    strt = new char[lstr];

	    if(strt)
	    {
		memcpy(strt,str,lstr);
	    }

	}

	return strt;
}
