#ifndef SPXCALLBACK_H
#define SPXCALLBACK_H

/* %W% %G% P. Brochard */

#if defined(X11)

#include <X11/Intrinsic.h>
#include "SpxOpen.h"

#else /* !X11 */

#include "SpxOpen.h"

typedef void* Widget;
typedef void (*XtCallbackProc)();
typedef void* XtPointer;

#endif /* fin X11 */

#ifdef __cplusplus
extern "C" {
#endif

#define SpxNenterAffCallback "enterAffCallback"
#define SpxNleaveAffCallback "leaveAffCallback"
#define SpxNbpressAffCallback "bpressAffCallback"
#define SpxNbreleaseAffCallback "breleaseAffCallback"
#define SpxNmnotifyAffCallback "mnotifyAffCallback"

#define SpxNbpressbaseAffCallback "bpressbaseAffCallback"
#define SpxNbreleasebaseAffCallback "breleasebaseAffCallback"
#define SpxNmnotifybaseAffCallback "mnotifybaseAffCallback"

typedef struct
{
	int x;
	int y;
	unsigned state;
	unsigned button;
} SpxButtonCallbackStruct;

typedef struct
{
	float x;
	float y;
	unsigned state;
	unsigned button;
} SpxButtonBaseCallbackStruct;

typedef struct
{
	int x;
	int y;
	unsigned state;
} SpxMotionCallbackStruct;

typedef struct
{
	float x;
	float y;
	unsigned state;
} SpxMotionBaseCallbackStruct;

typedef int SpxPositionId;
typedef int SpxMapId;

void SpxAddCallback(Widget w,const char* reason,XtCallbackProc proc,
		XtPointer clientdata,SPXFILE* spx_file);
void SpxRemoveCallback(Widget w,const char* reason,XtCallbackProc proc,
		XtPointer clientdata,SPXFILE* spx_file);

void SpxSetPosAfficheur(Widget w,int decalx,int decaly,SPXFILE* spx_file);
SpxPositionId SpxAddPosAfficheur(Widget w,int decalx,int decaly,
		SPXFILE* spx_file);
void SpxRemovePosAfficheur(SpxPositionId spi);

SpxMapId SpxAddMapAfficheur(Widget w,SPXFILE* spx_file);
void SpxRemoveMapAfficheur(SpxMapId spi);

void SpxSetPosabsAfficheur(int x,int y,SPXFILE* spx_file);

unsigned SpxSetCurseur(unsigned curseur,SPXFILE* spx_file);

void SpxMapAfficheur(SPXFILE* spx_file);
void SpxUnmapAfficheur(SPXFILE* spx_file);

void SpxSortie(SPXFILE* spx_file);

#ifdef __cplusplus
}
#endif

#endif
