#ifdef PTGEN

#ifndef P4ALEA_H
#   include "dinosaure/P4alea.h"
#endif

// ****************************************************************
// Implementation generique des fonctions de type quicksort
// ****************************************************************

// %W% %G% Pierre Brochard

void
quicksort(const PTGEN x,unsigned* jrang,const unsigned& n)
{

	for(register unsigned j=0;j<n;j++) jrang[j] = j;

	quicksort_no_init(x,jrang,n);
}

void
quicksort_no_init(const PTGEN x,unsigned* jrang,const unsigned& n)
{
#ifdef DBG
	unsigned jcomptri = 0;
#endif
	int jpointr = 0;
	const unsigned jtai = 8*sizeof(unsigned)+1;
	int jdebut[jtai];
	int jfin[jtai];

	jdebut[0] = 0;
	jfin[0] = n-1;

	while(jpointr>=0)
	{

	    if(jdebut[jpointr]>=jfin[jpointr]) 
	    {
		jpointr--;
	    }
	    else
	    {
		register int kkd = jdebut[jpointr];
		register int kkf = jfin[jpointr];
		register int kki = alea(kkd,kkf);
		register unsigned jtemp = jrang[kkd];

		jrang[kkd] = jrang[kki];
		jrang[kki] = jtemp;

		register unsigned kkpiv = jrang[kkd];
		register int jptrm = kkd;
		register int jptrd = kkf+1;

		while(jptrm<jptrd)
		{
		    register P4Boolean compm = TRUE;

		    while(compm && jptrd>jptrm)
		    {
			jptrd--;

			if(jptrd>jptrm)
			{
#ifdef DBG
			   jcomptri++;
#endif
			   register unsigned kpiv = jrang[jptrd];

			   compm = P4Boolean(x[kkpiv]<x[kpiv]);
			}

		    }

		    compm = TRUE;

		    while(compm && jptrd>jptrm)
		    {
			jptrm++;

			if(jptrd>jptrm)
			{
#ifdef DBG
			   jcomptri++;
#endif
			   register unsigned kpiv = jrang[jptrm];

			   compm = P4Boolean(x[kpiv]<x[kkpiv]);
			}

		    }

		    if(jptrm<jptrd)
		    {
			jtemp = jrang[jptrm];
			jrang[jptrm] = jrang[jptrd];
			jrang[jptrd] = jtemp;
		    }

		}

		jrang[kkd] = jrang[jptrd];
		jrang[jptrd] = kkpiv;

		unsigned id1 = kkd;
		unsigned if1 = jptrd-1;
		unsigned id2 = jptrd+1;
		unsigned if2 = kkf;

		int long1 = if1-id1;
		int long2 = if2-id2;

		if(long1<long2) 
		{
		   jdebut[jpointr] = id2;
		   jfin[jpointr] = if2;
		   jpointr++;
		   jdebut[jpointr] = id1;
		   jfin[jpointr] = if1;
		}
		else
		{
		   jdebut[jpointr] = id1;
		   jfin[jpointr] = if1;
		   jpointr++;
		   jdebut[jpointr] = id2;
		   jfin[jpointr] = if2;
		}

	    }

	}
	
#ifdef DBG
	cout << " jcomptri " << jcomptri << endl;
#endif

	//for (i=0;i<n;i++)
	//{
	   //cout << " i " << i << " jrang " << jrang[i] 
		//<< " x " << x[jrang[i]] << endl;
	//}
}
#endif /* PTGEN */
