#ifndef P4TABGENBASE_H
#define P4TABGENBASE_H

// %W% %G% Pierre Brochard

// ******************************************************
//  instance de TabGEN pour les types de bases
//  avec macros ou templates suivant les compilos
// ******************************************************

#include "S6compat.h"

#if defined(P4VERSION_AVEC_TEMPLATE) /* version avec template */

#  include "P4constant.h"

#  ifndef P4TABGEN_H
      template<class GEN> class TabGEN;
      template<class GEN> class TabGENbuf;
#  endif

#  if P4VERSION_AVEC_TEMPLATE == 4
      typedef TabGEN<REEL> TabREEL;
      typedef TabGENbuf<REEL> TabREELbuf;
      typedef TabGEN<REEL_S> TabREEL_S;
      typedef TabGENbuf<REEL_S> TabREEL_Sbuf;
      typedef TabGEN<int> Tabint;
      typedef TabGENbuf<int> Tabintbuf;
      typedef TabGEN<unsigned> Tabunsigned;
      typedef TabGENbuf<unsigned> Tabunsignedbuf;
      typedef TabGEN<unsigned char> Tabchar;
      typedef TabGENbuf<unsigned char> Tabcharbuf;
      typedef TabGEN<Test> TabTest;
      typedef TabGENbuf<Test> TabTestbuf;
#  else
#     define TabREEL TabGEN<REEL>
#     define TabREELbuf TabGENbuf<REEL>
#     define TabREEL_S TabGEN<REEL_S>
#     define TabREEL_Sbuf TabGENbuf<REEL_S>
#     define Tabint TabGEN<int>
#     define Tabintbuf TabGENbuf<int>
#     define Tabunsigned TabGEN<unsigned>
#     define Tabunsignedbuf TabGENbuf<unsigned>
#     define Tabchar TabGEN<unsigned char>
#     define Tabcharbuf TabGENbuf<unsigned char>
#     define TabTest TabGEN<Test>
#     define TabTestbuf TabGENbuf<Test>
#  endif

#else /* version sans template */

#  define GEN REEL
#  define TabGEN TabREEL
#  define TabGENbuf TabREELbuf
#  include "dinosaure/P4tabgen.h"
#  undef GEN
#  undef TabGEN
#  undef TabGENbuf

#  define GEN REEL_S
#  define TabGEN TabREEL_S
#  define TabGENbuf TabREEL_Sbuf
#  include "dinosaure/P4tabgen.h"
#  undef GEN
#  undef TabGEN
#  undef TabGENbuf

#  define GEN int
#  define TabGEN Tabint
#  define TabGENbuf Tabintbuf
#  include "dinosaure/P4tabgen.h"
#  undef GEN
#  undef TabGEN
#  undef TabGENbuf

#  define GEN unsigned
#  define TabGEN Tabunsigned
#  define TabGENbuf Tabunsignedbuf
#  include "dinosaure/P4tabgen.h"
#  undef GEN
#  undef TabGEN
#  undef TabGENbuf

#  define GEN unsigned char
#  define TabGEN Tabchar
#  define TabGENbuf Tabcharbuf
#  include "dinosaure/P4tabgen.h"
#  undef GEN
#  undef TabGEN
#  undef TabGENbuf

#  define GEN Test
#  define TabGEN TabTest
#  define TabGENbuf TabTestbuf
#  define INCR22
#  include "P4constant.h"
#  include "dinosaure/P4tabgen.h"
#  undef INCR22
#  undef GEN
#  undef TabGEN
#  undef TabGENbuf

#endif /* fin version sans template */

#endif /* P4TABGENBASE_H */
