#ifndef U8SERVEUR_H
#define U8SERVEUR_H

// classes de gestion de serveur socket
//  %W% %G% Pierre Brochard

#ifdef CRAY
#   undef _POSIX_SOURCE
#endif

#ifdef _IBMR2
#   define _BSD
#endif

#include <sys/types.h>

typedef long int	U8InputId;
typedef long unsigned	U8IntervalId;

typedef void*           U8Pointer;

class nxstream;
class ElementInput;

// *************************************************
// structure a passer aux input+timeout callback
// *************************************************

class U8Input
{
	friend class ElementInput;
	friend class ElementVisInp;

	U8InputId xid;
	U8IntervalId xtd;
	ElementInput* evs;
};

// *************************************************
//       classe de base (virtuelle pure)
// *************************************************

class ElementVisuel;

class ElementBase
{
    public :

	virtual ~ElementBase();

	virtual ElementInput* ElInput();
	virtual ElementVisuel* ElVisuel();

     protected :

	ElementBase();

	static int poulpe_flag_sig_usr2;
	static int _mask; // masque initial pour signal SIGUSR2
};

// *************************************************
//       gestion des fichiers (socket)
// *************************************************

class ElementInput : virtual public ElementBase
{
    public:

	ElementInput();
	virtual ~ElementInput();

	virtual ElementInput* ElInput();

    // Gestionnaire de fichiers
    // fonctions membres virtual car peuvent avoir besoin d'etre surdefinie
    // dans une classe derivee (comme ElementVisInp)

	virtual U8InputId AddInputDriver(nxstream* file,int mode);
	virtual void RemoveInputDriver(U8InputId input_id);

    // Fonction locale du Widget 

	virtual void LectureInputCB(int fid,U8InputId input_id);

    // Boucle generale de traitement

	virtual void ScruteEvenement(int);

    // Extraction nxstream* pour fd donne

	static nxstream* GetNxstream(int fid);
	static nxstream* GetNxstream2(int fid,U8InputId& num);

    protected :

	static void LeDriverInputCB(U8Pointer client_data,int* fid,
		U8InputId* input_id);
	static void LeDriverTimerCB(U8Pointer client_data,
		U8IntervalId* pt_timer_id);

	static int Select(int& rc,int& fdi);

	static int             _nb_fd;
	static nxstream**      _fd_tab;
	static U8Pointer*      _class_tab;

	static fd_set          _readfds;
	static fd_set          _writefds;
};

#endif
