#ifndef NXSTREAMIOCOMPAT_H
#define NXSTREAMIOCOMPAT_H

/* Logiciel Narcisse.
   Copyright, droits d'auteurs : CEA/DAM-Ile de France
   Auteur : Pierre Brochard (CEA/DAM-Ile de France)
   %W% %G%
*/

#include "U8machcomp.h"

#ifdef __cplusplus

/* Pour compatibilite avec compilateurs C++ recents (post norme ISO). */

#if !defined(NAR_SUN_ISO) && !defined(NAR_GNU_ISO) && !defined(NAR_INTEL_ISO)
#   include <fstream.h>
#   include <iostream.h>
#   include <iomanip.h>
#   include <new.h>
#   include <strstream.h>
#else
#   include <strstream>
using std::ostrstream;
using std::istrstream;
using std::strstream;

#   include <fstream>
using std::filebuf;
using std::ifstream;
using std::ofstream;
using std::fstream;
using std::streampos;

#   include <iostream>
using std::iostream;
using std::ostream;
using std::istream;
using std::ios;
using std::streambuf;

using std::cout;
using std::cin;
using std::cerr;
using std::clog;

using std::ws;
using std::endl;
using std::ends;
using std::flush;

#   include <iomanip>
using std::boolalpha;
using std::noboolalpha;
using std::showbase;
using std::noshowbase;
using std::showpoint;
using std::noshowpoint;
using std::showpos;
using std::noshowpos;
using std::skipws;
using std::noskipws;
using std::uppercase;
using std::nouppercase;
using std::internal;
using std::left;
using std::right;
using std::dec;
using std::hex;
using std::oct;
using std::fixed;
using std::scientific;

using std::resetiosflags;
using std::setiosflags;
using std::setbase;
using std::setfill;
using std::setprecision;
using std::setw;

#   include <new>
using std::bad_alloc;
using std::nothrow_t;
using std::nothrow;
using std::new_handler;
using std::set_new_handler;
#endif

#endif /* fin cplusplus */

#endif /* fin NXSTREAMIOCOMPAT_H */
