#ifndef U8Xfig_H
#define U8Xfig_H

// %W% %G% Pierre Brochard
// modele de driver L3 en C++

#include <stdio.h>
#include "poulpe/U8driver.h"

// **********************************************************
//     classe U8Xfig : Driver Xfig
//     Pour interfacer avec Sanglier (bibliotheque L3) :
//
//     U8Xfig* Xfig = new U8Xfig;
//     Xfig->NomDebutFichier("debut_nom_fichier");
//     U8Xfig::Driver(Xfig);
//     L3AddNewDriver(U8Xfig::L3XfigSanglier,"Xfig",TRUE);
//     L3ChoixDriver("Xfig");
//
// **********************************************************

class U8Xfig : public U8DriverL3
{
    public:

        U8Xfig();
	~U8Xfig();

	void L3Dialogue(int bloc_l3[]);
	void L3Open(const int bloc_l3[]);
	void L3Close(const int bloc_l3[]);
	void L3Texte(const int bloc_l3[]);
	void L3TexteSoft(const int bloc_l3[]);
	void L3Colormap(const int bloc_l3[]);
	void L3Couleur(const int bloc_l3[]);
	void L3Brillance(const int bloc_l3[]);
	void L3Pixel(const int bloc_l3[]);
	void L3Cadre(const int bloc_l3[]);
	void L3Segment(const int bloc_l3[]);
	void L3Marqueur(const int bloc_l3[]);
	void L3Polygone(const int bloc_l3[]);
	void L3Axe(const int bloc_l3[]);
	void L3Flush(const int bloc_l3[]);
	void L3Default(const int bloc_l3[]);
	void L3End(const int bloc_l3[]);
    // pour interface avec sanglier

	inline static void L3XfigSanglier(int codel3[]);
	inline static void Driver(U8Xfig* const);
	static U8Xfig* Driver();

    // couleurs

	static const int _defncolors; // taille de _defaultmap

    // init du debut du nom de fichier (se termine par XXXX.pgml ou
    // XXXX est un compteur sur 4 chiffres commencant a 0000)

	void NomDebutFichier(const char* filedebut);

    private:

    // pour interfacer avec sanglier

	static U8Xfig* _Xfig;

    // open/close

	char* _filedebut;
	char* _filename;
	FILE* _filenx;
	FILE* _file;
	static int _numfile;

    // pour bounding box

	double _factor;
	int _xmin;
	int _xmax;
	int _ymin;
	int _ymax;

    // coefs de changement d echelle

	double _a;
	double _b;
	double _c;
	double _d;

    // couleurs

	static const int _maxcolors;
	static const char* _defaultmap[];
	int _ncolors;
	int _color;

    // profondeur

	int _depth;

    // Pour mettre dans un bloc un texte soft ou un axe

	int _texte_soft;
	int _axe;
	int _first_vect;
};

inline void
U8Xfig::L3XfigSanglier(int codel3[])
{

	if(_Xfig) _Xfig->L3Driver(codel3);

}

inline void
U8Xfig::Driver(U8Xfig* const Xfig)
{
	_Xfig = Xfig;
}

inline U8Xfig*
U8Xfig::Driver()
{
	return _Xfig;
}

#endif /* fin U8Xfig_H */
