c *----------------------------------------------------*
c * Type general pour eviter les pbs futurs            *
c *----------------------------------------------------*

c   les variables atomiques sont en double precision
c   les tableaux en simple precision

c *----------------------------------------------------*
c * Enum courantes                                     *
c *----------------------------------------------------*

	integer FALSE,TRUE

	parameter(FALSE=0,TRUE=1)

c *----------------------------------------------------*
c * Definition des constantes elementaires             *
c *----------------------------------------------------*

	integer Dep
	double precision Emin,Emax,Bmin,Bmax

	parameter(Dep=1000000000)
	parameter(Emin = -37.,Emax = +37.)
	parameter(Bmin = 1.e-37,Bmax = 1.e+37)

c *----------------------------------------------------*
c * Definition des modes de grilles                    *
c *----------------------------------------------------*

	integer A_PLEIN,A_CREUX,A_MICREUX,A_VIDE,A_ABSENT

	parameter(A_PLEIN=0,A_CREUX=1,A_MICREUX=2)
	parameter(A_VIDE=3,A_ABSENT=4)

c *----------------------------------------------------*
c * Definition des modes de troncatures 3d             *
c *----------------------------------------------------*

	integer TR3D_GA,TR3D_NO,TR3D_DR,TR3D_GD

	parameter(TR3D_GA=-1,TR3D_NO=0,TR3D_DR=1,TR3D_GD=2)

c *----------------------------------------------------*
c * Definition du mode de trace 3d                     *
c *----------------------------------------------------*

	integer L32DROT,L33DROT,L33DSROT

	parameter(L32DROT=0,L33DROT=1,L33DSROT=2)

c *------------------------------------------------------------*
c * Definition du mode lineaire ou logarithmique sur un axe 3d *
c *------------------------------------------------------------*

	integer ECH3DLIN,ECH3DLOG,ECH3DINC

	parameter(ECH3DLIN=0,ECH3DLOG=1,ECH3DINC=2)

c ECH3DLIN : lineaire 
c ECH3DLOG : logarithmique 
c ECH3DINC : on garde le mode precedent 

c *---------------------------------------------------------*
c * Definition des modes de trace du dessous de la surface  *
c *---------------------------------------------------------*

	integer BAS_INC,BAS_NOTR,BAS_TR

	parameter(BAS_INC=-1,BAS_NOTR=0,BAS_TR=1)

c *---------------------------------------------------------*
c * Definition du mode de masquage (parties cachees)        *
c *---------------------------------------------------------*

	integer MASK_INC,MASK_NO,MASK_MIN,MASK_MAX,MASK_TRI

	parameter(MASK_INC=-1)
	parameter(MASK_NO=0)
	parameter(MASK_MIN=1)
	parameter(MASK_MAX=2)
	parameter(MASK_TRI=3)

c *---------------------------------------------------------*
c * Numerotation des faces                                  *
c *---------------------------------------------------------*

	integer B_DESSUS,B_DESSOUS
	integer B_DEVANT,B_DERRIERE
	integer B_DROITE,B_GAUCHE

	parameter(B_DESSUS=0,B_DESSOUS=1)
	parameter(B_DEVANT=2,B_DERRIERE=3)
	parameter(B_DROITE=4,B_GAUCHE=5)

c *---------------------------------------------------------*
c * lissage ou lissage+filaire                              *
c *---------------------------------------------------------*

	integer LIS,LIS_FIL

	parameter(LIS=0,LIS_FIL=1)

c *---------------------------------------------------------*
c * filaire ou niveaux ou filaire+niveaux                   *
c *---------------------------------------------------------*

	integer FIL,FAC,FAC_FIL,NIV,FIL_NIV,FAC_NIV,FAC_FIL_NIV

	parameter(FIL = 0,FAC = 1,FAC_FIL = 2,NIV = 3)
	parameter(FIL_NIV = 4,FAC_NIV = 5,FAC_FIL_NIV = 6)

c *---------------------------------------------------------*
c * options 3d ou 4d                                        *
c *---------------------------------------------------------*

	integer OPT_3D,OPT_4D

	parameter(OPT_3D=0,OPT_4D=1)

