#ifndef P4GEOMUTIL_H
#define P4GEOMUTIL_H

// %W% %G% Pierre Brochard

#include "dinosaure/P4tabgenbase.h"

class GeomUtil
{
    private :

        virtual void dummy() = 0;

    public:

	friend class GeomPure4;

    //  calculs des parametres de segments pour les segments definitifs

	static void SegmentsEquatFromPoints(TabREELbuf& a,TabREELbuf& b,
			TabREELbuf& c,const TabREELbuf& x,
			const TabREELbuf& y,const Tabunsignedbuf& seg_debut,
			const Tabunsignedbuf& seg_fin);
	static void SegmentsToMailles(const TabREELbuf& x,const TabREELbuf& y,
			const Tabunsignedbuf& seg_debut,
			const Tabunsignedbuf& seg_fin,
			const Tabunsignedbuf& seg_contour,
			Tabunsignedbuf* const sommets,
			Tabunsignedbuf* const contours);
	static void MaillesElimineDoubles(Tabunsignedbuf* const sommets,
			Tabunsignedbuf* const contours,unsigned tai,
			unsigned num_maille,unsigned& nombre_mailles);
	static REEL AngleVecteurs(REEL xs,REEL ys,REEL x1,REEL y1,
			REEL x2,REEL y2);
	static REEL AngleVecteurs2(REEL xs,REEL ys,REEL x1,REEL y1,
			REEL x2,REEL y2);
	static void ElimineSegments(const TabREELbuf& xnew,
			const TabREELbuf& ynew,Tabunsignedbuf& seg_debut,
			Tabunsignedbuf& seg_fin,Tabunsignedbuf& seg_origine,
			Tabunsignedbuf& seg_contour);
	static void ElimineSegmentsExt(const TabREELbuf& xnew,
			const TabREELbuf& ynew,Tabunsignedbuf& seg_debut,
			Tabunsignedbuf& seg_fin,Tabunsignedbuf& seg_origine,
			Tabunsignedbuf& seg_contour,const unsigned nnu_orig);
	static void PrintSegments(const TabREELbuf& xnew,const TabREELbuf& ynew,
			const TabREELbuf& znew,const Tabunsignedbuf& seg_debut,
			const Tabunsignedbuf& seg_fin);
	static REEL CarreDiffVecteurs3D(register REEL x1,register REEL y1,
			register REEL z1,register REEL x2,register REEL y2,
			register REEL z2);
	static REEL NormAbsDiffVecteurs2D(register REEL x1,register REEL y1,
			register REEL x2,register REEL y2);
};

#endif /* P4GEOMUTIL_H */
