struct SccsIdP4MailleNS3f
{
	static const char* const sccs_id;
};

const char* const SccsIdP4MailleNS3f::sccs_id = "%W% %G% Pierre Brochard";

#include "P4maillens3f.h"
#include "dinosaure/P4quicksort.h"

int
MailleNS3f::DonneSommets(Tabunsignedbuf& t,unsigned numaille) const
{

	if(numaille<_nmailles)
	{
	    unsigned nxprov[3];
	    const int* mailles = _mailles;
	    const int numai3 = 3*numaille;

	    nxprov[0] = mailles[numai3]-1;
	    nxprov[1] = mailles[numai3+1]-1;
	    nxprov[2] = mailles[numai3+2]-1;

	    t.ModTab(nxprov,3);

	    return 0;
	}
	else
	{
	    cerr << "Erreur dans " << __FILE__ << " ligne " << __LINE__ << endl;
	    return -1;
	}

}

int
MailleNS3f::LitTraceFil(Tabcharbuf& t,unsigned numaille) const
{

	if(numaille<_nmailles)
	{
	    unsigned char nxprov[3];

	    nxprov[0] = TRACE_FIL_OUI;
	    nxprov[1] = TRACE_FIL_OUI;
	    nxprov[2] = TRACE_FIL_OUI;

	    t.ModTab(nxprov,3);

	    return 0;
	}
	else
	{
	    cerr << "Erreur dans " << __FILE__ << " ligne " << __LINE__ << endl;
	    return -1;
	}

}

void
MailleNS3f::VideMailles()
{
	_nmailles = 0;
	_mailles.Enleve();
	_nsommets = 0;
	_sommets.Enleve();
}

int
MailleNS3f::DonneMaillesSommet(Tabunsignedbuf& t,unsigned nusommet) 
{
	int nsommets = _nsommets;

	if(!nsommets)
	{
	// calcul du tableau _sommets au format decrit ci-dessous
	// peut etre vu comme l'inversion du tableau _mailles

	    unsigned nmailles = _nmailles;
	    unsigned subdimn = 3*nmailles;
	    const int* mailles = _mailles;
	    const int* maipnma = mailles;

	// calcul de _nsommets

	    P4Max(subdimn,maipnma,nsommets);nsommets++;
	    _nsommets = nsommets;

	// inversion de _mailles

	    unsigned* rang = new unsigned[subdimn];

	    quicksort(maipnma,rang,subdimn);

	    unsigned dimsommets = nsommets + subdimn;

	    _sommets.ModValn(dimsommets);

	    unsigned* som = new unsigned[subdimn];
	    register unsigned i=0;

	    for(;i<nmailles;i++)
	    {
		register const unsigned jmin = 3*i;
		register const unsigned jmax = jmin + 3;

		for(register unsigned j=jmin;j<jmax;j++)
		{
		    som[j] = i;
		}

	    }

	    unsigned* sommets = _sommets;
	    unsigned* sompnsom = sommets + nsommets;

	    for(i=0;i<subdimn;i++)
	    {
		sommets[maipnma[rang[i]]]++;
		sompnsom[i] = som[rang[i]];
	    }

	    delete[] rang;
	    delete[] som;

	    for(register int ii=1;ii<nsommets;ii++)
	    {
		sommets[ii] += sommets[ii-1];
	    }

	}

	if(int(nusommet) < nsommets)
	{
    /* maillage non structure :
       rangement :
       pour chaque sommet on donne le nombre de mailles et les numeros 
       de ces mailles = tableau _sommets =
		nombre de mailles pour le sommet 0
		nombre de mailles pour le sommet 0 + 1
		nombre de mailles pour le sommet 0 + 1 + 2
			...
		numeros des mailles sommet 0
		numeros des mailles sommet 1
		numeros des mailles sommet 2
			...     */

	    const unsigned j = _sommets[nusommet];
	    const unsigned i = nusommet ? _sommets[nusommet-1] : 0;

	    t.ModTab(&_sommets[i+nsommets],j-i);

	    return 0 ;
	}
	else
	{
	    cerr << "Erreur dans " << __FILE__ << " ligne " <<
		__LINE__ << endl;
	    return -1;
	}

}
