#ifndef P4MAILLEQCQ_H
#define P4MAILLEQCQ_H

// %W% %G% Pierre Brochard

#include "dinosaure/P4tabgenbasec.h"
#include "dinosaure/P4tabgenbase.h"

class MailleQcq
{
    protected :

        unsigned _nmailles;

    public :

	MailleQcq() : _nmailles(0) {};
	MailleQcq(unsigned nmailles) : _nmailles(nmailles) {};
	MailleQcq(const MailleQcq& m) : _nmailles(m._nmailles) {};
	virtual ~MailleQcq() {};

	unsigned Nmailles() const {return _nmailles;};
	virtual unsigned Nvolumes() const {return 0;};

	virtual const char* TypeMailles() const {return "MailleQcq";};

	virtual void VideMailles() {_nmailles=0;};

    // donne les sommets pour un numero de maille donne :
	virtual int DonneSommets(Tabunsignedbuf&,unsigned) const = 0;
    // donne les mailles pour un numero de sommet donne :
	virtual int DonneMaillesSommet(Tabunsignedbuf&,unsigned) = 0;
    // donne les mailles pour un numero de volume donne :
	virtual int DonneMailles(Tabunsignedbuf&,unsigned) const;
    // donne les volumes pour un numero de sommet donne :
	virtual int DonneVolumesSommet(Tabunsignedbuf&,unsigned);
    // donne les volumes pour un numero de maille donne :
	virtual int DonneVolumesMaille(Tabunsignedbuf&,unsigned);

	virtual int  LitTraceFil(const unsigned,const unsigned) const = 0;
	virtual int  LitTraceFil(Tabcharbuf&,unsigned) const = 0;

	virtual MailleQcq* NewCopy() const = 0;

	virtual void operator  = (const MailleQcq& m)
		{_nmailles=m._nmailles;}; 
};

inline int
MailleQcq::DonneMailles(Tabunsignedbuf& t,unsigned) const
{
    // ---------------------------------------------------------------------
    // retourne 1 si pas de notion de volume pour le maillage
    // retourne 0 si le maillage contient la notion de volume
    // DonneMailles retourne alors dans t (1er parametre) les numeros de
    // mailles pour un volume dont on donne le numero en 2eme parametre
    // si erreur alors retourne -1
    // ---------------------------------------------------------------------

	t.Enleve();

	return 1;
}

inline int
MailleQcq::DonneVolumesSommet(Tabunsignedbuf& t,unsigned)
{
    // ---------------------------------------------------------------------
    // retourne 1 si pas de notion de volume pour le maillage
    // retourne 0 si le maillage contient la notion de volume
    // DonneVolumesSommet retourne alors dans t (1er parametre) les numeros de
    // volumes pour un sommet dont on donne le numero en 2eme parametre
    // si erreur alors retourne -1
    // ---------------------------------------------------------------------

	t.Enleve();

	return 1;
}

inline int
MailleQcq::DonneVolumesMaille(Tabunsignedbuf& t,unsigned)
{
    // ---------------------------------------------------------------------
    // retourne 1 si pas de notion de volume pour le maillage
    // retourne 0 si le maillage contient la notion de volume
    // DonneVolumesMaille retourne alors dans t (1er parametre) les numeros de
    // volumes pour une maille dont on donne le numero en 2eme parametre
    // si erreur alors retourne -1
    // ---------------------------------------------------------------------

	t.Enleve();

	return 1;
}

#endif
