#include "P4maillest4.h"

struct SccsIdP4MailleSt4
{
	static const char* const sccs_id;
};

const char* const SccsIdP4MailleSt4::sccs_id = "%W% %G% P. Brochard";

int
MailleSt4::DonneSommets(Tabunsignedbuf& t,unsigned numaille) const
{

	if(numaille<_nmailles)
	{
	    register unsigned nx = _nx;
	    register unsigned nx1 = nx-1;
	    register unsigned i = numaille%nx1;
	    register unsigned j = numaille/nx1;
	    unsigned nxprov[4];

	    nxprov[0] = i+j*nx;
	    nxprov[1] = nxprov[0]+1;
	    nxprov[2] = nxprov[1]+nx;
	    nxprov[3] = nxprov[2]-1;
	    t.ModTab(nxprov,4);

	    return 0;
	}
	else
	{
	    cerr << "Erreur dans " << __FILE__ << " ligne " <<
		__LINE__ << endl;
	    return -1;
	}

}

int
MailleSt4::LitTraceFil(Tabcharbuf& t,unsigned numaille) const
{

	if(numaille<_nmailles)
	{
	    unsigned char nxprov[4];

	    nxprov[0] = TRACE_FIL_OUI;
	    nxprov[1] = TRACE_FIL_OUI;
	    nxprov[2] = TRACE_FIL_OUI;
	    nxprov[3] = TRACE_FIL_OUI;
	    t.ModTab(nxprov,4);

	    return 0;
	}
	else
	{
	    cerr << "Erreur dans " << __FILE__ << " ligne " <<
		__LINE__ << endl;
	    return -1;
	}

}

int
MailleSt4::DonneMaillesSommet(Tabunsignedbuf& t,unsigned nusommet)
{
	register const unsigned nx = _nx;
	register const unsigned nmailles = _nmailles;
	register const unsigned nx1 = nx-1;
	register const unsigned ny = nmailles/nx1 + 1;
	register const unsigned nsommets = nx*ny;

	if(nusommet < nsommets)
	{
	    register const unsigned i = nusommet%nx;
	    register const unsigned j = nusommet/nx;
	    register const unsigned ny1 = ny-1;
	    register unsigned nb = 0;
	    unsigned nxprov[4];

	    if(!i)
	    {

		if(!j)
		{
		    nxprov[0] = 0;
		    nb = 1;
		}
		else if(j==ny1)
		{
		    nxprov[0] = nmailles - nx1;
		    nb = 1;
		}
		else
		{
		    nxprov[0] = (j-1)*nx1;
		    nxprov[1] = j*nx1;
		    nb = 2;
		}

	    }
	    else if(i==nx1)
	    {

		if(!j)
		{
		    nxprov[0] = nx1-1;
		    nb = 1;
		}
		else if(j==ny1)
		{
		    nxprov[0] = nmailles-1;
		    nb = 1;
		}
		else
		{
		    nxprov[0] = j*nx1-1;
		    nxprov[1] = (j+1)*nx1-1;
		    nb = 2;
		}

	    }
	    else if(!j)
	    {
		nxprov[0] = i-1;
		nxprov[1] = i;
		nb = 2;
	    }
	    else if(j==ny1)
	    {
		nxprov[0] = nmailles-nx1+i-1;
		nxprov[1] = nmailles-nx1+i;
		nb = 2;
	    }
	    else
	    {
		nxprov[0] = (j-1)*nx1+i-1;
		nxprov[1] = nxprov[0] + 1;
		nxprov[2] = nxprov[1] + nx1;
		nxprov[3] = nxprov[2] - 1;
		nb = 4;
	    }

	    t.ModTab(nxprov,nb);

	    return 0;
	}
	else
	{
	    cerr << "Erreur dans " << __FILE__ << " ligne " <<
		__LINE__ << endl;
	    return -1;
	}

}

