#ifndef P4MAILLEST8_H
#define P4MAILLEST8_H

// %W% %G% Pierre Brochard

#include "P4maillest4.h"

class MailleSt8 : public MailleSt4
{
    private:

        unsigned _ny;

    public:

        MailleSt8() : MailleSt4(),_ny(0) {}
        MailleSt8(unsigned nmailles,unsigned nx,unsigned ny) :
			MailleSt4(nmailles,nx),_ny(ny) {}
        MailleSt8(MailleSt8& m) : MailleSt4(m),_ny(m._ny) {}

        unsigned Nvolumes() const;

        const char* TypeMailles() const {return "MailleSt8";}

        void VideMailles() {_nmailles=0;_nx=0;_ny=0;}

        int DonneSommets(Tabunsignedbuf& t,unsigned numaille) const;
	int DonneMaillesSommet(Tabunsignedbuf&,unsigned);
        int DonneMailles(Tabunsignedbuf& t,unsigned nuvolume) const;

        int LitTraceFil(const unsigned,const unsigned) const
	{return TRACE_FIL_OUI;}
        int LitTraceFil(Tabcharbuf& t,unsigned numaille) const;

        MailleQcq* NewCopy() const {return new MailleSt8;}

        void operator = (const MailleQcq& m)
	{
		_nx = ((const MailleSt8&) m)._nx;
		_ny = ((const MailleSt8&) m)._ny;
		_nmailles = ((const MailleSt8&) m)._nmailles;
	}

};

#endif
