#include "P4minos.h"
#include "minotaure/P4graf2.h"

struct SccsIdP4Minos
{
	static const char* const sccs_id;
};

const char* const SccsIdP4Minos::sccs_id = " %W% %G% Pierre Brochard ";

static P4Graf2 graf;

// points d'entrees de P4graf0

extern "C"
{

    void P4Time(P4Boolean my_time)
    {
	graf.P4Time(my_time);
    }

    void P4TimeGeom(P4Boolean time_geom)
    {
	graf.P4TimeGeom(time_geom);
    }

    void P4ModeTrace(int modetrace)
    {
	graf.P4ModeTrace(modetrace);
    }

    int P4Ptvue(REEL site,REEL azimu,REEL dista,REEL xcen,
			REEL ycen,REEL scalxy,REEL redrv,REEL redrh)
    {
	return graf.P4Ptvue(site,azimu,dista,xcen,ycen,scalxy,redrv,redrh);
    }


    int P4PtvueScxy(REEL site,REEL azimu,REEL dista,REEL xcen,
			REEL ycen,REEL scalx,REEL scaly,
			REEL redrv,REEL redrh)
    {
	return graf.P4PtvueScxy(site,azimu,dista,xcen,ycen,scalx,scaly,
			redrv,redrh);
    }

    int P4PtvueScxyGen(REEL site,REEL azimu,REEL angpl,REEL dista,
			REEL xcen,REEL ycen,REEL scalx,REEL scaly,
			REEL redrv,REEL redrh)
    {
	return graf.P4PtvueScxyGen( site,azimu,angpl,dista,xcen,ycen,scalx,
			scaly,redrv,redrh);
    }

    void P4Datas()
    {
	graf.P4Datas();
    }

    void P4Dcoin(REEL decalx,REEL decaly,REEL decalz)
    {
	graf.P4Dcoin(decalx,decaly,decalz);
    }

    void P4Dcoin2(REEL x1,REEL y1t,REEL z1,REEL x2,REEL y2,REEL z2)
    {
	graf.P4Dcoin2(x1,y1t,z1,x2,y2,z2);
    }

    void P4Defpa(int ibas,int jcolor)
    {
	graf.P4Defpa(ibas,jcolor);
    }

    void P4Def2(int masque,int icotes,REEL zarg1)
    {
	graf.P4Def2(masque,icotes,zarg1);
    }

    void P4Dtron(int jx,int jy,int jz)
    {
	graf.P4Dtron(jx,jy,jz);
    }

    void P4Dsp3(REEL x1,REEL y1t,REEL x2,REEL y2) 
    {
	graf.P4Dsp3(x1,y1t,x2,y2);
    }

    void P4DefSpace(REEL x1,REEL y1t,REEL z1,REEL x2,REEL y2,REEL z2,
		int logx,int logy,int logz,P4Boolean sans_sauvegarde)
    {
	graf.P4DefSpace(x1,y1t,z1,x2,y2,z2,logx,logy,logz,sans_sauvegarde);
    }

    void P4Dnbdgr(REEL x2s1,REEL y2s1,REEL z2s1,REEL c2s1,REEL h2s1)
    {
	graf.P4Dnbdgr(x2s1,y2s1,z2s1,c2s1,h2s1);
    }

    void P4Dcolo(int ico)
    {
	graf.P4Dcolo(ico);
    }

// points d'entree de P4graf1

    int P4CorrigeVecteur(REEL* px1,REEL* py1,REEL* pz1,REEL* px2,REEL* py2,
		REEL* pz2)
    {
	return graf.P4CorrigeVecteur(*px1,*py1,*pz1,*px2,*py2,*pz2);
    }

    int  P4Vecteur(REEL x1,REEL y1t,REEL z1,REEL x2,REEL y2,REEL z2)
    {
	return graf.P4Vecteur(x1,y1t,z1,x2,y2,z2);
    }

    int  P4VecteurColor(REEL x1,REEL y1t,REEL z1,REEL x2,REEL y2,REEL z2,
		int c)
    {
	return graf.P4VecteurColor(x1,y1t,z1,x2,y2,z2,c);
    }

    int  P4VecteurColorBis(REEL x1,REEL y1t,REEL z1,REEL c1,REEL x2,REEL y2,
		REEL z2,REEL c2)
    {
	return graf.P4VecteurColor(x1,y1t,z1,c1,x2,y2,z2,c2);
    }

    void P4ChoixHauteurs(const Opt34d cz)
    {
	graf.P4ChoixHauteurs(cz);
    }

    int P4InitHauteurs(REEL hauteurs[],int couleurs[],
		unsigned nbrehauteurs,Opt34d cz,const P4Boolean logh)
    {
	return graf.P4InitHauteurs(hauteurs,couleurs,nbrehauteurs,cz,logh);
    }

#ifndef REQRS
    int P4InitHauteursBis(REEL_S hauteurs[],int couleurs[],
		unsigned nbrehauteurs,Opt34d cz,const P4Boolean logh)
    {
	return graf.P4InitHauteurs(hauteurs,couleurs,nbrehauteurs,cz,logh);
    }
#endif

    int P4InitHauteursTer(REEL_S hauteurs[],unsigned nbrehauteurs,
		Opt34d cz,unsigned couleurmin,
		unsigned couleurmax,const P4Boolean logh)
    {
	return graf.P4InitHauteurs(hauteurs,nbrehauteurs,
		cz,couleurmin,couleurmax,logh);
    }

    int P4InitHauteursQua(REEL hmin,REEL hmax,REEL_S z[],int nx,int ny,
		int nz,Opt34d cz,unsigned nbrehauteurs,
		P4Boolean modlog,unsigned couleurmin,unsigned couleurmax)
    {
	return graf.P4InitHauteurs(hmin,hmax,z,nx,ny,
		nz,cz,nbrehauteurs,modlog,couleurmin,couleurmax);
    }

    int P4CalcHauteurs(REEL_S hauteurs[],const int nbrehauteurs,
		const REEL_S hmin,const REEL_S hmax,const REEL_S z[],
		const int nx,const int ny,const int nz,
		const P4Boolean modlog)
    {
	return graf.P4CalcHauteurs(hauteurs,nbrehauteurs,hmin,hmax,z,
		nx,ny,nz,modlog);
    }

    int P4LigneBrisee(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],const REEL_S c[],int npoints,int pas)
    {
	return graf.P4Graf1::P4LigneBrisee(x,y,z,c,npoints,pas);
    }

    int P4LigneBriseeBis(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],int npoints,int pas)
    {
	return graf.P4Graf1::P4LigneBrisee(x,y,z,npoints,pas);
    }

    int P4LigneFermee(REEL_S x[],REEL_S y[],REEL_S z[],
		REEL_S c[],int npoints,const unsigned char* tf)
    {
	return graf.P4LigneFermee(x,y,z,c,npoints,tf);
    }

    int P4LigneFermeeBis(REEL_S x[],REEL_S y[],REEL_S z[],int npoints)
    {
	return graf.P4LigneFermee(x,y,z,npoints);
    }

    int P4LigneFermeeTer(REEL_S x[],REEL_S y[],REEL_S z[],
		int npoints,const unsigned char* tf)
    {
	return graf.P4LigneFermee(x,y,z,npoints,tf);
    }

    int P4Polygone(REEL_S x[],REEL_S y[],REEL_S z[],
		int npoints) 
    {
	return graf.P4Graf1::P4Polygone(x,y,z,npoints) ;
    }

    int P4PolygoneBis(REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int npoints)
    {
	return graf.P4Graf1::P4Polygone(x,y,z,c,npoints);
    }

// points d'entres de P4graf2

    void P4ChercheMaillesInit(const P4Boolean cherche_mailles)
    {
	graf.P4ChercheMaillesInit(cherche_mailles);
    }

    void P4DefEchelles(const REEL xmin,const REEL ymin,
		const REEL zmin,const REEL cmin,const REEL xmax,
		const REEL ymax,const REEL zmax,const REEL cmax,
		const int logx,const int logy,
		const int logz,const int logc)
    {
	graf.P4DefEchelles(xmin,ymin,zmin,cmin,xmax,ymax,zmax,cmax,
		logx,logy,logz,logc);
    }

    void P4LitEchelles(REEL* pxmin,REEL* pymin,REEL* pzmin,
		REEL* pcmin,REEL* pxmax,REEL* pymax,REEL* pzmax,
		REEL* pcmax,int* plogx,int* plogy,int* plogz,int* plogc)
    {
	graf.P4LitEchelles(*pxmin,*pymin,*pzmin,*pcmin,*pxmax,*pymax,
		*pzmax,*pcmax,*plogx,*plogy,*plogz,*plogc);
    }

    int P4LigneBriseeTer(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],const REEL_S c[],int npoints,
		P4Boolean trace_lent,int nombre_cesures)
    {
	return graf.P4LigneBrisee(x,y,z,c,npoints,trace_lent,nombre_cesures);
    }

    int P4LigneBriseeQua(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],int npoints,P4Boolean trace_lent,
		int nombre_cesures)
    {
	return graf.P4LigneBrisee(x,y,z,npoints,trace_lent,nombre_cesures);
    }

    int P4PolygoneTer(REEL_S x[],REEL_S y[],REEL_S z[],int npoints)
    {
	return graf.P4Polygone(x,y,z,npoints);
    }

    void P4Init34d(Opt34d fil,Opt34d fac,Opt34d niv,Opt34d lis)
    {
	graf.P4Init34d(fil,fac,niv,lis);
    }

    int P4Filaire(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int dimx,int dimy,int dimz,int dimc,
		int nx,int ny)
    {
	return graf.P4Filaire(x,y,z,c,dimx,dimy,dimz,dimc,nx,ny);
    }

    int P4FilaireBis(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int dimx,int dimy,int dimz,int dimc,
		int nx,int ny,unsigned mailles[],unsigned nmailles,
		int dimmailles,Fil opt_fil)
    {
	return graf.P4Filaire(x,y,z,c,dimx,dimy,dimz,dimc,nx,ny,
		mailles,nmailles,dimmailles,opt_fil);
    }

    int P4Lissage(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int dimx,int dimy,int dimz,int dimc,
		int nx,int ny,unsigned mailles[],unsigned nmailles,
		int dimmailles,Lisse opt_lisse)
    {
	return graf.P4Lissage(x,y,z,c,dimx,dimy,dimz,dimc,nx,ny,
		mailles,nmailles,dimmailles,opt_lisse);
    }

    void P4TraceGrilles()
    {
	graf.P4TraceGrilles();
    }

    void P4AnnuleGrilles()
    {
	graf.P4AnnuleGrilles();
    }

    void P4DefCaracGrille(int taille_caract_titres,
		int taille_caract_echelles)
    {
	graf.P4DefCaracGrille(taille_caract_titres,taille_caract_echelles);
    }

    void P4AnnuleGrillesSimple()
    {
	graf.P4AnnuleGrillesSimple();
    }

    void P4NouvelleGrilleSimple()
    {
	graf.P4NouvelleGrilleSimple();
    }

    void P4DefTitreSimple(char* titre_axe_bas,char* titre_axe_haut,
		char* titre_axe_droite,char* titre_axe_gauche,
		char* unite_axe_bas,char* unite_axe_haut,
		char* unite_axe_droite,char* unite_axe_gauche)
    {
	graf.P4DefTitreSimple(titre_axe_bas,titre_axe_haut,
		titre_axe_droite,titre_axe_gauche,
		unite_axe_bas,unite_axe_haut,
		unite_axe_droite,unite_axe_gauche);
    }

    void P4DefGrilleSimple(Face face,REEL decalx,
		P4Boolean texte_horizontal,int grad_axex,int grad_axey,
		int* type_axe,P4Boolean* label_axe,
		int* grad_inter_axe, int* factorisation_axe)
    {
	graf.P4DefGrilleSimple(face,decalx,
		texte_horizontal,grad_axex,grad_axey,
		type_axe,label_axe,grad_inter_axe,factorisation_axe);
    }

    void P4AnnuleGrillesAuto()
    {
	graf.P4AnnuleGrillesAuto();
    }

    void P4NouvelleGrilleAuto()
    {
	graf.P4NouvelleGrilleAuto();
    }

    void P4DefTitreAuto(char* titre_x,char* titre_y,
		char* titre_z,char* unite_x,char* unite_y,
		char* unite_z)
    {
	graf.P4DefTitreAuto(titre_x,titre_y,titre_z,
		unite_x,unite_y,unite_z);
    }

    void P4DefGrilleAuto(REEL decalx,REEL decaly,REEL decalz,
		P4Boolean texte_horizontal,int grad_axex,int grad_axey,
		int grad_axez,int type_grilles,
		int* grad_inter)
    {
	graf.P4DefGrilleAuto(decalx,decaly,decalz,
		texte_horizontal,grad_axex,grad_axey,
		grad_axez,type_grilles,grad_inter);
    }

}


