// ident

struct SccsIdP4Minosf {
	static const char* const sccs_id;
};

const char* const SccsIdP4Minosf::sccs_id = "%W% %G% Pierre Brochard";

// *********************************************************
// includes
// *********************************************************

#include "P4minosf.h"
#include "minotaure/P4graf2.h"

// variables globales

static P4Graf2 graf;

// *********************************************************
// binding FORTRAN de minotaure
// *********************************************************

// points d'entrees de P4graf0

extern "C"
{
 
#ifdef CRAY
    void P4INIT()
    {
    }
#else
    void _main();

    void p4init_()
    {
#if !defined(_IBMR2) && !defined(SUNOS_5)
	_main();
#endif
    }
#endif

#ifdef CRAY
    void P4TIME(const P4Boolean& my_time)
#else
    void p4time_(const P4Boolean& my_time)
#endif
    {
	graf.P4Time(my_time);
    }

#ifdef CRAY
    void P4TIMEG(const P4Boolean& time_geom)
#else
    void p4timeg_(const P4Boolean& time_geom)
#endif
    {
	graf.P4TimeGeom(time_geom);
    }

    void p4modtra_(const int& modetrace)
    {
	graf.P4ModeTrace(modetrace);
    }

    int p4ptvue_(REEL_F& site,REEL_F& azimu,REEL_F& dista,REEL_F& xcen,
			REEL_F& ycen,REEL_F& scalxy,REEL_F& redrv,REEL_F& redrh)
    {
	return graf.P4Ptvue(site,azimu,dista,xcen,ycen,scalxy,redrv,redrh);
    }


    int p4ptvus_(REEL_F& site,REEL_F& azimu,REEL_F& dista,REEL_F& xcen,
			REEL_F& ycen,REEL_F& scalx,REEL_F& scaly,
			REEL_F& redrv,REEL_F& redrh)
    {
	return graf.P4PtvueScxy(site,azimu,dista,xcen,ycen,scalx,scaly,
			redrv,redrh);
    }

    int p4ptvsg_(REEL_F& site,REEL_F& azimu,REEL_F& angpl,REEL_F& dista,
			REEL_F& xcen,REEL_F& ycen,REEL_F& scalx,REEL_F& scaly,
			REEL_F& redrv,REEL_F& redrh)
    {
	return graf.P4PtvueScxyGen(site,azimu,angpl,dista,xcen,ycen,scalx,
			scaly,redrv,redrh);
    }

    void p4datas_()
    {
	graf.P4Datas();
    }

    void p4dcoins_(const REEL_F& decalx,const REEL_F& decaly,
		const REEL_F& decalz)
    {
	graf.P4Dcoin(decalx,decaly,decalz);
    }

    void p4dcoins2_(REEL_F& x1,REEL_F& y1t,REEL_F& z1,REEL_F& x2,
		REEL_F& y2,REEL_F& z2)
    {
	graf.P4Dcoin2(x1,y1t,z1,x2,y2,z2);
    }

    void p4defpa_(const int& ibas,const int& jcolor)
    {
	graf.P4Defpa(ibas,jcolor);
    }

    void p4def2_(const int& masque,const int& icotes,const REEL_F& zarg1)
    {
	graf.P4Def2(masque,icotes,zarg1);
    }

    void p4dtron_(const int& jx,const int& jy,const int& jz)
    {
	graf.P4Dtron(jx,jy,jz);
    }

    void p4dsp3_(REEL_F& x1,REEL_F& y1t,REEL_F& x2,REEL_F& y2) 
    {
	graf.P4Dsp3((REEL&) x1,(REEL&) y1t,(REEL&) x2,(REEL&) y2);
    }

    void p4dspace_(REEL_F& x1,REEL_F& y1t,REEL_F& z1,REEL_F& x2,
		REEL_F& y2,REEL_F& z2,int& logx,int& logy,int& logz,
		P4Boolean& sans_sauvegarde)
    {
	graf.P4DefSpace(x1,y1t,z1,x2,y2,z2,logx,logy,logz,sans_sauvegarde);
    }

    void p4dnbdgr_(REEL_F& x2s1,REEL_F& y2s1,REEL_F& z2s1,REEL_F& c2s1,
		REEL_F& h2s1)
    {
	graf.P4Dnbdgr(x2s1,y2s1,z2s1,c2s1,h2s1);
    }

    void p4dcolo_(const int& ico)
    {
	graf.P4Dcolo(ico);
    }

// points d'entree de P4graf1

    int p4corrv_(REEL_F& x1,REEL_F& y1t,REEL_F& z1,REEL_F& x2,REEL_F& y2,
		REEL_F& z2)
    {
	REEL xx1=x1,yy1=y1t,zz1=z1,xx2=x2,yy2=y2,zz2=z2;
	int ier=graf.P4CorrigeVecteur(xx1,yy1,zz1,xx2,yy2,zz2);
	x1=xx1,y1t=yy1,z1=zz1,x2=xx2,y2=yy2,z2=zz2;
	return ier;
    }

    int  p4vect_(REEL_F& x1,REEL_F& y1t,REEL_F& z1,REEL_F& x2,REEL_F& y2,
		REEL_F& z2)
    {
	return graf.P4Vecteur(x1,y1t,z1,x2,y2,z2);
    }

    int  p4vectc_(REEL_F& x1,REEL_F& y1t,REEL_F& z1,REEL_F& x2,REEL_F& y2,
		REEL_F& z2,int& c)
    {
	return graf.P4VecteurColor(x1,y1t,z1,x2,y2,z2,c);
    }

    int  p4vectcb_(REEL_F& x1,REEL_F& y1t,REEL_F& z1,REEL_F& c1,
		REEL_F& x2,REEL_F& y2,REEL_F& z2,REEL_F& c2)
    {
	return graf.P4VecteurColor(x1,y1t,z1,c1,x2,y2,z2,c2);
    }

    void p4chhau_(const Opt34d& cz)
    {
	graf.P4ChoixHauteurs(cz);
    }

    int p4inith_(REEL hauteurs[],int couleurs[],
		int& nbrehauteurs,Opt34d& cz,const P4Boolean& logh)
    {
	return graf.P4InitHauteurs(hauteurs,couleurs,(unsigned) nbrehauteurs,
		cz,logh);
    }

#ifndef REQRS
    int p4inithb_(REEL_S hauteurs[],int couleurs[],
		int& nbrehauteurs,Opt34d& cz,const P4Boolean& logh)
    {
	return graf.P4InitHauteurs(hauteurs,couleurs,(unsigned) nbrehauteurs,
		cz,logh);
    }
#endif

    int p4inithc_(REEL_S hauteurs[],int& nbrehauteurs,Opt34d& cz,
		int& couleurmin,int& couleurmax,const P4Boolean& logh)
    {
	return graf.P4InitHauteurs(hauteurs,(unsigned) nbrehauteurs,
		cz,(unsigned) couleurmin,(unsigned) couleurmax,logh);
    }

    int p4inithd_(REEL_F& hmin,REEL_F& hmax,REEL_S z[],int& nx,int& ny,
		int& nz,Opt34d& cz,int& nbrehauteurs,
		P4Boolean& modlog,int& couleurmin,int& couleurmax)
    {
	return graf.P4InitHauteurs(hmin,hmax,z,nx,ny,
		nz,cz,(unsigned) nbrehauteurs,modlog,
		(unsigned) couleurmin,(unsigned) couleurmax);
    }

    int p4calch_(REEL_S hauteurs[],const int& nbrehauteurs,
		const REEL_S& hmin,const REEL_S& hmax,const REEL_S z[],
		const int& nx,const int& ny,const int& nz,
		const P4Boolean& modlog)
    {
	return graf.P4CalcHauteurs(hauteurs,nbrehauteurs,hmin,hmax,z,
		nx,ny,nz,modlog);
    }

    int p4ligbr_(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],const REEL_S c[],int& npoints,int& pas)
    {
	return graf.P4Graf1::P4LigneBrisee(x,y,z,c,npoints,pas);
    }

    int p4ligbrb_(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],int& npoints,int& pas)
    {
	return graf.P4Graf1::P4LigneBrisee(x,y,z,npoints,pas);
    }

    int p4ligfe_(REEL_S x[],REEL_S y[],REEL_S z[],
		REEL_S c[],int& npoints,const unsigned char* tf)
    {
	return graf.P4LigneFermee(x,y,z,c,npoints,tf);
    }

    int p4ligfeb_(REEL_S x[],REEL_S y[],REEL_S z[],int& npoints)
    {
	return graf.P4LigneFermee(x,y,z,npoints);
    }

    int p4ligfec_(REEL_S x[],REEL_S y[],REEL_S z[],
		int& npoints,const unsigned char* tf)
    {
	return graf.P4LigneFermee(x,y,z,npoints,tf);
    }

    int p4polyg_(REEL_S x[],REEL_S y[],REEL_S z[],int& npoints) 
    {
	return graf.P4Graf1::P4Polygone(x,y,z,npoints) ;
    }

    int p4polygb_(REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],int& npoints)
    {
	return graf.P4Graf1::P4Polygone(x,y,z,c,npoints);
    }

// points d'entres de P4graf2

    void p4chmain_(const P4Boolean& cherche_mailles)
    {
	graf.P4ChercheMaillesInit(cherche_mailles);
    }

    void p4defec_(const REEL_F& xmin,const REEL_F& ymin,
		const REEL_F& zmin,const REEL_F& cmin,const REEL_F& xmax,
		const REEL_F& ymax,const REEL_F& zmax,const REEL_F& cmax,
		const int& logx,const int& logy,
		const int& logz,const int& logc)
    {
	graf.P4DefEchelles(xmin,ymin,zmin,cmin,xmax,ymax,zmax,cmax,
		logx,logy,logz,logc);
    }

    void p4litec_(REEL_F& xmin,REEL_F& ymin,REEL_F& zmin,REEL_F& cmin,
		REEL_F& xmax,REEL_F& ymax,REEL_F& zmax,REEL_F& cmax,
		int& logx,int& logy,int& logz,int& logc)
    {
	REEL xxmin=xmin,yymin=ymin,zzmin=zmin,ccmin=cmin;
	REEL xxmax=xmax,yymax=ymax,zzmax=zmax,ccmax=cmax;
	graf.P4LitEchelles(xxmin,yymin,zzmin,ccmin,xxmax,yymax,zzmax,ccmax,
		logx,logy,logz,logc);
	xmin=xxmin,ymin=yymin,zmin=zzmin,cmin=ccmin;
	xmax=xxmax,ymax=yymax,zmax=zzmax,cmax=ccmax;
    }

    int p4ligbrc_(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],const REEL_S c[],int& npoints,
		P4Boolean& trace_lent,int& nombre_cesures)
    {
	return graf.P4LigneBrisee(x,y,z,c,npoints,trace_lent,nombre_cesures);
    }

    int p4ligbrd_(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],int& npoints,P4Boolean& trace_lent,
		int& nombre_cesures)
    {
	return graf.P4LigneBrisee(x,y,z,npoints,trace_lent,nombre_cesures);
    }

    int p4polygc_(REEL_S x[],REEL_S y[],REEL_S z[],int& npoints)
    {
	return graf.P4Polygone(x,y,z,npoints);
    }

    void p4in34d_(const Opt34d& fil,const Opt34d& fac,const Opt34d& niv,
		const Opt34d& lis)
    {
	graf.P4Init34d(fil,fac,niv,lis);
    }

    int p4fil_(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int& dimx,int& dimy,int& dimz,int& dimc,
		int& nx,int& ny)
    {
	return graf.P4Filaire(x,y,z,c,dimx,dimy,dimz,dimc,nx,ny);
    }

    int p4filb_(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int& dimx,int& dimy,int& dimz,int& dimc,
		int& nx,int& ny,int mailles[],int& nmailles,
		int& dimmailles,Fil& opt_fil)
    {
	return graf.P4Filaire(x,y,z,c,dimx,dimy,dimz,dimc,nx,ny,
		mailles,nmailles,dimmailles,opt_fil);
    }

    int p4filc_(const int& nbrnoeuds,const int& nbrmailles,
		const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],const int mailles[][3],const Fil& opt_fil)
    {
	return graf.P4Filaire(nbrnoeuds,nbrmailles,x,y,z,c,mailles,opt_fil);
    }

    int p4lis_(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int& dimx,int& dimy,int& dimz,int& dimc,
		int& nx,int& ny,int mailles[],int& nmailles,
		int& dimmailles,Lisse& opt_lisse)
    {
	return graf.P4Lissage(x,y,z,c,dimx,dimy,dimz,dimc,nx,ny,
		mailles,nmailles,dimmailles,opt_lisse);
    }

    int p4lisb_(const int& nbrnoeuds,const int& nbrmailles,
		const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],const int mailles[][3],const Lisse& opt_lisse)
    {
	return graf.P4Lissage(nbrnoeuds,nbrmailles,x,y,z,c,mailles,opt_lisse);
    }

    void p4tragr_()
    {
	graf.P4TraceGrilles();
    }

    void p4delgr_()
    {
	graf.P4AnnuleGrilles();
    }

    void p4defcg_(int& taille_caract_titres,int& taille_caract_echelles)
    {
	graf.P4DefCaracGrille(taille_caract_titres,taille_caract_echelles);
    }

    void p4delgrs_()
    {
	graf.P4AnnuleGrillesSimple();
    }

    void p4newgrs_()
    {
	graf.P4NouvelleGrilleSimple();
    }

    void p4defts_(char* titre_axe_bas,char* titre_axe_haut,
		char* titre_axe_droite,char* titre_axe_gauche,
		char* unite_axe_bas,char* unite_axe_haut,
		char* unite_axe_droite,char* unite_axe_gauche)
    {
	graf.P4DefTitreSimple(titre_axe_bas,titre_axe_haut,
		titre_axe_droite,titre_axe_gauche,
		unite_axe_bas,unite_axe_haut,
		unite_axe_droite,unite_axe_gauche);
    }

    void p4defgrs_(Face& face,REEL_F& decalx,
		P4Boolean& texte_horizontal,int& grad_axex,int& grad_axey,
		int* type_axe,P4Boolean* label_axe,
		int* grad_inter_axe, int* factorisation_axe)
    {
	graf.P4DefGrilleSimple(face,decalx,
		texte_horizontal,grad_axex,grad_axey,
		type_axe,label_axe,grad_inter_axe,factorisation_axe);
    }

    void p4delgra_()
    {
	graf.P4AnnuleGrillesAuto();
    }

    void p4newgra_()
    {
	graf.P4NouvelleGrilleAuto();
    }

    void p4defta_(char* titre_x,char* titre_y,
		char* titre_z,char* unite_x,char* unite_y,
		char* unite_z)
    {
	graf.P4DefTitreAuto(titre_x,titre_y,titre_z,
		unite_x,unite_y,unite_z);
    }

    void p4defgra_(REEL_F& decalx,REEL_F& decaly,REEL_F& decalz,
		P4Boolean& texte_horizontal,int& grad_axex,int& grad_axey,
		int& grad_axez,int& type_grilles,
		int* grad_inter)
    {
	graf.P4DefGrilleAuto(decalx,decaly,decalz,
		texte_horizontal,grad_axex,grad_axey,
		grad_axez,type_grilles,grad_inter);
    }

}


