#ifndef S6BOUTFICH_H
#define S6BOUTFICH_H

// %W% %G% Pierre Brochard
// definitions des classes de bouttons

#include "poulpe/IHM.h"
#include "P4constant.h"
#include "S6boutgen.h"
#include "poulpe/WidAffX.h"

// gestion fichier panel principal ...................................

class NomFichier : public Saisie
{
    public:

	NomFichier(const Widget& parent, const char *label,
		short int taille=20,const char *classe="nom_fichier") :
		Saisie(parent,label,taille,classe) {};
	~NomFichier() {};

	void SelectCB(XtPointer call_data);
};

// Gestion fichiers ....................................

class GestionFichier;

class PurgePsyBouton : public Bouton
{
    private :

	GestionFichier* _pto;

    public :

	PurgePsyBouton(const Widget& parent, const char *label,
		GestionFichier* pto = NULL) :
		Bouton(parent,label) {_pto = pto;};
	~PurgePsyBouton() {};

	void Attach(GestionFichier* pto) {_pto = pto;};

	void SelectCB(XtPointer call_data);
};

class AvancePsyBouton : public Bouton
{
    private :

	GestionFichier* _pto;

    public :

	AvancePsyBouton(const Widget& parent, const char *label,
		GestionFichier* pto = NULL) :
		Bouton(parent,label) {_pto = pto;};
	~AvancePsyBouton() {};

	void Attach(GestionFichier* pto) {_pto = pto;};

	void SelectCB(XtPointer call_data);
};

class ReculePsyBouton : public Bouton
{
    private :

	GestionFichier* _pto;

    public :

	ReculePsyBouton(const Widget& parent, const char *label,
		GestionFichier* pto = NULL) :
		Bouton(parent,label) {_pto = pto;};
	~ReculePsyBouton() {};

	void Attach(GestionFichier* pto) {_pto = pto;};

	void SelectCB(XtPointer call_data);
};

class AllPsyBouton : public Bouton
{
    private :

	GestionFichier* _pto;

    public :

	AllPsyBouton(const Widget& parent, const char *label,
		GestionFichier* pto = NULL) :
		Bouton(parent,label) {_pto = pto;};
	~AllPsyBouton() {};

	void Attach(GestionFichier* pto) {_pto = pto;};

	void SelectCB(XtPointer call_data);
};

class NomPsyFichier : public Saisie
{
    public:

	NomPsyFichier(const Widget& parent, const char *label,
		short int taille=20,const char *classe="nom_fichier") :
		Saisie(parent,label,taille,classe) {};
	~NomPsyFichier() {};

	void SelectCB(XtPointer call_data);
};

class PurgeL3Bouton : public Bouton
{
    private :

	GestionFichier* _pto;

    public :

	PurgeL3Bouton(const Widget& parent, const char *label,
		GestionFichier* pto = NULL) :
		Bouton(parent,label) {_pto = pto;};
	~PurgeL3Bouton() {};

	void Attach(GestionFichier* pto) {_pto = pto;};

	void SelectCB(XtPointer call_data);
};

class AvanceL3Bouton : public Bouton
{
    private :

	GestionFichier* _pto;

    public :

	AvanceL3Bouton(const Widget& parent, const char *label,
		GestionFichier* pto = NULL) :
		Bouton(parent,label) {_pto = pto;};
	~AvanceL3Bouton() {};

	void Attach(GestionFichier* pto) {_pto = pto;};

	void SelectCB(XtPointer call_data);
};

class ReculeL3Bouton : public Bouton
{
    private :

	GestionFichier* _pto;

    public :

	ReculeL3Bouton(const Widget& parent, const char *label,
		GestionFichier* pto = NULL) :
		Bouton(parent,label) {_pto = pto;};
	~ReculeL3Bouton() {};

	void Attach(GestionFichier* pto) {_pto = pto;};

	void SelectCB(XtPointer call_data);
};

class AllL3Bouton : public Bouton
{
    private :

	GestionFichier* _pto;

    public :

	AllL3Bouton(const Widget& parent, const char *label,
		GestionFichier* pto = NULL) :
		Bouton(parent,label) {_pto = pto;};
	~AllL3Bouton() {};

	void Attach(GestionFichier* pto) {_pto = pto;};

	void SelectCB(XtPointer call_data);
};

class NomL3Fichier : public Saisie
{
    public:

	NomL3Fichier(const Widget& parent, const char *label,
		short int taille=20,const char *classe="nom_fichier") :
		Saisie(parent,label,taille,classe) {};
	~NomL3Fichier() {};

	void SelectCB(XtPointer call_data);
};

class PsyNum : public Saisie
{
    private :

	GestionFichier* _pto;

    public:

	PsyNum(const Widget& parent, const char *label,
		short int taille=5,const char *classe="psy_num") :
		Saisie(parent,label,taille,classe) {_pto = NULL;};
	~PsyNum() {};

	void Attach(GestionFichier* pto) {_pto = pto;};

	void SelectCB(XtPointer call_data);
};

class L3Num : public Saisie
{
    private :

	GestionFichier* _pto;

    public:

	L3Num(const Widget& parent, const char *label,
		short int taille=5,const char *classe="psy_num") :
		Saisie(parent,label,taille,classe) {_pto = NULL;};
	~L3Num() {};

	void Attach(GestionFichier* pto) {_pto = pto;};

	void SelectCB(XtPointer call_data);
};

struct GestionFichierAnnuler : public Bouton
{	   
	GestionFichierAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~GestionFichierAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct GestionFichierAide : public Bouton
{	   
	GestionFichierAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~GestionFichierAide() {};
      
	void SelectCB(XtPointer call_data);
};

class GestionFichier : public PullDownEntry
{
    private:

	PopUp			_pere;
	ConteneurLigne		_tout;

	ConteneurJoli		_psy_j;
	ConteneurLigne		_psy;

	ConteneurColonne	_psy_label_cont;
	Label			_psy_label;

	ConteneurColonne	_psy_boutons;
	PurgePsyBouton		_psy_purge;
	AvancePsyBouton		_psy_avance;
	PsyNum			_psy_num;
	ReculePsyBouton		_psy_recule;
	AllPsyBouton		_psy_all;

	Conteneur		_psy_texte;
	NomPsyFichier		_psy_nom;

	ConteneurJoli		_l3_j;
	ConteneurLigne		_l3;

	ConteneurColonne	_l3_label_cont;
	Label			_l3_label;

	ConteneurColonne	_l3_boutons;
	PurgeL3Bouton		_l3_purge;
	AvanceL3Bouton		_l3_avance;
	L3Num			_l3_num;
	ReculeL3Bouton		_l3_recule;
	AllL3Bouton		_l3_all;

	Conteneur		_l3_texte;
	NomL3Fichier		_l3_nom;

	ConteneurJoli		_standard_j;

	ConteneurColonne	_standard;
	GestionFichierAnnuler	_annuler;
	GestionFichierAide	_aide;

    public:

	GestionFichier(const Widget& root,const Widget& parent,
		const char *label);
	~GestionFichier() {};

	void ChangePsy(const char* fich) {_psy_nom.Change(fich);};
	void ChangeL3(const char* fich) {_l3_nom.Change(fich);};

	void ChangeNumPsy(unsigned num);
	void ChangeNumL3(unsigned num);

	void SelectCB(XtPointer call_data);

	void Cache() {_pere.Cache();};
};

// pour le repertoire ...............................................

class PsycheCommuniqL3 : public SaveCommuniq
{
	public :

	    PsycheCommuniqL3() {};
	    ~PsycheCommuniqL3() {};

	    void AddNomFichier(char* fichier);
};

#endif
