#ifndef S6BOUTTONS_H
#define S6BOUTTONS_H

// %W% %G% Pierre Brochard
// definitions des classes de bouttons

#include "poulpe/IHM.h"
#include "P4constant.h"
#include "cameleon/C5tabconfig.h"
#include "poulpe/Repertoire.h"
#include "poulpe/Help.h"
#include "S6boutgen.h"
#include "S6boutgenpsy.h"

// fonctions Quit generale .............................

void Quit(int purge_fenet = 1);
extern "C" {void S6Exit(int status);}

// icone .............................................

class NewIcone : public PullDownEntry
{
    public:

	NewIcone(const Widget& parent, 
                 const char *label) : PullDownEntry(parent, label) {} ;

	void SelectCB(XtPointer call_data);
};

// bouton quit ................................................

class QuitMenu : public PullDownEntry
{
    public:

	QuitMenu(const Widget& parent, 
			const char* label,const char* classe = "MENEN_quit") :
			PullDownEntry(parent, label,classe) {} ;
	~QuitMenu() {};

	void SelectCB(XtPointer call_data);
};

// calcul image .................................

class CalculImage : public Bouton
{
    public :

	CalculImage(const Widget& parent,const char *label,
		const char* classe="BTN_calcul_image") :
		Bouton(parent, label,classe) {};
	~CalculImage() {};

	void SelectCB(XtPointer call_data);
};

// Info Psyche .................................

class InfoPsyche : public Bouton
{
    public :

	InfoPsyche(const Widget& parent,const char *label,
		const char* classe="BTN_info_psyche") :
		Bouton(parent, label,classe) {};
	~InfoPsyche() {};

	void SelectCB(XtPointer call_data);
};

// sous menus options 3d ..........................................

class Options3D;

class Options3dChoix : public BoutonDeChoix
{
    protected :

	Options3D* _pto;

    public :

	Options3dChoix(const Widget& parent, const char *label,
		Options3D* pto=NULL) : BoutonDeChoix(parent,label) {_pto=pto;};
	~Options3dChoix() {};

	void Attach(Options3D* pto) {_pto=pto;};
};

class Options3dChoixP3d : public Options3dChoix
{   	
    public:
   
	Options3dChoixP3d(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixP3d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixP4d : public Options3dChoix
{   	
    public:
   
	Options3dChoixP4d(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixP4d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixN3d : public Options3dChoix
{   	
    public:
   
	Options3dChoixN3d(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixN3d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixN4d : public Options3dChoix
{   	
    public:
   
	Options3dChoixN4d(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixN4d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixF3d : public Options3dChoix
{   	
    public:
   
	Options3dChoixF3d(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixF3d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixF4d : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dChoixF4d(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixF4d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixFimo : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dChoixFimo(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixFimo() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixFi3d : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dChoixFi3d(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixFi3d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixFi4d : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dChoixFi4d(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixFi4d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixL3d : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dChoixL3d(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixL3d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixL4d : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dChoixL4d(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixL4d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixSansm : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dChoixSansm(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixSansm() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixMasq0 : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dChoixMasq0(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixMasq0() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixMasq1 : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dChoixMasq1(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixMasq1() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixMasq2 : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dChoixMasq2(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixMasq2() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dChoixOui : public Options3dChoix
{   	
    public:
   
	Options3dChoixOui(const Widget& parent, const char *label,
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixOui() {};
      
	void SelectCB(XtPointer call_data);
};

class Options3dChoixNon : public Options3dChoix
{   	
    public:
   
	Options3dChoixNon(const Widget& parent, const char *label,
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dChoixNon() {};
      
	void SelectCB(XtPointer call_data);
};

class Options3dChoixFin : public PullDownEntry
{   	
    public:
   
	Options3dChoixFin(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~Options3dChoixFin() {};
      
	void SelectCB(XtPointer call_data);
};

class Options3dChoixAutresSlider : public Slider
{
    private :

        Options3D& _opt3d;

    public :
   
	Options3dChoixAutresSlider(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,Options3D& opt3d,
		const char* classe = "SLIDER") :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) ,
		_opt3d(opt3d) {};
	~Options3dChoixAutresSlider() {};
      
	void SelectCB(XtPointer call_data);
};

class Options3dChoixAutres : public PullDownEntry
{
    private :

        PopUp _pop;
	ConteneurLigne _tout;
	ConteneurJoli _joli;
	ConteneurColonne _col;
        Options3dChoixAutresSlider _sli;

    public:

   	Options3dChoixAutres(const Widget& root,const Widget& parent,
		const char* label,const int& mini, const int& maxi,
		const int& ValeurInitiale,Options3D& opt3d);
	~Options3dChoixAutres() {};
      
	void SelectCB(XtPointer call_data);
	void Change(int newmin,int newmax,int newpos)
		{_sli.Change(newmin,newmax,newpos);};
};

class Options3dTraceX : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dTraceX(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dTraceX() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dTraceY : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dTraceY(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dTraceY() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dTraceXY : public Options3dChoix
{
    private:
   	
    public:
   
	Options3dTraceXY(const Widget& parent, const char *label, 
		Options3D* pto=NULL) : Options3dChoix(parent,label,pto) {};
	~Options3dTraceXY() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3D
{
    private:

	PullDownSubMenu		_options3d;

	PullDownSubMenu		_pixel;
	PullDownSubMenu		_niveau;
	PullDownSubMenu		_facette;
	PullDownSubMenu		_filaire;
	PullDownSubMenu		_lissage;
	PullDownSubMenu		_trace_fil;
	PullDownSubMenu		_masque;
	PullDownSubMenuExclusif	_concatene;

	Options3dChoixP3d	_p3d;
	Options3dChoixP4d	_p4d;

	Options3dChoixN3d	_n3d;
	Options3dChoixN4d	_n4d;

	Options3dChoixF3d	_f3d;
	Options3dChoixF4d	_f4d;

	Options3dChoixFimo	_fimo;
	Options3dChoixFi3d	_fi3d;
	Options3dChoixFi4d	_fi4d;

	Options3dChoixL3d	_l3d;
	Options3dChoixL4d	_l4d;

	Options3dChoixSansm	_sansm;
	Options3dChoixMasq0	_masq0;
	Options3dChoixMasq1	_masq1;
	Options3dChoixMasq2	_masq2;

	Options3dChoixOui	_oui;
	Options3dChoixNon	_non;
	Options3dChoixFin	_fin;
	Options3dChoixAutres	_autres;

	Options3dTraceX		_trace_x;
	Options3dTraceY		_trace_y;
	Options3dTraceXY	_trace_xy;

    public:

	Options3D(const Widget& root,const Widget& parent,const char *label);
	~Options3D() {};

	void ChangeP3d(int choix) {_p3d.Change(choix);};
	void ChangeP4d(int choix) {_p4d.Change(choix);};

	void ChangeN3d(int choix) {_n3d.Change(choix);};
	void ChangeN4d(int choix) {_n4d.Change(choix);};

	void ChangeF3d(int choix) {_f3d.Change(choix);};
	void ChangeF4d(int choix) {_f4d.Change(choix);};

	void ChangeFimo(int choix) {_fimo.Change(choix);};
	void ChangeFi3d(int choix) {_fi3d.Change(choix);};
	void ChangeFi4d(int choix) {_fi4d.Change(choix);};

	void ChangeL3d(int choix) {_l3d.Change(choix);};
	void ChangeL4d(int choix) {_l4d.Change(choix);};

	void ChangeSansm(int choix) {_sansm.Change(choix);};
	void ChangeMasq0(int choix) {_masq0.Change(choix);};
	void ChangeMasq1(int choix) {_masq1.Change(choix);};
	void ChangeMasq2(int choix) {_masq2.Change(choix);};

	void ChangeConcatene(int& choix);

	void ChangeTraceX(int choix) {_trace_x.Change(choix);};
	void ChangeTraceY(int choix) {_trace_y.Change(choix);};
	void ChangeTraceXY(int choix) {_trace_xy.Change(choix);};

	int CalculOption3d();

	void Cache() {_options3d.Cache();};
	void Montre() {_options3d.Montre();};

	Widget GetId() {return _options3d.GetId();};
};

// sous menus options 2d ..........................................

class Options2D;

class Options2dChoix : public BoutonDeChoix {

    protected :

	Options2D* _pto;

    public :

	Options2dChoix(const Widget& parent, const char *label,
		const char* classe="OPT2DCHOIX",Options2D* pto=NULL) :
		BoutonDeChoix(parent,label,classe) {_pto=pto;};
	~Options2dChoix() {};

	void Attach(Options2D* pto) {_pto=pto;};
};

class Options2dChoixCour : public Options2dChoix {

    private:
   	
    public:
   
	Options2dChoixCour(const Widget& parent, const char *label, 
		const char* classe="OPT2DCHOIX",Options2D* pto=NULL) :
		Options2dChoix(parent,label,classe,pto) {};
	~Options2dChoixCour() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options2dChoixInte : public Options2dChoix {

    private:
   	
    public:
   
	Options2dChoixInte(const Widget& parent, const char *label, 
		const char* classe="OPT2DCHOIX",Options2D* pto=NULL) :
		Options2dChoix(parent,label,classe,pto) {};
	~Options2dChoixInte() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options2dChoixDeri : public Options2dChoix {

    private:
   	
    public:
   
	Options2dChoixDeri(const Widget& parent, const char *label, 
		const char* classe="OPT2DCHOIX",Options2D* pto=NULL) :
		Options2dChoix(parent,label,classe,pto) {};
	~Options2dChoixDeri() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options2dChoixOui : public Options2dChoix {

    private:
   	
    public:
   
	Options2dChoixOui(const Widget& parent, const char *label, 
		const char* classe="OPT2DCHOIX",Options2D* pto=NULL) :
		Options2dChoix(parent,label,classe,pto) {};
	~Options2dChoixOui() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options2dChoixNon : public Options2dChoix {

    private:
   	
    public:
   
	Options2dChoixNon(const Widget& parent, const char *label, 
		const char* classe="OPT2DCHOIX",Options2D* pto=NULL) :
		Options2dChoix(parent,label,classe,pto) {};
	~Options2dChoixNon() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options2D {

    private:

	PullDownSubMenu		_options2d;

	PullDownSubMenu		_trace;
	PullDownSubMenu		_concatene;

	Options2dChoixCour	_cour;
	Options2dChoixInte	_inte;
	Options2dChoixDeri	_deri;

	Options2dChoixOui	_oui;
	Options2dChoixNon	_non;

    public:

	Options2D(const Widget& parent,const char *label);
	~Options2D() {};

	void ChangeCour(int choix) {_cour.Change(choix);};
	void ChangeInte(int choix) {_inte.Change(choix);};
	void ChangeDeri(int choix) {_deri.Change(choix);};

	void ChangeOui(int choix) {_oui.Change(choix);};
	void ChangeNon(int choix) {_non.Change(choix);};

	void Cache() {_options2d.Cache();};
	void Montre() {_options2d.Montre();};
};

// choix verticaux ........................................

class ChoixVerticalCouleurTitres : public ChoixVerticalCascade
{
    public:

	ChoixVerticalCouleurTitres(const Widget& parent,
		ChoixVerticalPanel& panel,const char* name,
		const char* label,int col = 1) :
		ChoixVerticalCascade(parent,panel,name,label,col) {};
	~ChoixVerticalCouleurTitres() {};

	void ChargeInv();
};

class ChoixVerticalTailleTitres : public ChoixVerticalCascade
{
    public:

	ChoixVerticalTailleTitres(const Widget& parent,
		ChoixVerticalPanel& panel,const char* name,
		const char* label,int col = 1) :
		ChoixVerticalCascade(parent,panel,name,label,col) {};
	~ChoixVerticalTailleTitres() {};

	void ChargeInv();
};

// titres ....................................

class Titres;

class TitresChoix : public BoutonDeChoix
{
    protected :

	Titres* _pto;

    public :

	TitresChoix(const Widget& parent, const char *label,
		const char* classe,Titres* pto=NULL) :
		BoutonDeChoix(parent,label,classe) {_pto=pto;};
	~TitresChoix() {};

	void Attach(Titres* pto) {_pto=pto;};
};

class TitresChoixHaut : public TitresChoix
{
    private:
   	
    public:
   
	TitresChoixHaut(const Widget& parent, const char *label, 
		const char* classe,Titres* pto=NULL) :
		TitresChoix(parent,label,classe,pto) {};
	~TitresChoixHaut() {};
      
	void SelectCB(XtPointer call_data);
};

class TitresChoixGauche : public TitresChoix
{
    private:
   	
    public:
   
	TitresChoixGauche(const Widget& parent, const char *label, 
		const char* classe,Titres* pto=NULL) :
		TitresChoix(parent,label,classe,pto) {};
	~TitresChoixGauche() {};
      
	void SelectCB(XtPointer call_data);
};

class TitresChoixDroit : public TitresChoix
{
    private:
   	
    public:
   
	TitresChoixDroit(const Widget& parent, const char *label, 
		const char* classe,Titres* pto=NULL) :
		TitresChoix(parent,label,classe,pto) {};
	~TitresChoixDroit() {};
      
	void SelectCB(XtPointer call_data);
};

class TitresChoixBas : public TitresChoix
{
    private:
   	
    public:
   
	TitresChoixBas(const Widget& parent, const char *label, 
		const char* classe,Titres* pto=NULL) :
		TitresChoix(parent,label,classe,pto) {};
	~TitresChoixBas() {};
      
	void SelectCB(XtPointer call_data);
};

class TitresChoixNon : public TitresChoix
{
    private:
   	
    public:
   
	TitresChoixNon(const Widget& parent, const char *label, 
		const char* classe,Titres* pto=NULL) :
		TitresChoix(parent,label,classe,pto) {};
	~TitresChoixNon() {};
      
	void SelectCB(XtPointer call_data);
};

class TitresChoixSans : public TitresChoix
{
    private:
   	
    public:
   
	TitresChoixSans(const Widget& parent, const char *label, 
		const char* classe,Titres* pto=NULL) :
		TitresChoix(parent,label,classe,pto) {};
	~TitresChoixSans() {};
      
	void SelectCB(XtPointer call_data);
};

class TitresChoixAvec : public TitresChoix
{
    private:
   	
    public:
   
	TitresChoixAvec(const Widget& parent, const char *label, 
		const char* classe,Titres* pto=NULL) :
		TitresChoix(parent,label,classe,pto) {};
	~TitresChoixAvec() {};
      
	void SelectCB(XtPointer call_data);
};

class TitresSaisie : public Saisie
{
    private:
   	
    public:
   
	TitresSaisie(const Widget& parent,const char* label,
		short int taille=20,const char* classe="TitresSaisie") :
		Saisie(parent,label,taille,classe) {};
	~TitresSaisie() {};
      
	void SelectCB(XtPointer call_data);
	void ChangeValeur();
};

class TitreOK : public Bouton
{
    private :

	Titres* _pto;

    public :

	TitreOK(const Widget& parent, const char* label,
		const char* classe,Titres* pto = NULL) :
		Bouton(parent,label,classe) {_pto = pto;};
	~TitreOK() {};

	void Attach(Titres* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

struct TitreAnnuler : public Bouton
{	   
	TitreAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~TitreAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct TitreAide : public Bouton
{	   
	TitreAide(const Widget& parent, const char *label, 
		const char* classe);
	~TitreAide() {};
      
	void SelectCB(XtPointer call_data);
};

class Titres : public PullDownEntry
{
    private:

	PopUp				_pere;
	ConteneurLigne			_tout;

	ConteneurJoli			_titre_j;

	ConteneurExclusifColonne	_titre;
	Label				_titre_place_en;
	TitresChoixHaut			_haut;
	TitresChoixGauche		_gauche;
	TitresChoixDroit		_droit;
	TitresChoixBas			_bas;

	ConteneurJoli			_param_j;
	ConteneurLigne			_param_l;

	ConteneurExclusifColonne	_affichage;
	Label				_label_affichage;
	TitresChoixNon			_non;
	TitresChoixSans			_sans;
	TitresChoixAvec			_avec;

	ConteneurLigne			_texte;
	Label				_titre_mes;
	TitresSaisie			_titre_valeur;

	ConteneurColonne		_params;
	ChoixVerticalCouleurTitres	_couleur;
	ChoixVerticalTailleTitres	_taille;

	ConteneurJoli			_standard_j;

	ConteneurColonne		_titre_standard;
	TitreOK				_titre_ok;
	TitreAnnuler			_titre_annuler;
	TitreAide			_titre_aide;

    public:

	Titres(const Widget& root,const Widget& parent,
		const char *label);
	~Titres() {};

	void SelectCB(XtPointer call_data);

	void Cache() {_pere.Cache();};
	void Montre() {_pere.Montre();};

	void Charge(int titre_num);
	void ChargeInv();

	void Change(const char* titre_valeur);
	void ChangeValeur() {_titre_valeur.ChangeValeur();};

	void ChangeNumero(int& choix);

	void ChangeNon(int choix) {_non.Change(choix);};
	void ChangeSans(int choix) {_sans.Change(choix);};
	void ChangeAvec(int choix) {_avec.Change(choix);};
};

// textes ..............................................

class Textes;

class NombreTextesSaisie : public Saisie
{
    private:

	Textes* _pto;
	
    public:
   
	NombreTextesSaisie(const Widget& parent,const char* label,
		short int taille=3,const char* classe = "NombreTextesSaisie",
		Textes* pto=NULL) :
		Saisie(parent,label,taille,classe) {_pto = pto;};
	~NombreTextesSaisie() {};

	void Attach(Textes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
	void ChangeValeur(int nombre);
};

class NumeroTextesSlider : public Slider
{
   private:

	Textes* _pto;
	
   public:
   
	NumeroTextesSlider(const Widget& parent, const char *label, 
		const int& mini, const int& maxi, const int& ValeurInitiale,
		const char* classe="NumeroTextesSlider",Textes* pto=NULL) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe)
		{_pto=pto;};
	~NumeroTextesSlider() {};

	void Attach(Textes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class TextesChoix : public BoutonDeChoix
{
    protected :

	Textes* _pto;

    public :

	TextesChoix(const Widget& parent, const char *label,
		const char* classe,Textes* pto=NULL) :
		BoutonDeChoix(parent,label,classe) {_pto=pto;};
	~TextesChoix() {};

	void Attach(Textes* pto) {_pto=pto;};
};

class TextesChoixNon : public TextesChoix
{
    private:
   	
    public:
   
	TextesChoixNon(const Widget& parent, const char *label, 
		const char* classe,Textes* pto=NULL) :
		TextesChoix(parent,label,classe,pto) {};
	~TextesChoixNon() {};
      
	void SelectCB(XtPointer call_data);
};

class TextesChoixSans : public TextesChoix
{   	
    public:
   
	TextesChoixSans(const Widget& parent, const char *label, 
		const char* classe,Textes* pto=NULL) :
		TextesChoix(parent,label,classe,pto) {};
	~TextesChoixSans() {};
      
	void SelectCB(XtPointer call_data);
};

class TextesChoixAvec : public TextesChoix
{
    private:
   	
    public:
   
	TextesChoixAvec(const Widget& parent, const char *label, 
		const char* classe,Textes* pto=NULL) :
		TextesChoix(parent,label,classe,pto) {};
	~TextesChoixAvec() {};
      
	void SelectCB(XtPointer call_data);
};

class TextesSaisie : public Saisie
{   	
    public:
   
	TextesSaisie(const Widget& parent,const char* label,
		short int taille = 50,const char* classe="TextesSaisie") :
		Saisie(parent,label,taille,classe) {};
	~TextesSaisie() {};
      
	void SelectCB(XtPointer call_data);
	void ChangeValeur();
};

class ChoixVerticalCouleurTextes : public ChoixVerticalCascade
{
    public:

	ChoixVerticalCouleurTextes(const Widget& parent,
		ChoixVerticalPanel& panel,const char* name,
		const char* label,int col = 1) :
		ChoixVerticalCascade(parent,panel,name,label,col) {};
	~ChoixVerticalCouleurTextes() {};

	void ChargeInv();
};

class ChoixVerticalTailleTextes : public ChoixVerticalCascade
{
    public:

	ChoixVerticalTailleTextes(const Widget& parent,
		ChoixVerticalPanel& panel,const char* name,
		const char* label,int col = 1) :
		ChoixVerticalCascade(parent,panel,name,label,col) {};
	~ChoixVerticalTailleTextes() {};

	void ChargeInv();
};

class TextesBoutonPosition : public Bouton
{
    protected :

	Textes* _pto;

    public :

	TextesBoutonPosition(const Widget& parent, const char *label,
		const char* classe = "TextesBoutonPosition",Textes* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~TextesBoutonPosition() {};

	void Attach(Textes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class AngleTextesSlider : public Slider
{   	
   public:
   
	AngleTextesSlider(const Widget& parent, const char *label, 
		const int& mini, const int& maxi, const int& ValeurInitiale,
		const char* classe="AngleTextesSlider") :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~AngleTextesSlider() {};
      
	void SelectCB(XtPointer call_data);
};

class TexteGenerateurHard : public BoutonDeChoix
{   	
    public:
   
	TexteGenerateurHard(const Widget& parent, const char *label) :
		BoutonDeChoix(parent,label) {};
	~TexteGenerateurHard() {};
      
	void SelectCB(XtPointer call_data);
};

class TexteGenerateurSoft : public BoutonDeChoix
{
    public :

	TexteGenerateurSoft(const Widget& parent, const char *label) :
		BoutonDeChoix(parent,label) {};
	~TexteGenerateurSoft() {};

	void SelectCB(XtPointer call_data);
};

class TexteOK : public Bouton
{
    private :

	Textes* _pto;

    public :

	TexteOK(const Widget& parent, const char* label,
		const char* classe,Textes* pto = NULL) :
		Bouton(parent,label,classe) {_pto = pto;};
	~TexteOK() {};

	void Attach(Textes* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

struct TexteAnnuler : public Bouton
{	   
	TexteAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~TexteAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct TexteAide : public Bouton
{	   
	TexteAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~TexteAide() {};
      
	void SelectCB(XtPointer call_data);
};

class TextesAppel : public PullDownEntry
{
    public:

	TextesAppel(const Widget& parent,const char *label);
	~TextesAppel() {};

	void SelectCB(XtPointer call_data);
};

class Textes : public PopUp
{
    private:

	ConteneurLigne			_tout;

	ConteneurJoli			_texte_j;
	ConteneurLigne			_texte_l;

	ConteneurColonne		_nombregen;

	ConteneurColonne		_nombre;
	Label				_nombre_label;
	NombreTextesSaisie		_nombre_saisie;

	ConteneurExclusifColonne        _generateur;
	Label				_generateur_label;
	TexteGenerateurHard		_hard;
	TexteGenerateurSoft		_soft;

	ConteneurColonne		_numero;
	Label				_numero_label;
	NumeroTextesSlider		_numero_slider;

	ConteneurJoli			_param_j;
	ConteneurLigne			_param_l;

	ConteneurExclusifColonne	_affichage;
	Label				_affichage_label;
	TextesChoixNon			_non;
	TextesChoixSans			_sans;
	TextesChoixAvec			_avec;

	ConteneurColonne	      	_texte;
	Label				_texte_label;
	TextesSaisie			_texte_saisie;

	ConteneurColonne		_params;
	ChoixVerticalCouleurTextes	_couleur;
	ChoixVerticalTailleTextes	_taille;

	ConteneurColonne		_position;
	TextesBoutonPosition		_position_bouton;
	Label				_position_posx;
	Label				_position_posy;

	ConteneurColonne		_angle;
	Label				_angle_label;
	AngleTextesSlider		_angle_slider;

	ConteneurJoli			_standard_j;

	ConteneurColonne		_standard;
	TexteOK				_ok;
	TexteAnnuler			_annuler;
	TexteAide			_aide;

	int				_texte_nombre;

    public:

	Textes(const Widget& root,const char* titre,int nx,int ny);
	~Textes() {};

	void Charge(int texte_num);
	void ChargeInv();

	void Change(const char* texte_saisie);
	void Change(int min,int max,int pos);
	void Change(REEL xpos,REEL ypos);
	void ChangeValeur(int nombre);
	void ChangeValeur() {_texte_saisie.ChangeValeur();};
	void ChangeNombre();

	void ChangeType(int& choix);
	void ChangeGenerateur(int& choix);
};

#endif
