// ******************************************************************
//		classes bouttons (suite) de Psyche
// ******************************************************************

struct SccsIdS6Bouttons2
{
	static const char* const sccs_id;
};

const char* const SccsIdS6Bouttons2::sccs_id = "%W% %G% Pierre Brochard";

// ******************************************************************
//		includes
// ******************************************************************

#include "S6bouttonsys2.h"
#include "S6bouttons2.h"
#include "S6boutfich.h"
#include "S6boutgenpsy.h"
#include "S6constant.h"
#include "S6gerefenet.h"
#include "S6gerefich.h"
#include "S6gereconfig.h"
#include "S6namecomp.h"
#include "S6traduc.h"
#include "S6outils.h"
#include "S6gereenv.h"

// ******************************************************************
// grilles ................................................
// ******************************************************************

Grilles::Grilles(const Widget& root, const Widget& parent,
		const char *label) : PullDownEntry(parent, label),
		_pere(root,S6Traduc::traduc[97],200,100),
		_tout(_pere.GetId(),"GRILLE_TOUT",-1),

		_grille_j(_tout.GetId(),"GRILLE_GRILLE_J"),

		_grille(_grille_j.GetId(),"GRILLE_GRILLE",-1),
		_grilles(_grille.GetId(),S6Traduc::traduc[98]),
		_grilles_type(_grille.GetId(),"GRILLE_TYPE"),
		_non(_grilles_type.GetId(),S6Traduc::traduc[99],
			"grille_non"),
		_creuse(_grilles_type.GetId(),S6Traduc::traduc[100],
			"grille_creuse"),
		_semi_creuse(_grilles_type.GetId(),S6Traduc::traduc[101],
			"grille_semi_creuse"),
		_pleine(_grilles_type.GetId(),S6Traduc::traduc[102],
			"grille_pleine"),

		_echelle_z_j(_tout.GetId(),"GRILLE_ECHELLE_Z_J"),

		_echelle_z(_echelle_z_j.GetId(),"GRILLE_ECHELLE_Z",-1),
		_echelle_couleur_z(_echelle_z.GetId(),S6Traduc::traduc[103]),
		_echelle_z_type(_echelle_z.GetId(),"GRILLE_ECHELLE_Z_TYPE"),
		_non_z(_echelle_z_type.GetId(),S6Traduc::traduc[104],
			"grille_non_z"),
		_defaut_z(_echelle_z_type.GetId(),S6Traduc::traduc[105],
			"grille_defaut_z"),
		_position_z(_echelle_z_type.GetId(),S6Traduc::traduc[106],
			"grille_position_z"),

		_echelle_c_j(_tout.GetId(),"GRILLE_ECHELLE_C_J"),

		_echelle_c(_echelle_c_j.GetId(),"GRILLE_ECHELLE_C",-1),
		_echelle_couleur_c(_echelle_c.GetId(),S6Traduc::traduc[107]),
		_echelle_c_type(_echelle_c.GetId(),"GRILLE_ECHELLE_C_TYPE"),
		_non_c(_echelle_c_type.GetId(),S6Traduc::traduc[104],
			"grille_non_c"),
		_defaut_c(_echelle_c_type.GetId(),S6Traduc::traduc[105],
			"grille_defaut_c"),
		_position_c(_echelle_c_type.GetId(),S6Traduc::traduc[106],
			"grille_position_c"),

		_legende_34d_j(_tout.GetId(),"GRILLE_ECHELLE_34D_J"),

		_legende_34d(_legende_34d_j.GetId(),"GRILLE_ECHELLE_34D",-1),
		_legende_couleur_34d(_legende_34d.GetId(),
			S6Traduc::traduc[108]),
		_legende_34d_type(_legende_34d.GetId(),
			"GRILLE_CHELLE_34D_TYPE"),
		_non_34d(_legende_34d_type.GetId(),S6Traduc::traduc[104],
			"grille_non_34d"),
		_defaut_34d(_legende_34d_type.GetId(),S6Traduc::traduc[105],
			"grille_defaut_34d"),
		_position_34d(_legende_34d_type.GetId(),S6Traduc::traduc[106],
			"grille_position_34d"),

		_legende_2d_j(_tout.GetId(),"GRILLE_LEGENDE_2D_J"),

		_legende_2d(_legende_2d_j.GetId(),"GRILLE_LEGENDE_2D",-1),
		_legende_couleur_2d(_legende_2d.GetId(),S6Traduc::traduc[112]),
		_legende_2d_type(_legende_2d.GetId(),"GRILLE_LEGENDE_2D_TYPE"),
		_non_2d(_legende_2d_type.GetId(),S6Traduc::traduc[104],
			"grille_non_2d"),
		_defaut_2d(_legende_2d_type.GetId(),S6Traduc::traduc[105],
			"grille_defaut_2d"),
		_position_2d(_legende_2d_type.GetId(),S6Traduc::traduc[106],
			"grille_position_2d"),

		_params_j(_tout.GetId(),"GRILLE_PARAM_J"),

		_params(_params_j.GetId(),"GRILLE_PARAM",2),
		_params1(_params.GetId(),"GRILLE_PARAM1"),
		_couleur(_params1.GetId(),*(S6GereFenet::couleur),
			"GRILLE_COULEUR_GRILLE",S6Traduc::traduc[181],-1),
		_taille_labels(_params1.GetId(),*(S6GereFenet::taille),
			"AXE_TAILLE_LABEL",S6Traduc::traduc[143],-1),

		_grille_standard_j(_tout.GetId(),"GRILLE_STANDARD_J"),

		_grille_standard(_grille_standard_j.GetId(),
			"GRILLE_STANDARD",1),
		_grille_ok(_grille_standard.GetId(),
			S6Traduc::traduc[227],"BTN_OAA"),
		_grille_annuler(_grille_standard.GetId(),S6Traduc::traduc[228],
			"BTN_OAA"),
		_grille_aide(_grille_standard.GetId(),S6Traduc::traduc[229],
			"BTN_OAA")
{
	_non.Change(TRUE);

	_non_z.Change(TRUE);
	_non_c.Change(TRUE);
	_non_34d.Change(TRUE);

	_non_2d.Change(TRUE);

	_pere.BloqueGeom();
}

void Grilles::SelectCB(XtPointer call_data)
{
	ModeTrace(S6Output::Output());
	PullDownEntry::SelectCB(call_data);
	_pere.Montre();
}

void Grilles::ChangeGrille()
{
	_non.Change(grille_type==0);
	_creuse.Change(grille_type==1);
	_semi_creuse.Change(grille_type==2);
	_pleine.Change(grille_type==3);	
}

void Grilles::ChangeEchelleZ()
{
	_non_z.Change(hauteur_z_type==0);
	_defaut_z.Change(hauteur_z_type==1);
	_position_z.Change(hauteur_z_type==2);
}

void Grilles::ChangeEchelleC()
{
	_non_c.Change(hauteur_c_type==0);
	_defaut_c.Change(hauteur_c_type==1);
	_position_c.Change(hauteur_c_type==2);
}

void Grilles::ChangeLegende34D()
{
	_non_34d.Change(hauteur_label_type==0);
	_defaut_34d.Change(hauteur_label_type==1);
	_position_34d.Change(hauteur_label_type==2);
}

void Grilles::ChangeLegende2D()
{
	_non_2d.Change(courbe_label_type==0);
	_defaut_2d.Change(courbe_label_type==1);
	_position_2d.Change(courbe_label_type==2);
}

void Grilles::ChangeChoixVertical()
{
	_couleur.Change(grille_couleur);
	_taille_labels.Change(min(15,max(0,axe_taille_echelle/8-1)));
}

void Grilles::Montre2d()
{
	_pere.LibereGeom();
	_echelle_z_j.Cache();
	_echelle_c_j.Cache();
	_legende_34d_j.Cache();
	_legende_2d_j.Montre();
	_pere.BloqueGeom();
}

void Grilles::Montre3d()
{
	_pere.LibereGeom();
	_echelle_z_j.Montre();
	_echelle_c_j.Montre();
	_legende_34d_j.Montre();
	_legende_2d_j.Cache();
	_pere.BloqueGeom();
}

void Grilles::Cache()
{
	_pere.Cache();
}

void Grilles::Montre()
{
	_pere.Montre();
}

void GrilleOK::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // on prend en compte les valeurs de la config partielles lues
    // precedemment

	S6GereConfig::_config = S6GereConfigP::_p_grille_config;

	if(calcul_ok_cache) S6GereFenet::grilles->Cache();

}

void GrilleAnnuler::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // on annule les valeurs lues dans la config partielle

	S6GereConfigP::_p_grille_config = S6GereConfig::_config;
	S6GereFenet::ReConfigGrille();
	S6GereFenet::grilles->Cache();
}

void GrilleAide::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	if(S6GereFenet::grilles_help == NULL)
	{
	    cout << " creation pop-up-help Grilles " << endl;

	    S6GereFenet::grilles_help = new Help(GetId(),S6Traduc::traduc[238],
		"GRILLES_HELP");
	}	

	S6GereFenet::grilles_help->Montre();
}

void GrilleChoixNon::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_grille_type = 0;	
}

void GrilleChoixCreuse::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_grille_type = 1;		
}

void GrilleChoixSemiCreuse::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_grille_type = 2;
}

void GrilleChoixPleine::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_grille_type = 3;
}

void GrilleChoixNonz::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_hauteur_z_type = 0;	
}

void GrilleChoixDefautz::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_hauteur_z_type = 1;

	p_hauteur_z_x_min = .95;
	p_hauteur_z_y_min = .1;
	p_hauteur_z_x_max = .99;
	p_hauteur_z_y_max = .9;		
}

void GrilleChoixPositionz::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_hauteur_z_type = 2;

	L3GetPosition(2,p_hauteur_z_x_min,p_hauteur_z_y_min);
	L3GetPositionRect(2,p_hauteur_z_x_max,p_hauteur_z_y_max);

	cout << " hauteur_z_x_min " << p_hauteur_z_x_min << endl;
	cout << " hauteur_z_y_min " << p_hauteur_z_y_min << endl;
	cout << " hauteur_z_x_max " << p_hauteur_z_x_max << endl;
	cout << " hauteur_z_y_max " << p_hauteur_z_y_max << endl;
}

void GrilleChoixNonc::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_hauteur_c_type = 0;	
}

void GrilleChoixDefautc::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_hauteur_c_type = 1;

	p_hauteur_c_x_min = .85;
	p_hauteur_c_y_min = .1;
	p_hauteur_c_x_max = .89;
	p_hauteur_c_y_max = .9;		
}

void GrilleChoixPositionc::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_hauteur_c_type = 2;

	L3GetPosition(2,p_hauteur_c_x_min,p_hauteur_c_y_min);
	L3GetPositionRect(2,p_hauteur_c_x_max,p_hauteur_c_y_max);
}

void GrilleChoixNon34d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_hauteur_label_type = 0;	
}

void GrilleChoixDefaut34d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_hauteur_label_type = 1;

	p_hauteur_label_x_min = .85;
	p_hauteur_label_y_min = .1;
	p_hauteur_label_x_max = .89;
	p_hauteur_label_y_max = .9;		
}

void GrilleChoixPosition34d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_hauteur_label_type = 2;

	L3GetPosition(2,p_hauteur_label_x_min,p_hauteur_label_y_min);
	L3GetPositionRect(2,p_hauteur_label_x_max,p_hauteur_label_y_max);
}

void GrilleChoixNon2d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_courbe_label_type = 0;	
}

void GrilleChoixDefaut2d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_courbe_label_type = 1;

	p_courbe_label_x_min = .85;
	p_courbe_label_y_min = .1;
	p_courbe_label_x_max = .89;
	p_courbe_label_y_max = .9;		
}

void GrilleChoixPosition2d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_courbe_label_type = 2;

	L3GetPosition(2,p_courbe_label_x_min,p_courbe_label_y_min);
	L3GetPositionRect(2,p_courbe_label_x_max,p_courbe_label_y_max);
}

void ChoixVerticalCouleurGrille::ChargeInv()
{
	p_grille_couleur = Choix();

	if(!parametre_couleur_fond && !p_grille_couleur) p_grille_couleur = 1;

}

void ChoixVerticalTailleLabelsAxes::ChargeInv()
{
	p_axe_taille_echelle = max((Choix() + 1) * 8,10);
}

// sous-menu fond .............................................

Fond::Fond(const Widget& parent,const char *label) :
		_fond(parent, label),
		_oui(_fond.GetId(),S6Traduc::traduc[111]),
		_non(_fond.GetId(),S6Traduc::traduc[110]),
		_garde(_fond.GetId(),S6Traduc::traduc[308]),
		_efface(_fond.GetId(),S6Traduc::traduc[309])

{
	_non.Change(TRUE);
	_oui.Change(FALSE);
	_garde.Change(TRUE);
}

void
Fond::Change(int& choix)
{
	_non.Change(FALSE);
	_oui.Change(FALSE);
	_garde.Change(FALSE);

	switch(choix)
	{
	    case 0 :
		_non.Change(TRUE);
		break;

	    case 1 :
		_oui.Change(TRUE);
		break;

	    case 2 :
		_garde.Change(TRUE);
		break;

	    default :
		choix = 0;
		_non.Change(TRUE);
		break;
	}

}

void
FondNon::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_fond = 0;
}

void
FondOui::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_fond = 1;
}

void
FondGarde::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_fond = 2;
}

void
FondEfface::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);

	if(S6GereEnv::dest_x11)
	{
	    S6GereFenet::pt_canvas->Clear();
	}

}

// repertoire ...............................................

void
PsycheCommuniq::FichierChoisi(char** fichiers,int nombre,int action)
{
    // action = 0 stockage dans GestionFichier
    // action = 1 stockage dans GestionFichier + chargement fichier
    // action = 2 chargement fichier

	if(fichiers == NULL || nombre <= 0) return;

	if(!_chemin)
	{
	    _fichier = TRUE;

	    register int nb = S6NameComp::fichiers_repertoire_nb;
	    register int i=0;

	    for(;i<nb;i++)
	    {
		delete[] S6NameComp::fichiers_repertoire[i];
	    }

	    delete[] S6NameComp::fichiers_repertoire;

	    S6NameComp::fichiers_repertoire = new char*[nombre];

	    register int j = 0;

	    for(i=0;i<nombre;i++)
	    {

		if(fichiers[i] != NULL && strcmp(fichiers[i],"") != 0)
		{
		    char* fichier_temp = new char[strlen(fichiers[i])+1];

		    strcpy(fichier_temp,fichiers[i]);

		    S6NameComp::fichiers_repertoire[i] = fichier_temp;
		    j++;
		}

	    }

	    S6NameComp::fichiers_repertoire_nb = j;
	}
	else
	{
	    _fichier = FALSE;
	    _chemin = FALSE;

	    char* fichier_temp = NULL;
	    P4Boolean exist_l3 = FALSE;
	    P4Boolean exist_psy = FALSE;

	    for(int i=0;i<nombre;i++)
	    {

		if(fichiers[i] != NULL && strcmp(fichiers[i],"") != 0)
		{
		    fichier_temp = new char[strlen(fichiers[i])+
			 strlen(S6NameComp::chemin_repertoire)+2];

		    strcpy(fichier_temp,S6NameComp::chemin_repertoire);
		    strcat(fichier_temp,"/");
		    strcat(fichier_temp,fichiers[i]);

		    delete[] S6NameComp::fichier_points;

		    S6NameComp::fichier_points = fichier_temp;

		    if(action == 2)
		    {

			if(_ptr) _ptr->Change(fichier_temp);

			S6GereFichier::LitFichier();

			return;
		    }

		    if(!strstr(fichier_temp,"l3.") &&
		       !strstr(fichier_temp,".l3"))
		    {
			S6NameComp::AjoutePileFichiersPsy(fichier_temp);
			S6NameComp::num_fichier_psy =
			    S6NameComp::taille_pile_psy-1;
			exist_psy = TRUE;
		    }
		    else
		    {
			S6NameComp::AjoutePileFichiersL3(fichier_temp);
			S6NameComp::num_fichier_l3 =
			    S6NameComp::taille_pile_l3-1;
			exist_l3 = TRUE;
		    }

		    if(action) S6GereFichier::LitFichier();

		}

	    }

	    if(fichier_temp && _ptr) _ptr->Change(fichier_temp);

	    if(exist_psy && S6GereFenet::gestion_fichier)
	    {
		S6GereFenet::gestion_fichier->
		    ChangePsy(S6NameComp::pile_fichiers_psy[
		    S6NameComp::num_fichier_psy]);
		S6GereFenet::gestion_fichier->
		    ChangeNumPsy(S6NameComp::num_fichier_psy + 1);
	    }

	    if(exist_l3 && S6GereFenet::gestion_fichier)
	    {
		S6GereFenet::gestion_fichier->
		    ChangeL3(S6NameComp::pile_fichiers_l3[
		    S6NameComp::num_fichier_l3]);
		S6GereFenet::gestion_fichier->
		    ChangeNumL3(S6NameComp::num_fichier_l3 + 1);
	    }

	}

}

void
PsycheCommuniq::CheminChoisi(const char* const chemin,int action)
{
    // action = 0 stockage dans GestionFichier
    // action = 1 stockage dans GestionFichier + chargement fichier
    // action = 2 chargement fichier

	cout << "PsycheCommuniq> chemin " << chemin << endl;

	if(!chemin || strcmp(chemin,"") == 0) return;

	if(!_fichier)
	{
	    _chemin = TRUE;

	    char* chemin_temp = new char[strlen(chemin)+1];

	    strcpy(chemin_temp,chemin);

	    delete[] S6NameComp::chemin_repertoire;

	    S6NameComp::chemin_repertoire = chemin_temp;
	}
	else
	{
	    _fichier = FALSE;
	    _chemin = FALSE;

	    register int nb = S6NameComp::fichiers_repertoire_nb;
	    char* chemin_temp = NULL;
	    P4Boolean exist_l3 = FALSE;
	    P4Boolean exist_psy = FALSE;

	    for(register int i=0;i<nb;i++)
	    {
		chemin_temp = new char[strlen(chemin)+
			 strlen(S6NameComp::fichiers_repertoire[i])+2];

		strcpy(chemin_temp,chemin);
		strcat(chemin_temp,"/");
		strcat(chemin_temp,S6NameComp::fichiers_repertoire[i]);

		delete[] S6NameComp::fichier_points;

		S6NameComp::fichier_points = chemin_temp;

		if(action == 2)
		{

		    if(_ptr) _ptr->Change(chemin_temp);

		    S6GereFichier::LitFichier();

		    return;
		}

		if(!strstr(chemin_temp,"l3.") && !strstr(chemin_temp,".l3"))
		{
		    S6NameComp::AjoutePileFichiersPsy(chemin_temp);
		    S6NameComp::num_fichier_psy = S6NameComp::taille_pile_psy-1;
		    exist_psy = TRUE;
		}
		else
		{
		    S6NameComp::AjoutePileFichiersL3(chemin_temp);
		    S6NameComp::num_fichier_l3 = S6NameComp::taille_pile_l3-1;
		    exist_l3 = TRUE;
		}

		if(action) S6GereFichier::LitFichier();

	    }

	    if(chemin_temp && _ptr) _ptr->Change(chemin_temp);

	    if(exist_psy && S6GereFenet::gestion_fichier)
	    {
		S6GereFenet::gestion_fichier->
		    ChangePsy(S6NameComp::pile_fichiers_psy[
		    S6NameComp::num_fichier_psy]);
		S6GereFenet::gestion_fichier->
		    ChangeNumPsy(S6NameComp::num_fichier_psy + 1);
	    }

	    if(exist_l3 && S6GereFenet::gestion_fichier)
	    {
		S6GereFenet::gestion_fichier->
		    ChangeL3(S6NameComp::pile_fichiers_l3[
		    S6NameComp::num_fichier_l3]);
		S6GereFenet::gestion_fichier->
		    ChangeNumL3(S6NameComp::num_fichier_l3 + 1);
	    }

	}

}

const char*
PsycheCommuniq::DirectoryInitial()
{
	return S6NameComp::chemin_repertoire;
}
