// ident

struct SccsIdS6Bouttons3
{
	static const char* const sccs_id;
};

const char* const SccsIdS6Bouttons3::sccs_id = "%W% %G% Pierre Brochard";

// includes

#include "S6bouttonsys3.h"
#include "S6bouttons3.h"
#include "S6boutgenpsy.h"
#include "S6constant.h"
#include "S6trace.h"
#include "S6gerefenet.h"
#include "S6gerefich.h"
#include "S6points.h"
#include "S6gereconfig.h"
#include "sanglier.h"
#include "S6traduc.h"
#include "S6flagssup.h"
#include "S6initcourbe.h"
#include "dinosaure/S6string.h"

// ******************************************************************
//		classes bouttons (suite 2) de Psyche
// ******************************************************************

// courbes ..................................................

CourbesAppel::CourbesAppel(const Widget& parent,const char *label) :
		PullDownEntry(parent, label)
{
}

void
CourbesAppel::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);

	if(!S6GereFenet::courbes)
	{
	    S6GereFenet::courbes = new Courbes(S6GereFenet::root->
			    ElVisuel()->GetId());
	    S6GereFenet::ReConfigCourbes();

	    const unsigned nbcourbes =
		S6GereFichier::pt_points->DonneeAbstraite();

	    S6GereFenet::courbes->Change(nbcourbes);
	}	

	S6GereFenet::courbes->Montre();
}

Courbes::Courbes(const Widget& root) :
		PopUp(root,S6Traduc::traduc[208],200,200),
		_tout(GetId(),"COURBE_TOUT",-1),

		_nombre_j(_tout.GetId(),"courbe_nombre_j"),

		_nombre(_nombre_j.GetId(),"courbe_nombre"),
		_nombre_label(_nombre.GetId(),S6Traduc::traduc[209]),
		_nombre_saisie(_nombre.GetId(),""),
		_nombre_courbes_reel(_nombre.GetId(),""),

		_numero_j(_tout.GetId(),"courbe_numero_j"),
		_numero_l(_numero_j.GetId(),"courbe_numero_l",-1),

		_numero_min(_numero_l.GetId(),"courbe_numero_min"),
		_numero_label_min(_numero_min.GetId(),S6Traduc::traduc[210]),
		_numero_slider_min(_numero_min.GetId(),"",0,1,0),

		_numero_max(_numero_l.GetId(),"courbe_numero_max"),
		_numero_label_max(_numero_max.GetId(),S6Traduc::traduc[211]),
		_numero_slider_max(_numero_max.GetId(),"",0,1,0),

		_options_j(_tout.GetId(),"options_j"),
		_options_l(_options_j.GetId(),"options_l",-1),

		_cote(_options_l.GetId(),"COURBE_TYPE"),
		_cote_label(_cote.GetId(),S6Traduc::traduc[257]),
		_gauche(_cote.GetId(),S6Traduc::traduc[258],"courbe_gauche"),
		_droit(_cote.GetId(),S6Traduc::traduc[259],"courbe_droit"),

		_type(_options_l.GetId(),"COURBE_TYPE",2),
		_type_label(_type.GetId(),S6Traduc::traduc[212]),
		_non(_type.GetId(),S6Traduc::traduc[213],"courbe_non"),
		_simple(_type.GetId(),S6Traduc::traduc[214],"courbe_simple"),
		_marche(_type.GetId(),S6Traduc::traduc[215],"courbe_marche"),
		_plus(_type.GetId(),S6Traduc::traduc[216],"courbe_plus"),
		_etoile(_type.GetId(),S6Traduc::traduc[217],"courbe_etoile"),
		_rond(_type.GetId(),S6Traduc::traduc[218],"courbe_rond"),
		_mul(_type.GetId(),S6Traduc::traduc[219],"courbe_mul"),
		_point(_type.GetId(),S6Traduc::traduc[220],"courbe_point"),
		_erreur(_type.GetId(),S6Traduc::traduc[242],"courbe_erreur"),

		_label(_options_l.GetId(),"COURBE_LABEL",-1),
		_label_label(_label.GetId(),S6Traduc::traduc[221]),
		_label_saisie(_label.GetId(),""),
		_couleur_label(_label.GetId(),S6Traduc::traduc[222]),
		_couleur_choix(_label.GetId(),*(S6GereFenet::couleur),
			"COURBE_COULEUR_CHOIX",S6Traduc::traduc[307]),

		_standard_j(_tout.GetId(),"standard_j"),
		_standard(_standard_j.GetId(),"COURBE_STANDARD",1),
		_ok(_standard.GetId(),S6Traduc::traduc[227],"BTN_OAA"),
		_annuler(_standard.GetId(),S6Traduc::traduc[228],"BTN_OAA"),
		_aide(_standard.GetId(),S6Traduc::traduc[229],"BTN_OAA"),

		_courbe_nombre(0),
		_courbe_numero_min(0),
		_courbe_numero_max(0)
{
	_numero_slider_min.Attach(this);
	_numero_slider_max.Attach(this);
	_nombre_saisie.Attach(this);

	_gauche.Attach(this);
	_droit.Attach(this);

	_non.Attach(this);
	_simple.Attach(this);
	_marche.Attach(this);
	_plus.Attach(this);
	_etoile.Attach(this);
	_rond.Attach(this);
	_mul.Attach(this);
	_point.Attach(this);
	_erreur.Attach(this);

	_label_saisie.Attach(this);
	_couleur_choix.Attach(this);

	_non.Change(TRUE);

	_ok.Attach(this);

	_nombre.Margin(0);
	_numero_min.Margin(0);
	_numero_max.Margin(0);
	_type.Margin(0);
	BloqueGeom();
}

void
Courbes::Change(int nombre_courbes)
{
	S6String ss(nombre_courbes);
	char* ptos = ss;

	_nombre_courbes_reel.Change(ptos);

	delete[] ptos;
}

void
Courbes::ChargeType(int val)
{

    // lecture des valeurs de config a partir du popup Courbes

	if(val >= 0)
	{
	    ChangeNon(val == 0);

	    if(val < 3 || val > 7)
	    {
		ChangeSimple(val == 1);
	    }

	    ChangeMarche(val == 2);
	    ChangePlus(val == 3);
	    ChangeEtoile(val == 4);
	    ChangeRond(val == 5);
	    ChangeMul(val == 6);
	    ChangePoint(val == 7);
	    ChangeErreur(val == 8);
	}

	int pct = _marche.IsSelected()*2 +
		_plus.IsSelected()*3 + _etoile.IsSelected()*4 +
		_rond.IsSelected()*5 + _mul.IsSelected()*6 +
		_point.IsSelected()*7 + _erreur.IsSelected()*8;
	int simple = _simple.IsSelected();

	if(pct && simple)
	{
	    pct += 6;
	}
	else
	{
	    pct += simple;
	}

	if(!pct)
	{
	    ChangeNon(1);
	}

	for(int i=_courbe_numero_min;i<=_courbe_numero_max;i++)
	{
	    p_courbe_type[i] = pct - 1;
	}

}

void
Courbes::ChargeCote()
{

    // lecture des valeurs de config a partir du popup Courbes

	int dis = _droit.IsSelected();

	for(int i=_courbe_numero_min;i<=_courbe_numero_max;i++)
	{
	    p_courbe_cote[i] = dis;
	}

}

void
Courbes::Charge(int courbe_num_min,int courbe_num_max)
{

    // chargement des valeurs de config dans le popup Courbes

	cout << "Courbes> courbe_nombre " << _courbe_nombre;
	cout << "\nCourbes> courbe_numero_min " << courbe_num_min;
	cout << "\nCourbes> courbe_numero_max " << courbe_num_max << endl;

	courbe_num_min = max(0,min(courbe_num_min,_courbe_nombre-1));
	courbe_num_max = max(0,min(courbe_num_max,_courbe_nombre-1));

	_courbe_numero_min = courbe_num_min;
	_courbe_numero_max = courbe_num_max;

	Change(0,_courbe_nombre - 1,courbe_num_min,courbe_num_max);

	const int courbe_cote_val = p_courbe_cote[courbe_num_min];

	ChangeGauche(courbe_cote_val == 0);
	ChangeDroit(courbe_cote_val == 1);

	int courbe_type_val = p_courbe_type[courbe_num_min] + 1;

	ChangeNon(courbe_type_val == 0);
	ChangeSimple(courbe_type_val == 1 || courbe_type_val > 8);
	ChangeMarche(courbe_type_val == 2);

	if(courbe_type_val > 8)
	{
	   courbe_type_val -= 6;
	}

	ChangePlus(courbe_type_val == 3);
	ChangeEtoile(courbe_type_val == 4);
	ChangeRond(courbe_type_val == 5);
	ChangeMul(courbe_type_val == 6);
	ChangePoint(courbe_type_val == 7);
	ChangeErreur(courbe_type_val == 8);

	Change(p_courbe_label[courbe_num_min]);
	_couleur_choix.Change(p_courbe_couleur[courbe_num_min]);
}

void
Courbes::ChangeTaille(int taille)
{

	if(!taille)
	{
	    char*const* const val = p_courbe_label;

	    for(int i=taille;i<p_courbe_label_taille;i++)
	    {
		delete[] val[i];
	    }

	    delete[] p_courbe_label;p_courbe_label = NULL;
	    delete[] p_courbe_cote;p_courbe_cote = NULL;
	    delete[] p_courbe_type;p_courbe_type = NULL;
	    delete[] p_courbe_couleur;p_courbe_couleur = NULL;

	    p_courbe_label_taille = taille;
	    p_courbe_cote_taille = taille;
	    p_courbe_type_taille = taille;
	    p_courbe_couleur_taille = taille;

	    return;
	}

	((C5ConfigTabChar&) p_courbe_label_config)(taille,"");
	((C5ConfigTabInt&) p_courbe_cote_config)(taille,0);
	((C5ConfigTabInt&) p_courbe_type_config)(taille,0);
	((C5ConfigTabInt&) p_courbe_couleur_config)(taille,1);
}

void
Courbes::Change(const char* courbe_saisie)
{
	_label_saisie.Change(courbe_saisie);
}

void
Courbes::Change(int xmin,int xmax,int pos_min,int pos_max)
{
	_courbe_nombre = xmax + 1;
	xmax = xmin+1 > xmax ? xmin+1 : xmax;
	_numero_slider_min.Change(xmin,xmax,pos_min);
	_numero_slider_max.Change(xmin,xmax,pos_max);
}

void
Courbes::ChangeNombre()
{
	int courbe_nombre = 1;

	courbe_nombre = max(courbe_nombre,courbe_cote_taille);
	courbe_nombre = max(courbe_nombre,courbe_type_taille);
	courbe_nombre = max(courbe_nombre,courbe_label_taille);
	courbe_nombre = max(courbe_nombre,courbe_couleur_taille);
	ChangeTaille(courbe_nombre);
	_courbe_nombre = courbe_nombre;

	S6String ss(courbe_nombre);
	char* const ptos = ss;

	_nombre_saisie.Change(ptos);

	delete[] ptos;
}

void
CourbeOK::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // on prend en compte les valeurs de la config partielles lues
    // precedemment

	_pto->ChangeValeur(1);
	S6GereConfig::_config = S6GereConfigP::_p_courbe_config;
	S6InitCourbe::Init();

	if(calcul_ok_cache) S6GereFenet::courbes->Cache();

}

void
CourbeAnnuler::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // on annule les valeurs lues dans la config partielle

	S6GereConfigP::_p_courbe_config = S6GereConfig::_config;
	S6GereFenet::ReConfigCourbes();
	S6GereFenet::courbes->Cache();
}

void
CourbeAide::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	if(S6GereFenet::courbes_help == NULL)
	{
	    cout << "CourbeAide> creation pop-up-help Courbes " << endl;

	    S6GereFenet::courbes_help = new Help(GetId(),S6Traduc::traduc[260],
		"COURBES_HELP");
	}	

	S6GereFenet::courbes_help->Montre();
}

void
NombreCourbesSaisie::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	char* const nombre = GetText();
	istrstream is(nombre);
	int taille = 0;

	is >> taille;

	cout << "NombreCourbesSaisie> nombre de courbes " << taille << endl;

	if(taille >= 1000000000)
	{
	    taille = 999999999;

	    S6String ss(taille);
	    char* const ptos = ss;

	    Change(ptos);

	    delete[] ptos;
	}
	else if(taille == 0)
	{
	    taille = S6GereFichier::pt_points->DonneeAbstraite();

	    S6String ss(taille);
	    char* const ptos = ss;

	    Change(ptos);

	    delete[] ptos;
	}

	ChangeValeur(taille);
}

void
NombreCourbesSaisie::ChangeValeur(int nombre)
{
	_pto->ChangeTaille(nombre);
	_pto->Change(0,nombre-1,0,0);
	_pto->Charge(0,0);
}

void
NumeroCourbesSliderMin::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	int courbe_numero_min = GetValue();
	int courbe_numero_max = _pto->GetValueSliderMax();

	if(courbe_numero_min > courbe_numero_max)
	{
	    courbe_numero_max = courbe_numero_min;
	}

	_pto->ChangeValeur(1);
	_pto->Charge(courbe_numero_min,courbe_numero_max);
}

void
NumeroCourbesSliderMax::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	int courbe_numero_min = _pto->GetValueSliderMin();
	int courbe_numero_max = GetValue();

	if(courbe_numero_min > courbe_numero_max)
	{
	    courbe_numero_min = courbe_numero_max;
	}

	_pto->ChangeValeur(1);
	_pto->Charge(courbe_numero_min,courbe_numero_max);
}

void
ChoixVerticalCouleurCourbes::ChargeInv()
{
	int coul = Choix();

	if(!parametre_couleur_fond && !coul) coul = 1;

	const int cmin = _pto->CourbeNumeroMin();
	const int cmax = _pto->CourbeNumeroMax();
	int* const pcc = p_courbe_couleur;

	for(int i=cmin;i<=cmax;i++)
	{
	    pcc[i] = coul;
	}

}

void
CourbesSaisie::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	ChangeValeur();
}

void
CourbesSaisie::ChangeValeur(int test_modif)
{

    // lecture systematique du label de courbe si on change de numero de courbe

	if(!test_modif || AEteModifie())
	{
	    const char* const textprovi = GetText();
	    const int cmin = _pto->CourbeNumeroMin();
	    const int cmax = _pto->CourbeNumeroMax();

	    for(int i=cmin;i<=cmax;i++)
	    {
		delete[] p_courbe_label[i];

		S6String ss(textprovi);

		p_courbe_label[i] = ss;
	    }

	}

}

void
CourbesChoixGauche::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeCote();
}

void
CourbesChoixGauche::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeCote();
}

void
CourbesChoixDroit::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeCote();
}

void
CourbesChoixDroit::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeCote();
}

void
CourbesChoixNon::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeType(0);
}

void
CourbesChoixNon::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeType(-1);
}

void
CourbesChoixSimple::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeType(1);
}

void
CourbesChoixSimple::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeType(-1);
}

void
CourbesChoixMarche::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeType(2);
}

void
CourbesChoixMarche::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeType(-1);
}

void
CourbesChoixPlus::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeType(3);
}

void
CourbesChoixPlus::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeType(-1);
}

void
CourbesChoixEtoile::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeType(4);
}

void
CourbesChoixEtoile::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeType(-1);
}

void
CourbesChoixRond::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeType(5);
}

void
CourbesChoixRond::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeType(-1);
}

void
CourbesChoixMul::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeType(6);
}

void
CourbesChoixMul::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeType(-1);
}

void
CourbesChoixPoint::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeType(7);
}

void
CourbesChoixPoint::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeType(-1);
}

void
CourbesChoixErreur::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChargeType(8);
}

void
CourbesChoixErreur::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->ChargeType(-1);
}

// ************************************************************
//    panel gestion donnees
// ************************************************************

GestionDonneesAppel::GestionDonneesAppel(const Widget& parent,
		const char* label) :
		PullDownEntry(parent,label)
{
}

void
GestionDonneesAppel::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);

	if(!S6GereFenet::gestiondonnees)
	{
	    S6GereFenet::gestiondonnees =
		new GestionDonnees(S6GereFenet::root->ElVisuel()->GetId());
	    S6GereFenet::ReConfigGestionDonnees();
	}	

	S6GereFenet::gestiondonnees->Montre();
}

void
GestionDonneesOK::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);
	_pto->ChangeValeur();

	if(calcul_ok_cache)
	    _pto->Cache();

}

void
GestionDonneesAnnuler::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	if(S6GereFenet::gestiondonnees)
	    S6GereFenet::gestiondonnees->Cache();

}

void
GestionDonneesAide::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	if(!S6GereFenet::gestiondonnees_help)
	{
	    cout << "GestionDonneesAide> creation pop-up-help GestionDonnees " << endl;

	    S6GereFenet::gestiondonnees_help = new ScrHelp(GetId(),
		S6Traduc::traduc[354],"GESTIONDONNEES_HELP");
	}	

	S6GereFenet::gestiondonnees_help->Montre();
}

GestionDonnees::GestionDonnees(const Widget& root) :
		PopUp(root,S6Traduc::traduc[224],300,300),
		_tout(GetId(),"GESTION_DONNEE_TOUT",-1),

		_num_j(_tout.GetId(),"NUM_J"),
		_num(_num_j.GetId(),"NUM",-1),

		_nombre(_num.GetId(),"gestion_donnee_numero"),
		_nombre__label(_nombre.GetId(),S6Traduc::traduc[231]),
		_nombre_var_label(_nombre.GetId(),S6Traduc::traduc[232]),

		_numero(_num.GetId(),"gestion_donnee_numero"),
		_numero_label(_numero.GetId(),S6Traduc::traduc[225]),
		_numero_saisie(_numero.GetId(),""),
		_titre(_numero.GetId(),""),

		_standard_j(_tout.GetId(),"STANDARD_J"),

		_standard(_standard_j.GetId(),"GESTION_DONNEE_STANDARD",1),
		_ok(_standard.GetId(),S6Traduc::traduc[227],"BTN_OAA"),
		_annuler(_standard.GetId(),S6Traduc::traduc[228],"BTN_OAA"),
		_aide(_standard.GetId(),S6Traduc::traduc[229],"BTN_OAA")
{
	_ok.Attach(this);
	BloqueGeom();
}

void
GestionDonnees::ChangeNumero()
{
	S6String ss(donnee_noeud_numero);
	char* const ptos = ss;

	_numero_saisie.Change(ptos);
	ChangeAll();
	delete[] ptos;
}

void
GestionDonnees::ChangeVarLabel(const unsigned noeud,const unsigned maille)
{
	char* ptos = NULL;

	{
	    ostrstream os;

	    os << noeud << " + " << maille << ends;
	    LibereGeom();
	    _nombre_var_label.Change(ptos = os.str());
	    BloqueGeom();
	}

	delete[] ptos;
}

void
GestionDonnees::ChangeTitre(const char* const label)
{

	if(label)
	{
	    LibereGeom();
	    _titre.Change(label);
	    BloqueGeom();
	}

}

void
GestionDonnees::ChangeAll()
{

	if(!S6GereFichier::pt_points)
	    return;

	const unsigned nbblocs = S6GereFichier::pt_points->DonneeAbstraite();

	if(!nbblocs)
	    return;

	unsigned i;

	for(i=0;i<nbblocs;i++)
	{
	    S6DonneeAbstraite* const sda = S6GereFichier::pt_points->
		DonneeAbstraite()(i);

	    if(sda)
	    {
		const unsigned ncda = sda->CDatas();

		if(ncda)
		{
		    const unsigned taille_i = max(0u,min(unsigned(donnee_noeud_numero),
								  ncda-1));
		    const char* const lab = sda->Labels();
		    const char* const uni = sda->Unites();

		    if(lab && uni)
		    {
			char* const label = S6GereConfig::ExtractTexte(taille_i,
					sda->Labels());
			char* const unite = S6GereConfig::ExtractTexte(taille_i,
					sda->Unites());

			S6GereConfig::ChangeTexte(i,label,unite,1,1,80,0.05,0.05,0.0);
			delete[] label;
			delete[] unite;
		    }

		}

	    }

	}

	const unsigned nbblocs1 = nbblocs - 1;

	if(nbblocs1 < texte_valeur_taille)
	    ChangeTitre(texte_valeur[nbblocs1]);

	const S6DonneeAbstraite* const sda = S6GereFichier::pt_points->
	    DonneeAbstraite()(nbblocs1);

	unsigned nb_don_noeuds = 0;
	unsigned nb_don_mailles = 0;

	if(sda)
	{
	    const unsigned tai = sda->CDatasTypeC();

	    for(i=0;i<tai;i++)
		if(sda->CDatasTypeC()(i) == int(S6DONNEE_MAILLE))
		    nb_don_mailles++;
		else
		    nb_don_noeuds++;

	}

	ChangeVarLabel(nb_don_noeuds,nb_don_mailles);
}

void
NumeroDonneeNoeudSaisie::ChangeValeur()
{
	char* const nombre = GetText();
	istrstream is(nombre);
	int taille = 0;
	is >> taille;

	cout << "NumeroDonneeNoeudSaisie> numero de donnees noeuds " <<
	    taille << endl;

	donnee_noeud_numero = taille;
	S6GereFichier::ChangeCData();

	if(S6GereFenet::gestiondonnees)
	    S6GereFenet::gestiondonnees->ChangeAll();

	S6GereConfigP::_p_texte_config = S6GereConfig::_config;
	S6GereFenet::ReConfigTextes();
}

void
NumeroDonneeNoeudSaisie::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);
	ChangeValeur();
}

// ************************************************************
//       break psyche .................................
// ************************************************************

BreakPsyche::BreakPsyche(const Widget& parent,const char *label,
		const char* classe) :
		Bouton(parent, label,classe)
{
	_ref_break = GetId();
}

void
BreakPsyche::SelectCB(XtPointer call_data) 
{
	Bouton::SelectCB(call_data);
	S6Trace::BreakPsyche(0);

	cerr << "BreakPsyche> Break demande " << _ref_break << endl;
}

// sous-menu Scene .............................................

Scene::Scene(const Widget& parent,const char* label) :
		_scene(parent, label),
		_non(_scene.GetId(),S6Traduc::traduc[110]),
		_oui(_scene.GetId(),S6Traduc::traduc[111]),
		_fin(_scene.GetId(),S6Traduc::traduc[299]),
		_efface(_scene.GetId(),S6Traduc::traduc[338])
{
	_non.Change(TRUE);
	_oui.Change(FALSE);
	_non.Attach(this);
	_oui.Attach(this);
}

void
SceneNon::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	_pto->ChangeOui(FALSE);

	parametre_scene = 0;
}

void
SceneNon::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);

	_pto->ChangeOui(FALSE);
	_pto->ChangeNon(TRUE);

	parametre_scene = 0;
}

void
SceneOui::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	_pto->ChangeNon(FALSE);

	parametre_scene = 1;
}

void
SceneOui::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);

	_pto->ChangeNon(FALSE);
	_pto->ChangeOui(TRUE);

	parametre_scene = 1;
}

void
SceneFin::SelectCB(XtPointer)
{
	S6FlagsSup::num_scene = 0;

	L3SautDePage();
}

void
SceneEfface::SelectCB(XtPointer)
{
    // trace d'un rectangle de couleur fond a la taille 
    // de l'element de scene en cours (avec ses coef de zoom)

	if(parametre_scene)
	{
	    REEL xpag[4],ypag[4];

	    xpag[0] = 0.;ypag[0] = 1.;
	    xpag[1] = 1.;ypag[1] = 1.;
	    xpag[2] = 1.;ypag[2] = 0.;
	    xpag[3] = 0.;ypag[3] = 0.;
	    L3Couleur(0);

	    if(zoom_gra_x_min == 0. && zoom_gra_x_max == 0. &&
			    zoom_gra_y_min == 0. && zoom_gra_y_max == 0.)
	    {
		L3MiseEnPage(2,0.,0.,1.,1.,0.,0.,1.,1.); // textes
	    }
	    else
	    {
		L3MiseEnPage(2,zoom_gra_x_min,zoom_gra_y_min,zoom_gra_x_max,
				zoom_gra_y_max,0.,0.,1.,1.);
	    }

	    L3DefSpace(2,0.,0.,1.,1.);
	    L3Polygone(2,xpag,ypag,4);
	}

}

// trace image (fichiers graphiques).....................................

void
TraceImage::SelectCB(XtPointer call_data) 
{
	Bouton::SelectCB(call_data);
	S6Trace::TraceFichierL3();
}

// axe droit ................................................

AxeDroitAppel::AxeDroitAppel(const Widget& parent,const char *label) :
		PullDownEntry(parent, label)
{
}

void
AxeDroitAppel::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);

	if(!S6GereFenet::axe_droit)
	{
	    cout << "AxeDroitAppel> creation pop-up Axe droit " << endl;

	    S6GereFenet::axe_droit = new AxeDroit(S6GereFenet::root->
		ElVisuel()->GetId());
	    S6GereFenet::ReConfigAxeDroit();
	}	

	S6GereFenet::axe_droit->PopUp::Montre();
}

AxeDroit::AxeDroit(const Widget& root) :
		PopUp(root, S6Traduc::traduc[267],500,200),
		_tout(GetId(),"AXE_DROIT_TOUT",-1),

		_yj(_tout.GetId(),"AXE_DROIT_J"),
		_y(_yj.GetId(),"AXE_DROIT_Y",-1),
		_y_label(_y.GetId(),S6Traduc::traduc[262]),
		_y_type(_y.GetId(),"AXE_DROIT_Y_TYPE"),
		_y_lin(_y_type.GetId(),S6Traduc::traduc[121],
			"axe_droit_y_lin"),
		_y_log(_y_type.GetId(),S6Traduc::traduc[122],
			"axe_droit_y_log"),

		_y_bornes_j(_tout.GetId(),"AXE_DROIT_BORNES_J"),
		_y_bornes(_y_bornes_j.GetId(),"AXE_DROIT_BORNES",-1),
		_y_min_label(_y_bornes.GetId(),S6Traduc::traduc[264]),
		_y_min_texte(_y_bornes.GetId(),""),
		_y_max_label(_y_bornes.GetId(),S6Traduc::traduc[265]),
		_y_max_texte(_y_bornes.GetId(),""),
		_y_auto(_y_bornes.GetId(),S6Traduc::traduc[266]),

		_standard_j(_tout.GetId(),"AXE_DROIT_STANDARD_J"),
		_standard(_standard_j.GetId(),"AXE_DROIT_STANDARD",1),
		_ok(_standard.GetId(),S6Traduc::traduc[227],"BTN_OAA"),
		_annuler(_standard.GetId(),S6Traduc::traduc[228],
			"BTN_OAA"),
		_aide(_standard.GetId(),S6Traduc::traduc[229],
			"BTN_OAA")
{
	_y_lin.Change(TRUE);

	_y_auto.Attach(this);
	_ok.Attach(this);

	BloqueGeom();
}

void
AxeDroit::ChangeAxeMinY()
{
	ChangeAxeMinY(axe_yd_min);
}

void
AxeDroit::ChangeAxeMinY(REEL ymin)
{
	S6String ss(ymin);
	char* ptos = ss;

	_y_min_texte.Change(ptos);

	delete[] ptos;
}

void
AxeDroit::ChangeAxeMaxY()
{
	ChangeAxeMaxY(axe_yd_max);
}

void
AxeDroit::ChangeAxeMaxY(REEL ymax)
{
	S6String ss(ymax);
	char* ptos = ss;

	_y_max_texte.Change(ptos);

	delete[] ptos;
}

void
AxeDroit::Cache()
{
	_y.Montre();
}

void
AxeDroit::Montre()
{
	_y.Cache();
}

void 
AxeDroit::LitAxeMinY(REEL& ymin)
{
	istrstream is(_y_min_texte.GetText());

	is >> ymin;
}

void
AxeDroit::LitAxeMaxY(REEL& ymax)
{
	istrstream is(_y_max_texte.GetText());

	is >> ymax;
}

void
AxeDroitOK::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // lecture de tous les champs textes

	_pto->LitAxeMinY(p_axe_yd_min);p_axe_yd_min_reel = p_axe_yd_min;
	_pto->LitAxeMaxY(p_axe_yd_max);p_axe_yd_max_reel = p_axe_yd_max;

    // on prend en compte les valeurs de la config partielles lues
    // precedemment

	S6GereConfig::_config = S6GereConfigP::_p_axe_droit_config;

	if(calcul_ok_cache) _pto->PopUp::Cache();

}

void
AxeDroitAnnuler::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // on annule les valeurs lues dans la config partielle

	S6GereConfigP::_p_axe_droit_config = S6GereConfig::_config;
	S6GereFenet::ReConfigAxeDroit();
	S6GereFenet::axe_droit->PopUp::Cache();
}

void
AxeDroitAide::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	if(S6GereFenet::axe_droit_help == NULL)
	{
	    cout << "AxeDroitAide> creation pop-up-help Axe droit " << endl;

	    S6GereFenet::axe_droit_help = new Help(GetId(),
		S6Traduc::traduc[230],"AXE_DROIT_HELP");
	}	

	S6GereFenet::axe_droit_help->Montre();
}

void
AxeDroitChoixLinY::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_axe_log_yd = 0;	
}

void
AxeDroitChoixLogY::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_axe_log_yd = 1;	
}

void
AxeDroitMinY::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	istrstream is(GetText());
	REEL ymin = 0;

	is >> ymin;

	cout << "AxeDroitMinY> ymin " << ymin << endl;

	p_axe_yd_min = ymin;
	p_axe_yd_min_reel = ymin;
}

void
AxeDroitMaxY::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	istrstream is(GetText());
	REEL ymax = 0;

	is >> ymax;

	cout << "AxeDroitMaxY> ymax " << ymax << endl;

	p_axe_yd_max = ymax;
	p_axe_yd_max_reel = ymax;
}

void
AxeDroitAutoYBouton::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	p_axe_yd_min = 0.;
	p_axe_yd_max = 0.;
	p_axe_yd_min_reel = 0.;
	p_axe_yd_max_reel = 0.;

	_pto->ChangeAxeMinY(0.);
	_pto->ChangeAxeMaxY(0.);
}



