#ifndef S6BOUTTONS3_H
#define S6BOUTTONS3_H

// %W% %G% P. Brochard
// definitions des classes de bouttons

// ******************************************************
// courbes ..............................................
// ******************************************************

class Courbes;

class NombreCourbesSaisie : public Saisie
{
    private:

	Courbes* _pto;
	
    public:
   
	NombreCourbesSaisie(const Widget& parent,const char* label,
			short int taille=3,
			const char* classe = "NombreCourbesSaisie",
			Courbes* pto=NULL) :
			Saisie(parent,label,taille,classe) {_pto = pto;};
	~NombreCourbesSaisie() {};

	void Attach(Courbes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
	void ChangeValeur(int nombre);
};

class NumeroCourbesSliderMin : public Slider
{
   private:

	Courbes* _pto;
	
   public:
   
	NumeroCourbesSliderMin(const Widget& parent, const char *label, 
			const int& mini, const int& maxi,
			const int& ValeurInitiale,
			const char* classe="NumeroCourbesSliderMin",
			Courbes* pto=NULL) :
			Slider(parent,label,mini,maxi,ValeurInitiale,classe)
	{_pto=pto;};
	~NumeroCourbesSliderMin() {};

	void Attach(Courbes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class NumeroCourbesSliderMax : public Slider
{
   private:

	Courbes* _pto;
	
   public:
   
	NumeroCourbesSliderMax(const Widget& parent, const char *label, 
			const int& mini, const int& maxi,
			const int& ValeurInitiale,
			const char* classe="NumeroCourbesSliderMax",
			Courbes* pto=NULL) :
			Slider(parent,label,mini,maxi,ValeurInitiale,classe)
	{_pto=pto;};
	~NumeroCourbesSliderMax() {};

	void Attach(Courbes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class CourbesChoix : public BoutonDeChoix
{
    protected :

	Courbes* _pto;

    public :

	CourbesChoix(const Widget& parent, const char* label,
			const char* classe,Courbes* pto=NULL) :
			BoutonDeChoix(parent,label,classe) {_pto=pto;};
	~CourbesChoix() {};

	void Attach(Courbes* pto) {_pto=pto;};
};

struct CourbesChoixGauche : public CourbesChoix
{   
	CourbesChoixGauche(const Widget& parent, const char* label, 
		const char* classe,Courbes* pto=NULL) :
		CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixGauche() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct CourbesChoixDroit : public CourbesChoix
{
	CourbesChoixDroit(const Widget& parent, const char* label, 
			const char* classe,Courbes* pto=NULL) :
			CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixDroit() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct CourbesChoixNon : public CourbesChoix
{
	CourbesChoixNon(const Widget& parent, const char* label, 
			const char* classe,Courbes* pto=NULL) :
			CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixNon() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct CourbesChoixSimple : public CourbesChoix
{
	CourbesChoixSimple(const Widget& parent, const char* label, 
			const char* classe,Courbes* pto=NULL) :
			CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixSimple() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct CourbesChoixMarche : public CourbesChoix
{
	CourbesChoixMarche(const Widget& parent, const char* label, 
			const char* classe,Courbes* pto=NULL) :
			CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixMarche() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct CourbesChoixPlus : public CourbesChoix
{
	CourbesChoixPlus(const Widget& parent, const char* label, 
			const char* classe,Courbes* pto=NULL) :
			CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixPlus() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct CourbesChoixEtoile : public CourbesChoix
{
	CourbesChoixEtoile(const Widget& parent, const char* label, 
			const char* classe,Courbes* pto=NULL) :
			CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixEtoile() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct CourbesChoixRond : public CourbesChoix
{
	CourbesChoixRond(const Widget& parent, const char* label, 
			const char* classe,Courbes* pto=NULL) :
			CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixRond() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct CourbesChoixMul : public CourbesChoix
{
	CourbesChoixMul(const Widget& parent, const char* label, 
			const char* classe,Courbes* pto=NULL) :
			CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixMul() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct CourbesChoixPoint : public CourbesChoix
{
	CourbesChoixPoint(const Widget& parent, const char* label, 
			const char* classe,Courbes* pto=NULL) :
			CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixPoint() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct CourbesChoixErreur : public CourbesChoix
{
	CourbesChoixErreur(const Widget& parent, const char* label, 
			const char* classe,Courbes* pto=NULL) :
			CourbesChoix(parent,label,classe,pto) {};
	~CourbesChoixErreur() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class CourbesSaisie : public Saisie
{
    private :

	Courbes* _pto;

    public :
	   
	CourbesSaisie(const Widget& parent,const char* label,
			short int taille = 20,const char* classe="CourbesSaisie",
			Courbes* pto=NULL) :
			Saisie(parent,label,taille,classe) {_pto=pto;};
	~CourbesSaisie() {};

	void Attach(Courbes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
	void ChangeValeur(int test_modif = 0);
};

class ChoixVerticalCouleurCourbes : public ChoixVerticalCascade
{
    private :

	Courbes* _pto;

    public :

	ChoixVerticalCouleurCourbes(const Widget& parent,
			ChoixVerticalPanel& panel,const char* name,
			const char* label,int col = 1,Courbes* pto = NULL) :
			ChoixVerticalCascade(parent,panel,name,label,col)
	{_pto = pto;};
	~ChoixVerticalCouleurCourbes() {};

	void Attach(Courbes* pto) {_pto = pto;};
	void ChargeInv();
};

class CourbeOK : public Bouton
{
    private :

	Courbes* _pto;

    public :

	CourbeOK(const Widget& parent, const char* label,
			const char* classe,Courbes* pto = NULL) :
			Bouton(parent,label,classe) {_pto = pto;};
	~CourbeOK() {};

	void Attach(Courbes* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

struct CourbeAnnuler : public Bouton
{	   
	CourbeAnnuler(const Widget& parent, const char *label, 
			const char* classe) :
			Bouton(parent,label,classe) {};
	~CourbeAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct CourbeAide : public Bouton
{	   
	CourbeAide(const Widget& parent, const char *label, 
			const char* classe) :
			Bouton(parent,label,classe) {};
	~CourbeAide() {};
      
	void SelectCB(XtPointer call_data);
};

struct CourbesAppel : public PullDownEntry
{
	CourbesAppel(const Widget& parent,const char *label);
	~CourbesAppel() {};

	void SelectCB(XtPointer call_data);
};

class Courbes : public PopUp
{
    private:

	ConteneurLigne			_tout;

	ConteneurJoli                   _nombre_j;

	ConteneurColonne		_nombre;
	Label				_nombre_label;
	NombreCourbesSaisie		_nombre_saisie;
	Label				_nombre_courbes_reel;

	ConteneurJoli                   _numero_j;
	ConteneurLigne   		_numero_l;

	ConteneurColonne		_numero_min;
	Label				_numero_label_min;
	NumeroCourbesSliderMin		_numero_slider_min;

	ConteneurColonne		_numero_max;
	Label				_numero_label_max;
	NumeroCourbesSliderMax		_numero_slider_max;

	ConteneurJoli                   _options_j;
	ConteneurLigne   		_options_l;

	ConteneurExclusifColonne	_cote;
	Label				_cote_label;
	CourbesChoixGauche		_gauche;
	CourbesChoixDroit		_droit;

	ConteneurColonne		_type;
	Label				_type_label;
	CourbesChoixNon			_non;
	CourbesChoixSimple		_simple;
	CourbesChoixMarche		_marche;
	CourbesChoixPlus		_plus;
	CourbesChoixEtoile		_etoile;
	CourbesChoixRond		_rond;
	CourbesChoixMul			_mul;
	CourbesChoixPoint		_point;
	CourbesChoixErreur		_erreur;

	ConteneurColonne		_label;
	Label				_label_label;
	CourbesSaisie			_label_saisie;
	Label				_couleur_label;
	ChoixVerticalCouleurCourbes	_couleur_choix;

	ConteneurJoli                   _standard_j;
	ConteneurColonne		_standard;
	CourbeOK			_ok;
	CourbeAnnuler			_annuler;
	CourbeAide			_aide;

	int				_courbe_nombre;
	int				_courbe_numero_min;
	int				_courbe_numero_max;

    public:

	Courbes(const Widget& root);
	~Courbes() {};

	int CourbeNumeroMin() const {return _courbe_numero_min;};
	int CourbeNumeroMax() const {return _courbe_numero_max;};

	void Charge(int courbe_num_min,int courbe_num_max);
	void ChargeType(int val);
	void ChargeCote();

	int GetValueSliderMin() {return _numero_slider_min.GetValue();};
	int GetValueSliderMax() {return _numero_slider_max.GetValue();};

	void Change(const char* courbe_saisie);
	void Change(int nombre_courbes);
	void Change(int min,int max,int pos_min,int pos_max);
	void ChangeValeur(int test_mod = 0)
	{_label_saisie.ChangeValeur(test_mod);};
	void ChangeTaille(int taille);
	void ChangeNombre();

	void ChangeGauche(int choix) {_gauche.Change(choix);};
	void ChangeDroit(int choix) {_droit.Change(choix);};

	void ChangeNon(int choix) {_non.Change(choix);};
	void ChangeSimple(int choix) {_simple.Change(choix);};
	void ChangeMarche(int choix) {_marche.Change(choix);};
	void ChangePlus(int choix) {_plus.Change(choix);};
	void ChangeEtoile(int choix) {_etoile.Change(choix);};
	void ChangeRond(int choix) {_rond.Change(choix);};
	void ChangeMul(int choix) {_mul.Change(choix);};
	void ChangePoint(int choix) {_point.Change(choix);};
	void ChangeErreur(int choix) {_erreur.Change(choix);};
};

// ***************************************
//    panel gestion donnees
// ***************************************

class NumeroDonneeNoeudSaisie : public Saisie
{
    public:
   
	NumeroDonneeNoeudSaisie(const Widget& parent,const char* label,
		short int taille=3,
		const char* classe = "NumeroDonneeNoeudSaisie") :
		Saisie(parent,label,taille,classe) {};
	~NumeroDonneeNoeudSaisie() {};

	void SelectCB(XtPointer call_data);
	void ChangeValeur();
};

struct GestionDonneesAppel : public PullDownEntry
{
	GestionDonneesAppel(const Widget& parent,const char *label);
	~GestionDonneesAppel() {};

	void SelectCB(XtPointer call_data);
};

class GestionDonnees;

class GestionDonneesOK : public Bouton
{
    private :

	GestionDonnees* _pto;

    public :

	GestionDonneesOK(const Widget& parent, const char* const label,
		const char* const classe,GestionDonnees* const pto = NULL) :
		Bouton(parent,label,classe) {_pto = pto;};
	~GestionDonneesOK() {};

	void Attach(GestionDonnees* const pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

struct GestionDonneesAnnuler : public Bouton
{	   
	GestionDonneesAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~GestionDonneesAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct GestionDonneesAide : public Bouton
{	   
	GestionDonneesAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~GestionDonneesAide() {};
      
	void SelectCB(XtPointer call_data);
};

class GestionDonnees : public PopUp
{
    private:

	ConteneurLigne			_tout;

	ConteneurJoli			_num_j;
	ConteneurLigne			_num;

	ConteneurColonne		_nombre;
	Label				_nombre__label;
	Label				_nombre_var_label;

	ConteneurColonne		_numero;
	Label				_numero_label;
	NumeroDonneeNoeudSaisie		_numero_saisie;
	Label				_titre;

	ConteneurJoli			_standard_j;

	ConteneurColonne		_standard;
	GestionDonneesOK		_ok;
	GestionDonneesAnnuler		_annuler;
	GestionDonneesAide		_aide;

    public:

	GestionDonnees(const Widget& root);
	~GestionDonnees() {};

	void ChangeVarLabel(const unsigned  noeud,const unsigned maille);
	void ChangeTitre(const char* const label);
	void ChangeNumero();
	void ChangeAll();
	void ChangeValeur() {_numero_saisie.ChangeValeur();};
};

// **********************************************
// break psyche .................................
// **********************************************

class BreakPsyche : public Bouton
{
    public :

	BreakPsyche(const Widget& parent,const char *label,
		const char* classe="BTN_break");
	~BreakPsyche() {};

	void SelectCB(XtPointer call_data);
};

// sous-menu scene .............................................

class Scene;

class SceneBase : public BoutonDeChoix
{
    protected :

	Scene* _pto;

    public :

	SceneBase(const Widget& parent, const char* label,
		Scene* pto=NULL) : BoutonDeChoix(parent,label) {_pto=pto;};
	~SceneBase() {};

	void Attach(Scene* pto) {_pto=pto;};
};

class SceneNon : public SceneBase
{
    private:
   	
    public:
   
	SceneNon(const Widget& parent, const char* label, 
		Scene* pto=NULL) : SceneBase(parent,label,pto) {};
	~SceneNon() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class SceneOui : public SceneBase
{
    public :

	SceneOui(const Widget& parent, const char* label, 
		Scene* pto=NULL) : SceneBase(parent,label,pto) {};
	~SceneOui() {};

	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

struct SceneFin : public PullDownEntry
{
	SceneFin(const Widget& parent,const char* label) :
		PullDownEntry(parent,label) {};
	~SceneFin() {};

	void SelectCB(XtPointer call_data);
};

struct SceneEfface : public PullDownEntry
{
	SceneEfface(const Widget& parent,const char* label) :
		PullDownEntry(parent,label) {};
	~SceneEfface() {};

	void SelectCB(XtPointer call_data);
};

class Scene
{
    private:

	PullDownSubMenu		_scene;
	SceneNon		_non;
	SceneOui		_oui;
	SceneFin		_fin;
	SceneEfface	        _efface;

    public:

	Scene(const Widget& parent,const char *label);
	~Scene() {};

	void ChangeNon(int choix) {_non.Change(choix);};
	void ChangeOui(int choix) {_oui.Change(choix);};
};

// trace image (fichiers graphiques).................................

class TraceImage : public Bouton
{
    public :

	TraceImage(const Widget& parent,const char *label,
		const char* classe="BTN_trace_image") :
		Bouton(parent, label,classe) {};
	~TraceImage() {};

	void SelectCB(XtPointer call_data);
};

// axe droit ...............................................

class AxeDroit;

class AxeDroitOK : public Bouton
{
    private :

	AxeDroit* _pto;

    public :

	AxeDroitOK(const Widget& parent, const char* label,
		const char* classe,AxeDroit* pto = NULL) :
		Bouton(parent,label,classe) {_pto = pto;};
	~AxeDroitOK() {};

	void Attach(AxeDroit* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

struct AxeDroitAnnuler : public Bouton
{	   
	AxeDroitAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~AxeDroitAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeDroitAide : public Bouton
{	   
	AxeDroitAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~AxeDroitAide() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeDroitChoixLinY : public BoutonDeChoix
{	   
	AxeDroitChoixLinY(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~AxeDroitChoixLinY() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeDroitChoixLogY : public BoutonDeChoix
{	   
	AxeDroitChoixLogY(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~AxeDroitChoixLogY() {};
      
	void SelectCB(XtPointer call_data);
};

class Axes;

struct AxeDroitMinY : public Saisie
{
	AxeDroitMinY(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="AxeDroitMinY") :
		Saisie(parent,label,taille,classe) {};
	~AxeDroitMinY() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeDroitMaxY : public Saisie
{
	AxeDroitMaxY(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="AxeDroitMaxY") :
		Saisie(parent,label,taille,classe) {};
	~AxeDroitMaxY() {};
      
	void SelectCB(XtPointer call_data);
};

class AxeDroitAutoYBouton : public Bouton
{
    private :

	AxeDroit* _pto;

    public :

	AxeDroitAutoYBouton(const Widget& parent, const char *label,
		const char* classe = "AxeDroitAutoYBouton",AxeDroit* pto=NULL) :
		Bouton(parent,label,classe) {_pto = pto;};
	~AxeDroitAutoYBouton() {};

	void Attach(AxeDroit* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

struct AxeDroitAppel : public PullDownEntry
{
	AxeDroitAppel(const Widget& parent,const char* label);
	~AxeDroitAppel() {};

	void SelectCB(XtPointer call_data);
};

class AxeDroit : public PopUp
{
    private:

	ConteneurLigne			_tout;

	ConteneurJoli			_yj;
	ConteneurColonne		_y;
	Label				_y_label;

	ConteneurExclusifColonne	_y_type;
	AxeDroitChoixLinY		_y_lin;
	AxeDroitChoixLogY		_y_log;

	ConteneurJoli			_y_bornes_j;
	ConteneurColonne		_y_bornes;
	Label				_y_min_label;
	AxeDroitMinY			_y_min_texte;
	Label				_y_max_label;
	AxeDroitMaxY			_y_max_texte;
	AxeDroitAutoYBouton		_y_auto;

	ConteneurJoli			_standard_j;
	ConteneurColonne		_standard;
	AxeDroitOK			_ok;
	AxeDroitAnnuler			_annuler;
	AxeDroitAide			_aide;

    public:

	AxeDroit(const Widget& root);
	~AxeDroit() {};

	void ChangeAxeMinY();
	void ChangeAxeMaxY();

	void ChangeAxeMinY(REEL);
	void ChangeAxeMaxY(REEL);

	void LitAxeMinY(REEL&);
	void LitAxeMaxY(REEL&);

	void Cache();
	void Montre();
};

#endif
