#ifndef S6BOUTTONS5_H
#define S6BOUTTONS5_H

// %W% %G% Pierre Brochard
// definitions des classes de bouttons

#include "poulpe/IHM.h"
#include "S6boutgen.h"

// Point de vue .........................................

class SliderAzimuth : public Slider
{
   private:
   	
   public:
   
      SliderAzimuth(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
      ~SliderAzimuth() {};
      
      void SelectCB(XtPointer call_data);
};

class SliderSite : public Slider
{
    private:
   	
    public:
   
	SliderSite(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~SliderSite() {};
      
	void SelectCB(XtPointer call_data);
};

class SliderRoulis : public Slider
{   	
    public:
   
	SliderRoulis(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~SliderRoulis() {};
      
	void SelectCB(XtPointer call_data);
};

class SliderDistance : public Slider
{
    public:
   
	SliderDistance(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~SliderDistance() {};
      
	void SelectCB(XtPointer call_data);
};

class SliderRedrh : public Slider
{
    public:
   
	SliderRedrh(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~SliderRedrh() {};
      
	void SelectCB(XtPointer call_data);
};

class SliderRedrv : public Slider
{
    public:
   
	SliderRedrv(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~SliderRedrv() {};
      
	void SelectCB(XtPointer call_data);
};

struct PointDeVueOK : public Bouton
{
	PointDeVueOK(const Widget& parent, const char* label,
		const char* classe) :
		Bouton(parent,label,classe) {};
	~PointDeVueOK() {};

	void SelectCB(XtPointer call_data);
};

struct PointDeVueAnnuler : public Bouton
{	   
	PointDeVueAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~PointDeVueAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct PointDeVueAide : public Bouton
{	   
	PointDeVueAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~PointDeVueAide() {};
      
	void SelectCB(XtPointer call_data);
};

class PointDeVue : public PullDownEntry
{
    private:

	PopUp				_pere;
	ConteneurLigne			_tout;

	ConteneurColonne		_azimuth_cont;
	Label				_azimuth_label;
	SliderAzimuth			_azimuth;

	ConteneurColonne		_site_cont;
	Label				_site_label;
	SliderSite			_site;

	ConteneurColonne		_roulis_cont;
	Label				_roulis_label;
	SliderRoulis			_roulis;

	ConteneurColonne		_distance_cont;
	Label				_distance_label;
	SliderDistance			_distance;

	ConteneurColonne		_redrh_cont;
	Label				_redrh_label;
	SliderRedrh			_redrh;

	ConteneurColonne		_redrv_cont;
	Label				_redrv_label;
	SliderRedrv			_redrv;

	ConteneurColonne		_standard;
	PointDeVueOK			_ok;
	PointDeVueAnnuler		_annuler;
	PointDeVueAide			_aide;

    public:

	PointDeVue(const Widget& root,const Widget& parent,
		const char* label,const char* classe="MENEN_POINT_DE_VUE");
	~PointDeVue() {};

	void SelectCB(XtPointer call_data);
	void Change();
	void Cache();
	void Montre2d();
};

// animation .........................................

struct SliderPasAzimuth : public Slider
{   
      SliderPasAzimuth(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
      ~SliderPasAzimuth() {};
      
      void SelectCB(XtPointer call_data);
};

struct SliderPasSite : public Slider
{
	SliderPasSite(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~SliderPasSite() {};
      
	void SelectCB(XtPointer call_data);
};

struct SliderNombreAnim : public Slider
{
	SliderNombreAnim(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~SliderNombreAnim() {};
      
	void SelectCB(XtPointer call_data);
};

struct AnimationOK : public Bouton
{
	AnimationOK(const Widget& parent, const char* label,
		const char* classe) :
		Bouton(parent,label,classe) {};
	~AnimationOK() {};

	void SelectCB(XtPointer call_data);
};

struct AnimationAnnuler : public Bouton
{	   
	AnimationAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~AnimationAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct AnimationAide : public Bouton
{	   
	AnimationAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~AnimationAide() {};
      
	void SelectCB(XtPointer call_data);
};

class Animation : public PullDownEntry
{
    private:

	PopUp				_pere;
	ConteneurLigne			_tout;

	ConteneurColonne		_pas_azimuth_cont;
	Label				_pas_azimuth_label;
	SliderPasAzimuth		_pas_azimuth;

	ConteneurColonne		_pas_site_cont;
	Label				_pas_site_label;
	SliderPasSite			_pas_site;

	ConteneurColonne		_nombre_anim_cont;
	Label				_nombre_anim_label;
	SliderNombreAnim		_nombre_anim;

	ConteneurColonne		_standard;
	AnimationOK			_ok;
	AnimationAnnuler		_annuler;
	AnimationAide			_aide;

    public:

	Animation(const Widget& root,const Widget& parent,
		const char* label,const char* classe="MENEN_Animation");
	~Animation() {};

	void SelectCB(XtPointer call_data);
	void Change();
	void Cache();
	void Montre2d();
};

// Gestion des couleurs .........................................

class GestionCouleur;

struct SliderCoulBase : public Slider
{   
      SliderCoulBase(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
      ~SliderCoulBase() {};
      
      void SelectCB(XtPointer call_data);
};

struct SliderCoulPalette : public Slider
{
	SliderCoulPalette(const Widget& parent, const char* label, 
		const int& mini, const int& maxi,
		const int& ValeurInitiale,const char* classe) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~SliderCoulPalette() {};
      
	void SelectCB(XtPointer call_data);
};

struct GestionCouleurIcol : public Bouton
{
	GestionCouleurIcol(const Widget& parent, const char* label,
		const char* classe) :
		Bouton(parent,label,classe) {};
	~GestionCouleurIcol() {};

	void SelectCB(XtPointer call_data);
};

class GestionCouleurOK : public Bouton
{
    public:

	GestionCouleurOK(const Widget& parent, const char* label,
		const char* classe) :
		Bouton(parent,label,classe),_pto(NULL) {};
	~GestionCouleurOK() {};

	void Attach(GestionCouleur* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);

    private:

	GestionCouleur* _pto;
};

class GestionCouleurAnnuler : public Bouton
{
    public:

	GestionCouleurAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe),_pto(NULL) {};
	~GestionCouleurAnnuler() {};

	void Attach(GestionCouleur* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);

    private:

	GestionCouleur* _pto;
};

struct GestionCouleurAide : public Bouton
{	   
	GestionCouleurAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~GestionCouleurAide() {};
      
	void SelectCB(XtPointer call_data);
};

class GestionCouleur : public PullDownEntry
{
    private:

	PopUp				_pere;
	ConteneurLigne			_tout;

	ConteneurColonne		_icol_cont;
	GestionCouleurIcol		_icol;

	ConteneurColonne		_base_cont;
	Label				_base_label;
	SliderCoulBase		        _base;

	ConteneurColonne		_palette_cont;
	Label				_palette_label;
	SliderCoulPalette		_palette;

	ConteneurColonne		_standard;
	GestionCouleurOK		_ok;
	GestionCouleurAnnuler		_annuler;
	GestionCouleurAide		_aide;

    public:

	GestionCouleur(const Widget& root,const Widget& parent,
		const char* label,const char* classe="MENEN_GestionCouleur");
	~GestionCouleur() {};

	void SelectCB(XtPointer call_data);
	void Change();
	void Cache();
};

#endif
