#ifndef S6BOUTTONS6_H
#define S6BOUTTONS6_H

// %W% %G% P. Brochard
// definitions des classes de bouttons

// echelles .........................................

struct ChoixLinZh : public BoutonDeChoix
{	   
	ChoixLinZh(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~ChoixLinZh() {};
      
	void SelectCB(XtPointer call_data);
};

struct ChoixLogZh : public BoutonDeChoix
{	   
	ChoixLogZh(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~ChoixLogZh() {};
      
	void SelectCB(XtPointer call_data);
};

struct ChoixLinCh : public BoutonDeChoix
{	   
	ChoixLinCh(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~ChoixLinCh() {};
      
	void SelectCB(XtPointer call_data);
};

struct ChoixLogCh : public BoutonDeChoix
{	   
	ChoixLogCh(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~ChoixLogCh() {};
      
	void SelectCB(XtPointer call_data);
};

struct MinZh : public Saisie
{
	MinZh(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="MinZh") :
		Saisie(parent,label,taille,classe) {};
	~MinZh() {};
      
	void SelectCB(XtPointer call_data);
};

struct MaxZh : public Saisie
{
	MaxZh(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="MaxZh") :
		Saisie(parent,label,taille,classe) {};
	~MaxZh() {};
      
	void SelectCB(XtPointer call_data);
};

class Echelles;

class AutoZhBouton : public Bouton
{
    private :

	Echelles* _pto;

    public :

	AutoZhBouton(const Widget& parent, const char *label,
		const char* classe = "AutoZhBouton",Echelles* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~AutoZhBouton() {};

	void Attach(Echelles* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct MinCh : public Saisie
{
	MinCh(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="MinCh") :
		Saisie(parent,label,taille,classe) {};
	~MinCh() {};
      
	void SelectCB(XtPointer call_data);
};

struct MaxCh : public Saisie
{
	MaxCh(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="MaxCh") :
		Saisie(parent,label,taille,classe) {};
	~MaxCh() {};
      
	void SelectCB(XtPointer call_data);
};

class AutoChBouton : public Bouton
{
    private :

	Echelles* _pto;

    public :

	AutoChBouton(const Widget& parent, const char *label,
		const char* classe = "AutoChBouton",Echelles* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~AutoChBouton() {};

	void Attach(Echelles* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct NiveauSliderZ : public Slider
{   
	NiveauSliderZ(const Widget& parent, const char *label, 
		const int& mini, const int& maxi, const int& ValeurInitiale,
		const char* classe="NiveauSliderZ") :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~NiveauSliderZ() {};
      
	void SelectCB(XtPointer call_data);
};

struct NiveauSliderC : public Slider
{   
	NiveauSliderC(const Widget& parent, const char *label, 
		const int& mini, const int& maxi, const int& ValeurInitiale,
		const char* classe="NiveauSliderC") :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe) {};
	~NiveauSliderC() {};
      
	void SelectCB(XtPointer call_data);
};

class EchelleOK : public Bouton
{
    private :

	Echelles* _pto;

    public :

	EchelleOK(const Widget& parent, const char* label,
		const char* classe,Echelles* pto = NULL) :
		Bouton(parent,label,classe) {_pto = pto;};
	~EchelleOK() {};

	void Attach(Echelles* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

struct EchelleAnnuler : public Bouton
{	   
	EchelleAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~EchelleAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct EchelleAide : public Bouton
{	   
	EchelleAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~EchelleAide() {};
      
	void SelectCB(XtPointer call_data);
};

class Echelles : public PullDownEntry
{
    private:

	PopUp				_pere;
	ConteneurLigne			_tout;

	ConteneurColonne		_zch;

	Label				_zh_label;
	ConteneurExclusifColonne	_zh_type;
	ChoixLinZh			_zh_lin;
	ChoixLogZh			_zh_log;

	Label				_ch_label;
	ConteneurExclusifColonne	_ch_type;
	ChoixLinCh			_ch_lin;
	ChoixLogCh			_ch_log;

	ConteneurColonne		_zh_bornes;
	Label				_zh_min_label;
	MinZh				_zh_min_texte;
	Label				_zh_max_label;
	MaxZh				_zh_max_texte;
	AutoZhBouton			_zh_auto;

	ConteneurColonne		_ch_bornes;
	Label				_ch_min_label;
	MinCh				_ch_min_texte;
	Label				_ch_max_label;
	MaxCh				_ch_max_texte;
	AutoChBouton			_ch_auto;

	ConteneurColonne		_niveau_z;
	Label				_niveau_z_label;
	NiveauSliderZ			_niveau_z_slider;

	ConteneurColonne		_niveau_c;
	Label				_niveau_c_label;
	NiveauSliderC			_niveau_c_slider;

	ConteneurColonne		_standard;
	EchelleOK			_ok;
	EchelleAnnuler			_annuler;
	EchelleAide			_aide;

    public:

	Echelles(const Widget& root,const Widget& parent,
		const char* label,const char* classe="MENEN");
	~Echelles() {};

	void SelectCB(XtPointer call_data);

	void ChangeZh();
	void ChangeCh();

	void ChangeMinZh();
	void ChangeMaxZh();
	void ChangeMinCh();
	void ChangeMaxCh();

	void LitMinZh(REEL&);
	void LitMaxZh(REEL&);
	void LitMinCh(REEL&);
	void LitMaxCh(REEL&);

	void ChangeSliderZ();
	void ChangeSliderC();

	void Cache();
	void Montre2d();
};

// dimensions ................................

struct X1cm : public Saisie
{
	X1cm(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="X1cm") :
		Saisie(parent,label,taille,classe) {};
	~X1cm() {};
      
	void SelectCB(XtPointer call_data);
};

struct X2cm : public Saisie
{
	X2cm(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="X2cm") :
		Saisie(parent,label,taille,classe) {};
	~X2cm() {};
      
	void SelectCB(XtPointer call_data);
};

class Dimensions;

class PositionBoiteBouton : public Bouton
{
    private :

	Dimensions* _pto;

    public :

	PositionBoiteBouton(const Widget& parent, const char *label,
		const char* classe = "BTN_position_boite",
		Dimensions* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~PositionBoiteBouton() {};

	void Attach(Dimensions* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct Y1cm : public Saisie
{
	Y1cm(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="X1cm") :
		Saisie(parent,label,taille,classe) {};
	~Y1cm() {};
      
	void SelectCB(XtPointer call_data);
};

struct Y2cm : public Saisie
{
	Y2cm(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="X2cm") :
		Saisie(parent,label,taille,classe) {};
	~Y2cm() {};
      
	void SelectCB(XtPointer call_data);
};

class BoiteDefautBouton : public Bouton
{
    private :

	Dimensions* _pto;

    public :

	BoiteDefautBouton(const Widget& parent, const char *label,
		const char* classe = "BTN_boite_defaut",Dimensions* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~BoiteDefautBouton() {};

	void Attach(Dimensions* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class Dxcm : public Saisie
{
    private :

	Dimensions* _pto;

    public :

	Dxcm(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="X1cm",
		Dimensions* pto=NULL) :
		Saisie(parent,label,taille,classe) {_pto=pto;};
	~Dxcm() {};

	void Attach(Dimensions* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class Dycm : public Saisie
{
    private :

	Dimensions* _pto;

    public :

	Dycm(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="X2cm",
		Dimensions* pto=NULL) :
		Saisie(parent,label,taille,classe) {_pto=pto;};
	~Dycm() {};

	void Attach(Dimensions* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class DefautDxDy : public Bouton
{
    private :

	Dimensions* _pto;

    public :

	DefautDxDy(const Widget& parent, const char *label,
		const char* classe = "BTN_defaut_dxdy",Dimensions* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~DefautDxDy() {};

	void Attach(Dimensions* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class DimensionOK : public Bouton
{
    private :

	Dimensions* _pto;

    public :

	DimensionOK(const Widget& parent, const char* label,
		const char* classe,Dimensions* pto = NULL) :
		Bouton(parent,label,classe) {_pto = pto;};
	~DimensionOK() {};

	void Attach(Dimensions* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

struct DimensionAnnuler : public Bouton
{	   
	DimensionAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~DimensionAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct DimensionAide : public Bouton
{	   
	DimensionAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~DimensionAide() {};
      
	void SelectCB(XtPointer call_data);
};

class Dimensions : public PullDownEntry
{
    private:

	PopUp				_pere;
	ConteneurLigne			_tout;

	ConteneurColonne		_ligne_1;
	PositionBoiteBouton		_position_boite_bouton;
	Label				_x1cm_label;
	X1cm				_x1cm;
	Label				_x2cm_label;
	X2cm				_x2cm;

	ConteneurColonne		_ligne_2;
	BoiteDefautBouton		_boite_defaut_bouton;
	Label				_y1cm_label;
	Y1cm				_y1cm;
	Label				_y2cm_label;
	Y2cm				_y2cm;

	ConteneurColonne		_ligne_3;
	DefautDxDy			_defaut_dx_dy;
	Label				_dxcm_label;
	Dxcm				_dxcm;
	Label				_dycm_label;
	Dycm				_dycm;

	ConteneurColonne		_standard;
	DimensionOK			_ok;
	DimensionAnnuler		_annuler;
	DimensionAide			_aide;

    public:

	Dimensions(const Widget& root,const Widget& parent,
		const char* label,const char* classe="MENEN");
	~Dimensions() {};

	void Cache();
	void SelectCB(XtPointer call_data);

	void Change();

	void ChangeX1cm(REEL x1cm);
	void ChangeX2cm(REEL x2cm);
	void ChangeY1cm(REEL y1cm);
	void ChangeY2cm(REEL y2cm);
	void ChangeDxcm();
	void ChangeDycm();

	void LitX1cm();
	void LitX2cm();
	void LitY1cm();
	void LitY2cm();
	void LitDxcm();
	void LitDycm();
};

// sous-menu zoom 2d .............................................

class Zoom2dZoom : public PullDownEntry
{
    public:
   
	Zoom2dZoom(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~Zoom2dZoom() {};
      
	void SelectCB(XtPointer call_data);
};

class Zoom2dUnZoom : public PullDownEntry
{
    public :

	Zoom2dUnZoom(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~Zoom2dUnZoom() {};

	void SelectCB(XtPointer call_data);
};

class Zoom2d
{
    private:

	PullDownSubMenu		_zoom_2d;
	Zoom2dZoom		_zoom_2d_zoom;
	Zoom2dUnZoom		_zoom_2d_unzoom;

    public:

	Zoom2d(const Widget& parent,const char *label);
	~Zoom2d() {};

	void Montre() {_zoom_2d.Montre();};
	void Cache() {_zoom_2d.Cache();};
};

// sous-menu coordonnees .............................................

class Coordonnees;

class Coord3d : public PullDownEntry
{
    private :

	Coordonnees* _pto;

    public :

	Coord3d(const Widget& parent, const char *label,
		const char* classe = "MENEN",Coordonnees* pto=NULL) :
		PullDownEntry(parent,label,classe) {_pto=pto;};
	~Coord3d() {};

	void Attach(Coordonnees* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class Coord2d : public PullDownEntry
{
    private :

	Coordonnees* _pto;

    public :

	Coord2d(const Widget& parent, const char *label,
		const char* classe = "MENEN",Coordonnees* pto=NULL) :
		PullDownEntry(parent,label,classe) {_pto=pto;};
	~Coord2d() {};

	void Attach(Coordonnees* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class Coord2dDroit : public PullDownEntry
{
    private :

	Coordonnees* _pto;

    public :

	Coord2dDroit(const Widget& parent,const char* const label,
		const char* const classe = "MENEN",Coordonnees* const pto=NULL) :
		PullDownEntry(parent,label,classe) {_pto=pto;};
	~Coord2dDroit() {};

	void Attach(Coordonnees* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct CoordAnnuler : public Bouton
{	   
	CoordAnnuler(const Widget& parent, const char* const label, 
		const char* const classe) :
		Bouton(parent,label,classe) {};
	~CoordAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

class Coordonnees
{
    private:

	PullDownSubMenu		_coordonnees;
	Coord2d			_coord_2d;
	Coord2dDroit		_coord_2d_droit;
	Coord3d			_coord_3d;

	PopUp			_coord_2d_panel;
	ConteneurLigne		_coord_2d_tout;
	ConteneurColonne	_coord_2d_cont;
	Label			_label;
	CoordAnnuler		_annuler;

    public:

	Coordonnees(const Widget& root,const Widget& parent,
			const char* const label,
			const char* const classe="MENSB_Coordonnees");
	~Coordonnees() {};

	void MontreCont() {_coord_2d_panel.Montre();};

	void Change(const char* const neuf);

	void Montre2d();
	void Montre3d();
	void Cache();

	void Calcul(REEL,REEL);
};

// couleurs dessus et dessous surface ...........................

class CoulSurf;

class NombreCoulSaisie : public Saisie
{
    private:

	CoulSurf* _pto;
	
    public:
   
	NombreCoulSaisie(const Widget& parent,const char* label,
		short int taille=3,const char* classe = "NombreCoulSaisie",
		CoulSurf* pto=NULL) :
		Saisie(parent,label,taille,classe) {_pto = pto;};
	~NombreCoulSaisie() {};

	void Attach(CoulSurf* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
	void ChangeValeur(int nombre);
};

class NumeroCoulSliderMin : public Slider
{
   private:

	CoulSurf* _pto;
	
   public:
   
	NumeroCoulSliderMin(const Widget& parent, const char *label, 
		const int& mini, const int& maxi, const int& ValeurInitiale,
		const char* classe="NumeroCoulSliderMin",CoulSurf* pto=NULL) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe)
		{_pto=pto;};
	~NumeroCoulSliderMin() {};

	void Attach(CoulSurf* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class NumeroCoulSliderMax : public Slider
{
   private:

	CoulSurf* _pto;
	
   public:
   
	NumeroCoulSliderMax(const Widget& parent, const char *label, 
		const int& mini, const int& maxi, const int& ValeurInitiale,
		const char* classe="NumeroCoulSliderMax",CoulSurf* pto=NULL) :
		Slider(parent,label,mini,maxi,ValeurInitiale,classe)
		{_pto=pto;};
	~NumeroCoulSliderMax() {};

	void Attach(CoulSurf* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class ChoixVerticalCouleurDessusSurf : public ChoixVerticalCascade
{
    private :

	CoulSurf* _pto;

    public :

	ChoixVerticalCouleurDessusSurf(const Widget& parent,
		ChoixVerticalPanel& panel,const char* name,
		const char* label,int col = 1,CoulSurf* pto = NULL) :
		ChoixVerticalCascade(parent,panel,name,label,col) {_pto = pto;};
	~ChoixVerticalCouleurDessusSurf() {};

	void Attach(CoulSurf* pto) {_pto = pto;};
	void ChargeInv();
};

class ChoixVerticalCouleurDessousSurf : public ChoixVerticalCascade
{
    private :

	CoulSurf* _pto;

    public :

	ChoixVerticalCouleurDessousSurf(const Widget& parent,
		ChoixVerticalPanel& panel,const char* name,
		const char* label,int col = 1,CoulSurf* pto = NULL) :
		ChoixVerticalCascade(parent,panel,name,label,col) {_pto = pto;};
	~ChoixVerticalCouleurDessousSurf() {};

	void Attach(CoulSurf* pto) {_pto = pto;};
	void ChargeInv();
};

class CoulSurfOK : public Bouton
{
    private:

	CoulSurf* _pto;

    public:

	CoulSurfOK(const Widget& parent, const char* label,
		const char* classe,CoulSurf* pto = NULL) :
		Bouton(parent,label,classe) {_pto = pto;};
	~CoulSurfOK() {};

	void Attach(CoulSurf* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

struct CoulSurfAnnuler : public Bouton
{	   
	CoulSurfAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~CoulSurfAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct CoulSurfAide : public Bouton
{	   
	CoulSurfAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~CoulSurfAide() {};
      
	void SelectCB(XtPointer call_data);
};

struct CoulSurfAppel : public PullDownEntry
{
	CoulSurfAppel(const Widget& parent,const char *label);
	~CoulSurfAppel() {};

	void SelectCB(XtPointer call_data);
};

class CoulSurf : public PopUp
{
    private:

	ConteneurLigne			_tout;

	ConteneurJoli                   _nombre_j;

	ConteneurColonne		_nombre;
	Label				_nombre_label;
	NombreCoulSaisie		_nombre_saisie;

	ConteneurJoli                   _numero_j;
	ConteneurLigne   		_numero_l;

	ConteneurColonne		_numero_min;
	Label				_numero_label_min;
	NumeroCoulSliderMin		_numero_slider_min;

	ConteneurColonne		_numero_max;
	Label				_numero_label_max;
	NumeroCoulSliderMax		_numero_slider_max;

	ConteneurJoli                   _options_j;
	ConteneurLigne   		_options_l;

	ConteneurColonne		_couleur;
	ChoixVerticalCouleurDessusSurf	_couleur_dessus;
	ChoixVerticalCouleurDessousSurf	_couleur_dessous;

	ConteneurJoli                   _standard_j;

	ConteneurColonne		_standard;
	CoulSurfOK			_ok;
	CoulSurfAnnuler			_annuler;
	CoulSurfAide			_aide;

	int				_coul_nombre;
	int				_coul_numero_min;
	int				_coul_numero_max;

    public:

	CoulSurf(const Widget& root);
	~CoulSurf() {};

	int CoulNumeroMin() const {return _coul_numero_min;};
	int CoulNumeroMax() const {return _coul_numero_max;};
	int CoulNombre() const {return _coul_nombre;};

	void Charge(int coul_num_min,int coul_num_max);

	int GetValueSliderMin() {return _numero_slider_min.GetValue();};
	int GetValueSliderMax() {return _numero_slider_max.GetValue();};

	void Change(int min,int max,int pos_min,int pos_max);
	void ChangeValeur(int nombre);
	void ChangeNombre();
};

// vue 2d .................................................

class Vue2d : public PullDownEntry
{
    public:

	Vue2d(const Widget& parent,const char* label,
		const char* classe="MENEN") :
		PullDownEntry(parent,label,classe) {};
	~Vue2d() {};

	void SelectCB(XtPointer call_data);
};

// vue 3d .................................................

class Vue3d : public PullDownEntry
{
    public:

	Vue3d(const Widget& parent,const char* label,
		const char* classe="MENEN") :
		PullDownEntry(parent,label,classe) {};
	~Vue3d() {};

	void SelectCB(XtPointer call_data);
};

#endif
