#ifndef S6BOUTTONS7_H
#define S6BOUTTONS7_H

// %W% %G% P. Brochard
// definitions des classes de bouttons

// axes ...............................................

class Axes;

class AxeOK : public Bouton
{
    private :

	Axes* _pto;

    public :

	AxeOK(const Widget& parent, const char* label,
		const char* classe,Axes* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~AxeOK() {};

	void Attach(Axes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct AxeAnnuler : public Bouton
{	   
	AxeAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~AxeAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeAide : public Bouton
{	   
	AxeAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~AxeAide() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeChoixLinX : public BoutonDeChoix
{	   
	AxeChoixLinX(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~AxeChoixLinX() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeChoixLogX : public BoutonDeChoix
{	   
	AxeChoixLogX(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~AxeChoixLogX() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeChoixLinY : public BoutonDeChoix
{	   
	AxeChoixLinY(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~AxeChoixLinY() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeChoixLogY : public BoutonDeChoix
{	   
	AxeChoixLogY(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~AxeChoixLogY() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeChoixLinZ : public BoutonDeChoix
{	   
	AxeChoixLinZ(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~AxeChoixLinZ() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeChoixLogZ : public BoutonDeChoix
{	   
	AxeChoixLogZ(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~AxeChoixLogZ() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeChoixLinC : public BoutonDeChoix
{	   
	AxeChoixLinC(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~AxeChoixLinC() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeChoixLogC : public BoutonDeChoix
{	   
	AxeChoixLogC(const Widget& parent, const char *label, 
		const char* classe) :
		BoutonDeChoix(parent,label,classe) {};
	~AxeChoixLogC() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeMinX : public Saisie
{
	AxeMinX(const Widget& parent,const char* label,
		short int taille = 15,const char* classe="AxeMinX") :
		Saisie(parent,label,taille,classe) {};
	~AxeMinX() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeMaxX : public Saisie
{
	AxeMaxX(const Widget& parent,const char* label,
		short int taille = 15,const char* classe="AxeMaxX") :
		Saisie(parent,label,taille,classe) {};
	~AxeMaxX() {};
      
	void SelectCB(XtPointer call_data);
};

class AxeAutoXBouton : public Bouton
{
    private :

	Axes* _pto;

    public :

	AxeAutoXBouton(const Widget& parent, const char *label,
		const char* classe = "AxeAutoXBouton",Axes* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~AxeAutoXBouton() {};

	void Attach(Axes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct AxeMinY : public Saisie
{
	AxeMinY(const Widget& parent,const char* label,
		short int taille = 15,const char* classe="AxeMinY") :
		Saisie(parent,label,taille,classe) {};
	~AxeMinY() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeMaxY : public Saisie
{
	AxeMaxY(const Widget& parent,const char* label,
		short int taille = 15,const char* classe="AxeMaxY") :
		Saisie(parent,label,taille,classe) {};
	~AxeMaxY() {};
      
	void SelectCB(XtPointer call_data);
};

class AxeAutoYBouton : public Bouton
{
    private :

	Axes* _pto;

    public :

	AxeAutoYBouton(const Widget& parent, const char *label,
		const char* classe = "AxeAutoYBouton",Axes* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~AxeAutoYBouton() {};

	void Attach(Axes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct AxeMinZ : public Saisie
{
	AxeMinZ(const Widget& parent,const char* label,
		short int taille = 15,const char* classe="AxeMinZ") :
		Saisie(parent,label,taille,classe) {};
	~AxeMinZ() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeMaxZ : public Saisie
{
	AxeMaxZ(const Widget& parent,const char* label,
		short int taille = 15,const char* classe="AxeMaxZ") :
		Saisie(parent,label,taille,classe) {};
	~AxeMaxZ() {};
      
	void SelectCB(XtPointer call_data);
};

class AxeAutoZBouton : public Bouton
{
    private :

	Axes* _pto;

    public :

	AxeAutoZBouton(const Widget& parent, const char *label,
		const char* classe = "AxeAutoZBouton",Axes* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~AxeAutoZBouton() {};

	void Attach(Axes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct AxeMinC : public Saisie
{
	AxeMinC(const Widget& parent,const char* label,
		short int taille = 15,const char* classe="AxeMinC") :
		Saisie(parent,label,taille,classe) {};
	~AxeMinC() {};
      
	void SelectCB(XtPointer call_data);
};

struct AxeMaxC : public Saisie
{
	AxeMaxC(const Widget& parent,const char* label,
		short int taille = 15,const char* classe="AxeMaxC") :
		Saisie(parent,label,taille,classe) {};
	~AxeMaxC() {};
      
	void SelectCB(XtPointer call_data);
};

class AxeAutoCBouton : public Bouton
{
    private :

	Axes* _pto;

    public :

	AxeAutoCBouton(const Widget& parent, const char *label,
		const char* classe = "AxeAutoCBouton",Axes* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~AxeAutoCBouton() {};

	void Attach(Axes* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct AxesAppel : public PullDownEntry
{
	AxesAppel(const Widget& parent,const char* label);
	~AxesAppel() {};

	void SelectCB(XtPointer call_data);
};

class Axes : public PopUp
{
    private:

	ConteneurLigne			_tout;

	ConteneurColonne		_blocs;

	ConteneurJoli			_axe_j;
	ConteneurLigne			_axe;

	ConteneurColonne		_axe_x;
	Label				_axe_x_label;

	ConteneurExclusifColonne	_axe_x_type;
	AxeChoixLinX			_axe_x_lin;
	AxeChoixLogX			_axe_x_log;

	ConteneurColonne		_axe_y;
	Label				_axe_y_label;

	ConteneurExclusifColonne	_axe_y_type;
	AxeChoixLinY			_axe_y_lin;
	AxeChoixLogY			_axe_y_log;

	ConteneurColonne		_axe_z;
	Label				_axe_z_label;

	ConteneurExclusifColonne	_axe_z_type;
	AxeChoixLinZ			_axe_z_lin;
	AxeChoixLogZ			_axe_z_log;

	ConteneurColonne		_axe_c;
	Label				_axe_c_label;

	ConteneurExclusifColonne	_axe_c_type;
	AxeChoixLinC			_axe_c_lin;
	AxeChoixLogC			_axe_c_log;

	ConteneurJoli			_axe_standard_j;
	ConteneurColonne		_axe_standard;
	AxeOK				_axe_ok;
	AxeAnnuler			_axe_annuler;
	AxeAide				_axe_aide;

	ConteneurJoli			_axe_bornes_j;
	ConteneurLigne			_axe_bornes;

	ConteneurColonne		_axe_x_bornes;
	Label				_axe_x_min_label;
	AxeMinX				_axe_x_min_texte;
	Label				_axe_x_max_label;
	AxeMaxX				_axe_x_max_texte;
	AxeAutoXBouton			_axe_x_auto;

	ConteneurColonne		_axe_y_bornes;
	Label				_axe_y_min_label;
	AxeMinY				_axe_y_min_texte;
	Label				_axe_y_max_label;
	AxeMaxY				_axe_y_max_texte;
	AxeAutoYBouton			_axe_y_auto;

	ConteneurColonne		_axe_z_bornes;
	Label				_axe_z_min_label;
	AxeMinZ				_axe_z_min_texte;
	Label				_axe_z_max_label;
	AxeMaxZ				_axe_z_max_texte;
	AxeAutoZBouton			_axe_z_auto;

	ConteneurColonne		_axe_c_bornes;
	Label				_axe_c_min_label;
	AxeMinC				_axe_c_min_texte;
	Label				_axe_c_max_label;
	AxeMaxC				_axe_c_max_texte;
	AxeAutoCBouton			_axe_c_auto;

    public:

	Axes(const Widget& root);
	~Axes() {};

	void ChangeAxeX();
	void ChangeAxeY();
	void ChangeAxeZ();
	void ChangeAxeC();

	void ChangeAxeMinX();
	void ChangeAxeMaxX();
	void ChangeAxeMinY();
	void ChangeAxeMaxY();
	void ChangeAxeMinZ();
	void ChangeAxeMaxZ();
	void ChangeAxeMinC();
	void ChangeAxeMaxC();

	void ChangeAxeMinX(REEL);
	void ChangeAxeMaxX(REEL);
	void ChangeAxeMinY(REEL);
	void ChangeAxeMaxY(REEL);
	void ChangeAxeMinZ(REEL);
	void ChangeAxeMaxZ(REEL);
	void ChangeAxeMinC(REEL);
	void ChangeAxeMaxC(REEL);

	void LitAxeMinX(REEL&);
	void LitAxeMaxX(REEL&);
	void LitAxeMinY(REEL&);
	void LitAxeMaxY(REEL&);
	void LitAxeMinZ(REEL&);
	void LitAxeMaxZ(REEL&);
	void LitAxeMinC(REEL&);
	void LitAxeMaxC(REEL&);

	void Cache();
	void Montre();
};

// titres axes ...............................................

class TitresAxes;

class TitresAxeOK : public Bouton
{
    private :

	TitresAxes* _pto;

    public :

	TitresAxeOK(const Widget& parent, const char* label,
		const char* classe,TitresAxes* const pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~TitresAxeOK() {};

	void Attach(TitresAxes* const pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct TitresAxeAnnuler : public Bouton
{	   
	TitresAxeAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~TitresAxeAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct TitresAxeAide : public Bouton
{	   
	TitresAxeAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~TitresAxeAide() {};
      
	void SelectCB(XtPointer call_data);
};

struct TitresAxeTitreX : public Saisie
{
	TitresAxeTitreX(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="AxeTitreX") :
		Saisie(parent,label,taille,classe) {};
	~TitresAxeTitreX() {};
      
	void SelectCB(XtPointer call_data);
};

struct TitresAxeTitreY : public Saisie
{
	TitresAxeTitreY(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="AxeTitreY") :
		Saisie(parent,label,taille,classe) {};
	~TitresAxeTitreY() {};
      
	void SelectCB(XtPointer call_data);
};

struct TitresAxeTitreZ : public Saisie
{
	TitresAxeTitreZ(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="AxeTitreZ") :
		Saisie(parent,label,taille,classe) {};
	~TitresAxeTitreZ() {};
      
	void SelectCB(XtPointer call_data);
};

struct ChoixVerticalCouleurTitresAxes : public ChoixVerticalCascade
{
	ChoixVerticalCouleurTitresAxes(const Widget& parent,
			ChoixVerticalPanel& panel,const char* const name,
			const char* const label,const int col = 1,
			PopUp* const popupbloque = NULL) :
		ChoixVerticalCascade(parent,panel,name,label,col,popupbloque) {};
	~ChoixVerticalCouleurTitresAxes() {};

	void ChargeInv();
};

struct ChoixVerticalTailleTitresAxes : public ChoixVerticalCascade
{
	ChoixVerticalTailleTitresAxes(const Widget& parent,
			ChoixVerticalPanel& panel,const char* const name,
			const char* const label,const int col = 1,
			PopUp* const popupbloque = NULL) :
		ChoixVerticalCascade(parent,panel,name,label,col,popupbloque) {};
	~ChoixVerticalTailleTitresAxes() {};

	void ChargeInv();
};

struct TitresAxesAppel : public PullDownEntry
{
	TitresAxesAppel(const Widget& parent,const char* label);
	~TitresAxesAppel() {};

	void SelectCB(XtPointer call_data);
};

struct TitresAxeDroitTitreY : public Saisie
{
	TitresAxeDroitTitreY(const Widget& parent,const char* label,
		short int taille = 20,const char* classe="AxeDroitTitreY") :
		Saisie(parent,label,taille,classe) {};
	~TitresAxeDroitTitreY() {};
      
	void SelectCB(XtPointer call_data);
};

class TitresAxes : public PopUp
{
    private:

	ConteneurLigne			_tout;

	ConteneurJoli			_axe_j;
	ConteneurLigne			_axe;

	ConteneurColonne		_axe_x_titre;
	Label				_axe_x_titre_label;
	TitresAxeTitreX			_axe_x_titre_texte;

	ConteneurColonne		_axe_y_titre;
	Label				_axe_y_titre_label;
	TitresAxeTitreY			_axe_y_titre_texte;

	ConteneurColonne		_axe_yd_titre;
	Label				_axe_yd_titre_label;
	TitresAxeDroitTitreY		_axe_yd_titre_texte;

	ConteneurColonne		_axe_z_titre;
	Label				_axe_z_titre_label;
	TitresAxeTitreZ			_axe_z_titre_texte;

	ConteneurJoli			_params_j;

	ConteneurColonne		_params;
	ConteneurColonne		_params2;
	ChoixVerticalCouleurTitresAxes	_couleur_titres;
	ChoixVerticalTailleTitresAxes	_taille_titres;

	ConteneurJoli			_axe_standard_j;
	ConteneurColonne		_axe_standard;
	TitresAxeOK			_axe_ok;
	TitresAxeAnnuler		_axe_annuler;
	TitresAxeAide			_axe_aide;

    public:

	TitresAxes(const Widget& root);
	~TitresAxes() {};

	void ChangeAxeX();
	void ChangeAxeY();
	void ChangeAxeYD();
	void ChangeAxeZ();

	void LitAxeX(char*&);
	void LitAxeY(char*&);
	void LitAxeYD(char*&);
	void LitAxeZ(char*&);

	void ChangeChoixVertical();

	void Cache();
	void Montre();
};

#endif
