#ifndef S6GEREENV_H
#define S6GEREENV_H

// %W% %G% Pierre Brochard

#include "cameleon/C5tabptchar.h"
#include "dinosaure/P4tabgenbase.h"

// module de lecture et d'ecriture de variables d'environnements pour Psyche

class S6GereEnv
{
	friend int main(int,char**);
	friend void Quit(int);
	friend void L3GetPosition(int,REEL&,REEL&);
	friend void L3GetPositionRect(int,REEL&,REEL&);
	friend class S6GereFenet;
	friend class S6GereFichier;
	friend class S6InitFich;
	friend class S6NameComp;
	friend class S6OuvDriver;
	friend class S6Points;
	friend class S6PointsAscii;
	friend class S6PointsUcd;
	friend class S6PointsMtv;
	friend class S6Trace;
	friend class CalculImage;
	friend class NomFichier;
	friend class PsycheCommuniq;
	friend class TextesAppel;
	friend class AxesAppel;
	friend class Coord3d;
	friend class FondEfface;
	friend class GestionCouleurIcol;
	friend class S6GereConfig;

    private :

        virtual void dummy() = 0;

        static P4Boolean ihm; // pour IHM (X11, Xt, Motif)
        static P4Boolean ihm_aff_iconic; // pour afficheur X11
        static P4Boolean ihm_aff_sans_bandeau; // pour afficheur X11
        static P4Boolean dest_x11;  // destin x11 vrai et avec IHM vrai
        static P4Boolean dest_negs;  // destin negs vrai
        static P4Boolean dest_phigs;  // destin phigs vrai
        static P4Boolean dest_phigsx11;  // destin phigs x11 vrai
        static P4Boolean dest_phigscgm;  // destin phigs cgm vrai
        static P4Boolean dest_phigsps;  // destin phigs ps vrai
        static P4Boolean dest_phigspsc;  // destin phigs psc vrai
        static P4Boolean dest_phigsrle;  // destin phigs rle vrai
        static P4Boolean dest_gl;  // destin gl vrai
        static P4Boolean dest_xgl;  // destin xgl vrai
        static P4Boolean dest_postcoul;  // destin postcoul vrai
        static P4Boolean dest_postcoulfich;  // destin postcoulfich vrai
        static P4Boolean dest_postscript;  // destin postscript vrai
        static P4Boolean dest_gif;  // destin gif vrai
        static P4Boolean dest_png;  // destin png vrai
        static P4Boolean dest_pgml;  // destin pgml vrai
        static P4Boolean dest_svg;  // destin SVG vrai
        static P4Boolean dest_xfig;  // destin xfig vrai
        static P4Boolean dest_inte;  // dest_x11 ou dest_negs vrai
        static P4Boolean dest_postderive;  // dest_postcoul ou ... vrai
        static P4Boolean dest_sanglier;  // est une dest sanglier vrai
        static char* dest;  // destin reelle

        static Tabcptchar _var_env;
        static Tabptchar _val_env;

	static Tabchar   _alloc_env;

        static int ChargEnv(const char* const nomfich = NULL);
        static int PurgeEnv();

	static int InitDest(const char* const new_dest);
	static int EstInitialise();
};

#define naruser              ((char*) (S6GereEnv::_val_env[0u]))
#define color_sp3         ((char*) (S6GereEnv::_val_env[1u]))
#define colorf_sp3        ((char*) (S6GereEnv::_val_env[2u]))
#define destl3            ((char*) (S6GereEnv::_val_env[3u]))
#define negshost_sp3      ((char*) (S6GereEnv::_val_env[4u]))
#define port_sp3          ((char*) (S6GereEnv::_val_env[5u]))
#define negs              ((char*) (S6GereEnv::_val_env[6u]))
#define psyche_sp3        ((char*) (S6GereEnv::_val_env[7u]))
#define images_sp3        ((char*) (S6GereEnv::_val_env[8u]))
#define repertoire_sp3    ((char*) (S6GereEnv::_val_env[9u]))
#define images_negs       ((char*) (S6GereEnv::_val_env[10u]))
#define display_sp3       ((char*) (S6GereEnv::_val_env[11u]))
#define helppath          ((char*) (S6GereEnv::_val_env[12u]))
#define serveur_inet_sp3  ((char*) (S6GereEnv::_val_env[13u]))
#define scale_sp3         ((char*) (S6GereEnv::_val_env[14u]))
#define fichier_sp3       ((char*) (S6GereEnv::_val_env[15u]))
#define home              ((char*) (S6GereEnv::_val_env[16u]))
#define ihm_sp3           ((char*) (S6GereEnv::_val_env[17u]))
#define destin_sp3        ((char*) (S6GereEnv::_val_env[18u]))
#define serveur_ascii_sp3 ((char*) (S6GereEnv::_val_env[19u]))
#define serveur_ucd_sp3   ((char*) (S6GereEnv::_val_env[20u]))
#define tmpdir            ((char*) (S6GereEnv::_val_env[21u]))
#define serveur_unix_sp3  ((char*) (S6GereEnv::_val_env[22u]))
#define visual_sp3        ((char*) (S6GereEnv::_val_env[23u]))
#define host              ((char*) (S6GereEnv::_val_env[24u]))

#endif
