//
// Identification du source
//

struct SccsIdS6InitFich
{
	static const char* const sccs_id;
};

const char* const SccsIdS6InitFich::sccs_id = "%W% %G% Pierre Brochard";

// Includes

#include "poulpe/IHM.h"
#include "S6constant.h"
#include "dinosaure/P4tabgenbasec.h"
#include "S6gereenv.h"
#include "S6namecomp.h"
#include "S6initfich.h"
#include "S6gerefich.h"
#include "P4constant.h"
#include "S6points.h"
#include "S6flagssup.h"
#include "S6gereconfig.h"
#include "dinosaure/S6string.h"

// Implementation des fonctions membres de S6InitFich

int
S6InitFich::InitFich()
{

    // initialisation de la musique

	int ier = 0;

	char* ptos = NULL;

	{
	    S6String ss(psyche_sp3,"/",S6NameComp::nom_play);

	    ptos = ss;
	}

	if(access(ptos,R_OK) == 0)
	{
	    delete[] ptos;

	    S6String ss("cd ",psyche_sp3,";play ",S6NameComp::nom_play,
			    "&");

	    ptos = ss;cout << ptos << endl;ier=system(ptos);
	}

	delete[] ptos;

    // initialisation fichier (gestion std input et pipe ou rien)
    // fichier_points = "input", "interne"
    // (image en dur si fichier_sp3 = " "), ou fichier_sp3
    // (si fichier_sp3 different de " ")

	if(strcmp(fichier_sp3,"rsh"))
	{
	    S6String ss("test -t 0;echo $?>",S6NameComp::fichier_provi_1);

	    ptos = ss;ier=system(ptos);
	}

	delete[] ptos;
	delete[] S6NameComp::fichier_points;

	fstream f_p_1(S6NameComp::fichier_provi_1,ios::in|ios::out);
	int std_input = 0;
	int no_input = 1;

	f_p_1 >> std_input;

	if(std_input)
	{
	    char c_temp;

	    f_p_1.seekp(0);

	    if(cin.get(c_temp))
	    {
		f_p_1.put(c_temp);

		while(cin.get(c_temp)) f_p_1.put(c_temp);

		S6String ss("input");

		S6NameComp::fichier_points = ss;
		no_input = 0;
	    }

	}

	f_p_1.close();

	if(no_input)
	{

	    if(!strcmp(fichier_sp3," ") || !strcmp(fichier_sp3,"rsh"))
	    {
		S6String ss("interne");

		S6NameComp::fichier_points = ss;
	    }
	    else
	    {

		if(!strncmp(fichier_sp3,"/",1))
		{
		    S6String ss(fichier_sp3);

		    S6NameComp::fichier_points = ss;
		}
		else
		{
		    S6String ss(S6NameComp::chemin_repertoire,"/",fichier_sp3);

		    S6NameComp::fichier_points = ss;
		}

	    }

	}

	cout << "S6InitFich> fichier_points " <<
	    S6NameComp::fichier_points << endl;

	return ier;
}

int
S6InitFich::InitImageDur()
{

	if(S6GereFichier::pt_points == NULL)
	{
	    S6GereFichier::pt_points = new S6Points;
	}
	else
	{
	    S6Points* const s6p = S6GereFichier::pt_points;

	    if(s6p->Typefichier() == S6PHYSIQUE_2D &&
	        (option_2d_concatene == 0 ||
		S6FlagsSup::choix_trace != S6FlagsSup::TRACE_2D))
	    {
		s6p->Enleve();
		s6p->NbFichiersConcat(0);
	    }

	    if(s6p->Typefichier() != S6PHYSIQUE_2D &&
	        (option_3d_concatene == 0 ||
		S6FlagsSup::choix_trace == S6FlagsSup::TRACE_2D ||
		option_3d_concatene > 1 &&
		int(s6p->NbFichiersConcat()) == option_3d_concatene))
	    {
		s6p->Enleve();
		s6p->NbFichiersConcat(0);
	    }

	}

	S6Points* const s6p = S6GereFichier::pt_points;
	S6DonneeAbstraite* sda = new S6DonneeAbstraite;
	int nx = 4;
	int ny = 4;

	s6p->Typefichier(S6PHYSIQUE_4D);

	sda->Nx(nx);
	sda->Ny(ny);
	sda->Nz(1);
	sda->Typefichier(S6PHYSIQUE_4D);

	for(int j=0;j<ny;j++)
	{

	    for(int i=0;i<nx;i++)
	    {
		sda->X().Ajoute((REEL_S) (i-1.0));
		sda->Y().Ajoute((REEL_S) (j-1.0));
		sda->Z().Ajoute((REEL_S) (2.0-pow(sda->X()[i+j*nx],2)-
			pow(sda->Y()[i+j*nx],2)));
		sda->C().Ajoute(sda->Z()[i+j*nx]);
	    }

	}

	sda->C()[6] = 4.5;
	sda->C()[9] = -1.;
	sda->C()[10] = 4.5;
	sda->C()[6] = 1.5;

	s6p->Ajoute(sda);
	s6p->NbFichiersConcat(s6p->NbFichiersConcat()+1);

	if(option_3d_concatene > 1 &&
			int(s6p->NbFichiersConcat()) == option_3d_concatene)
	{
	    s6p->Enleve();
	    s6p->NbFichiersConcat(0);
	}

	nx=5;
	ny=1;
	sda = new S6DonneeAbstraite;

	sda->Nx(nx);
	sda->Ny(ny);
	sda->Nz(1);
	sda->Typefichier(S6PHYSIQUE_4D_NS);

	sda->X().Ajoute(4.0f);
	sda->Y().Ajoute(4.0f);
	sda->Z().Ajoute(0.0f);
	sda->C().Ajoute(2.0f);

	sda->X().Ajoute(5.0f);
	sda->Y().Ajoute(5.0f);
	sda->Z().Ajoute(2.0f);
	sda->C().Ajoute(1.0f);

	sda->X().Ajoute(5.0f);
	sda->Y().Ajoute(6.0f);
	sda->Z().Ajoute(3.0f);
	sda->C().Ajoute(0.0f);

	sda->X().Ajoute(4.0f);
	sda->Y().Ajoute(7.0f);
	sda->Z().Ajoute(2.0f);
	sda->C().Ajoute(1.0f);

	sda->X().Ajoute(2.0f);
	sda->Y().Ajoute(5.0f);
	sda->Z().Ajoute(7.0f);
	sda->C().Ajoute(0.0f);

	sda->Nmailles(1);
	sda->Mailles().Ajoute(unsigned(nx));

	unsigned nx1 = nx + 1;

	for(unsigned i=1;i<nx1;i++)
	{
	    sda->Mailles().Ajoute(i-1);
	}

	s6p->Ajoute(sda);
	s6p->NbFichiersConcat(s6p->NbFichiersConcat()+1);

	return 0;
}
