//
// Ident.
//

struct SccsIdS6Traduc
{
	static const char* const sccs_id;
};

const char* const SccsIdS6Traduc::sccs_id = "%W% %G% Pierre Brochard";

//
// Includes
//

#include "U8machcomp.h"
#include "P4constant.h"
#include <string.h>

#if defined(SC1_0) && defined(SUNOS_4)
#   include <strings.h>
#endif

#include "S6traduc.h"
#include "S6nom.h"

// *********************************************************************
// Ce module defini les chaines de caracteres aparaissant dans l'IHM
// *********************************************************************

// variables statiques de classe

int S6Traduc::version = 0; // voir S6de.C bandeau code
const char** S6Traduc::traduc = NULL;
const char** S6Traduc::couleur = NULL;
const char** S6Traduc::map = NULL;
const char** S6Traduc::dest = NULL;
const char** S6Traduc::affx = NULL;
const char** S6Traduc::repert = NULL;

unsigned S6Traduc::taille_traduc = 360;
unsigned S6Traduc::taille_couleur = 64;
unsigned S6Traduc::taille_map = 17;
unsigned S6Traduc::taille_dest = 23;
unsigned S6Traduc::taille_affx = 35;
unsigned S6Traduc::taille_repert = 7;

// init

void
S6Traduc::Init(const char* const lang)
{
	const char* nom_code = S6Nom::_nom_code;
	const int nom_logiciel =
	    nom_code[0] == '\141' && nom_code[1] == '\0' &&
	    nom_code[2] == '\162' && nom_code[3] == '\21' &&
	    nom_code[4] == '\170' && nom_code[5] == '\13' &&
	    nom_code[6] == '\170' && nom_code[7] == '\35' &&
	    nom_code[8] == '\75' && nom_code[9] == '\35' &&
	    nom_code[10] == '\75' && nom_code[11] == '\35';

	if(!nom_logiciel)
	{
	    version = 1;
	}

	InitTraduc(lang,nom_logiciel);
	InitCouleur(lang);
	InitMap(lang);
	InitDest(lang);
	InitAffx(lang);
	InitRepert(lang);
}

void
S6Traduc::InitTraduc(const char* const lang,int nom_logiciel)
{
	delete[] traduc;

	traduc = new const char*[taille_traduc];

	if(!strcasecmp(lang,"francais"))
	{
	    InitTraducFrancais(nom_logiciel);
	}
	else if(!strcasecmp(lang,"anglais"))
	{
	    InitTraducAnglais(nom_logiciel);
	}
	else
	{
	    InitTraducAutre(nom_logiciel);
	}

}

void
S6Traduc::InitTraducFrancais(int nom_logiciel)
{
	const char** traduc_temp = traduc;

	*traduc_temp++ = "Nom du fichier :";
	*traduc_temp++ = "Calcul image";
	*traduc_temp++ = "Message : ";
	*traduc_temp++ = nom_logiciel ? "Narcisse ouvert" : "Psyche ouvert";
	*traduc_temp++ = "Fichier charg\351 ; initialisations";
	*traduc_temp++ = "Fin des initialisations";
	*traduc_temp++ = "Fichier en cours de chargement";
	*traduc_temp++ = "Trac\351 en cours";
	*traduc_temp++ = "Trac\351 termin\351";
	*traduc_temp++ = "Configuration";
	*traduc_temp++ = "Home";
	*traduc_temp++ = "Attach";
	*traduc_temp++ = "Lit";
	*traduc_temp++ = "Ecrit";
	*traduc_temp++ = "Configuration";
	*traduc_temp++ = "Azimut";
	*traduc_temp++ = "Site";
	*traduc_temp++ = "Options 3D";
	*traduc_temp++ = "Niveaux";
	*traduc_temp++ = "Facettes";
	*traduc_temp++ = "Filaire";
	*traduc_temp++ = "Lissage";
	*traduc_temp++ = "niveaux 3d";
	*traduc_temp++ = "niveaux 4d";
	*traduc_temp++ = "facettes 3d";
	*traduc_temp++ = "facettes 4d";
	*traduc_temp++ = "filaire mono";
	*traduc_temp++ = "filaire 3d";
	*traduc_temp++ = "filaire 4d";
	*traduc_temp++ = "lissage 3d";
	*traduc_temp++ = "lissage 4d";
	*traduc_temp++ = "Masque";
	*traduc_temp++ = "sans masque";
	*traduc_temp++ = "masque simple min";
	*traduc_temp++ = "masque simple max";
	*traduc_temp++ = "masque tri";
	*traduc_temp++ = "Options 2D";
	*traduc_temp++ = "Options";
	*traduc_temp++ = "Trace";
	*traduc_temp++ = "Concat\x0e9nation";
	*traduc_temp++ = "courbe";
	*traduc_temp++ = "int\x0e9grale";
	*traduc_temp++ = "d\x0e9riv\351e";
	*traduc_temp++ = "oui";
	*traduc_temp++ = "non";
	*traduc_temp++ = "Axes";
	*traduc_temp++ = "Titres";
	*traduc_temp++ = "Grilles";
	*traduc_temp++ = "Textes";
	*traduc_temp++ = "Titres";
	*traduc_temp++ = "Titre plac\x0e9 en :";
	*traduc_temp++ = "Affichage :";
	*traduc_temp++ = "haut";
	*traduc_temp++ = "gauche";
	*traduc_temp++ = "droit";
	*traduc_temp++ = "bas";
	*traduc_temp++ = "non";
	*traduc_temp++ = "sans cadre";
	*traduc_temp++ = "avec cadre";
	*traduc_temp++ = "Couleur";
	*traduc_temp++ = "antifond";
	*traduc_temp++ = "bleu";
	*traduc_temp++ = "vert";
	*traduc_temp++ = "jaune";
	*traduc_temp++ = "orange";
	*traduc_temp++ = "rouge";
	*traduc_temp++ = "violet";
	*traduc_temp++ = "gris";
	*traduc_temp++ = "autres";
	*traduc_temp++ = "Titre :";
	*traduc_temp++ = "Taille";
	*traduc_temp++ = "16";
	*traduc_temp++ = "15";
	*traduc_temp++ = "14";
	*traduc_temp++ = "13";
	*traduc_temp++ = "12";
	*traduc_temp++ = "11";
	*traduc_temp++ = "10";
	*traduc_temp++ = "9";
	*traduc_temp++ = "8";
	*traduc_temp++ = "7";
	*traduc_temp++ = "6";
	*traduc_temp++ = "5";
	*traduc_temp++ = "4";
	*traduc_temp++ = "3";
	*traduc_temp++ = "2";
	*traduc_temp++ = "1";
	*traduc_temp++ = "Nombre de textes :";
	*traduc_temp++ = "Num\x0e9ro du texte :";
	*traduc_temp++ = "Affichage :";
	*traduc_temp++ = "non";
	*traduc_temp++ = "sans cadre";
	*traduc_temp++ = "avec cadre";
	*traduc_temp++ = "Texte :";
	*traduc_temp++ = "Position";
	*traduc_temp++ = "Angle :";
	*traduc_temp++ = "Textes";
	*traduc_temp++ = "Grilles";
	*traduc_temp++ = "Grilles :";
	*traduc_temp++ = "non";
	*traduc_temp++ = "creuse";
	*traduc_temp++ = "semi-creuse";
	*traduc_temp++ = "pleine";
	*traduc_temp++ = "Echelle couleur z :";
	*traduc_temp++ = "non";
	*traduc_temp++ = "d\351faut";
	*traduc_temp++ = "position";
	*traduc_temp++ = "Echelle couleur c :";
	*traduc_temp++ = "L\x0e9gendes 3d-4d :";
	*traduc_temp++ = "Fond";
	*traduc_temp++ = "non";
	*traduc_temp++ = "oui";
	*traduc_temp++ = "Legendes :";
	*traduc_temp++ = "Point de vue";
	*traduc_temp++ = "Point de vue";
	*traduc_temp++ = "Distance";
	*traduc_temp++ = "Redress horizontales";
	*traduc_temp++ = "Redress verticales";
	*traduc_temp++ = "R\x0e9pertoire";
	*traduc_temp++ = "Axes";
	*traduc_temp++ = "Axe des X :";
	*traduc_temp++ = "lin";
	*traduc_temp++ = "log";
	*traduc_temp++ = "Nouveau titre axe X :";
	*traduc_temp++ = "Axe des Y :";
	*traduc_temp++ = "Nouveau titre axe Y :";
	*traduc_temp++ = "Axe des Z :";
	*traduc_temp++ = "Nouveau titre axe Z :";
	*traduc_temp++ = "Axe des C :";
	*traduc_temp++ = "X min :";
	*traduc_temp++ = "X max :";
	*traduc_temp++ = "Auto X";
	*traduc_temp++ = "Y min :";
	*traduc_temp++ = "Y max :";
	*traduc_temp++ = "Auto Y";
	*traduc_temp++ = "Z min :";
	*traduc_temp++ = "Z max :";
	*traduc_temp++ = "Auto Z";
	*traduc_temp++ = "C min :";
	*traduc_temp++ = "C max :";
	*traduc_temp++ = "Auto C";
	*traduc_temp++ = "Couleur titres axes :";
	*traduc_temp++ = "Taille titres axes :";
	*traduc_temp++ = "Taille labels axes :";
	*traduc_temp++ = "Echelles";
	*traduc_temp++ = "Echelle 3d :";
	*traduc_temp++ = "Echelle 4d :";
	*traduc_temp++ = "Zh min :";
	*traduc_temp++ = "Zh max :";
	*traduc_temp++ = "Auto Zh";
	*traduc_temp++ = "Ch min :";
	*traduc_temp++ = "Ch max :";
	*traduc_temp++ = "Auto Ch";
	*traduc_temp++ = "Echelles";
	*traduc_temp++ = "Nombre niveaux Z :";
	*traduc_temp++ = "Nombre niveaux C :";
	*traduc_temp++ = "Animation";
	*traduc_temp++ = "Anim pas azimut :";
	*traduc_temp++ = "Anim pas site :";
	*traduc_temp++ = "Nombre animation :";
	*traduc_temp++ = "Animation";
	*traduc_temp++ = "Dimensions";
	*traduc_temp++ = "Position boite";
	*traduc_temp++ = "X1 (cm) :";
	*traduc_temp++ = "X2 (cm) :";
	*traduc_temp++ = "Boite defaut";
	*traduc_temp++ = "Y1 (cm) :";
	*traduc_temp++ = "Y2 (cm) :";
	*traduc_temp++ = "Defaut DX,DY";
	*traduc_temp++ = "DX (cm) :";
	*traduc_temp++ = "DY (cm) :";
	*traduc_temp++ = "Dimensions";
	*traduc_temp++ = "Zoom";
	*traduc_temp++ = "Nul zoom";
	*traduc_temp++ = "Zoom 2d";
	*traduc_temp++ = "Coordonn\351es 2d";
	*traduc_temp++ = "Coordonnees";
	*traduc_temp++ = "Couleurs surface";
	*traduc_temp++ = "Couleur dessus surface";
	*traduc_temp++ = "Couleur dessous surface";
	*traduc_temp++ = "Couleurs surface";
	*traduc_temp++ = "Couleur grille :";
	*traduc_temp++ = "vue 2d";
	*traduc_temp++ = "vue 3d";
	*traduc_temp++ = "Coupe en i :";
	*traduc_temp++ = "Coupe en j :";
	*traduc_temp++ = "Moyenne de imin :";
	*traduc_temp++ = "         a imax :";
	*traduc_temp++ = "Moyenne de jmin :";
	*traduc_temp++ = "         a jmax :";
	*traduc_temp++ = "Projection de imin :";
	*traduc_temp++ = "            a imax :";
	*traduc_temp++ = "        par pas de :";
	*traduc_temp++ = "Projection de jmin :";
	*traduc_temp++ = "            a jmax :";
	*traduc_temp++ = "        par pas de :";
	*traduc_temp++ = "Coupes logiques";
	*traduc_temp++ = "Coupe en i active";
	*traduc_temp++ = "Coupe en j active";
	*traduc_temp++ = "Moyenne en i active";
	*traduc_temp++ = "Moyenne en j active";
	*traduc_temp++ = "Projection en i active";
	*traduc_temp++ = "Projection en j active";
	*traduc_temp++ = "Coupes";
	*traduc_temp++ = "Retour 3d";
	*traduc_temp++ = "Fichier";
	*traduc_temp++ = "Edition";
	*traduc_temp++ = "Param\350tres";
	*traduc_temp++ = "Courbes";
	*traduc_temp++ = "Nombre de courbes :";
	*traduc_temp++ = "n\x0b0 de courbe min :";
	*traduc_temp++ = "n\x0b0 de courbe max :";
	*traduc_temp++ = "Type :";
	*traduc_temp++ = "Non";
	*traduc_temp++ = "Simple";
	*traduc_temp++ = "Marche";
	*traduc_temp++ = "+";
	*traduc_temp++ = "*";
	*traduc_temp++ = "o";
	*traduc_temp++ = "x";
	*traduc_temp++ = ".";
	*traduc_temp++ = "Label :";
	*traduc_temp++ = "Couleur :";
	*traduc_temp++ = "Courbes";
	*traduc_temp++ = "Gestion de donn\351es 4D";
	*traduc_temp++ = "Num\x0e9ro donn\351es : ";
	*traduc_temp++ = "Gestion donn\351es 4D";
	*traduc_temp++ = "OK";
	*traduc_temp++ = "Annuler";
	*traduc_temp++ = "Aide";
	*traduc_temp++ = "Aide Axes";
	*traduc_temp++ = "Nombre variables noeuds + mailles : ";
	*traduc_temp++ = "0 + 0";
	*traduc_temp++ = "Type trac\351 fil";
	*traduc_temp++ = "Trac\351 en X";
	*traduc_temp++ = "Trac\351 en Y";
	*traduc_temp++ = "Trac\351 en XY";
	*traduc_temp++ = "Break";
	*traduc_temp++ = "Aide Grilles";
	*traduc_temp++ = "Aide Titres";
	*traduc_temp++ = "Aide Textes";
	*traduc_temp++ = "Aide Echelles";
	*traduc_temp++ = "B.E.";
	*traduc_temp++ = "Sc\350ne";
	*traduc_temp++ = "Trace image L3";
	*traduc_temp++ = "Gestion fichiers";
	*traduc_temp++ = "Purge";
	*traduc_temp++ = "==>";
	*traduc_temp++ = "<==";
	*traduc_temp++ = "Tous";
	*traduc_temp++ = "Gestion fichiers";
	*traduc_temp++ = "Fichiers de points "
	     "(*.spx *.sp3 *.inp + .Z ou .gz)";
	*traduc_temp++ = "Fichiers de points (l3.* *.l3 + .Z ou .gz)";
	*traduc_temp++ = "Purge";
	*traduc_temp++ = "==>";
	*traduc_temp++ = "<==";
	*traduc_temp++ = "Tous";
	*traduc_temp++ = "Courbe cot\351 : ";
	*traduc_temp++ = "Gauche";
	*traduc_temp++ = "Droit";
	*traduc_temp++ = "Aide Courbes";
	*traduc_temp++ = "Axe droit";
	*traduc_temp++ = "Axe des Y droit :";
	*traduc_temp++ = "Nouveau titre axe Y droit :";
	*traduc_temp++ = "Y min droit :";
	*traduc_temp++ = "Y max droit :";
	*traduc_temp++ = "Auto Y droit";
	*traduc_temp++ = "Axe droit";
	*traduc_temp++ = "Coordonn\351es 2d droite";
	*traduc_temp++ = "Roulis";
	*traduc_temp++ = "Aide Point de vue";
	*traduc_temp++ = "Aide Dimensions";
	*traduc_temp++ = "Aide Animation";
	*traduc_temp++ = "Aide Couleur surface";
	*traduc_temp++ = "Aide Configuration";
	*traduc_temp++ = "Agrandissement";
	*traduc_temp++ = "R\351duction";
	*traduc_temp++ = "Nul zoom";
	*traduc_temp++ = "Zoom graphique";
	*traduc_temp++ = "Z <-> C";
	*traduc_temp++ = "non";
	*traduc_temp++ = "oui";
	*traduc_temp++ = "BIENVENUE";
	*traduc_temp++ = "Coupe par un hyperplan :";
	*traduc_temp++ = "non";
	*traduc_temp++ = "oui";
	*traduc_temp++ = "";
	*traduc_temp++ = "Aide Options 3d";
	*traduc_temp++ = "Niveaux :";
	*traduc_temp++ = "Facettes :";
	*traduc_temp++ = "Filaire :";
	*traduc_temp++ = "Lissage :";
	*traduc_temp++ = "Equation hyperplan :";
	*traduc_temp++ = "x +";
	*traduc_temp++ = "y +";
	*traduc_temp++ = "z +";
	*traduc_temp++ = "c +";
	*traduc_temp++ = "= 0";
	*traduc_temp++ = "Cartes de couleurs";
	*traduc_temp++ = "Fin";
	*traduc_temp++ = "Drivers";
	*traduc_temp++ = "Sortie";
	*traduc_temp++ = "Masque :";
	*traduc_temp++ = "Coordonn\351es 3d";
	*traduc_temp++ = "Pixel : ";
	*traduc_temp++ = "Pixel 3d";
	*traduc_temp++ = "Pixel 4d";
	*traduc_temp++ = " ==> ";
	*traduc_temp++ = "garde";
	*traduc_temp++ = "efface";
	*traduc_temp++ = "G\351n\351rateur :";
	*traduc_temp++ = "hard";
	*traduc_temp++ = "soft";
	*traduc_temp++ = "fin";
	*traduc_temp++ = "autres";
	*traduc_temp++ = "Calcul socket";
	*traduc_temp++ = "Fichier sauvegarde";
	*traduc_temp++ = "Config sauvegarde";
	*traduc_temp++ = "OK cache";
	*traduc_temp++ = "oui";
	*traduc_temp++ = "non";
	*traduc_temp++ = "binaire";
	*traduc_temp++ = "ascii";
	*traduc_temp++ = "ucd";
	*traduc_temp++ = "rien";
	*traduc_temp++ = "Etat";
	*traduc_temp++ = "Port serveur : ";
	*traduc_temp++ = "Ports serveurs : ";
	*traduc_temp++ = "Sauve";
	*traduc_temp++ = "Multi -> Mono";
	*traduc_temp++ = "Coordonn\351es";
	*traduc_temp++ = "1 / 4";
	*traduc_temp++ = "2 / 4";
	*traduc_temp++ = "3 / 4";
	*traduc_temp++ = "4 / 4";
	*traduc_temp++ = "Calcul ihm";
	*traduc_temp++ = "Agrand. carr\351";
	*traduc_temp++ = "R\351duc. carr\351";
	*traduc_temp++ = "Efface";
	*traduc_temp++ = "Gestion des couleurs";
	*traduc_temp++ = "Appel de Colors";
	*traduc_temp++ = "Nombre couleurs de base : ";
	*traduc_temp++ = "Taille palette : ";
	*traduc_temp++ = "Aide Gestion des couleurs";
	*traduc_temp++ = "Nombre de couleurs :";
	*traduc_temp++ = "Num\351ro de couleur min :";
	*traduc_temp++ = "Num\351ro de couleur max :";
	*traduc_temp++ = "Nombre de blocs :";
	*traduc_temp++ = "N\260 de bloc min :";
	*traduc_temp++ = "N\260 de bloc max :";
	*traduc_temp++ = "Infos";
	*traduc_temp++ = "Pixel";
	*traduc_temp++ = "Mode pixmap";
	*traduc_temp++ = "Pas pour animation :";
	*traduc_temp++ = "Aide Gestion donn\351es";
	*traduc_temp++ = "Aide Gestion fichiers";
	*traduc_temp++ = "Coupes 3D";
	*traduc_temp++ = "Titres Axes";
	*traduc_temp++ = "Aide Titres Axes";
	*traduc_temp++ = "Titres Axes";
}

void
S6Traduc::InitTraducAnglais(int nom_logiciel)
{
	const char** traduc_temp = traduc;

	*traduc_temp++ = "Name of file :";
	*traduc_temp++ = "Compute image";
	*traduc_temp++ = "Message : ";
	*traduc_temp++ = nom_logiciel ? "Narcisse open" : "Psyche open";
	*traduc_temp++ = "File load ; initialization";
	*traduc_temp++ = "end of initialization";
	*traduc_temp++ = "File loading in progress";
	*traduc_temp++ = "Image in progress";
	*traduc_temp++ = "Image OK";
	*traduc_temp++ = "Configuration";
	*traduc_temp++ = "Home";
	*traduc_temp++ = "Attach";
	*traduc_temp++ = "Read";
	*traduc_temp++ = "Write";
	*traduc_temp++ = "Configuration";
	*traduc_temp++ = "Azimuth";
	*traduc_temp++ = "Site";
	*traduc_temp++ = "3D Options";
	*traduc_temp++ = "Isolines";
	*traduc_temp++ = "Flat";
	*traduc_temp++ = "Wire";
	*traduc_temp++ = "Smooth";
	*traduc_temp++ = "isolines 3d";
	*traduc_temp++ = "isolines 4d";
	*traduc_temp++ = "flat 3d";
	*traduc_temp++ = "flat 4d";
	*traduc_temp++ = "wire mono";
	*traduc_temp++ = "wire 3d";
	*traduc_temp++ = "wire 4d";
	*traduc_temp++ = "smooth 3d";
	*traduc_temp++ = "smoth 4d";
	*traduc_temp++ = "Mask";
	*traduc_temp++ = "without mask";
	*traduc_temp++ = "simple mask min";
	*traduc_temp++ = "simple mask max";
	*traduc_temp++ = "sort mask";
	*traduc_temp++ = "2D Options";
	*traduc_temp++ = "Options";
	*traduc_temp++ = "Trace";
	*traduc_temp++ = "Concatenation";
	*traduc_temp++ = "curve";
	*traduc_temp++ = "integral";
	*traduc_temp++ = "derivative";
	*traduc_temp++ = "yes";
	*traduc_temp++ = "no";
	*traduc_temp++ = "Axis";
	*traduc_temp++ = "Titles";
	*traduc_temp++ = "Grids";
	*traduc_temp++ = "Texts";
	*traduc_temp++ = "Titles";
	*traduc_temp++ = "Title's position :";
	*traduc_temp++ = "View :";
	*traduc_temp++ = "top";
	*traduc_temp++ = "left";
	*traduc_temp++ = "right";
	*traduc_temp++ = "bottom";
	*traduc_temp++ = "no";
	*traduc_temp++ = "without bounding box";
	*traduc_temp++ = "with bounding box";
	*traduc_temp++ = "Color";
	*traduc_temp++ = "foreground";
	*traduc_temp++ = "blue";
	*traduc_temp++ = "green";
	*traduc_temp++ = "yellow";
	*traduc_temp++ = "orange";
	*traduc_temp++ = "red";
	*traduc_temp++ = "purple";
	*traduc_temp++ = "grey";
	*traduc_temp++ = "others";
	*traduc_temp++ = "Title :";
	*traduc_temp++ = "Size";
	*traduc_temp++ = "16";
	*traduc_temp++ = "15";
	*traduc_temp++ = "14";
	*traduc_temp++ = "13";
	*traduc_temp++ = "12";
	*traduc_temp++ = "11";
	*traduc_temp++ = "10";
	*traduc_temp++ = "9";
	*traduc_temp++ = "8";
	*traduc_temp++ = "7";
	*traduc_temp++ = "6";
	*traduc_temp++ = "5";
	*traduc_temp++ = "4";
	*traduc_temp++ = "3";
	*traduc_temp++ = "2";
	*traduc_temp++ = "1";
	*traduc_temp++ = "Number of texts :";
	*traduc_temp++ = "text number :";
	*traduc_temp++ = "View :";
	*traduc_temp++ = "no";
	*traduc_temp++ = "without bounding box";
	*traduc_temp++ = "with bounding box";
	*traduc_temp++ = "Text :";
	*traduc_temp++ = "Position";
	*traduc_temp++ = "Angle :";
	*traduc_temp++ = "Texts";
	*traduc_temp++ = "Grids";
	*traduc_temp++ = "Grids :";
	*traduc_temp++ = "no";
	*traduc_temp++ = "empty";
	*traduc_temp++ = "half-full";
	*traduc_temp++ = "full";
	*traduc_temp++ = "Color scale z :";
	*traduc_temp++ = "no";
	*traduc_temp++ = "default";
	*traduc_temp++ = "position";
	*traduc_temp++ = "Color scale c :";
	*traduc_temp++ = "3d-4d legend :";
	*traduc_temp++ = "Background";
	*traduc_temp++ = "no";
	*traduc_temp++ = "yes";
	*traduc_temp++ = "Legend :";
	*traduc_temp++ = "Point of view";
	*traduc_temp++ = "Point of view";
	*traduc_temp++ = "Distance";
	*traduc_temp++ = "Horizontal set up";
	*traduc_temp++ = "Vertical set up";
	*traduc_temp++ = "Folder";
	*traduc_temp++ = "Axis";
	*traduc_temp++ = "X axis :";
	*traduc_temp++ = "lin";
	*traduc_temp++ = "log";
	*traduc_temp++ = "New X axis title :";
	*traduc_temp++ = "Y axis :";
	*traduc_temp++ = "New Y axis title :";
	*traduc_temp++ = "Z axis :";
	*traduc_temp++ = "New Z axis title :";
	*traduc_temp++ = "C axis :";
	*traduc_temp++ = "X min :";
	*traduc_temp++ = "X max :";
	*traduc_temp++ = "Auto X";
	*traduc_temp++ = "Y min :";
	*traduc_temp++ = "Y max :";
	*traduc_temp++ = "Auto Y";
	*traduc_temp++ = "Z min :";
	*traduc_temp++ = "Z max :";
	*traduc_temp++ = "Auto Z";
	*traduc_temp++ = "C min :";
	*traduc_temp++ = "C max :";
	*traduc_temp++ = "Auto C";
	*traduc_temp++ = "Axis titles color :";
	*traduc_temp++ = "Axis titles size :";
	*traduc_temp++ = "Axis labels size :";
	*traduc_temp++ = "Scales";
	*traduc_temp++ = "3d scale :";
	*traduc_temp++ = "4d scale :";
	*traduc_temp++ = "Zh min :";
	*traduc_temp++ = "Zh max :";
	*traduc_temp++ = "Auto Zh";
	*traduc_temp++ = "Ch min :";
	*traduc_temp++ = "Ch max :";
	*traduc_temp++ = "Auto Ch";
	*traduc_temp++ = "Scales";
	*traduc_temp++ = "Number of isolines Z :";
	*traduc_temp++ = "Number of isolines C :";
	*traduc_temp++ = "Animation";
	*traduc_temp++ = "Azimuth step :";
	*traduc_temp++ = "Site step :";
	*traduc_temp++ = "Number of animation :";
	*traduc_temp++ = "Animation";
	*traduc_temp++ = "Dimensions";
	*traduc_temp++ = "Box position";
	*traduc_temp++ = "X1 (cm) :";
	*traduc_temp++ = "X2 (cm) :";
	*traduc_temp++ = "Default box";
	*traduc_temp++ = "Y1 (cm) :";
	*traduc_temp++ = "Y2 (cm) :";
	*traduc_temp++ = "Default DX,DY";
	*traduc_temp++ = "DX (cm) :";
	*traduc_temp++ = "DY (cm) :";
	*traduc_temp++ = "Dimensions";
	*traduc_temp++ = "Zoom";
	*traduc_temp++ = "Nul zoom";
	*traduc_temp++ = "2d zoom";
	*traduc_temp++ = "2d coordinates";
	*traduc_temp++ = "Coordinates";
	*traduc_temp++ = "Surface color";
	*traduc_temp++ = "Above surface color";
	*traduc_temp++ = "Below surface color";
	*traduc_temp++ = "Surface colors";
	*traduc_temp++ = "Grid color :";
	*traduc_temp++ = "2d view";
	*traduc_temp++ = "3d view";
	*traduc_temp++ = "Cut on i :";
	*traduc_temp++ = "Cut on j :";
	*traduc_temp++ = "Mean from imin :";
	*traduc_temp++ = "       to imax :";
	*traduc_temp++ = "Mean from jmin :";
	*traduc_temp++ = "       to jmax :";
	*traduc_temp++ = "Projection from imin :";
	*traduc_temp++ = "             to imax :";
	*traduc_temp++ = "          by step of :";
	*traduc_temp++ = "Projection from jmin :";
	*traduc_temp++ = "             to jmax :";
	*traduc_temp++ = "          by step of :";
	*traduc_temp++ = "Logical cuts";
	*traduc_temp++ = "Cut i on";
	*traduc_temp++ = "Cut j on";
	*traduc_temp++ = "Mean i on";
	*traduc_temp++ = "Mean j on";
	*traduc_temp++ = "Projection i on";
	*traduc_temp++ = "Projection j on";
	*traduc_temp++ = "Cuts";
	*traduc_temp++ = "Back to 3d";
	*traduc_temp++ = "File";
	*traduc_temp++ = "Edit";
	*traduc_temp++ = "Parameters";
	*traduc_temp++ = "Curves";
	*traduc_temp++ = "Number of curves :";
	*traduc_temp++ = "curve number min :";
	*traduc_temp++ = "curve number max :";
	*traduc_temp++ = "Type :";
	*traduc_temp++ = "No";
	*traduc_temp++ = "Line";
	*traduc_temp++ = "Steps";
	*traduc_temp++ = "+";
	*traduc_temp++ = "*";
	*traduc_temp++ = "o";
	*traduc_temp++ = "x";
	*traduc_temp++ = ".";
	*traduc_temp++ = "Label :";
	*traduc_temp++ = "Color :";
	*traduc_temp++ = "Curves";
	*traduc_temp++ = "4D Data manager";
	*traduc_temp++ = "Data number : ";
	*traduc_temp++ = "4D Data manager";
	*traduc_temp++ = "OK";
	*traduc_temp++ = "Cancel";
	*traduc_temp++ = "Help";
	*traduc_temp++ = "Axis help";
	*traduc_temp++ = "Number of variables nodes + meshes :";
	*traduc_temp++ = "0 + 0";
	*traduc_temp++ = "Wire drawing mode";
	*traduc_temp++ = "Only X";
	*traduc_temp++ = "Only Y";
	*traduc_temp++ = "Both X and Y";
	*traduc_temp++ = "Break";
	*traduc_temp++ = "Grids help";
	*traduc_temp++ = "Titles help";
	*traduc_temp++ = "Texts help";
	*traduc_temp++ = "Scales help";
	*traduc_temp++ = "E.B.";
	*traduc_temp++ = "Scene";
	*traduc_temp++ = "Drawing L3";
	*traduc_temp++ = "File manager";
	*traduc_temp++ = "Clear";
	*traduc_temp++ = "==>";
	*traduc_temp++ = "<==";
	*traduc_temp++ = "All";
	*traduc_temp++ = "File";
	*traduc_temp++ = "Data File (*.spx *.sp3 *.inp + .Z ou .gz)";
	*traduc_temp++ = "Data File (l3.* *.l3 + .Z ou .gz)";
	*traduc_temp++ = "Clear";
	*traduc_temp++ = "==>";
	*traduc_temp++ = "<==";
	*traduc_temp++ = "All";
	*traduc_temp++ = "Curve side : ";
	*traduc_temp++ = "Left";
	*traduc_temp++ = "Right";
	*traduc_temp++ = "Curves help";
	*traduc_temp++ = "Right axis";
	*traduc_temp++ = "Y right axis :";
	*traduc_temp++ = "New Y right axis title :";
	*traduc_temp++ = "right Y min :";
	*traduc_temp++ = "right Y max :";
	*traduc_temp++ = "Auto right Y";
	*traduc_temp++ = "Right axis";
	*traduc_temp++ = "Right 2d coordinates";
	*traduc_temp++ = "Rolling";
	*traduc_temp++ = "Point of view help";
	*traduc_temp++ = "Dimensions help";
	*traduc_temp++ = "Animation help";
	*traduc_temp++ = "Surface color help";
	*traduc_temp++ = "Configuration help";
	*traduc_temp++ = "Zoom out";
	*traduc_temp++ = "Zoom in";
	*traduc_temp++ = "Nul zoom";
	*traduc_temp++ = "Graphical zoom";
	*traduc_temp++ = "Z <-> C";
	*traduc_temp++ = "no";
	*traduc_temp++ = "yes";
	*traduc_temp++ = "WELCOME";
	*traduc_temp++ = "Hyperplane cut :";
	*traduc_temp++ = "no";
	*traduc_temp++ = "yes";
	*traduc_temp++ = "";
	*traduc_temp++ = "3d options help";
	*traduc_temp++ = "Isolines :";
	*traduc_temp++ = "Flat :";
	*traduc_temp++ = "Wire :";
	*traduc_temp++ = "Smooth :";
	*traduc_temp++ = "Equation of hyperplan :";
	*traduc_temp++ = "x +";
	*traduc_temp++ = "y +";
	*traduc_temp++ = "z +";
	*traduc_temp++ = "c +";
	*traduc_temp++ = "= 0";
	*traduc_temp++ = "Colormaps";
	*traduc_temp++ = "End";
	*traduc_temp++ = "Drivers";
	*traduc_temp++ = "Exit";
	*traduc_temp++ = "Mask :";
	*traduc_temp++ = "3d Coordinates";
	*traduc_temp++ = "Pixel : ";
	*traduc_temp++ = "3d pixel";
	*traduc_temp++ = "4d pixel";
	*traduc_temp++ = " ==> ";
	*traduc_temp++ = "keep";
	*traduc_temp++ = "clear";
	*traduc_temp++ = "Generator :";
	*traduc_temp++ = "hard";
	*traduc_temp++ = "soft";
	*traduc_temp++ = "end";
	*traduc_temp++ = "others";
	*traduc_temp++ = "Socket compute";
	*traduc_temp++ = "File save";
	*traduc_temp++ = "Config save";
	*traduc_temp++ = "OK dismiss";
	*traduc_temp++ = "yes";
	*traduc_temp++ = "no";
	*traduc_temp++ = "binary";
	*traduc_temp++ = "ascii";
	*traduc_temp++ = "ucd";
	*traduc_temp++ = "nothing";
	*traduc_temp++ = "State";
	*traduc_temp++ = "Server port : ";
	*traduc_temp++ = "Servers ports : ";
	*traduc_temp++ = "Save";
	*traduc_temp++ = "Multi -> Mono";
	*traduc_temp++ = "Coordinates";
	*traduc_temp++ = "1 / 4";
	*traduc_temp++ = "2 / 4";
	*traduc_temp++ = "3 / 4";
	*traduc_temp++ = "4 / 4";
	*traduc_temp++ = "Ihm compute";
	*traduc_temp++ = "Square zoom out";
	*traduc_temp++ = "Square zoom in";
	*traduc_temp++ = "Clean";
	*traduc_temp++ = "Color manager";
	*traduc_temp++ = "Call Colors";
	*traduc_temp++ = "Number of basic colors : ";
	*traduc_temp++ = "Size of palette : ";
	*traduc_temp++ = "Color manager help";
	*traduc_temp++ = "Colors number :";
	*traduc_temp++ = "Min color number :";
	*traduc_temp++ = "Max color number :";
	*traduc_temp++ = "Block number :";
	*traduc_temp++ = "Min block number :";
	*traduc_temp++ = "Max block number :";
	*traduc_temp++ = "Infos";
	*traduc_temp++ = "Pixel";
	*traduc_temp++ = "Pixmap mode";
	*traduc_temp++ = "Animation step :";
	*traduc_temp++ = "Data manager Help";
	*traduc_temp++ = "File manager Help";
	*traduc_temp++ = "3D cut";
	*traduc_temp++ = "Axis Titles";
	*traduc_temp++ = "Axis Titles Help";
	*traduc_temp++ = "Axis Titles";
}

void
S6Traduc::InitTraducAutre(int nom_logiciel)
{
	const char** traduc_temp = traduc;

	*traduc_temp++ = "Nom du fichier :";
	*traduc_temp++ = "Calcul image";
	*traduc_temp++ = "Message : ";
	*traduc_temp++ = nom_logiciel ? "Narcisse ouvert" : "Psyche ouvert";
	*traduc_temp++ = "Fichier charge ; initialisations";
	*traduc_temp++ = "Fin des initialisations";
	*traduc_temp++ = "Fichier en cours de chargement";
	*traduc_temp++ = "Trace en cours";
	*traduc_temp++ = "Trace termine";
	*traduc_temp++ = "Configuration";
	*traduc_temp++ = "Home";
	*traduc_temp++ = "Attach";
	*traduc_temp++ = "Lit";
	*traduc_temp++ = "Ecrit";
	*traduc_temp++ = "Configuration";
	*traduc_temp++ = "Azimut";
	*traduc_temp++ = "Site";
	*traduc_temp++ = "Options 3D";
	*traduc_temp++ = "Niveaux";
	*traduc_temp++ = "Facettes";
	*traduc_temp++ = "Filaire";
	*traduc_temp++ = "Lissage";
	*traduc_temp++ = "niveaux 3d";
	*traduc_temp++ = "niveaux 4d";
	*traduc_temp++ = "facettes 3d";
	*traduc_temp++ = "facettes 4d";
	*traduc_temp++ = "filaire mono";
	*traduc_temp++ = "filaire 3d";
	*traduc_temp++ = "filaire 4d";
	*traduc_temp++ = "lissage 3d";
	*traduc_temp++ = "lissage 4d";
	*traduc_temp++ = "Masque";
	*traduc_temp++ = "sans masque";
	*traduc_temp++ = "masque simple min";
	*traduc_temp++ = "masque simple max";
	*traduc_temp++ = "masque tri";
	*traduc_temp++ = "Options 2D";
	*traduc_temp++ = "Options";
	*traduc_temp++ = "Trace";
	*traduc_temp++ = "Concatenation";
	*traduc_temp++ = "courbe";
	*traduc_temp++ = "integrale";
	*traduc_temp++ = "derivee";
	*traduc_temp++ = "oui";
	*traduc_temp++ = "non";
	*traduc_temp++ = "Axes";
	*traduc_temp++ = "Titres";
	*traduc_temp++ = "Grilles";
	*traduc_temp++ = "Textes";
	*traduc_temp++ = "Titres";
	*traduc_temp++ = "Titre place en :";
	*traduc_temp++ = "Affichage :";
	*traduc_temp++ = "haut";
	*traduc_temp++ = "gauche";
	*traduc_temp++ = "droit";
	*traduc_temp++ = "bas";
	*traduc_temp++ = "non";
	*traduc_temp++ = "sans cadre";
	*traduc_temp++ = "avec cadre";
	*traduc_temp++ = "Couleur";
	*traduc_temp++ = "antifond";
	*traduc_temp++ = "bleu";
	*traduc_temp++ = "vert";
	*traduc_temp++ = "jaune";
	*traduc_temp++ = "orange";
	*traduc_temp++ = "rouge";
	*traduc_temp++ = "violet";
	*traduc_temp++ = "gris";
	*traduc_temp++ = "autres";
	*traduc_temp++ = "Titre :";
	*traduc_temp++ = "Taille";
	*traduc_temp++ = "16";
	*traduc_temp++ = "15";
	*traduc_temp++ = "14";
	*traduc_temp++ = "13";
	*traduc_temp++ = "12";
	*traduc_temp++ = "11";
	*traduc_temp++ = "10";
	*traduc_temp++ = "9";
	*traduc_temp++ = "8";
	*traduc_temp++ = "7";
	*traduc_temp++ = "6";
	*traduc_temp++ = "5";
	*traduc_temp++ = "4";
	*traduc_temp++ = "3";
	*traduc_temp++ = "2";
	*traduc_temp++ = "1";
	*traduc_temp++ = "Nombre de textes :";
	*traduc_temp++ = "Numero du texte :";
	*traduc_temp++ = "Affichage :";
	*traduc_temp++ = "non";
	*traduc_temp++ = "sans cadre";
	*traduc_temp++ = "avec cadre";
	*traduc_temp++ = "Texte :";
	*traduc_temp++ = "Position";
	*traduc_temp++ = "Angle :";
	*traduc_temp++ = "Textes";
	*traduc_temp++ = "Grilles";
	*traduc_temp++ = "Grilles :";
	*traduc_temp++ = "non";
	*traduc_temp++ = "creuse";
	*traduc_temp++ = "semi-creuse";
	*traduc_temp++ = "pleine";
	*traduc_temp++ = "Echelle couleur z :";
	*traduc_temp++ = "non";
	*traduc_temp++ = "defaut";
	*traduc_temp++ = "position";
	*traduc_temp++ = "Echelle couleur c :";
	*traduc_temp++ = "Legendes 3d-4d :";
	*traduc_temp++ = "Fond";
	*traduc_temp++ = "non";
	*traduc_temp++ = "oui";
	*traduc_temp++ = "Legendes :";
	*traduc_temp++ = "Point de vue";
	*traduc_temp++ = "Point de vue";
	*traduc_temp++ = "Distance";
	*traduc_temp++ = "Redress horizontales";
	*traduc_temp++ = "Redress verticales";
	*traduc_temp++ = "Repertoire";
	*traduc_temp++ = "Axes";
	*traduc_temp++ = "Axe des X :";
	*traduc_temp++ = "lin";
	*traduc_temp++ = "log";
	*traduc_temp++ = "Nouveau titre axe X :";
	*traduc_temp++ = "Axe des Y :";
	*traduc_temp++ = "Nouveau titre axe Y :";
	*traduc_temp++ = "Axe des Z :";
	*traduc_temp++ = "Nouveau titre axe Z :";
	*traduc_temp++ = "Axe des C :";
	*traduc_temp++ = "X min :";
	*traduc_temp++ = "X max :";
	*traduc_temp++ = "Auto X";
	*traduc_temp++ = "Y min :";
	*traduc_temp++ = "Y max :";
	*traduc_temp++ = "Auto Y";
	*traduc_temp++ = "Z min :";
	*traduc_temp++ = "Z max :";
	*traduc_temp++ = "Auto Z";
	*traduc_temp++ = "C min :";
	*traduc_temp++ = "C max :";
	*traduc_temp++ = "Auto C";
	*traduc_temp++ = "Couleur titres axes :";
	*traduc_temp++ = "Taille titres axes :";
	*traduc_temp++ = "Taille labels axes :";
	*traduc_temp++ = "Echelles";
	*traduc_temp++ = "Echelle 3d :";
	*traduc_temp++ = "Echelle 4d :";
	*traduc_temp++ = "Zh min :";
	*traduc_temp++ = "Zh max :";
	*traduc_temp++ = "Auto Zh";
	*traduc_temp++ = "Ch min :";
	*traduc_temp++ = "Ch max :";
	*traduc_temp++ = "Auto Ch";
	*traduc_temp++ = "Echelles";
	*traduc_temp++ = "Nombre niveaux Z :";
	*traduc_temp++ = "Nombre niveaux C :";
	*traduc_temp++ = "Animation";
	*traduc_temp++ = "Anim pas azimut :";
	*traduc_temp++ = "Anim pas site :";
	*traduc_temp++ = "Nombre animation :";
	*traduc_temp++ = "Animation";
	*traduc_temp++ = "Dimensions";
	*traduc_temp++ = "Position boite";
	*traduc_temp++ = "X1 (cm) :";
	*traduc_temp++ = "X2 (cm) :";
	*traduc_temp++ = "Boite defaut";
	*traduc_temp++ = "Y1 (cm) :";
	*traduc_temp++ = "Y2 (cm) :";
	*traduc_temp++ = "Defaut DX,DY";
	*traduc_temp++ = "DX (cm) :";
	*traduc_temp++ = "DY (cm) :";
	*traduc_temp++ = "Dimensions";
	*traduc_temp++ = "Zoom";
	*traduc_temp++ = "Nul zoom";
	*traduc_temp++ = "Zoom 2d";
	*traduc_temp++ = "Coordonnees 2d";
	*traduc_temp++ = "Coordonnees";
	*traduc_temp++ = "Couleurs surface";
	*traduc_temp++ = "Couleur dessus surface";
	*traduc_temp++ = "Couleur dessous surface";
	*traduc_temp++ = "Couleurs surface";
	*traduc_temp++ = "Couleur grille :";
	*traduc_temp++ = "vue 2d";
	*traduc_temp++ = "vue 3d";
	*traduc_temp++ = "Coupe en i :";
	*traduc_temp++ = "Coupe en j :";
	*traduc_temp++ = "Moyenne de imin :";
	*traduc_temp++ = "         a imax :";
	*traduc_temp++ = "Moyenne de jmin :";
	*traduc_temp++ = "         a jmax :";
	*traduc_temp++ = "Projection de imin :";
	*traduc_temp++ = "            a imax :";
	*traduc_temp++ = "        par pas de :";
	*traduc_temp++ = "Projection de jmin :";
	*traduc_temp++ = "            a jmax :";
	*traduc_temp++ = "        par pas de :";
	*traduc_temp++ = "Coupes logiques";
	*traduc_temp++ = "Coupe en i active";
	*traduc_temp++ = "Coupe en j active";
	*traduc_temp++ = "Moyenne en i active";
	*traduc_temp++ = "Moyenne en j active";
	*traduc_temp++ = "Projection en i active";
	*traduc_temp++ = "Projection en j active";
	*traduc_temp++ = "Coupes";
	*traduc_temp++ = "Retour 3d";
	*traduc_temp++ = "Fichier";
	*traduc_temp++ = "Edition";
	*traduc_temp++ = "Parametres";
	*traduc_temp++ = "Courbes";
	*traduc_temp++ = "Nombre de courbes :";
	*traduc_temp++ = "Numero de courbe min :";
	*traduc_temp++ = "Numero de courbe max :";
	*traduc_temp++ = "Type :";
	*traduc_temp++ = "Non";
	*traduc_temp++ = "Simple";
	*traduc_temp++ = "Marche";
	*traduc_temp++ = "+";
	*traduc_temp++ = "*";
	*traduc_temp++ = "o";
	*traduc_temp++ = "x";
	*traduc_temp++ = ".";
	*traduc_temp++ = "Label :";
	*traduc_temp++ = "Couleur :";
	*traduc_temp++ = "Courbes";
	*traduc_temp++ = "Gestion de donnees 4D";
	*traduc_temp++ = "Numero donnees : ";
	*traduc_temp++ = "Gestion donnees 4D";
	*traduc_temp++ = "OK";
	*traduc_temp++ = "Annuler";
	*traduc_temp++ = "Aide";
	*traduc_temp++ = "Aide Axes";
	*traduc_temp++ = "Nombre variables noeuds + mailles : ";
	*traduc_temp++ = "0 + 0";
	*traduc_temp++ = "Type trace fil";
	*traduc_temp++ = "Trace en X";
	*traduc_temp++ = "Trace en Y";
	*traduc_temp++ = "Trace en XY";
	*traduc_temp++ = "Break";
	*traduc_temp++ = "Aide Grilles";
	*traduc_temp++ = "Aide Titres";
	*traduc_temp++ = "Aide Textes";
	*traduc_temp++ = "Aide Echelles";
	*traduc_temp++ = "B.E.";
	*traduc_temp++ = "Scene";
	*traduc_temp++ = "Trace image L3";
	*traduc_temp++ = "Gestion fichiers";
	*traduc_temp++ = "Purge";
	*traduc_temp++ = "==>";
	*traduc_temp++ = "<==";
	*traduc_temp++ = "Tous";
	*traduc_temp++ = "Gestion fichiers";
	*traduc_temp++ = "Fichiers de points "
	     "(*.spx *.sp3 *.inp + .Z ou .gz)";
	*traduc_temp++ = "Fichiers de points (l3.* *.l3 + .Z ou .gz)";
	*traduc_temp++ = "Purge";
	*traduc_temp++ = "==>";
	*traduc_temp++ = "<==";
	*traduc_temp++ = "Tous";
	*traduc_temp++ = "Courbe cote : ";
	*traduc_temp++ = "Gauche";
	*traduc_temp++ = "Droit";
	*traduc_temp++ = "Aide Courbes";
	*traduc_temp++ = "Axe droit";
	*traduc_temp++ = "Axe des Y droit :";
	*traduc_temp++ = "Nouveau titre axe Y droit :";
	*traduc_temp++ = "Y min droit :";
	*traduc_temp++ = "Y max droit :";
	*traduc_temp++ = "Auto Y droit";
	*traduc_temp++ = "Axe droit";
	*traduc_temp++ = "Coordonnees 2d droite";
	*traduc_temp++ = "Roulis";
	*traduc_temp++ = "Aide Point de vue";
	*traduc_temp++ = "Aide Dimensions";
	*traduc_temp++ = "Aide Animation";
	*traduc_temp++ = "Aide Couleur surface";
	*traduc_temp++ = "Aide Configuration";
	*traduc_temp++ = "Agrandissement";
	*traduc_temp++ = "Reduction";
	*traduc_temp++ = "Nul zoom";
	*traduc_temp++ = "Zoom graphique";
	*traduc_temp++ = "Z <-> C";
	*traduc_temp++ = "non";
	*traduc_temp++ = "oui";
	*traduc_temp++ = "BIENVENUE";
	*traduc_temp++ = "Coupe par un hyperplan :";
	*traduc_temp++ = "non";
	*traduc_temp++ = "oui";
	*traduc_temp++ = "";
	*traduc_temp++ = "Aide Options 3d";
	*traduc_temp++ = "Niveaux :";
	*traduc_temp++ = "Facettes :";
	*traduc_temp++ = "Filaire :";
	*traduc_temp++ = "Lissage :";
	*traduc_temp++ = "Equation hyperplan :";
	*traduc_temp++ = "x +";
	*traduc_temp++ = "y +";
	*traduc_temp++ = "z +";
	*traduc_temp++ = "c +";
	*traduc_temp++ = "= 0";
	*traduc_temp++ = "Cartes de couleurs";
	*traduc_temp++ = "Fin";
	*traduc_temp++ = "Drivers";
	*traduc_temp++ = "Sortie";
	*traduc_temp++ = "Masque :";
	*traduc_temp++ = "Coordonnees 3d";
	*traduc_temp++ = "Pixel : ";
	*traduc_temp++ = "Pixel 3d";
	*traduc_temp++ = "Pixel 4d";
	*traduc_temp++ = " ==> ";
	*traduc_temp++ = "garde";
	*traduc_temp++ = "efface";
	*traduc_temp++ = "Generateur :";
	*traduc_temp++ = "hard";
	*traduc_temp++ = "soft";
	*traduc_temp++ = "fin";
	*traduc_temp++ = "autres";
	*traduc_temp++ = "Calcul socket";
	*traduc_temp++ = "Fichier sauvegarde";
	*traduc_temp++ = "Config sauvegarde";
	*traduc_temp++ = "OK cache";
	*traduc_temp++ = "oui";
	*traduc_temp++ = "non";
	*traduc_temp++ = "binaire";
	*traduc_temp++ = "ascii";
	*traduc_temp++ = "ucd";
	*traduc_temp++ = "rien";
	*traduc_temp++ = "Etat";
	*traduc_temp++ = "Port serveur : ";
	*traduc_temp++ = "Ports serveurs : ";
	*traduc_temp++ = "Sauve";
	*traduc_temp++ = "Multi -> Mono";
	*traduc_temp++ = "Coordonnees";
	*traduc_temp++ = "1 / 4";
	*traduc_temp++ = "2 / 4";
	*traduc_temp++ = "3 / 4";
	*traduc_temp++ = "4 / 4";
	*traduc_temp++ = "Calcul ihm";
	*traduc_temp++ = "Agrand. carre";
	*traduc_temp++ = "Reduc. carre";
	*traduc_temp++ = "Efface";
	*traduc_temp++ = "Gestion des couleurs";
	*traduc_temp++ = "Appel de Colors";
	*traduc_temp++ = "Nombre couleurs de base : ";
	*traduc_temp++ = "Taille palette : ";
	*traduc_temp++ = "Aide Gestion des couleurs";
	*traduc_temp++ = "Nombre de couleurs :";
	*traduc_temp++ = "Numero de couleur min :";
	*traduc_temp++ = "Numero de couleur max :";
	*traduc_temp++ = "Nombre de blocs :";
	*traduc_temp++ = "No de bloc min :";
	*traduc_temp++ = "No de bloc max :";
	*traduc_temp++ = "Infos";
	*traduc_temp++ = "Pixel";
	*traduc_temp++ = "Mode pixmap";
	*traduc_temp++ = "Pas pour animation :";
	*traduc_temp++ = "Aide Gestion donnees";
	*traduc_temp++ = "Aide Gestion fichiers";
	*traduc_temp++ = "Coupes 3D";
	*traduc_temp++ = "Titres Axes";
	*traduc_temp++ = "Aide Titres Axes";
	*traduc_temp++ = "Titres Axes";
}

void
S6Traduc::InitCouleur(const char* const lang)
{
	delete[] couleur;

	couleur = new const char*[taille_couleur];

	if(strcasecmp(lang,"anglais"))
	{
    // *****************************************************
    //     tableau pour les couleurs
    // *****************************************************

	    const char** couleur_temp = couleur;

	    *couleur_temp++ = "fond";
	    *couleur_temp++ = "antifond";
	    *couleur_temp++ = "bleu";
	    *couleur_temp++ = "vert";
	    *couleur_temp++ = "jaune";
	    *couleur_temp++ = "orange";
	    *couleur_temp++ = "rouge";
	    *couleur_temp++ = "violet";
	    *couleur_temp++ = "noir";
	    *couleur_temp++ = "blanc";
	    *couleur_temp++ = "10";
	    *couleur_temp++ = "11";
	    *couleur_temp++ = "12";
	    *couleur_temp++ = "13";
	    *couleur_temp++ = "14";
	    *couleur_temp++ = "15";
	    *couleur_temp++ = "16";
	    *couleur_temp++ = "17";
	    *couleur_temp++ = "18";
	    *couleur_temp++ = "19";
	    *couleur_temp++ = "20";
	    *couleur_temp++ = "21";
	    *couleur_temp++ = "22";
	    *couleur_temp++ = "23";
	    *couleur_temp++ = "24";
	    *couleur_temp++ = "25";
	    *couleur_temp++ = "26";
	    *couleur_temp++ = "27";
	    *couleur_temp++ = "28";
	    *couleur_temp++ = "29";
	    *couleur_temp++ = "30";
	    *couleur_temp++ = "31";
	    *couleur_temp++ = "32";
	    *couleur_temp++ = "33";
	    *couleur_temp++ = "34";
	    *couleur_temp++ = "35";
	    *couleur_temp++ = "36";
	    *couleur_temp++ = "37";
	    *couleur_temp++ = "38";
	    *couleur_temp++ = "39";
	    *couleur_temp++ = "40";
	    *couleur_temp++ = "41";
	    *couleur_temp++ = "42";
	    *couleur_temp++ = "43";
	    *couleur_temp++ = "44";
	    *couleur_temp++ = "45";
	    *couleur_temp++ = "46";
	    *couleur_temp++ = "47";
	    *couleur_temp++ = "48";
	    *couleur_temp++ = "49";
	    *couleur_temp++ = "50";
	    *couleur_temp++ = "51";
	    *couleur_temp++ = "52";
	    *couleur_temp++ = "53";
	    *couleur_temp++ = "54";
	    *couleur_temp++ = "55";
	    *couleur_temp++ = "56";
	    *couleur_temp++ = "57";
	    *couleur_temp++ = "58";
	    *couleur_temp++ = "59";
	    *couleur_temp++ = "60";
	    *couleur_temp++ = "61";
	    *couleur_temp++ = "62";
	    *couleur_temp++ = "63";
	}
	else
	{
    // *****************************************************
    //     tableau pour les couleurs
    // *****************************************************

	    const char** couleur_temp = couleur;

	    *couleur_temp++ = "background";
	    *couleur_temp++ = "foreground";
	    *couleur_temp++ = "blue";
	    *couleur_temp++ = "green";
	    *couleur_temp++ = "yellow";
	    *couleur_temp++ = "orange";
	    *couleur_temp++ = "red";
	    *couleur_temp++ = "purple";
	    *couleur_temp++ = "black";
	    *couleur_temp++ = "white";
	    *couleur_temp++ = "10";
	    *couleur_temp++ = "11";
	    *couleur_temp++ = "12";
	    *couleur_temp++ = "13";
	    *couleur_temp++ = "14";
	    *couleur_temp++ = "15";
	    *couleur_temp++ = "16";
	    *couleur_temp++ = "17";
	    *couleur_temp++ = "18";
	    *couleur_temp++ = "19";
	    *couleur_temp++ = "20";
	    *couleur_temp++ = "21";
	    *couleur_temp++ = "22";
	    *couleur_temp++ = "23";
	    *couleur_temp++ = "24";
	    *couleur_temp++ = "25";
	    *couleur_temp++ = "26";
	    *couleur_temp++ = "27";
	    *couleur_temp++ = "28";
	    *couleur_temp++ = "29";
	    *couleur_temp++ = "30";
	    *couleur_temp++ = "31";
	    *couleur_temp++ = "32";
	    *couleur_temp++ = "33";
	    *couleur_temp++ = "34";
	    *couleur_temp++ = "35";
	    *couleur_temp++ = "36";
	    *couleur_temp++ = "37";
	    *couleur_temp++ = "38";
	    *couleur_temp++ = "39";
	    *couleur_temp++ = "40";
	    *couleur_temp++ = "41";
	    *couleur_temp++ = "42";
	    *couleur_temp++ = "43";
	    *couleur_temp++ = "44";
	    *couleur_temp++ = "45";
	    *couleur_temp++ = "46";
	    *couleur_temp++ = "47";
	    *couleur_temp++ = "48";
	    *couleur_temp++ = "49";
	    *couleur_temp++ = "50";
	    *couleur_temp++ = "51";
	    *couleur_temp++ = "52";
	    *couleur_temp++ = "53";
	    *couleur_temp++ = "54";
	    *couleur_temp++ = "55";
	    *couleur_temp++ = "56";
	    *couleur_temp++ = "57";
	    *couleur_temp++ = "58";
	    *couleur_temp++ = "59";
	    *couleur_temp++ = "60";
	    *couleur_temp++ = "61";
	    *couleur_temp++ = "62";
	    *couleur_temp++ = "63";
	}

}

void
S6Traduc::InitMap(const char* const lang)
{
	delete[] map;

	map = new const char*[taille_map];

	if(strcasecmp(lang,"anglais"))
	{
    // *****************************************************
    //     tableau pour les maps de couleurs
    // *****************************************************

	    const char** map_temp = map;

	    *map_temp++ = "Autres";
	    *map_temp++ = "Absolute";
	    *map_temp++ = "Binary";
	    *map_temp++ = "Blue-green";
	    *map_temp++ = "Default";
	    *map_temp++ = "Negative";
	    *map_temp++ = "Positive";
	    *map_temp++ = "Rainbow";
	    *map_temp++ = "RainbowHLS";
	    *map_temp++ = "Random";
	    *map_temp++ = "Red-blue";
	    *map_temp++ = "Red-green";
	    *map_temp++ = "Shifted";
	    *map_temp++ = "StandardL3";
	    *map_temp++ = "Dlpp1";
	    *map_temp++ = "Xcode";
	    *map_temp++ = "InvDefault";
	}
	else
	{
	    const char** map_temp = map;

	    *map_temp++ = "Others";
	    *map_temp++ = "Absolute";
	    *map_temp++ = "Binary";
	    *map_temp++ = "Blue-green";
	    *map_temp++ = "Default";
	    *map_temp++ = "Negative";
	    *map_temp++ = "Positive";
	    *map_temp++ = "Rainbow";
	    *map_temp++ = "RainbowHLS";
	    *map_temp++ = "Random";
	    *map_temp++ = "Red-blue";
	    *map_temp++ = "Red-green";
	    *map_temp++ = "Shifted";
	    *map_temp++ = "StandardL3";
	    *map_temp++ = "Dlpp1";
	    *map_temp++ = "Xcode";
	    *map_temp++ = "InvDefault";
	}

}

void
S6Traduc::InitDest(const char* const lang)
{
	delete[] dest;

	dest = new const char*[taille_dest];

	if(strcasecmp(lang,"anglais"))
	{
    // *****************************************************
    //     tableau pour les destinations drivers
    // *****************************************************

	    const char** dest_temp = dest;

	    *dest_temp++ = "negs";
	    *dest_temp++ = "t4014";
	    *dest_temp++ = "visu";
	    *dest_temp++ = "post";
	    *dest_temp++ = "postcoul";
	    *dest_temp++ = "postcoulfich";
	    *dest_temp++ = "postscript";
	    *dest_temp++ = "lwc";
	    *dest_temp++ = "lwct";
	    *dest_temp++ = "x11";
	    *dest_temp++ = "phigs";
	    *dest_temp++ = "phigsx11";
	    *dest_temp++ = "phigscgm";
	    *dest_temp++ = "gl";
	    *dest_temp++ = "xgl";
	    *dest_temp++ = "phigsps";
	    *dest_temp++ = "phigspsc";
	    *dest_temp++ = "phigsrle";
	    *dest_temp++ = "gif";
	    *dest_temp++ = "pgml";
	    *dest_temp++ = "xfig";
	    *dest_temp++ = "svg";
	    *dest_temp++ = "png";
	}
	else
	{
    // *****************************************************
    //     tableau pour les destinations drivers
    // *****************************************************

	    const char** dest_temp = dest;

	    *dest_temp++ = "negs";
	    *dest_temp++ = "t4014";
	    *dest_temp++ = "visu";
	    *dest_temp++ = "post";
	    *dest_temp++ = "postcolor";
	    *dest_temp++ = "postcolorfich";
	    *dest_temp++ = "postscript";
	    *dest_temp++ = "lwc";
	    *dest_temp++ = "lwct";
	    *dest_temp++ = "x11";
	    *dest_temp++ = "phigs";
	    *dest_temp++ = "phigsx11";
	    *dest_temp++ = "phigscgm";
	    *dest_temp++ = "gl";
	    *dest_temp++ = "xgl";
	    *dest_temp++ = "phigsps";
	    *dest_temp++ = "phigspsc";
	    *dest_temp++ = "phigsrle";
	    *dest_temp++ = "gif";
	    *dest_temp++ = "pgml";
	    *dest_temp++ = "xfig";
	    *dest_temp++ = "svg";
	    *dest_temp++ = "png";
	}

}

void
S6Traduc::InitAffx(const char* const lang)
{
	delete[] affx;

	affx = new const char*[taille_affx];

	if(strcasecmp(lang,"anglais"))
	{
    // *****************************************************
    //     tableaux pour l'afficheur X11
    // *****************************************************

	    const char** affx_temp = affx;

	    *affx_temp++ = "Affichage";
	    *affx_temp++ = "Parametres d'impression";
	    *affx_temp++ = "Impression";
	    *affx_temp++ = "Retrace";
	    *affx_temp++ = "Sauve";
	    *affx_temp++ = "Taille";
	    *affx_temp++ = "Break";
	    *affx_temp++ = "Impression";
	    *affx_temp++ = "Nom du fichier ou de l'imprimante :";
	    *affx_temp++ = "Imprimante";
	    *affx_temp++ = "Fichier";
	    *affx_temp++ = "Fichier debut";
	    *affx_temp++ = "Couleur";
	    *affx_temp++ = "ToutNoir";
	    *affx_temp++ = "Noir&Blanc";
	    *affx_temp++ = "Identification";
	    *affx_temp++ = "Logo";
	    *affx_temp++ = "Chronometre";
	    *affx_temp++ = "EPS";
	    *affx_temp++ = "Video inverse";
	    *affx_temp++ = "Dimensions exactes";
	    *affx_temp++ = "Textes en noir";
	    *affx_temp++ = "Portrait";
	    *affx_temp++ = "Paysage";
	    *affx_temp++ = "Titre de l'image";
	    *affx_temp++ = "  OK  ";
	    *affx_temp++ = "Annuler";
	    *affx_temp++ = "Aide";
	    *affx_temp++ = "Taille";
	    *affx_temp++ = "Largeur (pixel) : ";
	    *affx_temp++ = "Hauteur (pixel) : ";
	    *affx_temp++ = "Clip largeur : ";
	    *affx_temp++ = "Clip hauteur : ";
	    *affx_temp++ = "Aide Dessin";
	    *affx_temp++ = "Actions";
	}
	else
	{
    // *****************************************************
    //     tableaux pour l'afficheur X11
    // *****************************************************

	    const char** affx_temp = affx;

	    *affx_temp++ = "Display";
	    *affx_temp++ = "Parameters for printing";
	    *affx_temp++ = "Print";
	    *affx_temp++ = "Redraw";
	    *affx_temp++ = "Save";
	    *affx_temp++ = "Size";
	    *affx_temp++ = "Break";
	    *affx_temp++ = "Print";
	    *affx_temp++ = "Name of file or printer :";
	    *affx_temp++ = "Printer";
	    *affx_temp++ = "File";
	    *affx_temp++ = "Beginning of file";
	    *affx_temp++ = "Color";
	    *affx_temp++ = "AllBlack";
	    *affx_temp++ = "Black&White";
	    *affx_temp++ = "Identification";
	    *affx_temp++ = "Logo";
	    *affx_temp++ = "Timer";
	    *affx_temp++ = "EPS";
	    *affx_temp++ = "Reverse video";
	    *affx_temp++ = "Exact Dimensions";
	    *affx_temp++ = "Black Texts";
	    *affx_temp++ = "Portrait";
	    *affx_temp++ = "Landscape";
	    *affx_temp++ = "Title of picture";
	    *affx_temp++ = "  OK  ";
	    *affx_temp++ = "Cancel";
	    *affx_temp++ = "Help";
	    *affx_temp++ = "Size";
	    *affx_temp++ = "Width (pixel) : ";
	    *affx_temp++ = "Height (pixel) : ";
	    *affx_temp++ = "Width clip : ";
	    *affx_temp++ = "Height clip : ";
	    *affx_temp++ = "Display Help";
	    *affx_temp++ = "Make";
	}

}

void
S6Traduc::InitRepert(const char* const lang)
{
	delete[] repert;

	repert = new const char*[taille_repert];

	if(!strcasecmp(lang,"francais"))
	{
	// ********************************************************
	//   tableau pour le repertoire
	// ********************************************************

	    const char** repert_temp = repert;

	    *repert_temp++ = "Repertoire";
	    *repert_temp++ = "OK";
	    *repert_temp++ = "Annuler";
	    *repert_temp++ = "Aide";
	    *repert_temp++ = "Dernier fichier s\351lectionn\351 :";
	    *repert_temp++ = "Filtre :";
	    *repert_temp++ = "R\351pertoire :";
	}
	else if(!strcasecmp(lang,"anglais"))
	{
	// ********************************************************
	//   tableau pour le repertoire
	// ********************************************************

	    const char** repert_temp = repert;

	    *repert_temp++ = "Folder";
	    *repert_temp++ = "OK";
	    *repert_temp++ = "Cancel";
	    *repert_temp++ = "Help";
	    *repert_temp++ = "Last select file :";
	    *repert_temp++ = "Filter :";
	    *repert_temp++ = "Directory :";
	}
	else
	{
	// ********************************************************
	//   tableau pour le repertoire
	// ********************************************************

	    const char** repert_temp = repert;

	    *repert_temp++ = "Repertoire";
	    *repert_temp++ = "OK";
	    *repert_temp++ = "Annuler";
	    *repert_temp++ = "Aide";
	    *repert_temp++ = "Dernier fichier selectionne :";
	    *repert_temp++ = "Filtre :";
	    *repert_temp++ = "Repertoire :";
	}

}
