//
//	panel Help (en motif)
//

struct SccsIdHelp
{
	static const char* const sccs_id;
};

const char* const SccsIdHelp::sccs_id = "%W% %G% Pierre Brochard";

// includes

#include "poulpe/Help.h"
#include "U8constant.h"
#include "poulpe/U8affx.h"

#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/PushB.h>
#include <Xm/ScrolledW.h>
#include <Xm/Separator.h>
#include <Xm/Form.h>
#include <Xm/MessageB.h>
#include <Xm/DialogS.h>

// Classe pop up help

Help::Help(const Widget& parent, const char* titre,const char* classe)
{
	int             n = 0;
	Arg             warg[10];

	XtSetArg(warg[n], XmNwidth, 100); n++;
	XtSetArg(warg[n], XmNheight, 100); n++;
	XtSetArg(warg[n], XmNvisual, _visual); n++;
	XtSetArg(warg[n], XmNsaveUnder, False); n++;
	XtSetArg(warg[n], XmNkeyboardFocusPolicy,_KFPVal);n++;

	_shell = XmCreateDialogShell(parent,"DialogShell",warg,n);

	XmString xmlabel = XmStringCreate((char*) titre,
		XmSTRING_DEFAULT_CHARSET);

        _labelInterne = xmlabel;
	n = 0;XtSetArg(warg[n], XmNdialogTitle, xmlabel); n++;

	_widgetid = XmCreateMessageBox(_shell,(char*) classe,warg,n);
	RegisterCol(_widgetid);

	U8AfficheurX* const uax = U8AfficheurX::Driver();

	if(uax)
	{
	    uax->l3_tabwid_init(_widgetcol);
	}

	Widget temp = XmMessageBoxGetChild(_widgetid,XmDIALOG_CANCEL_BUTTON);
	XtUnmanageChild(temp);
	temp = XmMessageBoxGetChild(_widgetid,XmDIALOG_HELP_BUTTON);
	XtUnmanageChild(temp);

	XtRealizeWidget(_widgetid);
}

Help::~Help()
{
	UnRegisterCol(_widgetid);

	if (_labelInterne)
	{
	    XmStringFree((XmString) _labelInterne);
	}

	//if(_shell) XtDestroyWidget(_shell);

}

void
Help::Cache()
{
	XtUnmanageChild(_widgetid);
}

void
Help::Montre()
{
	XtManageChild(_widgetid);
}

// Classe pop up help avec ScrollBar

ScrHelp::ScrHelp(const Widget& parent, const char* titre,const char* classe)
{
	_widgetid = XtVaCreatePopupShell( "HELP",
			transientShellWidgetClass,
			parent,
			XmNx, 390,
			XmNy, 160,
			XmNwidth, 500,
			XmNheight, 300,
			XmNtitle, titre,
			XtNvisual,_visual,
			XmNsaveUnder, False,
			XmNmappedWhenManaged, False,
			XmNkeyboardFocusPolicy,_KFPVal,
			NULL );
	RegisterCol(_widgetid);

	U8AfficheurX* const uax = U8AfficheurX::Driver();

	if(uax)
	{
	    uax->l3_tabwid_init(_widgetcol);
	}

	XtRealizeWidget(_widgetid);
	XtVaSetValues(_widgetid,XmNwidth,500,XmNheight,300,NULL );

	_form = XtVaCreateManagedWidget( "form",
			xmFormWidgetClass,
			_widgetid,
			XmNresizePolicy, XmRESIZE_NONE,
			XmNunitType, XmPIXELS,
			XmNx, 190,
			XmNy, 175,
			XmNwidth, 500,
			XmNheight, 300,
			NULL );

	_scrWin = XtVaCreateManagedWidget( "scrWin",
			xmScrolledWindowWidgetClass,
			_form,
			XmNscrollingPolicy, XmAUTOMATIC,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset, 70,
			XmNleftAttachment, XmATTACH_FORM,
			XmNleftOffset, 10,
			XmNrightAttachment, XmATTACH_FORM,
			XmNrightOffset, 10,
			XmNtopAttachment, XmATTACH_FORM,
			XmNtopOffset, 10,
			XmNinitialResourcesPersistent,_IRPVal,
			NULL );

	_label = XtVaCreateManagedWidget( classe,
			xmLabelWidgetClass,
			_scrWin,
			XmNalignment, XmALIGNMENT_BEGINNING,
			NULL );

	_sep = XtVaCreateManagedWidget( "sep",
			xmSeparatorWidgetClass,
			_form,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset, 60,
			XmNleftAttachment, XmATTACH_FORM,
			XmNleftOffset, 10,
			XmNrightAttachment, XmATTACH_FORM,
			XmNrightOffset, 10,
			NULL );

	XmString xmlabel = XmStringCreate("OK",XmSTRING_DEFAULT_CHARSET);

        _labelInterne = xmlabel;
	_ok = XtVaCreateManagedWidget( "ok",
			xmPushButtonWidgetClass,
			_form,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset, 10,
			XmNlabelString,xmlabel,
			XmNleftOffset, -40,
			XmNleftPosition, 50,
			XmNleftAttachment, XmATTACH_POSITION,
			XmNheight, 40,
			XmNwidth, 80,
			NULL );
	XtAddCallback(_ok, XmNactivateCallback,
			(XtCallbackProc) ElementVisuel::LeBoutonSelCB,
			(XtPointer) this);
}

ScrHelp::~ScrHelp()
{
	UnRegisterCol(_widgetid);

	if (_labelInterne)
	{
	    XmStringFree((XmString) _labelInterne);
	}

	//if(_ok) XtDestroyWidget(_ok);

	//if(_sep) XtDestroyWidget(_sep);

	//if(_label) XtDestroyWidget(_label);

	//if(_scrWin) XtDestroyWidget(_scrWin);

	//if(_form) XtDestroyWidget(_form);

}

void
ScrHelp::SelectCB(XtPointer)
{
	Cache();
}

void
ScrHelp::Cache()
{
	XtPopdown(_widgetid);
}

void
ScrHelp::Montre()
{
	XtPopup(_widgetid, XtGrabNone);
}

/* Fin de Fichier */
