#include "poulpe/S6de.h"
#include "P4constant.h"

struct SccsIdS6DE
{
	static const char* const sccs_id;
};

const char* const SccsIdS6DE::sccs_id = "%W% %G% Pierre Brochard";

// codage du bandeau et du copyright

char*
S6DET(int choix)
{
	unsigned taille = 0;
	char* vvvv = NULL;

	if(choix)
	{
	    taille = 16;
            vvvv = new char[taille];

            vvvv[0] = 0x3c;
            vvvv[1] = 0x4f;
            vvvv[2] = 0x36;
            vvvv[3] = 0x55;
            vvvv[4] = 0x3d;
            vvvv[5] = 0x58;
            vvvv[6] = 0x78;
            vvvv[7] = 0x2e;
            vvvv[8] = 0x1f;
            vvvv[9] = 0x3f;
            vvvv[10] = 0xc;
            vvvv[11] = 0x22;
            vvvv[12] = 0x16;
            vvvv[13] = 0x38;
            vvvv[14] = 0x8;
            vvvv[15] = 0x0;
        }
        else
        {
            taille = 18;
            vvvv = new char[taille];

            vvvv[0] = 0x22;
            vvvv[1] = 0x43;
            vvvv[2] = 0x31;
            vvvv[3] = 0x52;
            vvvv[4] = 0x3b;
            vvvv[5] = 0x48;
            vvvv[6] = 0x3b;
            vvvv[7] = 0x5e;
            vvvv[8] = 0x7e;
            vvvv[9] = 0x28;
            vvvv[10] = 0x19;
            vvvv[11] = 0x39;
            vvvv[12] = 0xa;
            vvvv[13] = 0x24;
            vvvv[14] = 0x10;
            vvvv[15] = 0x3e;
            vvvv[16] = 0xe;
            vvvv[17] = 0x0;
	}

	char mask[2];

	mask[0] = 0x6c;
	mask[1] = '\0';

	char* buff = new char[taille];

	buff[taille-1] = '\0';

	for(unsigned i=0;i<taille-1;i++)
	{
	    mask[0] = mask[0] ^ vvvv[i];
	    buff[i] = mask[0];
	    mask[0] = vvvv[i];
	}

	delete[] vvvv;

	return buff;
}

char*
S6DEC(const char* const lang)
{
	unsigned taille = 0;
	char* vvvv = NULL;

	if(!strcasecmp(lang,"francais"))
	{
	    taille = 24;
            vvvv = new char[taille];

            vvvv[0] = 0x96;
            vvvv[1] = 0xb6;
            vvvv[2] = 0xf5;
            vvvv[3] = 0xb0;
            vvvv[4] = 0xf1;
            vvvv[5] = 0xde;
            vvvv[6] = 0x9a;
            vvvv[7] = 0xdb;
            vvvv[8] = 0x96;
            vvvv[9] = 0xbb;
            vvvv[10] = 0xf2;
            vvvv[11] = 0x9e;
            vvvv[12] = 0xfb;
            vvvv[13] = 0xdb;
            vvvv[14] = 0xbf;
            vvvv[15] = 0xda;
            vvvv[16] = 0xfa;
            vvvv[17] = 0xbc;
            vvvv[18] = 0xce;
            vvvv[19] = 0xaf;
            vvvv[20] = 0xc1;
            vvvv[21] = 0xa2;
            vvvv[22] = 0xc7;
            vvvv[23] = 0x0;
        }
        else
        {
            taille = 32;
            vvvv = new char[taille];

            vvvv[0] = 0x5c;
            vvvv[1] = 0x33;
            vvvv[2] = 0x43;
            vvvv[3] = 0x3a;
            vvvv[4] = 0x48;
            vvvv[5] = 0x21;
            vvvv[6] = 0x46;
            vvvv[7] = 0x2e;
            vvvv[8] = 0x5a;
            vvvv[9] = 0x7a;
            vvvv[10] = 0x39;
            vvvv[11] = 0x7c;
            vvvv[12] = 0x3d;
            vvvv[13] = 0x12;
            vvvv[14] = 0x56;
            vvvv[15] = 0x17;
            vvvv[16] = 0x5a;
            vvvv[17] = 0x77;
            vvvv[18] = 0x3e;
            vvvv[19] = 0x52;
            vvvv[20] = 0x37;
            vvvv[21] = 0x17;
            vvvv[22] = 0x73;
            vvvv[23] = 0x16;
            vvvv[24] = 0x36;
            vvvv[25] = 0x70;
            vvvv[26] = 0x2;
            vvvv[27] = 0x63;
            vvvv[28] = 0xd;
            vvvv[29] = 0x6e;
            vvvv[30] = 0xb;
            vvvv[31] = 0x0;
	}

	char mask[2];

	mask[0] = 0x3f;
	mask[1] = '\0';

	char* buff = new char[taille];

	buff[taille-1] = '\0';

	for(unsigned i=0;i<taille-1;i++)
	{
	    mask[0] = mask[0] ^ vvvv[i];
	    buff[i] = mask[0];
	    mask[0] = vvvv[i];
	}

	delete[] vvvv;

	return buff;
}

/* fin de fichier */
