/***************/
/* L3Couleur.c */
/***************/

#include <stdio.h>

#include "L3Environnement.h"
#include "L3Couleur.h"
#include "L3AppelDrivers.h"

#ifndef lint
    static const char sccs_id[] = "%W% %G% DMA/AIM/LM";
#endif

/**************************************************************************
 * Procedure utilisateur : L3Couleur                    		  *
 *------------------------------------------------------------------------*
 * Parametres :								  *
 *   couleur : numero de la couleur (entre 0 et 255)                      *
 *				   		                          *
 * Valeur de retour : aucune				                  *
 *								          *
 * Description : voir document CEL.V DMA/SIE/IG NT 58.9 de juillet 1987   *
 *    "GRAF CIGALE"							  *
 *                                                                        *
 * Erreurs :                                                              *
 *   numero de couleur interdite                                          *
 **************************************************************************/

void L3Couleur(int couleur)
{
    /*---------------------------------------------*/
    /* couleurs dans la nouvelle convention        */
    /*---------------------------------------------*/

	static int codel3[] = {3,CODEL3COULEUR,0};

	if (couleur < 0 || couleur >= 255)
        {
   
	/*---------------------------------------------*/
	/* Erreur : selection d'une couleur interdite. */
	/*---------------------------------------------*/

	    (void) fprintf(stderr,
		"L3Couleur : numero de couleur interdite :%d\n", couleur);
	    return;
	}

	if ( couleur  == COULEURCOURANTE )
	{
	    return ;
	}

	COULEURCOURANTE = couleur ;
	codel3couleur[2] = codel3 [ 2 ] = couleur ;
       
	L3AppelDrivers ( codel3 ) ;
}

