/**************************/
/* L3LectureCoordonnees.c */
/**************************/

#include <stdio.h>

#include "L3Environnement.h"
#include "L3LectureCoordonnees.h"

#ifndef lint
    static const char sccs_id[] = "%W% %G% DMA/AIM/LM";
#endif

/**********************************************************************************************************
 * Procedure utilisateur : L3LectureCoordonnees                                                           *
 *--------------------------------------------------------------------------------------------------------*
 * Parametres :                                                                                           *
 *   sousimage : numero de la sous-image concernee                                                        *
 *   p_x       : pointeur sur la variable destinee a contenir l'abcisse utilisateur du point selectionne  *
 *   p_y       : pointeur sur la variable destinee a contenir l'ordonnee utilisateur du point selectionne *
 *                                                                                                        *
 * Valeur de retour : aucune.                                                                             *
 *                                                                                                        *
 * Description : voir document CEL.V DMA/SIE/IG NT 58.9 de juillet 1987 "GRAF CIGALE"                     *
 *                                                                                                        *
 * Erreurs : aucune.                                                                                      *
 **********************************************************************************************************/

void
L3LectureCoordonnees(sousimage, p_x, p_y)
	int             sousimage;
	REEL           *p_x;
	REEL           *p_y;

{
	int             codel3[14];

	SETSOUSIMAGE(sousimage);

	L3DialogueGETPOS(codel3, GRANDECROIX, SANSELASTIQUE, SANSMARQUE, SANSTRACE);

	L3ConvCoordL3VersUtil(codel3[7], codel3[8], p_x, p_y);
}
