/* identification du source */

#ifndef lint
    static const char* const sccs_id = " %W% %G% Pierre Brochard";
#endif

/* includes */

#include "SpxP.h"
#include "SpxBoLabel.h"
#include "SpxFtnP.h"

static void SpxSubstitueExposant(char texte[]);
static int SpxRound(double valeur);
static void SpxGrignoteLabel(char texte[],int Impose);
static void SpxBeauLabelPur(REEL valeur,
	       int nsignif,
	       char textesortie[],
	       int Impose
	       );

const char MODEXPOSANT = '^';

void
#ifdef CRAY
SPXBOL(float* x,_fcd valeurf,int* lglu)
#else
FUNCDECL(spxbol)(float* x,char* valeur,int* lglu,int lvaleur)
#endif
{
#ifdef CRAY
	char* valeur = _fcdtocp(valeurf);
	int lvaleur = _fcdlen(valeurf);
#endif
	REEL temp_x = (REEL) *x;
	int temp_lglu = 0;

	SpxBoLabel(temp_x,valeur,lvaleur);
	*lglu = temp_lglu = strlen(valeur);
	memset(valeur+temp_lglu,atoi(" "),lvaleur-temp_lglu);
}

void
SpxBoLabel(REEL x,char* valeur,int lvaleur)
{
	SpxBeauLabelPur(x,4,valeur,-1);

	if((int) strlen(valeur) >= lvaleur)
	{
	    printf(" pb tableau valeur declare trop petit pour SpxBoLabel\n");
	}

	printf(" valeur %s\n",valeur);
}

static void
SpxBeauLabelPur(REEL valeur,
	       int nsignif,
	       char textesortie[],
	       int Impose
	       )
{
   char            format[20], tot[10], frac[10];
   int             ntot, nfrac, nint;
   int             valint;

   if (valeur == 0.0)
      (void) strcpy(textesortie, "0");
   else {
      if ((fabs(valeur) < 1000.0) && (fabs(valeur) >= 1.0)) {
	 nint = (int) log10(fabs(valeur)) + 1;
	 nfrac = nsignif - nint;
	 if (nfrac > 0) {
	    ntot = nsignif + 2;
	    (void) sprintf(tot, "%d", ntot);
	    (void) sprintf(frac, "%d", nfrac);
	    (void) strcpy(format, "%");
	    (void) strcat(format, tot);
	    (void) strcat(format, ".");
	    (void) strcat(format, frac);
	    (void) strcat(format, "lf");
	    (void) sprintf(textesortie, format, valeur);
	 } else {
	    valint = SpxRound(valeur * exp10((double) nfrac)) *
	             SpxRound(exp10((double) (-nfrac)));
	    (void) sprintf(textesortie, "%d", valint);
	 }
      } else {
	 ntot = nsignif + 7;
	 (void) sprintf(tot, "%d", ntot);
	 (void) sprintf(frac, "%d", nsignif);
	 (void) strcpy(format, "%");
	 (void) strcat(format, tot);
	 (void) strcat(format, ".");
	 (void) strcat(format, frac);
	 (void) strcat(format, "g");
	 (void) sprintf(textesortie, format, valeur);
	 SpxSubstitueExposant(textesortie);
      }
   }

   SpxGrignoteLabel(textesortie, Impose);
}

static void
SpxGrignoteLabel(char texte[],int Impose)
{
   char           *avantvirgule;
   char           *apresvirgule;
   char           *avantexposant;
   char           *apresexposant;
   int             i, j, k, l, id;
   int             exposant = 0;
   int             finexposant = 0;
   int             virgule = 0;
   int             finvirgule = 0;
   int             blanc = 0;
   int 	           lgtexte = strlen(texte);

/* allocation de la memoire et mise a zero */
   avantvirgule = malloc(lgtexte + 1);
   apresvirgule = malloc(lgtexte + 1 + (Impose > 0 ? Impose : 2));
   avantexposant = malloc(lgtexte + 1);
   apresexposant = malloc(lgtexte + 1);
   
   memset(avantvirgule,0,lgtexte + 1);
   memset(apresvirgule,0,lgtexte + 1 + (Impose > 0 ? Impose : 2));
   memset(avantexposant,0,lgtexte + 1);
   memset(apresexposant,0,lgtexte + 1);

/* suppression des blancs de tete */
   i = 0;
   while (texte[i] == ' ')
      i++;

/* suppression des blancs de fin */
   j = lgtexte - 1;
   while (texte[j] == ' ')
      j--;

   virgule = -1;
   finvirgule = -1;
   exposant = -1;
   finexposant = -1;
   blanc = -1;

   /* on recherche le "." le " " le "e" ou le "MODEXPOSANT" */
   for (k = j; k >= i; k--) {
      if (texte[k] == '.') {
	 virgule = k;
	 break;
      }
   }
   for (k = j; k >= i; k--) {
      if (texte[k] == 'e' || texte[k] == 'E' || texte[k] == MODEXPOSANT) {
	 exposant = k;
	 break;
      }
   }
   for (k = j; k >= i; k--) {
      if (texte[k] == ' ') {
	 blanc = k;
	 break;
      }
   }

/* calibrage des diverses zones */
   finvirgule = j;

   if (exposant != -1) {
      finexposant = j;
      finvirgule = exposant - 1;
      for (id = 0, l = exposant; l <= finexposant; l++, id++) {
	 apresexposant[id] = texte[l];
      }
      apresexposant[id] = '\0';
   }
   if (blanc != -1) {
      finvirgule = blanc - 1;
      strcpy(avantexposant, " ");
      if ((exposant != -1) && ((blanc + 1) != exposant)) {
	 for (id = 0, l = blanc; l < exposant; l++, id++) {
	    avantexposant[id] = texte[l];
	 }
	 avantexposant[id] = '\0';
      }
   }
   if (virgule == -1) {
      for (id = 0, l = i; l <= finvirgule; id++, l++) {
	 avantvirgule[id] = texte[l];
      }
      avantvirgule[id] = '\0';
   } else {
      for (id = 0, l = i; l < virgule; id++, l++) {
	 avantvirgule[id] = texte[l];
      }
      avantvirgule[id] = '\0';
      for (id = 0, l = virgule; l <= finvirgule; id++, l++) {
	 apresvirgule[id] = texte[l];
      }
      apresvirgule[id] = '\0';
   }

/* suppression des elements indesirables dans chacun des champs */
/*	AVANT la VIRGULE */
   id = 1;
   /* detection de la presence du signe */
   if (avantvirgule[id] == '-') {
      id = 2;
   }
   /* elimination des blancs entre le signe et la partie entiere */
   while (avantvirgule[id] == ' ') {
      l = id;
      while (avantvirgule[l] != 0) {
	 avantvirgule[l] = avantvirgule[l + 1];
	 l++;
      }
   }
   /* elimination des blancs entre la partie entiere et la virgule */
   for (id = (strlen(avantvirgule) - 1); id >= 0; id--) {
      if (avantvirgule[id] != ' ') {
	 break;
      }
      avantvirgule[id] = '\0';
   }
/*	APRES la VIRGULE */
   for (id = (strlen(apresvirgule) - 1); id >= 0; id--) {
      if (apresvirgule[id] != '.' &&
	  apresvirgule[id] != '0' &&
	  apresvirgule[id] != ' ') {
	 break;
      }
      apresvirgule[id] = '\0';
   }
/*	APRES EXPOSANT */
   id = 1;
   /* elimination du + de l'exposant */
   if (apresexposant[id] == '+') {
      l = id;
      while (apresexposant[l] != 0) {
	 apresexposant[l] = apresexposant[l + 1];
	 l++;
      }
   }
   if (apresexposant[id] == '-') {
      id = 2;
   }
   /* elimination des zeros en tete d'exposant */
   while (apresexposant[id] == '0') {
      l = id;
      while (apresexposant[l] != 0) {
	 apresexposant[l] = apresexposant[l + 1];
	 l++;
      }
   }
   if ((strlen(apresexposant) == 1) && (apresexposant[0] == MODEXPOSANT)) {
      strcat(apresexposant, "0");
   }
/* cas des 1 10^X */
   if (Impose <= 0) {
      if ((strcmp("1", avantvirgule) == 0) &&
	  (strlen(apresvirgule) == 0) &&
	  (strlen(avantexposant) != 0)) {
	 strcpy(avantvirgule, "");
      }
   }
/* Format impose */
   if (Impose > 0) {
      int ll;
      if (strlen(avantvirgule) == 0) {
	 strcat(avantvirgule , "0");
      }
      if (strlen(apresvirgule) == 0) {
	   strcat(apresvirgule , ".");
      }
      ll = strlen(apresvirgule) - 1; /* exclu le . */
      while (ll < Impose) {
	 strcat(apresvirgule , "0");
	 ll++;
      }
   }
   
   strcpy(texte, avantvirgule);
   strcat(texte, apresvirgule);
   strcat(texte, avantexposant);
   strcat(texte, apresexposant);

/* desallocation de la memoire */
   free(avantvirgule);
   free(apresvirgule);
   free(avantexposant);
   free(apresexposant);
}

static void
SpxSubstitueExposant(char texte[])
{
   char            texte1[256], texte2[2];
   int             i, j, k;

   i = j = k = 0;

   /* recherche de l'exposant */
   while ((texte[i] != 'e') && (texte[i] != '\0'))
      i++;

   if (texte[i] == 'e') {
      strcpy(texte1, texte);
      texte1[i] = '\0';
      i++;
      strcat(texte1, " 10");
      texte2[0] = MODEXPOSANT;
      texte2[1] = '\0';
      strcat(texte1, texte2);
      strcat(texte1, texte + i);

      (void) strcpy(texte, texte1);
   }
}

static int
SpxRound(double valeur)
{
   int             signe, intval, entier;
   double          floorval, ceilval;

   if (valeur == 0.0)
      entier = 0;
   else {
      if (valeur < 0.0)
	 signe = -1;
      else
	 signe = 1;

      valeur = fabs(valeur);

      floorval = floor(valeur);
      ceilval = ceil(valeur);

      if ((valeur - floorval) < (ceilval - valeur))
	 intval = (int) floorval;
      else
	 intval = (int) ceilval;

      entier = intval * signe;
   }

   return (entier);
}
