/* identification du source */

#ifndef lint
    static const char* const sccs_id = "%W% %G% P. Brochard";
#endif

#include "SpxP.h"
#include "SpxBase.h"
#include "SpxFtnP.h"

/*--------------------------------------------------------------*/
/*    nouveau binding fortran                                   */
/*--------------------------------------------------------------*/

/* spxb2p = binding FORTRAN de SpxBase2DPoint */

int
#ifdef CRAY_PROTO
SPXB2P(REEL_S* x,REEL_S* y,int* couleur,IntFtn* spx_file)
#else
FUNCDECL(spxb2p)(REEL_S* x,REEL_S* y,int* couleur,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DPoint(*x,*y,*couleur,(SPXFILE*) (*spx_file));
}

/* spxb2s = binding FORTRAN de SpxBase2DSegment */

int
#ifdef CRAY_PROTO
SPXB2S(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,int* couleur,IntFtn* spx_file)
#else
FUNCDECL(spxb2s)(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,
		int* couleur,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DSegment(*x1,*y1,*x2,*y2,*couleur,
			(SPXFILE*) (*spx_file));
}

/* spxb2a = binding FORTRAN de SpxBase2DArc */

int
#ifdef CRAY_PROTO
SPXB2A(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,REEL_S* x3,REEL_S* y3,
		int* couleur,IntFtn* spx_file)
#else
FUNCDECL(spxb2a)(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,REEL_S* x3,
		REEL_S* y3,int* couleur,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DArc(*x1,*y1,*x2,*y2,*x3,*y3,*couleur,
			(SPXFILE*) (*spx_file));
}

/* spxb2r = binding FORTRAN de SpxBase2DRectangle */

int
#ifdef CRAY_PROTO
SPXB2R(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,int* couleur,IntFtn* spx_file)
#else
FUNCDECL(spxb2r)(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,
		int* couleur,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DRectangle(*x1,*y1,*x2,*y2,*couleur,
			(SPXFILE*) (*spx_file));
}

/* spxb2pl = binding FORTRAN de SpxBase2DPolyligne */

int
#ifdef CRAY_PROTO
SPXB2PL(REEL_S* x,REEL_S* y,int* taille,int* couleur,IntFtn* spx_file)
#else
FUNCDECL(spxb2pl)(REEL_S* x,REEL_S* y,int* taille,
		int* couleur,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DPolyligne(x,y,*taille,*couleur,
			(SPXFILE*) (*spx_file));
}

/* spxb2pg = binding FORTRAN de SpxBase2DPolygone */

int
#ifdef CRAY_PROTO
SPXB2PG(REEL_S* x,REEL_S* y,int* taille,int* couleur,IntFtn* spx_file)
#else
FUNCDECL(spxb2pg)(REEL_S* x,REEL_S* y,int* taille,
		int* couleur,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DPolygone(x,y,*taille,*couleur,
			(SPXFILE*) (*spx_file));
}

/* spxb2pc = binding FORTRAN de SpxBase2DPolygoneContoure */

int
#ifdef CRAY_PROTO
SPXB2PC(REEL_S* x,REEL_S* y,int* taille,int* couleur,int* couleurcont,
		IntFtn* spx_file)
#else
FUNCDECL(spxb2pc)(REEL_S* x,REEL_S* y,int* taille,
		int* couleur,int* couleurcont,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DPolygoneContoure(x,y,*taille,*couleur,
			*couleurcont,(SPXFILE*) (*spx_file));
}

/* spxb2tp = binding FORTRAN de SpxBase2DTabPoint */

int
#ifdef CRAY_PROTO
SPXB2TP(REEL_S* x,REEL_S* y,int* taille,int* couleur,IntFtn* spx_file)
#else
FUNCDECL(spxb2tp)(REEL_S* x,REEL_S* y,int* taille,int* couleur,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DTabPoint(x,y,*taille,*couleur,
			(SPXFILE*) (*spx_file));
}

/* spxb2ts = binding FORTRAN de SpxBase2DTabSegment */

int
#ifdef CRAY_PROTO
SPXB2TS(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,int* taille,
		int* couleur,IntFtn* spx_file)
#else
FUNCDECL(spxb2ts)(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,int* taille,
		int* couleur,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DTabSegment(x1,y1,x2,y2,*taille,*couleur,
			(SPXFILE*) (*spx_file));
}

/* spxb2ta = binding FORTRAN de SpxBase2DTabArc */

int
#ifdef CRAY_PROTO
SPXB2TA(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,REEL_S* x3,REEL_S* y3,
		int* taille,int* couleur,IntFtn* spx_file)
#else
FUNCDECL(spxb2ta)(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,REEL_S* x3,
		REEL_S* y3,int* taille,int* couleur,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DTabArc(x1,y1,x2,y2,x3,y3,*taille,*couleur,
			(SPXFILE*) (*spx_file));
}

/* spxb2tr = binding FORTRAN de SpxBase2DTabRectangle */

int
#ifdef CRAY_PROTO
SPXB2TR(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,int* taille,
		int* couleur,IntFtn* spx_file)
#else
FUNCDECL(spxb2tr)(REEL_S* x1,REEL_S* y1,REEL_S* x2,REEL_S* y2,int* taille,
		int* couleur,IntFtn* spx_file)
#endif
{
	return (int) SpxBase2DTabRectangle(x1,y1,x2,y2,*taille,*couleur,
			(SPXFILE*) (*spx_file));
}

/* spxb2d = binding FORTRAN de SpxBase2DDelete */

void
#ifdef CRAY_PROTO
SPXB2D(int* item,IntFtn* spx_file)
#else
FUNCDECL(spxb2d)(int* item,IntFtn* spx_file)
#endif
{
	SpxBase2DDelete(*item,(SPXFILE*) (*spx_file));
}

/* spxb2da = binding FORTRAN de SpxBase2DDeleteAll */

void
#ifdef CRAY_PROTO
SPXB2DA(IntFtn* spx_file)
#else
FUNCDECL(spxb2da)(IntFtn* spx_file)
#endif
{
	SpxBase2DDeleteAll((SPXFILE*) (*spx_file));
}

/* fin fichier */
