/* identification du source */

static const char* const sccs_id = " %W% %G% P. Brochard";

#include "SpxP.h"
#include "narcisse.h"
#include "SpxFtnP.h"

/* spxrc4ns appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXRC4NS(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
       int* nmailles,int* dimmailles,int mailles[],
       _fcd tabcle,int* ivalcle,REEL_S* xvalcle,_fcd cvalcle,
       int* nicle,int* nxcle,int* nccle,_fcd nomsp3)
#else
FUNCDECL(spxrc4ns)(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
       int* nmailles,int* dimmailles,int mailles[],
       char* tabcle,int* ivalcle,REEL_S* xvalcle,char* cvalcle,
       int* nicle,int* nxcle,int* nccle,char* nomsp3,
       int l1,int l2,int l3)
#endif
{
#ifdef CRAY_PROTO
	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_nomsp3 = SpxStrCopy(nomsp3,l3);
#endif
	char* temp_tabcle = NULL;
	char* temp_cvalcle = NULL;
	SPXFILE* spx_file = NULL;
	unsigned n = 0;
	int i = 0;
	int ntaille = *nicle+*nxcle+*nccle+1;
	SpxArg* spx_arg = (SpxArg*) malloc(ntaille*sizeof(SpxArg));

	SpxInitArg(spx_arg,ntaille);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",0);n++;

	for(i=0;i<*nicle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+i*lo1,lo1);
#else
	    temp_tabcle = SpxStrCopy(tabcle+i*l1,l1);
#endif
	    SpxSetArgInt(&spx_arg[n],temp_tabcle,ivalcle[i]);n++;

	    free(temp_tabcle);
	}

	for(i=0;i<*nxcle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+(i+*nicle)*lo1,lo1);
#else
	    temp_tabcle = SpxStrCopy(tabcle+(i+*nicle)*l1,l1);
#endif
	    SpxSetArgReel(&spx_arg[n],temp_tabcle,xvalcle[i]);n++;

	    free(temp_tabcle);
	}

	for(i=0;i<*nccle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);
	    int lo2 = _fcdlen(cvalcle);
	    int l = i+*nicle+*nxcle;

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+l*lo1,lo1);
	    temp_cvalcle = SpxStrCopy(_fcdtocp(cvalcle)+i*lo2,lo2);
#else
	    temp_tabcle = SpxStrCopy(tabcle+(i+*nicle+*nxcle)*l1,l1);
	    temp_cvalcle = SpxStrCopy(cvalcle+i*l2,l2);
#endif
	    SpxSetArgChar(&spx_arg[n],temp_tabcle,temp_cvalcle);n++;

	    free(temp_tabcle);
	    free(temp_cvalcle);
	}

	spx_file = SpxOpen(temp_nomsp3);

	free(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);
	SpxPurgeArg(spx_arg,ntaille);n=0;

	SpxNonStruc4d(*npoints,x,y,z,c,*nmailles,*dimmailles,mailles,spx_file);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",1);n++;
	SpxSetValues(spx_file,spx_arg,n);
	SpxPurgeArg(spx_arg,ntaille);

	free(spx_arg);

	SpxClose(spx_file);
}

/* spxrc appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXRC(_fcd tabcle,int* ivalcle,REEL_S* xvalcle,_fcd cvalcle,
       int* nicle,int* nxcle,int* nccle,_fcd nomsp3)
#else
FUNCDECL(spxrc)(char* tabcle,int* ivalcle,REEL_S* xvalcle,char* cvalcle,
       int* nicle,int* nxcle,int* nccle,char* nomsp3,
       int l1,int l2,int l3)
#endif
{
#ifdef CRAY_PROTO
	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_nomsp3 = SpxStrCopy(nomsp3,l3);
#endif
	char* temp_tabcle = NULL;
	char* temp_cvalcle = NULL;
	SPXFILE* spx_file = NULL;
	unsigned n = 0;
	int i = 0;
	int ntaille = *nicle+*nxcle+*nccle;
	SpxArg* spx_arg = (SpxArg*) malloc(ntaille*sizeof(SpxArg));

	SpxInitArg(spx_arg,ntaille);

	for(i=0;i<*nicle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+i*lo1,lo1);
#else
	    temp_tabcle = SpxStrCopy(tabcle+i*l1,l1);
#endif
	    SpxSetArgInt(&spx_arg[n],temp_tabcle,ivalcle[i]);n++;

	    free(temp_tabcle);
	}

	for(i=0;i<*nxcle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+(i+*nicle)*lo1,lo1);
#else
	    temp_tabcle = SpxStrCopy(tabcle+(i+*nicle)*l1,l1);
#endif
	    SpxSetArgReel(&spx_arg[n],temp_tabcle,xvalcle[i]);n++;

	    free(temp_tabcle);
	}

	for(i=0;i<*nccle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);
	    int lo2 = _fcdlen(cvalcle);
	    int l = i+*nicle+*nxcle;

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+l*lo1,lo1);
	    temp_cvalcle = SpxStrCopy(_fcdtocp(cvalcle)+i*lo2,lo2);
#else
	    temp_tabcle = SpxStrCopy(tabcle+(i+*nicle+*nxcle)*l1,l1);
	    temp_cvalcle = SpxStrCopy(cvalcle+i*l2,l2);
#endif
	    SpxSetArgChar(&spx_arg[n],temp_tabcle,temp_cvalcle);n++;

	    free(temp_tabcle);
	    free(temp_cvalcle);
	}

	spx_file = SpxOpen(temp_nomsp3);

	free(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);
	SpxPurgeArg(spx_arg,ntaille);

	free(spx_arg);

	SpxClose(spx_file);
}

/* spxrc3re appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXRC3RE(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
       _fcd tabcle,int* ivalcle,REEL_S* xvalcle,_fcd cvalcle,
       int* nicle,int* nxcle,int* nccle,_fcd nomsp3)
#else
FUNCDECL(spxrc3re)(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
       char* tabcle,int* ivalcle,REEL_S* xvalcle,char* cvalcle,
       int* nicle,int* nxcle,int* nccle,char* nomsp3,
       int l1,int l2,int l3)
#endif
{
#ifdef CRAY_PROTO
	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_nomsp3 = SpxStrCopy(nomsp3,l3);
#endif
	char* temp_tabcle = NULL;
	char* temp_cvalcle = NULL;
	SPXFILE* spx_file = NULL;
	unsigned n = 0;
	int i = 0;
	int ntaille = *nicle+*nxcle+*nccle+1;
	SpxArg* spx_arg = (SpxArg*) malloc(ntaille*sizeof(SpxArg));

	SpxInitArg(spx_arg,ntaille);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",0);n++;

	for(i=0;i<*nicle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+i*lo1,lo1);
#else
	    temp_tabcle = SpxStrCopy(tabcle+i*l1,l1);
#endif
	    SpxSetArgInt(&spx_arg[n],temp_tabcle,ivalcle[i]);n++;

	    free(temp_tabcle);
	}

	for(i=0;i<*nxcle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+(i+*nicle)*lo1,lo1);
#else
	    temp_tabcle = SpxStrCopy(tabcle+(i+*nicle)*l1,l1);
#endif
	    SpxSetArgReel(&spx_arg[n],temp_tabcle,xvalcle[i]);n++;

	    free(temp_tabcle);
	}

	for(i=0;i<*nccle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);
	    int lo2 = _fcdlen(cvalcle);
	    int l = i+*nicle+*nxcle;

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+l*lo1,lo1);
	    temp_cvalcle = SpxStrCopy(_fcdtocp(cvalcle)+i*lo2,lo2);
#else
	    temp_tabcle = SpxStrCopy(tabcle+(i+*nicle+*nxcle)*l1,l1);
	    temp_cvalcle = SpxStrCopy(cvalcle+i*l2,l2);
#endif
	    SpxSetArgChar(&spx_arg[n],temp_tabcle,temp_cvalcle);n++;

	    free(temp_tabcle);
	    free(temp_cvalcle);
	}

	spx_file = SpxOpen(temp_nomsp3);

	free(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);
	SpxPurgeArg(spx_arg,ntaille);n=0;

	SpxRect3d(*nx,*ny,x,y,z,*dimz,spx_file);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",1);n++;
	SpxSetValues(spx_file,spx_arg,n);
	SpxPurgeArg(spx_arg,ntaille);

	free(spx_arg);

	SpxClose(spx_file);
}

/* spxrc2mu appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXRC2MU(REEL_S x[],int* dimx,REEL_S y[],int* dimy,int* nx,int* ny,
       _fcd tabcle,int* ivalcle,REEL_S* xvalcle,_fcd cvalcle,
       int* nicle,int* nxcle,int* nccle,_fcd nomsp3)
#else
FUNCDECL(spxrc2mu)(REEL_S x[],int* dimx,REEL_S y[],int* dimy,int* nx,int* ny,
       char* tabcle,int* ivalcle,REEL_S* xvalcle,char* cvalcle,
       int* nicle,int* nxcle,int* nccle,char* nomsp3,
       int l1,int l2,int l3)
#endif
{
#ifdef CRAY_PROTO
	char* temp_nomsp3 = SpxStrCopy(_fcdtocp(nomsp3),_fcdlen(nomsp3));
#else
	char* temp_nomsp3 = SpxStrCopy(nomsp3,l3);
#endif
	char* temp_tabcle = NULL;
	char* temp_cvalcle = NULL;
	SPXFILE* spx_file = NULL;
	unsigned n = 0;
	int i = 0;
	int ntaille = *nicle+*nxcle+*nccle+1;
	SpxArg* spx_arg = (SpxArg*) malloc(ntaille*sizeof(SpxArg));
	unsigned compt = 0;
	REEL_S* temp_x = NULL;
	REEL_S* temp_y = NULL;

	SpxInitArg(spx_arg,ntaille);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",0);n++;

	for(i=0;i<*nicle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+i*lo1,lo1);
#else
	    temp_tabcle = SpxStrCopy(tabcle+i*l1,l1);
#endif
	    SpxSetArgInt(&spx_arg[n],temp_tabcle,ivalcle[i]);n++;

	    free(temp_tabcle);
	}

	for(i=0;i<*nxcle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+(i+*nicle)*lo1,lo1);
#else
	    temp_tabcle = SpxStrCopy(tabcle+(i+*nicle)*l1,l1);
#endif
	    SpxSetArgReel(&spx_arg[n],temp_tabcle,xvalcle[i]);n++;

	    free(temp_tabcle);
	}

	for(i=0;i<*nccle;i++)
	{
#ifdef CRAY_PROTO
	    int lo1 = _fcdlen(tabcle);
	    int lo2 = _fcdlen(cvalcle);
	    int l = i+*nicle+*nxcle;

	    temp_tabcle = SpxStrCopy(_fcdtocp(tabcle)+l*lo1,lo1);
	    temp_cvalcle = SpxStrCopy(_fcdtocp(cvalcle)+i*lo2,lo2);
#else
	    temp_tabcle = SpxStrCopy(tabcle+(i+*nicle+*nxcle)*l1,l1);
	    temp_cvalcle = SpxStrCopy(cvalcle+i*l2,l2);
#endif
	    SpxSetArgChar(&spx_arg[n],temp_tabcle,temp_cvalcle);n++;

	    free(temp_tabcle);
	    free(temp_cvalcle);
	}

	spx_file = SpxOpen(temp_nomsp3);

	free(temp_nomsp3);

	SpxSetValues(spx_file,spx_arg,n);
	SpxPurgeArg(spx_arg,ntaille);n=0;

	for(i=0;i<*ny;i++)
        {
	    compt += nx[i];
	}
	
	temp_x = (REEL_S*) malloc(compt*sizeof(REEL_S));
	temp_y = (REEL_S*) malloc(compt*sizeof(REEL_S));

	for(i=0,compt=0;i<*ny;compt+=nx[i],i++)
        {
	    memcpy((char*) &temp_x[compt],(char*) &x[i*(*dimx)],
		sizeof(REEL_S)*nx[i]);
	    memcpy((char*) &temp_y[compt],(char*) &y[i*(*dimy)],
		sizeof(REEL_S)*nx[i]);
	}

	SpxMulCourbe(temp_x,temp_y,nx,*ny,spx_file);

	free(temp_x);
	free(temp_y);

	SpxSetArgInt(&spx_arg[n],"calcul_socket",1);n++;
	SpxSetValues(spx_file,spx_arg,n);
	SpxPurgeArg(spx_arg,ntaille);

	free(spx_arg);

	SpxClose(spx_file);
}

