/* identification du source */

#ifndef lint
    static const char sccs_id[] = "%W% %G% Pierre Brochard";
#endif

/* Includes */

#include "SpxP.h"
#include "nx.h"
#include "SpxGetDonAbs.h"
#include "SpxOpenP.h"

/* Implementations */

int
SpxGetDonneeAbstraite(const int dimbloc,const int dimxy,const int dimz,
		const int dimc,const int dimmai,const int dimvol,
		REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nbloc,int nx[],int ny[],int nz[],
		SpxTypeDon type[],SpxTypeC typec[],SpxTypeMailles typemailles[],
		int nmailles[],int dimmailles[],int mailles[],
		int nvolumes[],int dimvolumes[],int volumes[],
		SPXFILE* spx_file)
{

	if(spx_file && spx_file->type == SPXSOCKET)
	{
            FILE* file_fich = spx_file->file;
	    int typecom = 3;
	    int nbbloc = 0;
	    int i = 0;
	    int ier = 0;
	    REEL_S* temp = NULL;
	    int* tempi = NULL;
	    int temp_compt = 0;
	    int tempi_compt = 0;

            fnxwriti(file_fich,1,&typecom);
            fnxflush(file_fich);
	    fnxreadi(file_fich,1,&nbbloc);

	    *nbloc = nbbloc;

	    for(i=0;i<nbbloc;i++)
	    {
		int typetemp = 0;
		int typectemp = 0;
		int typemaillestemp = 0;
		int nxtemp = 0;
		int nytemp = 0;
		int nztemp = 0;
		int nbx = 0;
		int nby = 0;
		int nbz = 0;
		int nbc = 0;
		int nbmailles = 0;
		int nbvolumes = 0;
		int nbdimmailles = 0;
		int nbdimvolumes = 0;
		int nbdonnees_tronc = 0;

		if(i>=dimbloc) ier = 1;

	    /* lecture type */

		fnxreadi(file_fich,1,&typetemp);

		if(i<dimbloc) type[i] = (SpxTypeDon) typetemp;

	    /* lecture typec */

		fnxreadi(file_fich,1,&typectemp);

		if(i<dimbloc) typec[i] = (SpxTypeC) typectemp;

	    /* lecture typemailles */

		fnxreadi(file_fich,1,&typemaillestemp);

		if(i<dimbloc) typemailles[i] = (SpxTypeMailles) typemaillestemp;

	    /* lecture nx ny nz */

		fnxreadi(file_fich,1,&nxtemp);

		if(i<dimbloc) nx[i] = nxtemp;

		fnxreadi(file_fich,1,&nytemp);

		if(i<dimbloc) ny[i] = nytemp;

		fnxreadi(file_fich,1,&nztemp);

		if(i<dimbloc) nz[i] = nztemp;

	    /* lecture x */

		fnxreadi(file_fich,1,&nbx);

		if(temp_compt < nbx)
		{

		    if(temp) free(temp);

		    temp = (REEL_S*) malloc(nbx*sizeof(REEL_S));
		    temp_compt = nbx;
		}

		fnxreadf(file_fich,nbx,temp);

		if(i<dimbloc)
		{
		    nbdonnees_tronc = nbx;

		    if(nbdonnees_tronc>dimxy)
		    {
			ier = 1;
			nbdonnees_tronc = dimxy;
		    }

		    memcpy(x+dimxy*i,temp,nbdonnees_tronc*sizeof(REEL_S));
		}

	    /* lecture y */

		fnxreadi(file_fich,1,&nby);

		if(temp_compt < nby)
		{

		    if(temp) free(temp);

		    temp = (REEL_S*) malloc(nby*sizeof(REEL_S));
		    temp_compt = nby;
		}

		fnxreadf(file_fich,nby,temp);

		if(i<dimbloc)
		{
		    nbdonnees_tronc = nby;

		    if(nbdonnees_tronc>dimxy)
		    {
			ier = 1;
			nbdonnees_tronc = dimxy;
		    }

		    memcpy(y+dimxy*i,temp,nbdonnees_tronc*sizeof(REEL_S));
		}

	    /* lecture z */

		fnxreadi(file_fich,1,&nbz);

		if(temp_compt < nbz)
		{

		    if(temp) free(temp);

		    temp = (REEL_S*) malloc(nbz*sizeof(REEL_S));
		    temp_compt = nbz;
		}

		fnxreadf(file_fich,nbz,temp);

		if(i<dimbloc)
		{
		    nbdonnees_tronc = nbz;

		    if(nbdonnees_tronc>dimz)
		    {
			ier = 1;
			nbdonnees_tronc = dimz;
		    }

		    memcpy(z+dimz*i,temp,nbdonnees_tronc*sizeof(REEL_S));
		}

	    /* lecture c */

		fnxreadi(file_fich,1,&nbc);

		if(temp_compt < nbc)
		{

		    if(temp) free(temp);

		    temp = (REEL_S*) malloc(nbc*sizeof(REEL_S));
		    temp_compt = nbc;
		}

		fnxreadf(file_fich,nbc,temp);

		if(i<dimbloc)
		{
		    nbdonnees_tronc = nbc;

		    if(nbdonnees_tronc>dimc)
		    {
			ier = 1;
			nbdonnees_tronc = dimc;
		    }

		    memcpy(c+dimc*i,temp,nbdonnees_tronc*sizeof(REEL_S));
		}

	    /* lecture nmailles */

		fnxreadi(file_fich,1,&nbmailles);

		if(i<dimbloc) nmailles[i] = nbmailles;

	    /* lecture dimmailles */

		fnxreadi(file_fich,1,&nbdimmailles);

		if(i<dimbloc) dimmailles[i] = nbdimmailles;

	    /* lecture mailles */

		if(tempi_compt < nbdimmailles)
		{

		    if(tempi) free(tempi);

		    tempi = (int*) malloc(nbdimmailles*sizeof(int));
		    tempi_compt = nbdimmailles;
		}

		nbdonnees_tronc = nbdimmailles;

		if(nbdonnees_tronc>dimmai)
		{
		    ier = 1;
		    nbdonnees_tronc = dimmai;
		}

		fnxreadi(file_fich,nbdimmailles,tempi);

		if(i<dimbloc) memcpy(mailles+dimmai*i,tempi,
				nbdonnees_tronc*sizeof(int));

	    /* lecture nvolumes */

		fnxreadi(file_fich,1,&nbvolumes);

		if(i<dimbloc) nvolumes[i] = nbvolumes;

	    /* lecture dimvolumes */

		fnxreadi(file_fich,1,&nbdimvolumes);

		if(i<dimbloc) dimvolumes[i] = nbdimvolumes;

	    /* lecture volumes */

		if(tempi_compt < nbdimvolumes)
		{

		    if(tempi) free(tempi);

		    tempi = (int*) malloc(nbdimvolumes*sizeof(int));
		    tempi_compt = nbdimvolumes;
		}

		nbdonnees_tronc = nbdimvolumes;

		if(nbdonnees_tronc>dimvol)
		{
		    ier = 1;
		    nbdonnees_tronc = dimvol;
		}

		fnxreadi(file_fich,nbdimvolumes,tempi);

		if(i<dimbloc) memcpy(volumes+dimvol*i,tempi,
				nbdonnees_tronc*sizeof(int));

	    }

	    if(temp) free(temp);

	    if(tempi) free(tempi);

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);

	    return ier;
	}

	return -1;
}

