/* identification du source */

#ifndef lint
    static const char sccs_id[] = "%W% %G% Pierre Brochard";
#endif

#include "SpxP.h"
#include "SpxVisuDri.h"
#include "nx.h"
#include "SpxPrintSurf.h"
#include "SpxOpenP.h"

static void
SpxGenPrintSurf(int nx,int ny,void* z,int dimz,int precision,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;

	if(!spx_file) return;

	if(SpxDebut(spx_file)) return;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp = 0;
            int i = 0;
            int* nxsto = NULL;
	    char* const zz = (char*) z;

	    SPXDEFICODLMOT(icod,lmot,precision);
            temp = 0;
            fnxwriti(file_fich,1,&temp);
            temp = ny;
            fnxwriti(file_fich,1,&temp);
    
            nxsto = (int*) malloc(ny*sizeof(int));
    
            if(!nxsto)
            {
                fprintf(stderr," pas assez de place memoire ; fin lecture");
                return;
            }
    
            for(i=0;i<ny;i++)
            {
                nxsto[i] = nx;
            }
    
            fnxwriti(file_fich,ny,nxsto);
    
            free(nxsto);nxsto = NULL;
    
            for(i=0;i<ny;i++)
            {
                fnxwritt(file_fich,nx,zz+i*dimz*lmot,icod,"sp");
            }
    
            temp = 0;
            fnxwriti(file_fich,1,&temp);
            fnxwrite(file_fich,"@",1);
	}
	else
	{
	    char temp[80];
	    int i = 0,j = 0;

	    for(;i<nx;i++)
	    {

		for(j=0;j<ny;j++)
		{
		    SPXASCII(precision,
				    sprintf(temp,"%g\n",((REEL4*) z)[i+j*dimz]),
				    sprintf(temp,"%g\n",((REEL_S*) z)[i+j*dimz]),
				    sprintf(temp,"%g\n",((REEL*) z)[i+j*dimz]));
		    fnxwrite(file_fich,temp,strlen(temp));
		}

		if(i != nx-1)
		{
		    sprintf(temp,"~e\n");
		    fnxwrite(file_fich,temp,strlen(temp));
		}
		else
		{
		    sprintf(temp,"~f\n");
		    fnxwrite(file_fich,temp,strlen(temp));
		}

	    }

	}

	fnxflush(file_fich);
	SpxFin(spx_file);
}

void
SpxPrintSurf(int nx,int ny,REEL_S z[],int dimz,SPXFILE* spx_file)
{
	SpxGenPrintSurf(nx,ny,z,dimz,SPXREAL,spx_file);
}

/* double precision (transmis en ieee 32 bits) */

void
SpxDPrintSurf(int nx,int ny,REEL z[],int dimz,SPXFILE* spx_file)
{
	SpxGenPrintSurf(nx,ny,z,dimz,SPXDOUBLEPRECISION,spx_file);
}

/* REAL*4 (transmis en ieee 32 bits) */

void
Spx4PrintSurf(int nx,int ny,REEL4 z[],int dimz,SPXFILE* spx_file)
{
	SpxGenPrintSurf(nx,ny,z,dimz,SPXREAL4,spx_file);
}

/* REAL*8 (transmis en ieee 32 bits) */

void
Spx8PrintSurf(int nx,int ny,REEL8 z[],int dimz,SPXFILE* spx_file)
{
#if defined(CRAY)
	SpxGenPrintSurf(nx,ny,z,dimz,SPXREAL,spx_file);
#else
	SpxGenPrintSurf(nx,ny,z,dimz,SPXDOUBLEPRECISION,spx_file);
#endif
}
