/* identification du source */

#ifndef lint
   static const char* const sccs_id = "%W% %G% Pierre Brochard";
#endif

#include "SpxP.h"
#include "SpxSetArg.h"
#include "SpxOpenP.h"

#define FREE(a) if(a) {free((char*) (a));(a) = NULL;}

/*---------------------------------------------------------------------*/

void
SpxVPurgeArg(SPXFILE* spx_file)
{
	unsigned taille = 0;
	SpxArg* spx_arg = NULL;

	if(!spx_file) return;

	taille = spx_file->spxarg_taille;
	spx_arg = spx_file->spxarg;

	if(!spx_arg) return;

	SpxPurgeArg(spx_arg,taille);

	FREE(spx_file->spxarg);
	spx_file->spxarg_taille = 0;
}

/* --------------------------------------------------------------------*/

static SpxArg*
SpxAllocArg(SPXFILE* spx_file)
{
	unsigned taille = 0;
	SpxArg* spx_arg = NULL;

	if(!spx_file) return NULL;

	taille = spx_file->spxarg_taille;
	spx_arg = spx_file->spxarg;

	if(!spx_arg)
	{
	    spx_arg = malloc(sizeof(SpxArg));
	    taille = 1;
	}
	else
	{
	    spx_arg = realloc(spx_arg,(++taille)*sizeof(SpxArg));
	}

	if(!spx_arg) return NULL;

	spx_file->spxarg = spx_arg;
	spx_file->spxarg_taille = taille;
	spx_arg += taille - 1;
	memset((char*) spx_arg,0,sizeof(SpxArg));

	return spx_arg;
}

static SpxArg*
SpxAllocTabArg(SPXFILE* spx_file,const char* name)
{
	unsigned taille = 0;
	unsigned taille2 = 0;
	SpxArg* spx_arg = NULL;

	if(!spx_file) return NULL;

	taille = spx_file->spxarg_taille;
	spx_arg = spx_file->spxarg;

	if(!spx_arg)
	{
	    spx_arg = malloc(sizeof(SpxArg));
	    taille2 = taille = 1;
	}
	else
	{
	    unsigned i = 0;

	    for(;i<taille;i++)
	    {

		if(!strcmp((spx_arg+i)->gen.name,name)) break;

	    }

	    if(i == taille)
	    {
		spx_arg = realloc(spx_arg,(++taille)*sizeof(SpxArg));
		taille2 = taille;
	    }
	    else
		taille2 = i;

	}

	if(!spx_arg) return NULL;

	spx_file->spxarg = spx_arg;
	spx_file->spxarg_taille = taille;
	spx_arg += taille2 - 1;

	if(taille == taille2)
	    memset((char*) spx_arg,0,sizeof(SpxArg));
	else
	    spx_arg++;

	return spx_arg;
}

void
SpxVSetArgInt(SPXFILE* spx_file,char* name,int value)
{
	SpxArg* spx_arg = SpxAllocArg(spx_file);

	if(spx_arg) SpxSetArgInt(spx_arg,name,value);

}

void
SpxVSetArgReel(SPXFILE* spx_file,char* name,REEL_S value)
{
	SpxArg* spx_arg = SpxAllocArg(spx_file);

	if(spx_arg) SpxSetArgReel(spx_arg,name,value);

}

void
SpxVSetArgChar(SPXFILE* spx_file,char* name,char* value)
{
	SpxArg* spx_arg = SpxAllocArg(spx_file);

	if(spx_arg) SpxSetArgChar(spx_arg,name,value);

}

void
SpxVSetArgTabInt(SPXFILE* spx_file,char* name,int value,int indice)
{
	SpxArg* spx_arg = SpxAllocTabArg(spx_file,name);

	if(spx_arg) SpxSetArgTabInt(spx_arg,name,value,indice);

}

void
SpxVSetArgTabReel(SPXFILE* spx_file,char* name,REEL_S value,int indice)
{
	SpxArg* spx_arg = SpxAllocTabArg(spx_file,name);

	if(spx_arg) SpxSetArgTabReel(spx_arg,name,value,indice);

}

void
SpxVSetArgTabChar(SPXFILE* spx_file,char* name,char* value,int indice)
{
	SpxArg* spx_arg = SpxAllocTabArg(spx_file,name);

	if(spx_arg) SpxSetArgTabChar(spx_arg,name,value,indice);

}

/* --------------------------------------------------------------------*/
