#
# Makefile servant a fabriquer un executable a partir d un main donne
# make doit etre execute depuis le repertoire
# ou sont situes le main et la makefile
#
# Version originale : par Pierre Brochard : CEA/DAM-Ile de France
#
# utilisation courante : make EXAMPLE=nom_exe 
# On lance un Bourne-shell
#

#NARLOC="Repertoire d'installation de Narcisse"/Narcisse/V1.3
#NARLOC="Narcisse installation directory"/Narcisse/V1.3
SHELL = /bin/sh

include $(NARLOC)/cfg/machines/Default_Options.mk
include $(NARLOC)/cfg/Global_Macros.mk
include $(NARLOC)/cfg/machines/Global_Macros.mk
include $(NARLOC)/cfg/machines/$(ARCH)/macros.mk
include $(NARLOC)/cfg/machines/$(ARCH)/options$(OPT).mk
include .special_options.mk

LIBRAIRIES = $(NARLOC)/lib/$(ARCH)/$(OPT)
INCLUDES   = -I$(NARLOC)/include
EXEDIR     = $(NARLOC)/exe/$(ARCH)/$(OPT)
LIBDIR     = $(NARLOC)/lib/$(ARCH)/$(OPT)
EXE        = bid
EXEF       = bidf

debut:
	@IWD=`pwd`;if [ -f $(EXAMPLE).c ] ;then \
          $(MAKE) link clean EXEF="bid" EXE="$(EXEDIR)/$(EXAMPLE)" \
              SRC="$(EXAMPLE).c" COMP="$(CC)" LCOMP="$(LD)"; \
        elif [ -f $(EXAMPLE).C ] ;then \
          $(MAKE) link clean EXEF="bid" EXE="$(EXEDIR)/$(EXAMPLE)" \
             SRC="$(EXAMPLE).C" COMP="$(CC++)" LCOMP="$(LD)"; \
        elif [ -f $(EXAMPLE).f ] ;then \
          $(MAKE) linkf clean EXE="bid" EXEF="$(EXEDIR)/$(EXAMPLE)" \
             SRC="$(EXAMPLE).f" LCOMP="$(LDF)"; \
        fi

libdyna:
	@IWD=`pwd`;if [ -f $(EXAMPLE).c ] ;then \
          $(MAKE) link clean EXEDIR="$(LIBDIR)" EXEF="bid" \
		EXE="$(LIBDIR)/$(EXAMPLE).so" SRC="`ls *.c|tr '\012' ' '`" \
		COMP="$(CC)" LCOMP="$(LDY)"; \
        elif [ -f $(EXAMPLE).C ] ;then \
          $(MAKE) link clean EXEDIR="$(LIBDIR)" EXEF="bid" \
		EXE="$(LIBDIR)/$(EXAMPLE).so" SRC="`ls *.C|tr '\012' ' '`" \
		COMP="$(CC++)" LCOMP="$(LDY)"; \
        elif [ -f $(EXAMPLE).f ] ;then \
          $(MAKE) linkf clean EXEDIR="$(LIBDIR)" EXE="bid" \
		EXEF="$(LIBDIR)/$(EXAMPLE).so" SRC="`ls *.f|tr '\012' ' '`" \
		LCOMP="$(LDY)"; \
        fi;\
	if [ -f $(EXAMPLE).sce -a -f $(LIBDIR)/$(EXAMPLE).so ] ;then \
	  cp $(EXAMPLE).sce $(LIBDIR);fi

link:
	@$(MAKE) $(EXE)

linkf:
	@$(MAKE) $(EXEF)

clean:
	@cd $(EXEDIR);$(RM) *.o;$(RM) $(SRC)

$(EXE) : $(SRC) $(LIB) $(LIBS) $(LIBMODDEP)
	@echo "---> compilation de : $(SRC)"
	@cd $(EXEDIR);$(RM) *.o;$(RM) $(SRC)
	@cp $(SRC) $(EXEDIR)
	@chmod u+w $(EXEDIR)/*.[cC]
	@IWD=`pwd`;cd $(EXEDIR);for fic in $(SRC);\
           do echo $$fic;$(COMP) -I$$IWD -I$$IWD/../include \
              $(ALL_INCLUDES) -c $$fic;done
	@echo "---> link de : $@"
	@$(RM) $(EXE)
	-@IWD=`pwd`;$(MAKEMODEXASUP)
	@IWD=`pwd`;cd $(EXEDIR);$(LCOMP) -o $(EXE) *.o $(LIBMOD) \
           $(LIBS) $(ADDLIB)

$(EXEF) : $(SRC) $(LIB) $(LIBS) $(LIBMODDEP)
	@echo "---> compilation de : $(SRC)"
	@cd $(EXEDIR); $(RM) *.o; $(RM) $(SRC)
	@cp $(SRC) $(EXEDIR)
	@chmod u+w $(EXEDIR)/*.f
	@$(RM) $(EXEDIR)/$(SRC)
	@IWD=`pwd`;for fic in $(SRC);\
           do $(CPP) -I$$IWD -I$$IWD/../include $(ALL_INCLUDES) \
              $$fic > $(EXEDIR)/$$fic; done
	@IWD=`pwd`;cd $(EXEDIR);for fic in $(SRC);\
           do echo $$fic;$(FC) -c $$fic;done
	@echo "---> link de : $@"
	@$(RM) $(EXEF)
	-@IWD=`pwd`;$(MAKEMODEXASUP)
	@IWD=`pwd`;cd $(EXEDIR);$(LCOMP) -o $(EXEF) *.o $(LIBMOD) \
           $(LIBS) $(ADDLIB) $(LIBFOR)
