#
# Macros par defaut pour l'architecture Linux_2__ix86
#
MAKE        = make -k
ATLAS_EXTRACT_INCLUDE = \
	$(PROJECT_HOME)/cfg/.Atlas/Makefiles/Reference_Public_Includes_GNU.mk
MKDEP_ACTION = cd $(LST);$(TOUCH) $%;$(AR) r $(LIBAR) $%
ARR         = $(AR) r $(LIBAR) *.o;$(AR) x $(LIBAR);\
                for fic in `ls *.o 2> /dev/null` ; do\
                  if [ "`cat $$fic|wc -c`" -eq "0" ] ;then\
                    $(RM) $$fic;fi;done;\
                $(RM) $(LIBAR);$(AR) r

XFPARAL = -fomit-frame-pointer -funroll-loops -Winline -D__USE_STRING_INLINES \
		-DXMEMORY -DXPARA -m32 -mfpmath=sse -msse2 -march=i686 -DXSSE2
XPARAL = $(XFPARAL) -ftree-vectorize -ftree-vectorizer-verbose=3

CC          = $(NPREFIX)gcc -fPIC -D_XOPEN_SOURCE -D_BSD_SOURCE -D_POSIX_SOURCE \
		-DLINUX -DLINUX_2 $(XPARAL) $(CFLAGS) $(MCFLAGS_LINUX_2__IX86) \
		$$TIRPCDEF $$TIRPCINC
CC++        = $(NPREFIX)g++ -fPIC -DLINUX -DLINUX_2 -DS6FRANCAIS $(XPARAL) \
		$(C++FLAGS) $(MC++FLAGS_LINUX_2__IX86) $$TIRPCDEF $$TIRPCINC
CPP         = $(NPREFIX)cpp -P -DLINUX -DLINUX_2 -DNDEBUG \
		$(MCPPFLAGS_LINUX_2__IX86)
FC          = $(NPREFIX)gfortran -DLINUX -DLINUX_2 $(XPARAL) $(FFLAGS) \
		$(MFFLAGS_LINUX_2__IX86)
LD          = $(NPREFIX)g++ -v $(XPARAL) $(LDFLAGS) $(MLDFLAGS_LINUX_2__IX86) \
		$$TIRPCLIB -Wl,--copy-dt-needed-entries
LDF         = $(NPREFIX)gfortran -v $(XFPARAL) $(LDFLAGS) \
		$(MLDFLAGS_LINUX_2__IX86) $$TIRPCLIB -Wl,--copy-dt-needed-entries

LIBMOTIF    = -lMrm -lXm -lXp
LIBXTK      = -lXpm -lXt -lXaw -lXmu -lXext -lX11 -lSM -lICE -lXau
LIBGRA      =

INCMOTIF    = .
INCSAN      = $(PROJECT_HOME)/src/sanglier/.include
INCSANP     = $(PROJECT_HOME)/src/sanglier/.include
INCSANESP   = $(MODIF_HOME)/src/sanglier

ADDLIBMAC   = -lm
ADDLIBMACFTN =

LIBMOD      = $(LIBMOD_LINUX_2__IX86)
LIBPROJ     = $(LIBRAIRIES)/libnx.a $(LIBRAIRIES)/libsanglier.a
LIBFOR      = $(LIBFOR_LINUX_2__IX86)
