#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "narcisse.h"
#include "SpxObjets.h"

/*                      ====>    M A I N     <====              */

int
main(int argc,char** argv) 
{

  /* exemple de trace de cylindre type camenbert pour Psyche */

  /* generation configuration */

  if(argc == 2)
    {
      fprintf(stderr,"Usage :\tcamenbert\n\tcamenbert nbpoints val1 val2 ... valn\n");
      return 1;
    }

  SpxArg spx_arg[15];

  SpxInitArg(spx_arg,15);

  SpxSetArgInt(spx_arg,"output",0);
  SpxSetArgReel(spx_arg+1,"axe_x_min",0.);
  SpxSetArgReel(spx_arg+2,"axe_x_max",0.);
  SpxSetArgReel(spx_arg+3,"axe_y_min",0.);
  SpxSetArgReel(spx_arg+4,"axe_y_max",0.);
  SpxSetArgReel(spx_arg+5,"axe_z_min",32);
  SpxSetArgReel(spx_arg+6,"axe_z_max",60);
  SpxSetArgReel(spx_arg+7,"axe_c_min",0.);
  SpxSetArgReel(spx_arg+8,"axe_c_max",0.);
  SpxSetArgInt(spx_arg+9,"calcul_socket",-1);
  SpxSetArgInt(spx_arg+10,"option_3d_concatene",0);
  SpxSetArgInt(spx_arg+11,"option_3d_conv_mu_mo",1);
  SpxSetArgTabInt(spx_arg+12,"hauteur_c",0,53);
  SpxSetArgInt(spx_arg+13,"option_3d",255);
  SpxSetArgInt(spx_arg+14,"option_3d_masque",3);

  /* on ouvre un fichier (ici socket) */

  {
    size_t dim = 100;
    float* c = NULL;
    SPXFILE* spx_file = SpxOpen(" ");

    SpxSetValues(spx_file,spx_arg,15);

    if(argc <= 1)
      {
	size_t i = 0;

	c = malloc(dim * sizeof(float));

	for(;i<dim;i++)
	  c[i] = i;

      }
    else if(argc > 2)
      {
	double som = 0.;
	double val = 0.;
	double sval = 0.;
	size_t i = 0;
	size_t j = 2;

	dim = atoi(argv[1]);
	c = malloc(dim * sizeof(float));

	for(;j<argc;j++)
	  {
	    val = atof(argv[j]);
	    som += val;
	  }
	
	j = 2;
	val = atof(argv[j]);
	sval = ((double) dim) * val / som;

	for(;i<dim;i++)
	  {

	    while(i > sval && j + 1 < argc)
	      {
		j++;
		val = atof(argv[j]);
		sval += ((double) dim) * val / som;
	      }

	    c[i] = val;
	  }

      }

    /* on envoie les spheres dans le fichier ouvert */
    if(c)
      {
	SpxObjetCylindre4d(10.,20.,30.,2.,10.,20.,40.,1.,.3,c,dim, spx_file);
	free(c);
      }

    /* on ferme le fichier */
    SpxClose(spx_file);
  }

  return 0;
}
    
  




