      program testte
c ----------------------------------------------------------
c       lecture d''un fichier lu par Narcisse
c       test de l''appel spxgda
c /*************************************************************************/
c /* spxgda appelable en FORTRAN                                           */
c /* proto fortran :                                                       */
c /* integer spxgda                                                        */
c /*                                                                       */
c /* integer function spxgda(dimbloc,dimdon,dimc,dimmai,dimvol,            */
c /*		x,y,z,c,nbloc,nx,ny,nz,                                    */
c /*		type,typec,typemailles,                                    */
c /*		nmailles,dimmailles,mailles,                               */
c /*		nvolumes,dimvolumes,volumes,spx_file)                      */
c /* integer dimbloc 2eme dim des tableaux x,y,z,c,mailles,volumes         */
c /*   et 1ere dim des tableaux nx,ny,nz,type,typec,typemailles,           */
c /*   nmailles,dimmailles,nvolumes,dimvolumes  (en entree)                */
c /* integer dimxy 1ere dim des tableaux x,y    (en entree)                */
c /* integer dimz 1ere dim du tableau z         (en entree)                */
c /* integer dimc   1ere dim du tableau c       (en entree)                */
c /* integer dimmai 1ere dim du tableau mailles  (en entree)               */
c /* integer dimvol 1ere dim du tableau volumes   (en entree)              */
c /* real x(dimdon,dimbloc),y(dimdon,dimbloc),z(dimdon,dimbloc) (en retour)*/
c /* real c(dimc,dimbloc)                       (en retour)                */
c /* integer nbloc nombre de blocs lus (en retour)                         */
c /* integer nx(dimbloc),ny(dimbloc),nz(dimbloc) (en retour)               */
c /* integer type(dimbloc),typec(dimbloc),typemailles(dimbloc) (en retour) */
c /* integer nmailles(dimbloc),dimmailles(dimbloc) (en retour)             */
c /* integer nvolumes(dimbloc),dimvolumes(dimbloc) (en retour)             */
c /* integer mailles(dimmai,dimbloc) (en retour)                           */
c /* integer volumes(dimvol,dimbloc) (en retour)                           */
c /* integer spx_file (en entree)     donne par appel a spcopen            */
c /* spxgda vaut 1 en retour si l'une des dimensions est trop petite pour  */
c /*   contenir les donnees lues                                           */
c /* spxgda vaut 0 en retour si tout va bien                               */
c /* spxgda vaut -1 si spx_file vaut 0 (fichier non ouvert par spcopen)    */
c /*************************************************************************/
c ----------------------------------------------------------
      character*80 sccsid
      data sccsid/" @(#)getdonnees2d.f	1.1 12/02/10 P. Brochard"/
c ----------------------------------------------------------

c
      integer dimbloc,dimxy,dimz,dimc,dimmai,dimvol
      parameter(dimbloc=2,dimxy=12000,dimz=12000,dimc=12000)
      parameter(dimmai=100000,dimvol=1)
      real x(dimxy,dimbloc),y(dimxy,dimbloc)
      real z(dimz,dimbloc),c(dimc,dimbloc)
      integer nx(dimbloc),ny(dimbloc),nz(dimbloc)
      integer type(dimbloc),typec(dimbloc),typemailles(dimbloc)
      integer nmailles(dimbloc),dimmailles(dimbloc)
      integer nvolumes(dimbloc),dimvolumes(dimbloc)
      integer mailles(dimmai,dimbloc),volumes(dimvol,dimbloc)

      integer spcfile
      integer spcopen
      integer spxfile
      integer spxopen
      integer spxgda

      spcfile = spcopen('NARCISSE.1')

      ier = spxgda(dimbloc,dimxy,dimz,dimc,dimmai,dimvol,
     s            x,y,z,c,nbloc,nx,ny,nz,type,typec,typemailles,
     s            nmailles,dimmailles,mailles,
     s            nvolumes,dimvolumes,volumes,spcfile)
 
      call spxclose(spcfile)

c ier vaut 1 si l''une des dimensions dim... est insuffisante pour contenir
c le fichier lu par Narcisse
c ier vaut 0 si tout va bien
c ier vaut -1 si le spcopen n''a pas ouvert de sockets

      print*," ier ",ier," nbloc ",nbloc

      spxfile = spxopen('NARCISSE.1')

      do i=1,min(nbloc,dimbloc)
        print*," type ",type(i)
        print*," nx ",nx(i)
        print*," ny ",ny(i)
        print*," nz ",nz(i)

        if(type(i).eq.1) then

          do j=1,nx(i)
            x(j,i) = 3*x(j,i)
          enddo

          call spx2moc(x(1,i),y(1,i),nx(i),spxfile)
        endif

      enddo

      call spxclose(spxfile)

      end
