#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "narcisse.h"

/*                      ====>    M A I N     <====              */

int main(int argc,char** argv) 
{

/* exemple de trace de nappe + configuration pour Psyche */

#define nx_max 100
#define ny_max 100
        float x[ny_max][nx_max];
        float y[ny_max][nx_max];
        float z[ny_max][nx_max];
        int nx=100, ny=100, dimx=nx_max, dimy=nx_max, dimz=nx_max;
        
        int i = 0,j = 0;
        double pasx = 1.0/(nx-1);
        double pasy = 1.0/(ny-1);
	double R = 10.;
	double r = 2.;
        SPXFILE* spx_file = NULL;

    /* declarations tableau de configuration */

        SpxArg spx_arg[32];
        unsigned n = 0;

    /* init tableau de configuration */

        SpxInitArg(spx_arg,32);

   /* on remplit le tableau de configuration */

        /* trace sans les bras */
	SpxSetArgInt(&spx_arg[n],"option_3d",7);n++;

        /* le mot cle "calcul_socket" debranche (0) ou rebranche (1)
        le trace automatique effectue par Psyche lors des appels
        SpxSetValues, SpxMonoCourbe, SpxMulCourbe, SpxNonStruc4d,
        SpxRect3d, SpxRect4d, SpxTetra3d, SpxTetra4d */

        SpxSetArgInt(&spx_arg[n],"calcul_socket",0);n++;
        SpxSetArgInt(&spx_arg[n],"titre_affiche_bas",0);n++;
        SpxSetArgInt(&spx_arg[n],"titre_affiche_haut",0);n++;
        SpxSetArgInt(&spx_arg[n],"titre_affiche_gauche",0);n++;
        SpxSetArgInt(&spx_arg[n],"titre_affiche_droit",0);n++;
        SpxSetArgInt(&spx_arg[n],"titre_taille_bas",60);n++;
        SpxSetArgInt(&spx_arg[n],"titre_couleur_bas",0);n++;
        SpxSetArgInt(&spx_arg[n],"grille_couleur",0);n++;
        SpxSetArgInt(&spx_arg[n],"grille_type",0);n++;
        SpxSetArgInt(&spx_arg[n],"axe_couleur_titre",0);n++;
        SpxSetArgInt(&spx_arg[n],"axe_taille_titre",70);n++;
        SpxSetArgInt(&spx_arg[n],"option_3d_couleur_up",0);n++;
        SpxSetArgInt(&spx_arg[n],"option_3d_couleur_down",0);n++;
        SpxSetArgInt(&spx_arg[n],"ptvue_azimuth",60);n++;
        SpxSetArgInt(&spx_arg[n],"ptvue_site",45);n++;
	SpxSetArgInt(spx_arg+n,"parametre_map",-1);n++;
	SpxSetArgInt(spx_arg+n,"option_3d_masque",3);n++;

	SpxSetArgReel(spx_arg+n,"axe_z_min",-(R+r));n++;
	SpxSetArgReel(spx_arg+n,"axe_z_max",R+r);n++;
	SpxSetArgReel(spx_arg+n,"hauteur_z_h_min",-r);n++;
	SpxSetArgReel(spx_arg+n,"hauteur_z_h_max",r);n++;

        SpxSetArgChar(&spx_arg[n],"titre_valeur_bas","El!evation color!ee");n++;
        SpxSetArgChar(&spx_arg[n],"axe_valeur_x","X");n++;
        SpxSetArgChar(&spx_arg[n],"axe_valeur_y","Y");n++;
        SpxSetArgChar(&spx_arg[n],"axe_valeur_z","Altitude");n++;


        /* les tableaux sont remplis indices par indices ; les
        arguments sont :
        1-> structure dans laquelle SpxSetArg* range les elements
                de configuration
        2-> mot cle auquel on veut affecter une valeur
        3-> valeur a mettre dans l'indice du tableau donne
                par le 4ieme argument
        4-> indice */

	SpxSetArgTabInt(spx_arg+n,"parametre_map_pal",0,179);n++;
        SpxSetArgTabInt(&spx_arg[n],"hauteur_z",0,59);n++;
        SpxSetArgTabInt(&spx_arg[n],"hauteur_c",0,59);n++;

    /* on ouvre un fichier (ici socket) */

        spx_file = SpxOpen(" ");

    /* on envoit la configuration dans le fichier ouvert (ici socket) */

        SpxSetValues(spx_file,spx_arg,n);
	SpxSync(spx_file);

    /* on envoit le fichier couleur */

	{
	    SPXFILE* spcol_file = SpcolOpen(" ");

	    SpxSetColor("pal","#GreenBlueMod\nCRGB\n2\n"
			"0.0 0.93 0.91 0.67\n"
			"1.0 0.72 0.53 0.04",spcol_file);
	    SpxSync(spcol_file);
	    SpxClose(spcol_file);
	}

    /* on genere la nappe */

        for(i=0;i<nx;i++)
        {
	    const double phi = i*pasx*3.141592653589*2.;
	    const double sphi = sin(phi);
	    const double cphi = cos(phi);

            for(j=0;j<ny;j++)
            {
		const double teta = j*pasy*3.141592653589*2.;
		const double steta = sin(teta);
		const double cteta = cos(teta);

		x[j][i] = (float) ((R + r*cteta)*cphi);
		y[j][i] = (float) ((R + r*cteta)*sphi);
		z[j][i] = (float) (r*steta);
            }

        }

    /* on envoie la nappe dans le fichier ouvert (ici socket) */

        SpxTetra3d(nx, ny, (float*) x, dimx, (float*) y, dimy,
		(float*) z, dimz, spx_file);

    /* on nettoie le tableau de configuration */

        SpxPurgeArg(spx_arg,32);n=0;
        SpxSetArgInt(&spx_arg[n],"calcul_socket",1);n++;
	SpxSync(spx_file);
	SpxSetValues(spx_file,spx_arg,n);

        SpxClose(spx_file);
        
        return 0;
}
    
  




