#ifndef X11
#   define X11
#endif

#include <stdio.h>
#include <unistd.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include "SpxCallback.h"

/* exemple de fonction appelee en cas de clic avec la souris */

typedef struct _MyData
{
	int _essai1;
	char _essai2[256];
} MyData;

static void
MyBpressbaseCB(Widget w,XtPointer clientdata,XtPointer calldata)
{
	SpxButtonBaseCallbackStruct* const sbcs =
	    (SpxButtonBaseCallbackStruct* const) calldata;
	MyData* const my_data = (MyData* const) clientdata;

	printf("Entrez un nombre ? \n");
	scanf("%d",&my_data->_essai1);
	printf("Entrez une chaine de caracteres ? \n");
	scanf("%s",my_data->_essai2);
	printf("x = %f, y = %f, state %d, button %d\n",sbcs->x,sbcs->y,
			sbcs->state,sbcs->button);
}

static void
SpxScrute(Widget w)
{
	XtInputMask mask = 0;
	XtAppContext app_context = XtWidgetToApplicationContext(w);

	while(mask = XtAppPending(app_context))
	{
	    XtAppProcessEvent(app_context,mask);
	}

}

int
main(int argc,char* argv[])
{
	XtAppContext appc;
	Widget toplevel;
	SPXFILE* spxfile = NULL;
	int i = 0;
	MyData my_data;

	my_data._essai1 = 3;
	strcpy(my_data._essai2,"Bonjour");

    /* initialisation X11 */

	toplevel = XtVaAppInitialize( &appc,
			"app",
			NULL, 0,
			&argc, argv,
			NULL,NULL);
	XtVaSetValues(toplevel,XtNoverrideRedirect,True,
			XtNwidth,1,XtNheight,1,NULL);

    /* ouverture d'une connexion avec Psyche et init du callback */

	spxfile = SpcOpen(" ");
	SpxAddCallback(toplevel,SpxNbpressbaseAffCallback,
			(XtCallbackProc) MyBpressbaseCB,
			(XtPointer) &my_data,spxfile);
	SpxClose(spxfile);

	XtRealizeWidget(toplevel);

	for(i=0;i<10;i++)
	{
	    printf("entier %d\n",my_data._essai1);
	    printf("chaine %s\n",my_data._essai2);
	    sleep(2); /* faire qqchose */
	    SpxScrute(toplevel);
	}

	return 0;
}
