#ifndef _COL_H
#define _COL_H
#include "ERR.h"

/************************************
 * Types de definitions de couleurs *
 ************************************/
typedef enum
{
   COL_INVALID,			       /* Type non reconnu */
   COL_CHLS,			       /* Couleur, Hue, Light, Saturation */
   COL_CRGB,			       /* Couleur, Red, Green, Blue */
   COL_HLS,				       /* Hue, Light, Saturation */
   COL_RGB				       /* Red, Green, Blue */
}               TypeColorDef;	       /* TYPES DE DEFINITIONS DE COULEURS */

/**********************************
 * Fonctions d'acces aux couleurs *
 **********************************/

#ifdef __cplusplus
extern "C" {
#endif

extern          TypeError
COL_InfoColorFile (char *datafile,     /* Nom du fichier a ouvrir */
		   int *numtab);       /* Nombre de tables de couleurs */

extern          TypeError
COL_InfoColorTable (char *datafile,    /* Nom du fichier a ouvrir */
		    int number,	       /* Numero de la table */
		    char *name,	       /* Pointeur sur le nom de la table */
		    TypeColorDef * type,	/* Type de definition */
		    int *nval,	       /* Nombre de valeurs */
		    int *ncmp);	       /* Nombre de composantes */

extern          TypeError
COL_GetColorValues (char *datafile,    /* Nom du fichier a ouvrir */
		    int number,	       /* Numero de la table */
		    float *values);    /* Valeurs de la table */

extern          TypeError
COL_GetColorDef (TypeColorDef code,    /* code du type de couleurs */
		 char *type);	       /* String correspondant au code */

#ifdef __cplusplus
}
#endif

#endif				       /* _COL_H          */
