
/*
 * Heading of common `ERR'
 * __________________________________________________________________________
 *
 * .NAME
 *
 * ERR - Include publique pour la gestion des
 *
 * .UTILISATION
 * #include "ERR.h"
 *
 * .FONCTIONS
 * ERR_Print_Messag
 * ERR_Get_Number
 * ERR_Get_Messag
 * ERR_Clear_All
 *
 * .ID: Fichier: ERR.h Version: 1.1 Modifie: 93/04/30  CEL-V/DMA/SIE/IG
 *
 * .Auteur: Perros Jean-Pierre (6421)
 * __________________________________________________________________________
 */

#ifndef _ERR_H
#define _ERR_H

#ifdef __cplusplus
extern "C" {
#endif

/***************************************
 * Clefs d'acces aux niveaux d'erreurs *
 ***************************************/
typedef enum
{
   MIN_FATAL = -4,		       /* A partir du niveau FATAL */
   MIN_ERROR = -3,		       /* A partir du niveau ERROR */
   MIN_WARNING = -2,		       /* A partir du niveau WARNING */
   MIN_INFO = -1,		       /* A partir du niveau INFO */
   OK = 0,			       /* Pas d'erreur */
   INFO = 1,			       /* De niveau INFO */
   WARNING = 2,			       /* De niveau WARNING */
   ERROR = 3,			       /* De niveau ERROR */
   FATAL = 4			       /* De niveau FATAL */
} TypeError;

/***********************************************************************
 * Declaration des fonctions publiques, d'acces aux messages d'erreurs *
 ***********************************************************************/

extern int      ERR_Put_Messag (TypeError level, char *messag);
extern int      ERR_Print_Messag (TypeError level);
extern int      ERR_Get_Number (TypeError level);
extern int      ERR_Get_Messag (TypeError level, char **list_messag);
extern int      ERR_Clear_All (void);

#ifdef __cplusplus
}
#endif

#endif				       /* _ERR_H */

/*
 * End of common `ERR'
 */
