#ifndef P4ALEA_H
#define P4ALEA_H

/* @(#)P4alea.h	1.5 10/12/10 Pierre Brochard */

#include <sys/types.h>

#if defined(HP_UX_10) && defined(_INCLUDE_POSIX4_SOURCE)
/* Sinon gcc 2.7.2.1 rale sur un extern struct sigevent ! */
#   include <sys/sigevent.h>
#endif

#include <time.h>

#ifdef CRAY

// *********************************************************
//     version vectorisable
// *********************************************************

extern "C" {double _ranf();};

// Retourne un nombre pseudo aleatoire compris strictement entre 0 et 1

inline double
alea()
{
	return _ranf();
}

// Genere une racine temporelle aleatoire pour les appels suivants a alea

inline void
racinet()
{
	time_t rac = time(NULL);
	unsigned nbturn = rac & 0xff;

        while(nbturn--) alea();

}

#else

// *********************************************************
//     version scalaire
// *********************************************************

double alea();
void racinet();
#endif

// *********************************************************
//     Pour toutes machines
// *********************************************************

// Retourne un nombre pseudo aleatoire compris entre kd et kf ou egal a kd ou kf

inline int
alea(int kd,int kf)
{
	register int ki = int((kf-kd+1)*alea()) + kd;

	return ki > kf ? kf : ki;
}
#endif /* fin P4ALEA_H */
