#ifndef S6STRING_H
#define S6STRING_H

// @(#)S6string.h	1.7 10/12/10 Pierre Brochard

#include <stdio.h>

char* S6strdup(const char* s1);
char* S6strcasedup(const char* s1);

// Classe cas copie du pointeur seul

class S6PString
{

    public:

	S6PString(char* const str = NULL) : _str(str) {};
	~S6PString() {};

	operator char*() const {return _str;};
	operator const char*() const {return _str;};
	S6PString operator = (S6PString s) {_str=s._str;return s;};

    private :

	char* _str;
};

class S6constPString
{
    public :

	S6constPString(const char* const str = NULL) : _str(str)  {};
	~S6constPString() {};

	operator const char*() const {return _str;};
	S6constPString operator = (S6constPString s) {_str=s._str;return s;};

    private :

	const char* _str;
};

// cas copie de la ou des chaines avec alloc new (pas de desalloc automatique)

class S6String
{
    private:

	char* init(const double val) const;
	char* init(const int val) const;
	char* init(const int val,const unsigned tval) const;
	char* init(const char* const str) const;

    public:

	S6String(const char* const str = NULL) {_str = init(str);};
	S6String(const char* const str,const char* const str2)
	{
		const char* const str_temp = str ? str : "";
		const char* const str2_temp = str2 ? str2 : "";
		const size_t lstr = strlen(str_temp);
		const size_t lstr2 = strlen(str2_temp);

		_str = new char[lstr+lstr2+1];

		if(_str)
		{
		    memcpy(_str,str_temp,lstr);
		    memcpy(_str+lstr,str2_temp,lstr2+1);
		}

	};
	S6String(const char* const str,const char* const str2,
			const char* const str3)
	{
		const char* const str_temp = str ? str : "";
		const char* const str2_temp = str2 ? str2 : "";
		const char* const str3_temp = str3 ? str3 : "";
		const size_t lstr = strlen(str_temp);
		const size_t lstr2 = strlen(str2_temp);
		const size_t lstr3 = strlen(str3_temp);

		_str = new char[lstr+lstr2+lstr3+1];

		if(_str)
		{
		    memcpy(_str,str_temp,lstr);
		    memcpy(_str+lstr,str2_temp,lstr2);
		    memcpy(_str+lstr+lstr2,str3_temp,lstr3+1);
		}

	};
	S6String(const char* const str,const char* const str2,
			const char* const str3,const char* const str4)
	{
		const char* const str_temp = str ? str : "";
		const char* const str2_temp = str2 ? str2 : "";
		const char* const str3_temp = str3 ? str3 : "";
		const char* const str4_temp = str4 ? str4 : "";
		const size_t lstr = strlen(str_temp);
		const size_t lstr2 = strlen(str2_temp);
		const size_t lstr3 = strlen(str3_temp);
		const size_t lstr4 = strlen(str4_temp);

		_str = new char[lstr+lstr2+lstr3+lstr4+1];

		if(_str)
		{
		    memcpy(_str,str_temp,lstr);
		    memcpy(_str+lstr,str2_temp,lstr2);
		    memcpy(_str+lstr+lstr2,str3_temp,lstr3);
		    memcpy(_str+lstr+lstr2+lstr3,str4_temp,lstr4+1);
		}

	};
	S6String(const char* const str,const char* const str2,
			const char* const str3,const char* const str4,
			const char* const str5)
	{
		const char* const str_temp = str ? str : "";
		const char* const str2_temp = str2 ? str2 : "";
		const char* const str3_temp = str3 ? str3 : "";
		const char* const str4_temp = str4 ? str4 : "";
		const char* const str5_temp = str5 ? str5 : "";
		const size_t lstr = strlen(str_temp);
		const size_t lstr2 = strlen(str2_temp);
		const size_t lstr3 = strlen(str3_temp);
		const size_t lstr4 = strlen(str4_temp);
		const size_t lstr5 = strlen(str5_temp);

		_str = new char[lstr+lstr2+lstr3+lstr4+lstr5+1];

		if(_str)
		{
		    memcpy(_str,str_temp,lstr);
		    memcpy(_str+lstr,str2_temp,lstr2);
		    memcpy(_str+lstr+lstr2,str3_temp,lstr3);
		    memcpy(_str+lstr+lstr2+lstr3,str4_temp,lstr4);
		    memcpy(_str+lstr+lstr2+lstr3+lstr4,str5_temp,lstr5+1);
		}

	};
	S6String(const char* const str,const char* const str2,
			const char* const str3,const int val,const unsigned tval)
	{
		const char* const str_temp = str ? str : "";
		const char* const str2_temp = str2 ? str2 : "";
		const char* const str3_temp = str3 ? str3 : "";
		const size_t lstr = strlen(str_temp);
		const size_t lstr2 = strlen(str2_temp);
		const size_t lstr3 = strlen(str3_temp);
		char* const str4 = init(val,tval);
		const char* const str4_temp = str4 ? str4 : "";
		const size_t lstr4 = strlen(str4_temp);

		_str = new char[lstr+lstr2+lstr3+lstr4+1];

		if(_str)
		{
		    memcpy(_str,str_temp,lstr);
		    memcpy(_str+lstr,str2_temp,lstr2);
		    memcpy(_str+lstr+lstr2,str3_temp,lstr3);
		    memcpy(_str+lstr+lstr2+lstr3,str4_temp,lstr4+1);
		}

		delete str4;
	};
	S6String(const int val) {_str = init(val);};
	S6String(const unsigned val) {_str = init(int(val));};
	S6String(const REEL val) {_str = init(double(val));};
	~S6String() {};

    // on s'arrete au premier NULL

	void vainit(const char* const str,...);

    // on ne s'arrete pas au premier NULL mais on borne a 128 le nombre
    // de strings sans le dire (nstr est le nombre de strings)

	void vainit(unsigned nstr,const char* const str,...);

    // operateurs

	operator char*() const {return _str;};
	operator const char*() const {return _str;};
	S6String& operator = (const S6String& s)
	{
		delete _str;

		_str = init(s._str);
		return (*this);
	};

    private :

	char* _str;
};

#endif
