#ifndef P4GRAF1_H
#define P4GRAF1_H

// @(#)P4graf1.h	1.6 10/12/10 Pierre Brochard

#include "minotaure/P4graf0.h"

class Hauteurs;

class P4Graf1 : public P4Graf0
{
    protected:

	Hauteurs&  _hauteurs_c;      // hauteurs 4eme tableau
	Hauteurs&  _hauteurs_z;      // hauteurs 3eme tableau
	Hauteurs*  ptr_hauteurs;     // 3 ou 4 actif

    public:

	P4Graf1();
	~P4Graf1();

	int P4Code(REEL x,REEL y,REEL z);
	int P4CorrigeVecteur(REEL& x1,REEL& y1,REEL& z1,REEL& x2,REEL& y2,
			REEL& z2);

	int  P4Color(REEL c) ;

	int  P4Vecteur(REEL x1,REEL y1,REEL z1,REEL x2,REEL y2,REEL z2);
	int  P4VecteurSave(REEL x1,REEL y1,REEL z1,REEL x2,REEL y2,REEL z2,
			const int reuse,REEL& xproj,REEL& yproj,REEL& zproj);
	int  P4VecteurColor(REEL x1,REEL y1,REEL z1,REEL x2,REEL y2,REEL z2,
			int c);
	int  P4VecteurColorSave(REEL x1,REEL y1,REEL z1,REEL x2,REEL y2,REEL z2,
			int c,const int reuse,REEL& xproj,REEL& yproj,
			REEL& zproj);
	int  P4VecteurColor(REEL x1,REEL y1,REEL z1,REEL c1,REEL x2,REEL y2,
			REEL z2,REEL c2);
	int  P4VecteurColorSave(REEL x1,REEL y1,REEL z1,REEL c1,REEL x2,REEL y2,
			REEL z2,REEL c2,const int reuse,REEL& xproj,REEL& yproj,
			REEL& zproj);

	void P4ChoixHauteurs(const Opt34d cz=OPT_4D);

	int P4InitHauteurs(REEL hauteurs[],int couleurs[],
			unsigned nbrehauteurs,Opt34d cz=OPT_4D,
			const P4Boolean logh=FALSE);
#ifndef REQRS
	int P4InitHauteurs(REEL_S hauteurs[],int couleurs[],
			unsigned nbrehauteurs,Opt34d cz=OPT_4D,
			const P4Boolean logh=FALSE);
#endif
	int P4InitHauteurs(REEL_S hauteurs[],unsigned nbrehauteurs,
			Opt34d cz=OPT_4D,unsigned couleurmin=8,
			unsigned couleurmax=62,
			const P4Boolean logh=FALSE);
	int P4InitHauteurs(REEL hmin,REEL hmax,REEL_S z[],int nx,int ny,
			int nz,Opt34d cz=OPT_4D,unsigned nbrehauteurs=54,
			P4Boolean modlog=FALSE,unsigned couleurmin=8,
			unsigned couleurmax=62,P4Boolean logresu = TRUE);

	int P4CalcHauteurs(REEL_S* RESTRICT hauteurs /*[nbrehauteurs]*/,
			const int nbrehauteurs,const REEL_S hmin,
			const REEL_S hmax,
			const REEL_S z[],const int nx,const int ny,
			const int nz,
			const P4Boolean modlog = FALSE);

	int P4LigneBrisee(const REEL_S x,const REEL_S y[],
			const REEL_S z[],const REEL_S c[],
			int npoints,int pas=1) ;
	int P4LigneBrisee(const REEL_S x[],const REEL_S y,
			const REEL_S z[],const REEL_S c[],
			int npoints,int pas=1) ;
	int P4LigneBrisee(const REEL_S x[],const REEL_S y[],
			const REEL_S z[],const REEL_S c[],
			int npoints,int pas=1) ;

	int P4LigneBrisee(const REEL_S x,const REEL_S y[],
			const REEL_S z[],int npoints,int pas=1) ;
	int P4LigneBrisee(const REEL_S x[],const REEL_S y,
			const REEL_S z[],int npoints,int pas=1) ;
	int P4LigneBrisee(const REEL_S x[],const REEL_S y[],
			const REEL_S z[],int npoints,int pas=1) ;

	int P4LigneBrisee(const REEL x[],const REEL y[],
			const REEL z[],const REEL c[],int npoints,
			const unsigned char* tf) ;
	int P4LigneBrisee(const REEL x[],const REEL y[],
			const REEL z[],int npoints,const unsigned char* tf) ;

#ifndef REQRS
	int P4LigneFermee(const REEL_S x[],const REEL_S y[],
			const REEL_S z[],const REEL_S c[],int npoints,
			const unsigned char* tf=NULL) ;
	int P4LigneFermee(const REEL_S x[],const REEL_S y[],
			const REEL_S z[],int npoints) ;
	int P4LigneFermee(const REEL_S x[],const REEL_S y[],
			const REEL_S z[],int npoints,const unsigned char* tf) ;
#endif

	int P4LigneFermee(const REEL x[],const REEL y[],
			const REEL z[],const REEL c[],int npoints,
			const unsigned char* tf=NULL) ;
	int P4LigneFermee(const REEL x[],const REEL y[],
			const REEL z[],int npoints) ;
	int P4LigneFermee(const REEL x[],const REEL y[],
			const REEL z[],int npoints,const unsigned char* tf) ;

#ifndef REQRS
	int P4Polygone(const REEL_S x[],const REEL_S y[],const REEL_S z[],
			int npoints) ;
	int P4Polygone(const REEL_S x[],const REEL_S y[],const REEL_S z[],
			const REEL_S c[],int npoints) ;
#endif
	int P4Polygone(const REEL x[],const REEL y[],const REEL z[],
			int npoints) ;
	int P4Polygone(const REEL x[],const REEL y[],const REEL z[],
			const REEL c[],int npoints) ;

	friend ostream& operator << (ostream& ost,const P4Graf1& p23) ;
};

#endif
