#ifndef NXSYSTEM_H
#define NXSYSTEM_H

/* @(#)nxsystem.h	1.2 10/12/10 Pierre Brochard */

#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/param.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Recuperation utilisateur */

struct passwd* U8GetPasswd(void);

/* Recuperation home de l utilisateur */

#define L_U8GetHome 1024
char* U8GetHome(char* s);

/* Pour les machines qui n ont pas cuserid : */

#if defined(EPIX) && !defined(_SYSTYPE_SVR4)
#   define NX_NOCUSERID
    char* cuserid(char* s);
#endif

/* Recuperation nom de l utilisateur (U8GetUser a preferer a cuserid) */

#if !defined(L_cuserid)
#   define L_cuserid 9 /* defini normalement dans stdio.h mais pas
			  pour SunOS_4 acc-1.0 : */
#endif

/* Modif PB 19/09/2008 : on augmente L_U8GetUser au cas ou. */

#if 64 > L_cuserid
#  define L_U8GetUser 64
#else
#  define L_U8GetUser L_cuserid
#endif

char* U8GetUser(char* s);

/* Recuperation nom de la machine */

#if defined(SUNOS_4) || defined(AIX_3)
    extern int gethostname(char* name,int namelen);
#endif

#if (defined(SUNOS) && !defined(SUNOS_4)) ||\
	(defined(IRIX) && !defined(IRIX_4)) ||\
	(defined(EPIX) && defined(_SYSTYPE_SVR4))
#   include <limits.h>
#   include <sys/systeminfo.h>
#   define gethostname(a,b) sysinfo(SI_HOSTNAME,(a),(b))
#endif

/* gethostname bufferise. */
int U8GetHostname(char* const s,const size_t lg);

/* gethostbyname bufferise. */
struct hostent* U8GetHostbyname(const char* const hostname);

#ifdef __cplusplus
}
#endif

#endif /* NXSYSTEM_H */
