/* @(#)make/defs */
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>

#define NEWLINE '\n'
#define CNULL   '\0'
#define BLANK   ' '
#define TAB     '\t'
#define DOT     '.'
#define WIGGLE  '~'
#define AT      '@'
#define MINUS   '-'
#define UNDERSC '_'
#define EQUALS  '='
#define SLASH   '/'
#define STAR    '*'
#define LCURLY  '{'
#define RCURLY  '}'
#define LPAREN  '('
#define RPAREN  ')'
#define LSQUAR  '['
#define RSQUAR  ']'
#define QUESTN  '?'
#define KOLON   ':'
#define SKOLON  ';'
#define DOLLAR  '$'
#define GREATR  '>'
#define POUND   '#'
#define BACKSLASH       '\\'


/*
 *      Flags
 */

#define ALLOC(x) (struct x *) intalloc((long int) sizeof(struct x))


#define TURNON(a)       (Mflags |= (a))
#define TURNOFF(a)      (Mflags &= (~(a)))
#define IS_ON(a)        (Mflags&(a))
#define IS_OFF(a)       (!(IS_ON(a)))

#define DBUG    0000001         /* debug flag */
#define ENVOVER 0000002         /* environ overides file defines */
#define EXPORT  0000004         /* put current variable in environ */
#define PRTR    0000010         /* set `-p' flag */
#define SIL     0000020         /* set `-s' flag */
#define NOEX    0000040         /* set `-n' flag */
#define INTRULE 0000100         /* use internal rules */
#define TOUCH   0000200         /* set `-t' flag */
#define GET     0000400         /* do a $(GET) if file not found */
#define QUEST   0001000         /* set `-q' flag */
#define INARGS  0002000         /* currently reading cmd args */
#define IGNERR  0004000         /* set `-i' flag */
#define KEEPGO  0010000         /* set `-k' flag */
#define GF_KEEP 0020000         /* keep auto get files */
#define MH_DEP  0040000         /* use old question about whether cmd exists */
#define MEMMAP  0100000         /* print memory map */

typedef char *CHARSTAR;
typedef int  *INTSTAR;

#if defined(IRIX_6)
    typedef time_t TIMETYPE;
#else
    typedef long int TIMETYPE;
#endif

typedef struct gothead *GOTHEAD;
typedef struct gotf *GOTF;
typedef struct chain *CHAIN;
typedef struct opendir *OPENDIR;
typedef struct pattern *PATTERN;
typedef struct varblock *VARBLOCK;
typedef struct shblock *SHBLOCK;
typedef struct depblock *DEPBLOCK;
typedef struct lineblock *LINEBLOCK;
typedef struct nameblock *NAMEBLOCK;

extern CHARSTAR *environ;
extern int Mflags;
extern FILE *fin;
extern CHARSTAR *linesptr;
/*
 *      flags for get()
 */
#define CD      0
#define NOCD    1


#define max(a,b)        ((a)>(b)?(a):(b))
#define SHELLCOM "/bin/sh"

#ifdef unix
/*  to install metering, add a statement like */
/*******
#define METERFILE "/usr/sif/make/Meter"
******/
/* to turn metering on, set external variable meteron to 1 */
#endif

/* define FSTATIC to be static on systems with C compilers
   supporting file-static; otherwise define it to be null
*/
#define FSTATIC static

#define NO 0
#define YES 1

#define equal(a,b)      (a[0] == b[0] ? !strcmp((a),(b)) : NO )
#define any(a,b)        strchr( (a), (b) )
#define HASHSIZE 8093
#define NLEFTS 2048
#define NCHARS 1000
#define NINTS  500
#define INMAX 50000
#define OUTMAX 7500
#define MAXODIR 10
#define MAXKIDS 16

#define ALLDEPS  1
#define SOMEDEPS 2

#define META 01
#define TERMINAL 02
extern char funny[128];

extern int sigivalue;
extern int sigqvalue;
extern int ndocoms;
extern int okdel;
extern CHARSTAR prompt;
extern char junkname[ ];
extern char RELEASE[];

struct nameblock
{
        NAMEBLOCK nextname;             /* pointer to next nameblock */
        NAMEBLOCK backname;             /* pointer to predecessor */
        CHARSTAR namep;         /* ASCII name string */
        CHARSTAR alias;         /* ASCII alias (when namep translates to another
                                 * pathstring.
                                 */
        LINEBLOCK linep; /* pointer to dependents */
        unsigned done:3;  /* flag used to tell when finished */
        unsigned septype:3;     /* distinguishes between single and double : */
        unsigned rundep:1;      /* flag indicating runtime translation done */
        unsigned nohalt:1;      /* flag indicating bad exit status is OK */
        TIMETYPE modtime;       /* set by exists() */
};

extern NAMEBLOCK mainname ;
extern NAMEBLOCK firstname;

struct lineblock
{
        LINEBLOCK nextline;
        DEPBLOCK depp;
        SHBLOCK shp;
};

extern LINEBLOCK sufflist;

struct depblock
{
        DEPBLOCK nextdep;
        NAMEBLOCK depname;
};

struct shblock
{
        SHBLOCK nextsh;
        CHARSTAR shbp;
};

struct varblock
{
        VARBLOCK nextvar;
        CHARSTAR varname;
        CHARSTAR varval;
        unsigned noreset:1;
        unsigned used:1;
        unsigned envflg:1;
        unsigned v_aflg:1;
};

extern VARBLOCK firstvar;

struct pattern
{
        PATTERN nextpattern;
        CHARSTAR patval;
};

extern PATTERN firstpat;

struct  opendir
{
        OPENDIR nextopendir;
        DIR * dirfc;
        CHARSTAR dirn;
};
extern OPENDIR firstod;


struct chain
{
        CHAIN nextchain;
        CHARSTAR datap;
};

/*
 *      The following two structures are used to cleanup after
 *      `make' does an automatic get of a file. See get() and
 *      cleanup().
 */
struct gotf                     /* list of files */
{
        GOTF gnextp;
        CHARSTAR gnamep;
};

struct gothead                  /* first member of list of files */
{
        GOTF gnextp;
        CHARSTAR gnamep;
        GOTF endp;
};


extern int waits;               /* number of entries in... */
extern int maxprocess;          /* number of processes to keep active */
extern struct waiter            /* the child process wait table */
{
        int pid;                /* process ID of child */
        int makeblock;          /* nonzero if 'make' forked itself to do a block */
        NAMEBLOCK p;            /* target implemented by command */
        CHARSTAR cmd;           /* text of forked command */
} waitt [MAXKIDS];

extern NAMEBLOCK dowait();

extern char proceed;            /* stop if ever set to zero */
extern char Nullstr[];
extern CHARSTAR badptr;

CHARSTAR copys();
CHARSTAR copstr();
CHARSTAR concat();
CHARSTAR colontrans();
CHARSTAR dftrans();
CHARSTAR straightrans();
CHARSTAR mkqlist();
CHARSTAR findfl();
CHARSTAR addstars();
CHARSTAR strshift();
CHARSTAR  intalloc();
VARBLOCK varptr();
VARBLOCK srchvar();
TIMETYPE prestime(), exists();
DEPBLOCK srchdir();
NAMEBLOCK srchname(), makename();
CHARSTAR strrchr();
CHARSTAR strchr();
CHARSTAR sdot();
CHARSTAR trysccs();

