#
# Macros par defaut pour l'architecture Linux_2__ix86
#
MAKE        = make -k
ATLAS_EXTRACT_INCLUDE = \
	$(PROJECT_HOME)/cfg/.Atlas/Makefiles/Reference_Public_Includes_GNU.mk
MKDEP_ACTION = cd $(LST);$(TOUCH) $%;$(AR) r $(LIBAR) $%
ARR         = $(AR) r $(LIBAR) *.o;$(AR) x $(LIBAR);\
                for fic in `ls *.o 2> /dev/null` ; do\
                  if [ "`cat $$fic|wc -c`" -eq "0" ] ;then\
                    $(RM) $$fic;fi;done;\
                $(RM) $(LIBAR);$(AR) r

XPARAL = -mfpmath=sse -msse2 -march=nocona -fomit-frame-pointer -funroll-loops \
		-Winline -ftree-vectorize -ftree-vectorizer-verbose=5 -DXPARA \
		-DXSSE2 -DXMEMORY

CC          = gcc -ansi -D_BSD_SOURCE -D_POSIX_SOURCE -DLINUX -DLINUX_2 \
		$(XPARAL) $(CFLAGS) $(MCFLAGS_LINUX_2__IX86) \
		-I/usr/lib/gcc-lib/linux-i486/2.7.2/include -I/usr/include
CC++        = g++ -DLINUX -DLINUX_2 -DS6FRANCAIS $(XPARAL) $(C++FLAGS) \
		$(MC++FLAGS_LINUX_2__IX86) -I/usr/lib/g++-include \
		-I/usr/lib/gcc-lib/linux-i486/2.7.2/include -I/usr/include
CPP         = /lib/cpp -P -DLINUX -DLINUX_2 -DNDEBUG \
		$(MCPPFLAGS_LINUX_2__IX86)
FC          = f2c -DLINUX -DLINUX_2 $(XPARAL) $(FFLAGS) \
		$(MFFLAGS_LINUX_2__IX86)
LD          = g++ -v $(XPARAL) $(LDFLAGS) $(MLDFLAGS_LINUX_2__IX86)

#LIBMOTIF    = -L/usr/local/lesstif/lib -lMrm -lXm
LIBMOTIF    = -L/usr/Moo-Tiff/lib -lMrm -lXm -lXp
#LIBMOTIF    = /usr/Moo-Tiff/lib/libMrm.a /usr/Moo-Tiff/lib/libXm.a
LIBXTK      = -L/usr/X11R6/lib -lXpm -lXt -lXaw -lXmu -lXext -lX11
LIBGRA      =

#INCMOTIF    = /usr/local/lesstif/include
INCMOTIF    = /usr/Moo-Tiff/include
INCSAN      = $(PROJECT_HOME)/src/sanglier/.include
INCSANP     = $(PROJECT_HOME)/src/sanglier/.include
INCSANESP   = $(MODIF_HOME)/src/sanglier

ADDLIBMAC   = -lm
ADDLIBMACFTN = -lf2c

LIBMOD      = $(LIBMOD_LINUX_2__IX86)
LIBPROJ     = $(LIBRAIRIES)/libnx.a $(LIBRAIRIES)/libsanglier.a
LIBFOR      = $(LIBFOR_LINUX_2__IX86)
