#
# Makefile servant a fabriquer un executable a partir d un main donne
# make doit etre execute depuis le repertoire
# ou sont situes le main et la makefile
#
# Version originale : par Pierre Brochard : CEA/DAM-Ile de France
#
# sccs_ID           : Examples.mk 1.8 23/01/13
#
#
# utilisation courante : make EXAMPLE=nom_exe 
# On lance un Bourne-shell
#
SHELL = /bin/sh

include ../../cfg/machines/Default_Options.mk
include $(ATLAS_HOME)/resources/Global_Macros.mk
include $(PROJECT_HOME)/cfg/machines/Global_Macros.mk
include $(PROJECT_HOME)/cfg/machines/$(ARCH)/macros.mk
include $(PROJECT_HOME)/cfg/machines/$(ARCH)/options$(OPT).mk
include .special_options.mk

PROJECTCFG = $(PROJECT_HOME)/cfg
LIBRAIRIES = $(PROJECT_HOME)/lib/$(ARCH)/$(OPT)
INCLUDES   = -I$(PROJECT_HOME)/src/$(COMPOS)/.include \
		-I$(PROJECT_HOME)/src/include
EXEDIR     = ../../exe/$(ARCH)/$(OPT)
LIBDIR     = ../../lib/$(ARCH)/$(OPT)
EXE        = bid
EXEF       = bidf

debut:
	@$(MAKE) template
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	IWD=`pwd`;if [ -f $(EXAMPLE).c ] ;then \
          $(MAKE) link clean EXEF="bid" EXE="$(EXEDIR)/$(EXAMPLE)" \
              SRC="$(EXAMPLE).c" COMP="$(CC)" LCOMP="$(LD)"; \
        elif [ -f $(EXAMPLE).C ] ;then \
          $(MAKE) link clean EXEF="bid" EXE="$(EXEDIR)/$(EXAMPLE)" \
             SRC="$(EXAMPLE).C" COMP="$(CC++)" LCOMP="$(LD)"; \
        elif [ -f $(EXAMPLE).f ] ;then \
          $(MAKE) linkf clean EXE="bid" EXEF="$(EXEDIR)/$(EXAMPLE)" \
             SRC="$(EXAMPLE).f" LCOMP="$(LDF)"; \
        fi

strip:
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	[ "$(OPT)" != DBG -a -x $(EXEDIR)/$(EXAMPLE) ] && \
		$${NPREFIX}$(STRIP) $(EXEDIR)/$(EXAMPLE) || true;\
	[ "$(OPT)" != DBG -a -x $(LIBDIR)/$(EXAMPLE).so ] && \
		$${NPREFIX}$(STRIP) $(LIBDIR)/$(EXAMPLE).so || true

libdyna:
	@$(MAKE) template
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	IWD=`pwd`;if [ -f $(EXAMPLE).c ] ;then \
          $(MAKE) link clean EXEDIR="$(LIBDIR)" EXEF="bid" \
		EXE="$(LIBDIR)/$(EXAMPLE).so" SRC="`ls *.c|tr '\012' ' '`" \
		COMP="$(CC)" LCOMP="$(LDY)"; \
        elif [ -f $(EXAMPLE).C ] ;then \
          $(MAKE) link clean EXEDIR="$(LIBDIR)" EXEF="bid" \
		EXE="$(LIBDIR)/$(EXAMPLE).so" SRC="`ls *.C|tr '\012' ' '`" \
		COMP="$(CC++)" LCOMP="$(LDY)"; \
        elif [ -f $(EXAMPLE).f ] ;then \
          $(MAKE) linkf clean EXEDIR="$(LIBDIR)" EXE="bid" \
		EXEF="$(LIBDIR)/$(EXAMPLE).so" SRC="`ls *.f|tr '\012' ' '`" \
		LCOMP="$(LDY)"; \
        fi;\
	if [ -f $(EXAMPLE).sce -a -f $(LIBDIR)/$(EXAMPLE).so ] ;then \
	  cp $(EXAMPLE).sce $(LIBDIR);fi

link:
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	$(MAKE) $(EXE)

linkf:
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	$(MAKE) $(EXEF)

clean:
	@cd $(EXEDIR);$(RM) *.o;$(RM) $(EXAMPLE).[cCf]

mrproper:
	@cd $(EXEDIR);$(RM) *.o;$(RM) $(EXEDIR)/$(EXAMPLE)

$(EXE) : $(SRC) $(LIB) $(LIBS) $(LIBMODDEP)
	@echo "---> compilation de : $(SRC)"
	@cd $(EXEDIR);$(RM) *.o;$(RM) $(SRC)
	@cp $(SRC) $(EXEDIR)
	@chmod u+w $(EXEDIR)/*.[cC]
	@IWD=`pwd`;cd $(EXEDIR);for fic in $(SRC);\
           do echo $$fic;$(NPREFIX)$(COMP) -I$$IWD -I$$IWD/../../src/include \
              $(ALL_INCLUDES) -c $$fic;done
	@echo "---> link de : $@"
	@$(RM) $(EXE)
	-@IWD=`pwd`;$(MAKEMODEXASUP)
	@IWD=`pwd`;cd $(EXEDIR);$(NPREFIX)$(LCOMP) -o $$IWD/$(EXE) *.o $(LIBMOD) \
           $(LIBS) $(ADDLIB)

$(EXEF) : $(SRC) $(LIB) $(LIBS) $(LIBMODDEP)
	@echo "---> compilation de : $(SRC)"
	@cd $(EXEDIR); $(RM) *.o; $(RM) $(SRC)
	@cp $(SRC) $(EXEDIR)
	@chmod u+w $(EXEDIR)/*.f
	@$(RM) $(EXEDIR)/$(SRC)
	@IWD=`pwd`;for fic in $(SRC);\
           do $(CPP) -I$$IWD -I$$IWD/../../src/include $(ALL_INCLUDES) \
              $$fic > $(EXEDIR)/$$fic; done
	@IWD=`pwd`;cd $(EXEDIR);for fic in $(SRC);\
           do echo $$fic;$(FC) -c $$fic;done
	@echo "---> link de : $@"
	@$(RM) $(EXEF)
	-@IWD=`pwd`;$(MAKEMODEXASUP)
	@IWD=`pwd`;cd $(EXEDIR);\
	   $(NPREFIX)$(LCOMP) -o $$IWD/$(EXEF) *.o $(LIBMOD) \
           $(LIBS) $(ADDLIB) $(LIBFOR)

template :
	@echo "---> init pour template C++ :"
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;IWD=`pwd`;\
          if [ "$(ARCH)" = "SunOS_5__sun4" ] ;then \
            if [ -d $$IWD/../../exe/$(ARCH) ] ; then \
              if [ ! -d $$IWD/../../exe/$(ARCH)/$(OPT) ] ; then \
                mkdir $$IWD/../../exe/$(ARCH)/$(OPT); \
              fi; \
              if [ ! -d $$IWD/../../exe/$(ARCH)/$(OPT)/Templates.DB ] ; then \
                mkdir $$IWD/../../exe/$(ARCH)/$(OPT)/Templates.DB; \
              else \
                $(RM) -r $$IWD/../../exe/$(ARCH)/$(OPT)/Templates.DB/*; \
              fi; \
              cp $$IWD/../../cfg/machines/$(ARCH)/Template.opt \
                $$IWD/../../exe/$(ARCH)/$(OPT)/Templates.DB/Template.opt; \
              echo "cfg/machines/$(ARCH)/Template.opt copie"; \
            else \
              echo "erreur : espace remote non installe ou make " \
                   "newlib non fait"; \
            fi; \
          elif [ "$(ARCH)" = "IRIX_5__sgi4d" ] ;then \
            if [ -d $$IWD/../../exe/$(ARCH) ] ; then \
              if [ ! -d $$IWD/../../exe/$(ARCH)/$(OPT) ] ; then \
                mkdir $$IWD/../../exe/$(ARCH)/$(OPT); \
              fi; \
              if [ -d $$IWD/../../exe/$(ARCH)/$(OPT)/Templates.DB ] ; then \
                $(RM) $$IWD/../../exe/$(ARCH)/$(OPT)/Templates.DB/*; \
              fi; \
            else \
              echo "erreur : espace remote non installe ou make " \
                   "newlib non fait"; \
            fi; \
          fi
