#
# Makefile servant a fabriquer la composante $(COMPOS)
# dans l'espace de Modification
# make doit etre execute depuis le repertoire $(COMPOS)
#
# Version originale : Projet OURANOS
#
# Modifie par Pierre Brochard : CEA/DAM-Ile de France de 1992 a 2000
#
# sccs_ID           : $ 1.12 23/01/08
#

# On lance un Bourne-shell
SHELL = /bin/sh
PROJECT_PWD = .

include $(MODIF_HOME)/cfg/machines/Default_Options.mk
include $(ATLAS_HOME)/resources/Global_Macros.mk
include $(PROJECT_HOME)/cfg/machines/Global_Macros.mk
include $(PROJECT_HOME)/cfg/machines/$(ARCH)/macros.mk
include $(PROJECT_HOME)/cfg/machines/$(ARCH)/options$(OPT).mk
include $(PROJECT_PWD)/.special_options.mk

# INCLUDES peut etre ou non ajoute a SPECIAL_INCLUDES des .special_options.mk
# ALL_INCLUDES reprend tous les includes
# TEMPLATE_INCLUDES contient les definitions des templates C++ (.C de meme nom
# que les .h contenant les declarations)
# TEMPLATE_DIR est la racine du repertoire servant a instancier les
# templates (Templates.DB sur SUN par exemple). 
# LIBRAIRIES est le chemin des librairies de l'espace de reference. 

PROJECTCFG = $(PROJECT_HOME)/cfg
LIBRAIRIES = $(PROJECT_HOME)/lib/$(ARCH)/$(OPT)
INCLUDES   =
ALL_INCLUDES = -I$(MODIF_HOME)/src/$(COMPOS) -I$(MODIF_HOME)/src/include \
		$(SPECIAL_INCLUDES)
TEMPLATE_INCLUDES = -I$(MODIF_HOME)/src/include/templates
TEMPLATE_DIR = $(MODIF_HOME)/lib/$(ARCH)/$(OPT)/$(COMPOS)
EXE        = ../../exe/$(ARCH)/$(OPT)/$(COMPOS)
LIB        = ../../lib/$(ARCH)/$(OPT)/lib$(COMPOS).a
LIBDIR     = ../../lib/$(ARCH)/$(OPT)
LIBAR      = ../lib$(COMPOS).a
LST        = ../../lib/$(ARCH)/$(OPT)/$(COMPOS)
LIBO       = ../lib$(COMPOS).a
LIBC       = $(LST)/.objc.a
LIBC++     = $(LST)/.objc++.a
LIBF       = $(LST)/.objf.a
LIBY       = $(LST)/.objy.a
FDEPA      = .depend

.f.a :;
.c.a :;
.C.a :;
.y.a :;

debut:
	@$(MAKE) init
	-@$(MAKE) template
# Generation d'une makefile contenant les dependances C, C++ et F77
	@IWD=`pwd`;cd $(LST);$(TOUCH) $(FDEPA);$(RM) *.[oycCf] xx;\
	  cat $$IWD/makefile $(FDEPA) > xx
# Lancement recursif de make sur l'ensemble des fichiers C de la 
# composante pour compilation
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ "`ls *.c 2> /dev/null|wc -c`" -ne "0" ] ;then \
          $(MAKE) $(LIBC) PROJECT_PWD=`pwd` OBJECTS="`ls *.c 2> /dev/null|\
          grep -v main.c | sed 's+^+$(LIB)\(+;s+\.c$$+\.o\)+'|\
          tr '\012' ' '`" -f $(LST)/xx;fi
# Lancement recursif de make sur l'ensemble des fichiers C++ de la 
# composante pour compilation
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ "`ls *.C 2> /dev/null|wc -c`" -ne "0" ] ;then \
          $(MAKE) $(LIBC++) PROJECT_PWD=`pwd` OBJECTS="`ls *.C 2> /dev/null|\
           grep -v main.C | sed 's+^+$(LIB)\(+;s+\.C$$+\.o\)+'|\
           tr '\012' ' '`" -f $(LST)/xx;fi
# Lancement recursif de make sur l'ensemble des fichiers F77 de la composante 
# pour compilation
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ "`ls *.f 2> /dev/null|wc -c`" -ne "0" ] ;then \
          $(MAKE) $(LIBF) PROJECT_PWD=`pwd` OBJECTS="`ls *.f 2> /dev/null|\
          grep -v main.f | sed 's+^+$(LIB)\(+;s+\.f$$+\.o\)+'|\
          tr '\012' ' '`" -f $(LST)/xx;fi
# Lancement recursif de make sur l'ensemble des fichiers yacc de la composante 
# pour compilation
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ "`ls *.y 2> /dev/null|wc -c`" -ne "0" ] ;then \
          $(MAKE) $(LIBY) PROJECT_PWD=`pwd` OBJECTS="`ls *.y 2> /dev/null|\
          grep -v main.y | sed 's+^+$(LIB)\(+;s+\.y$$+\.o\)+'|\
          tr '\012' ' '`" -f $(LST)/xx;fi
# Stockage des .o dans la librarie
	@$(MAKE) ranlib

# Indication a make du caractere "precieux" des bibliotheques
# (il ne les detruit pas en cas de probleme)
# Mis apres debut sinon pb avec le make OSF1
.PRECIOUS : $(LIB) $(LIBC) $(LIBC++) $(LIBF) $(LIBY)

lib:
	@$(MAKE) debut
	@$(MAKE) otemain

load:
	@$(MAKE) debut
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ -f main.[cCf] ] ;then \
	$(MAKE) $(EXE) SRC=`ls main.[cCf] 2> /dev/null`;fi

link:
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ -f main.[cCf] ] ;then \
	$(MAKE) init;$(MAKE) $(EXE) SRC=`ls main.[cCf] 2> /dev/null`;fi

otemain :
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ -f $(LIB) -a "`$${NPREFIX}$(AR) t $(LIB) | \
		grep '^main.o$$' | wc -l`" -eq 1 ] ;then\
           $${NPREFIX}$(AR) d $(LIB) main.o;$(TOUCH) -c $(LIB);$(RANLIB) $(LIB);\
           echo "---> make otemain : main enleve";\
         else\
           echo "---> make otemain : pas de main trouve";\
         fi

$(EXE) : $(LIB) $(LIBS) $(LIBMODDEP) $(SRC)
	@echo "---> link de : $@"
	-@$(RMEXE)
	@IWD=`pwd`;cd $(LST);$(RM) __* *.[oycCf];\
          if [ -f $$IWD/$(LIB) ] ;then $(AR) x $$IWD/$(LIB);fi
	-@IWD=`pwd`;$(MAKEMODEXESUP)
	-@IWD=`pwd`;cd $(LST);if [ ! -f main.o ];then\
            echo "Fabrication du main";$(RM) main.[cCf];\
	    cp $$IWD/main.[cCf] .;\
            if [ -f main.f ] ;then\
              $(CPP) $(ALL_INCLUDES) main.f > main.f.temp;\
              $(RM) main.f;mv -f main.f.temp main.f;\
              $(FC) -c main.f;\
            elif [ -f main.c ] ;then\
              $(CC) $(ALL_INCLUDES) -c main.c;\
            elif [ -f main.C ] ;then\
              $(CC++) $(ALL_INCLUDES) -c main.C;\
            fi;\
          fi;\
          if [ -f main.o ];then\
            $(LD) -o $$IWD/$(EXE) *.o $(LIBMOD) $(LIBS) $(ADDLIB);\
            $(TOUCH) -c $$IWD/$(EXE);\
          else\
            echo "Executable non genere car pas de main.o";\
          fi
	@cd $(LST);$(RM) *.[oycCf]

$(LIBC) : $(OBJECTS)
	@echo "---> compilation de : $(?:.o=.c)"
	@cd $(LST);$(RM) $(?:.o=.c)
	@cp $(?:.o=.c) $(LST)
	@IWD=`pwd`;cd $(LST);chmod ug+rw `ls *.c 2> /dev/null`;\
         if [ -x $(MKDEP) ] ;then \
           $(MKDEP) $(ALL_INCLUDES) -L'$$(LIB)' -f $(FDEPA) $(?:.o=.c);\
         fi
	-@IWD=`pwd`;cd $(LST);\
          for fic in $(?:.o=.c);do \
            echo $$fic;$(CC) $(ALL_INCLUDES) -c $$fic;done;$(TOUCH) -c $?

$(LIBC++) : $(OBJECTS)
	@echo "---> compilation de : $(?:.o=.C)"
	@cd $(LST);$(RM) $(?:.o=.C)
	@cp $(?:.o=.C) $(LST)
	@IWD=`pwd`;cd $(LST); chmod ug+rw `ls *.C 2> /dev/null`;\
         if [ -x $(MKDEP) ] ;then \
           $(MKDEP) $(ALL_INCLUDES) -L'$$(LIB)' -f $(FDEPA) $(?:.o=.C);\
         fi
	-@IWD=`pwd`;cd $(LST);\
          for fic in $(?:.o=.C);do \
            echo $$fic;$(CC++) $(ALL_INCLUDES) -c $$fic;done;$(TOUCH) -c $?

$(LIBF) : $(OBJECTS)
	@echo "---> compilation de : $(?:.o=.f)"
	@cd $(LST);$(RM) $(?:.o=.f)
	@cp $(?:.o=.f) $(LST)
	@IWD=`pwd`;cd $(LST);chmod ug+rw `ls *.f 2> /dev/null`;\
         if [ -x $(MKDEP) ] ;then \
           $(MKDEP) $(ALL_INCLUDES) -L'$$(LIB)' -f $(FDEPA) $(?:.o=.f);\
         fi
	@cd $(LST);
	@IWD=`pwd`;cd $(LST);for fic in $(?:.o=.f);do \
             $(CPP) $(ALL_INCLUDES) $$fic > $${fic}.temp;\
             $(RM) $$fic;mv -f $${fic}.temp $$fic;\
             $(FC) -c $$fic;\
           done;$(TOUCH) -c $?

$(LIBY) : $(OBJECTS)
	@echo "---> compilation de : $(?:.o=.y)"
	@cd $(LST);$(RM) $(?:.o=.y)
	@cp $(?:.o=.y) $(LST)
	@IWD=`pwd`;cd $(LST);chmod ug+rw `ls *.y 2> /dev/null`;\
         if [ -x $(MKDEP) ] ;then \
           $(MKDEP) $(ALL_INCLUDES) -L'$$(LIB)' -f $(FDEPA) $(?:.o=.y);\
         fi
	@cd $(LST);
	@IWD=`pwd`;cd $(LST);for fic in $(?:.o=.y);do \
             $(RM) y.tab.c;$(AYACC) $$fic;ficc="`basename $$fic .y`.c";\
             $(RM) $$ficc;mv -f y.tab.c $$ficc;\
             $(CC) $(ALL_INCLUDES) -c $$ficc;done;$(TOUCH) -c $?

# creation de la composante dans l'espace de modifications
# sans destruction de fichiers sources ou importants
# Sur la machine et dans les repertoires objets specifies
# dans cfg/machines/$ARCH/remote_project.sh
# MACHCOMP et DIRCOMP sont variables shell d'environnement facultatives
# permettant de modifie cette machine et ce repertoire destine aux objets
# (binaires + librairies + objets)
create :
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	echo "---> appel de make create";cd ../..;\
        if [ "$(ATLAS_HOME)" != "" ] ;then\
          if [ "`printenv PATH | grep $ATLAS_HOME/bin`" = "" ] ;then\
            PATH=${ATLAS_HOME}/bin:`printenv PATH`;export PATH;\
          fi;\
          create_modification_space;\
          PARAMETER_FILE=cfg/machines/$(ARCH)/remote_project.sh;\
          if [ -f $$PARAMETER_FILE ] ;then\
            . $$PARAMETER_FILE;\
          fi;\
          if [ "$(MACHCOMP)" != "" ] ;then\
            if [ "$(MACHCOMP)" = "NONE" ] ;then\
              REMOTE_MACH=;\
            else\
              REMOTE_MACH=$(MACHCOMP);\
            fi;\
          fi;\
          if [ -z "$$REMOTE_MACH" ] ;then\
            REMOTE_MACH="`atlas_name`";\
          fi;\
          if [ "$(DIRCOMP)" != "" ] ;then\
            if [ "$(DIRCOMP)" = "NONE" ] ;then\
              REMOTE_DIR=;\
            else\
              REMOTE_DIR=$(DIRCOMP);\
            fi;\
          fi;\
          create_remote_modification_space $(ARCH) $$REMOTE_MACH $$REMOTE_DIR;\
          create_component_in_modification_space $(COMPOS);\
        else\
          echo "Attention : ATLAS_HOME n'est pas defini : ";\
          echo "make create non fait";\
        fi
	@for DIR in ../../exe \
                  ../../exe/$(ARCH) \
                  ../../exe/$(ARCH)/$(OPT) \
                  ../../lib \
                  ../../lib/$(ARCH) \
                  ../../lib/$(ARCH)/$(OPT) \
                  ../../lib/$(ARCH)/$(OPT)/$(COMPOS);\
          do\
            if [ ! -d $$DIR ] ;then\
              mkdir $$DIR; chmod g+w $$DIR;\
              echo "---> creation de $$DIR";\
            fi\
          done
	-@$(RM) $(LIBC) $(LIBC++) $(LIBF) $(LIBY)
	@$(LN) $(LIBO) $(LIBC);$(LN) $(LIBO) $(LIBC++);\
	 $(LN) $(LIBO) $(LIBF);$(LN) $(LIBO) $(LIBY)

newlib :
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	echo "---> appel de make newlib";TESTLIB=GOOD;\
          for DIR in ../../exe \
                  ../../exe/$(ARCH) \
                  ../../exe/$(ARCH)/$(OPT) \
                  ../../lib \
                  ../../lib/$(ARCH) \
                  ../../lib/$(ARCH)/$(OPT) \
                  ../../lib/$(ARCH)/$(OPT)/$(COMPOS);\
          do\
            if [ ! -d $$DIR ] ;then\
              TESTLIB=BAD;\
            fi\
          done;\
          if [ "$$TESTLIB" = "BAD" -o ! -d $(LST) ] ;then\
            $(MAKE) create MACHCOMP=NONE;\
          fi
	@$(RM) $(LIB) $(LST)/$(FDEPA) $(LST)/$(FDEPA)[fc]
	@$(TOUCH) $(LST)/$(FDEPA)
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	  IWD=`pwd`;cd $(LST);echo "void atlas_ar_bidon(){}" > xyz.c;\
	  $${NPREFIX}$(CC) -c xyz.c;\
	  $${NPREFIX}$(AR) r $$IWD/$(LIB) xyz.o;\
	  $${NPREFIX}$(AR) d $$IWD/$(LIB) xyz.o;\
          $(TOUCH) -c $$IWD/$(LIB);$(RANLIB) $$IWD/$(LIB);$(RM) xyz.*
	@$(MAKE) clean
	-@$(MAKE) depend
	-@$(MAKE) template

depend :
	@echo "---> appel de make depend"
	-@if [ "`ls *.[cfyC] 2> /dev/null`" != "" ] ;then \
           $(RM) $(LST)/*.[cfyC];cp *.[cfyC] $(LST);\
           chmod ug+w $(LST)/*.[cfyC];fi
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	IWD=`pwd`;cd $(LST);$(RM) $(FDEPA);$(TOUCH) $(FDEPA);\
	if [ -x $(MKDEP) ] ;then \
          if [ "`ls *.[cyfC] 2> /dev/null`" != "" ] ;then \
            $(MKDEP) $(ALL_INCLUDES) -L'$$(LIB)' -f $(FDEPA) `ls *.[cfyC]`;\
          fi;\
        else \
	  for f in `ls *.[cfyC] 2> /dev/null` ; do\
	    echo "`echo $$f 2> /dev/null |\
              sed 's+^+# +'|tr -d '\012'`" >> $(FDEPA);\
	    echo "`echo $$f 2> /dev/null |\
              sed 's+^+$$\(LIB\)(+;s+\.[cfyC]$$+.o)+'|\
              tr -d '\012'` : $$f" >> $(FDEPA);\
            echo '	@$$(MKDEP_ACTION)' >> $(FDEPA);\
	  done;\
	  if [ "$(COMPOS)" != mkdep ] ;then\
            echo "********** Attention : pas de mkdep **********";fi;\
	fi

clean :
	-@$(RM) $(LST)/*.[oycCf] $(LST)/xx;$(RMEXE)

mrproper :
	-@$(RM) $(LST)/*.[oycCf] $(LST)/xx;$(RMEXE)
	-@$(RM) -rf $(LST) $(LIB)

# recuperation des include publics utilises par la composante $(COMPOS)
recuph :
	@$(RM) /tmp/recup.mk
	-@for fic in `ls *.[cCf]`; \
	  do grep 'include[ ]*\"' $$fic >> /tmp/recup.mk; done
	@eval "`sort -u /tmp/recup.mk | sed 's+\#include[ ]*\"+$(GET) \
          $(PROJECT_HOME)/src/include/SCCS/s.+;s+\"$$+;+'`"

init :
	@echo "---> Traitement de la composante $(COMPOS)"
# Initialisation des repertoires de travail et des fichiers de dependances
	@if [ ! -d $(LST) -o ! -f $(LIB) -o ! -f $(LIBC) -o \
           ! -f $(LIBC++) -o ! -f $(LIBF) -o ! -f $(LIBY) -o \
           ! -d ../../exe/$(ARCH)/$(OPT) -o \
           ! -d ../../lib/$(ARCH)/$(OPT) -o \
           "`echo \`cat $(LIB) 2>/dev/null| wc -c\``" -eq "0" ] ;then\
             $(MAKE) create;\
         else \
             $(MAKE) depend;\
         fi
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ "X$$XHOST" != "X" -a "X$$XCROSS" != "X" ] ;then \
	  if [ ! -d $(LIBRAIRIES) ] ; then \
	    mkdir -p $(LIBRAIRIES);fi;\
	  echo "---> Copie des libs de cross compilation";\
          for j in `cat $(PROJECTCFG)/Lcross` ;do \
	    i=`basename $$j`;subd=`dirname $$j`;\
	    [ "$$subd" = '.' ] && subd= || subd="/$$subd";\
	    [ ! -d $(LIBRAIRIES)$$subd ] && mkdir $(LIBRAIRIES)$$subd || true;\
	    if [ "$$XCROSSLIB" = yes -o ! -f $(LIBRAIRIES)$$subd/$$i ] ;then \
	      HOMECROSS=$$XCROSS/$$XHOST/$$XHOST;\
	      if [ -f $$HOMECROSS/lib*/$${i} ] ;then \
		echo "       - $$i copiee";\
	      	cp -af $$HOMECROSS/lib*/$${i} $(LIBRAIRIES)$$subd;\
		CRLIB=$(LIBRAIRIES)$$subd/$${i};\
		OTDLIB=`ls $$HOMECROSS/lib*/$${i}*[0-9] 2> /dev/null|tail -1`;\
		[ -f "$$OTDLIB" ] && \
	      	  cp -af $$HOMECROSS/lib*/$${i}*[0-9] $(LIBRAIRIES)$$subd;\
	        TDLIB=`ls $(LIBRAIRIES)$$subd/$${i}*[0-9] 2> /dev/null|tail -1`;\
	        if [ ! -h "$$TDLIB" -a -f "$$TDLIB" ] ;then \
		  if [ "$(OPT)" != DBG ] ; then \
	            cp -a "$$TDLIB" "$${TDLIB}.temp";\
		    $${NPREFIX}$(STRIP) "$${TDLIB}.temp";\
	            mv "$${TDLIB}.temp" "$$TDLIB";fi;\
		elif [ ! -h "$$CRLIB" -a -f "$$CRLIB" ] ;then \
		  chmod u+w "$${CRLIB}";\
	          cp -a "$$CRLIB" "$${CRLIB}.temp";\
		  chmod u+w "$${CRLIB}.temp";\
		  $${NPREFIX}$(STRIP) "$${CRLIB}.temp";\
	          mv "$${CRLIB}.temp" "$$CRLIB";fi;\
		fi;fi;done;fi

strip :
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	[ "$(OPT)" != DBG ] && $${NPREFIX}$(STRIP) $(EXE) || true

libdyna :
	@echo "---> creation lib dynamique :"
	@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	IWD=`pwd`;cd $(LST);\
          if [ "$${NPREFIX}$(LDY)" != "" ] ;then\
            if [ -f $$IWD/$(LIB) ] ;then\
              $${NPREFIX}$(AR) xv $$IWD/$(LIB);\
              $${NPREFIX}$(LDY) -o lib$(COMPOS)$(LDYSUFF) *.o;\
              mv lib$(COMPOS)$(LDYSUFF) $$IWD/$(LIBDIR);\
	      [ "$(OPT)" != DBG ] && \
		$${NPREFIX}$(STRIP) $$IWD/$(LIBDIR)/lib$(COMPOS)$(LDYSUFF);\
	      $(RM) *.o;\
            fi;\
          else \
            echo "Error : lib non cree : ";\
            echo "definissez LDY et LDYSUFF dans "\
                 "cfg/machines/$(ARCH)/macros.mk";\
	  fi

template :
	@echo "---> init pour template C++ :";IWD=`pwd`;\
         XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	 cd ../include/templates;$(RM) *;$(LN) ../*/*.C .;cd $$IWD;\
         $(TEMPLATE_ACT)

partiel :
#
# usage : make partiel SRC=liste de fichiers *.c *.C *.f *.y
#
	@$(MAKE) init
	-@$(MAKE) template
	@IWD=`pwd`;cd $(LST);$(TOUCH) $(FDEPA);$(RM) *.[oycCf] xx;\
         cat $$IWD/makefile $(FDEPA) > xx
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ "`ls *.c 2> /dev/null|wc -c`" -ne "0" ] ;then \
          $(MAKE) $(LIBC) PROJECT_PWD=`pwd` OBJECTS="`echo $(SRC) |\
          tr ' ' '\012' | sed 's+^+$(LIB)\(+;s+\.c$$+\.o\)+;s+^.*\.[Cfy]$$++'|\
          tr '\012' ' '`" -f $(LST)/xx;fi
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ "`ls *.C 2> /dev/null|wc -c`" -ne "0" ] ;then \
          $(MAKE) $(LIBC++) PROJECT_PWD=`pwd` OBJECTS="`echo $(SRC) |\
          tr ' ' '\012' | sed 's+^+$(LIB)\(+;s+\.C$$+\.o\)+;s+^.*\.[cfy]$$++'|\
          tr '\012' ' '`" -f $(LST)/xx;fi
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ "`ls *.f 2> /dev/null|wc -c`" -ne "0" ] ;then \
          $(MAKE) $(LIBF) PROJECT_PWD=`pwd` OBJECTS="`echo $(SRC) |\
          tr ' ' '\012' |sed 's+^+$(LIB)\(+;s+\.f$$+\.o\)+;s+^.*\.[cCy]$$++'|\
          tr '\012' ' '`" -f $(LST)/xx;fi
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	if [ "`ls *.y 2> /dev/null|wc -c`" -ne "0" ] ;then \
          $(MAKE) $(LIBY) PROJECT_PWD=`pwd` OBJECTS="`echo $(SRC) |\
          tr ' ' '\012' |sed 's+^+$(LIB)\(+;s+\.y$$+\.o\)+;s+^.*\.[cCf]$$++'|\
          tr '\012' ' '`" -f $(LST)/xx;fi
	@$(MAKE) ranlib

ranlib :
	-@XCOMP=yes;export XCOMP;. $(PROJECTCFG)/profile;\
	IWD=`pwd`;cd $(LST);\
          if [ "$(NOTESTO)" = "YES" -o "`ls *.o 2> /dev/null`" != "" ] ;then\
            $${NPREFIX}$(ARR) $(LIBAR) *.o;cd $$IWD;$(TOUCH) -c $(LIB);\
	    $(RANLIB) $(LIB);\
          fi
	@cd $(LST);$(RM) xx *.[oycCf];$(TOUCH) $(FDEPA)

include $(MODIF_HOME)/cfg/machines/Target_Sup.mk
